#include "sysconfig.h"
#include "sysdeps.h"
#include "options.h"
#include "uae/memory.h"
#include "custom.h"
#include "events.h"
#include "newcpu.h"
#include "cpu_prefetch.h"
#include "cputbl.h"
#define CPUFUNC(x) x##_ff
#define SET_CFLG_ALWAYS(x) SET_CFLG(x)
#define SET_NFLG_ALWAYS(x) SET_NFLG(x)
#ifdef NOFLAGS
#include "noflags.h"
#endif
#ifdef CPUEMU_0
const struct cputbl CPUFUNC(op_smalltbl_0)[] = {
{ CPUFUNC(op_0000_0), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_0), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_0), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_0), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_0), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_0), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_0), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_0), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_0), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_0), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_0), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_0), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_0), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_0), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_0), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_0), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_0), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_0), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_0), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_0), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_0), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_0), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_0), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_0), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_0), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_0), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00d0_0), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00e8_0), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f0_0), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f8_0), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f9_0), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fa_0), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fb_0), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0100_0), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_0), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_0), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_0), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_0), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_0), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_0), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_0), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_0), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_0), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_0), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_0), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_0), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_0), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_0), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_0), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_0), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_0), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_0), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_0), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_0), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_0), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_0), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_0), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_0), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_0), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_0), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_0), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_0), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_0), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_0), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_0), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_0), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_0), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_0), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_0), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_0), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_0), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_0), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_0), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_0), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_0), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_0), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_0), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_0), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_0), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_0), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_0), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_0), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_0), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_0), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_0), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_0), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_0), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02d0_0), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02e8_0), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f0_0), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f8_0), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f9_0), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fa_0), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fb_0), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0400_0), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_0), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_0), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_0), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_0), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_0), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_0), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_0), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_0), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_0), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_0), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_0), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_0), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_0), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_0), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_0), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_0), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_0), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_0), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_0), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_0), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_0), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_0), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_0), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04d0_0), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04e8_0), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f0_0), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f8_0), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f9_0), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fa_0), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fb_0), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0600_0), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_0), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_0), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_0), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_0), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_0), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_0), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_0), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_0), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_0), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_0), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_0), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_0), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_0), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_0), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_0), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_0), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_0), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_0), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_0), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_0), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_0), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_0), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_0), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c0_0), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c8_0), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06d0_0), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06e8_0), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f0_0), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f8_0), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f9_0), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fa_0), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fb_0), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ CPUFUNC(op_0800_0), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_0), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_0), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_0), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_0), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_0), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_0), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_0), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_0), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_0), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_0), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_0), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_0), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_0), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_0), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_0), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_0), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_0), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_0), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_0), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_0), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_0), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_0), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_0), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_0), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_0), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_0), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_0), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_0), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_0), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_0), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_0), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_0), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_0), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_0), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_0), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_0), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_0), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_0), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_0), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_0), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_0), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_0), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_0), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_0), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_0), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_0), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad0_0), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad8_0), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae0_0), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae8_0), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af0_0), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af8_0), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af9_0), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ CPUFUNC(op_0c00_0), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_0), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_0), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_0), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_0), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_0), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_0), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_0), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3a_0), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3b_0), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c40_0), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_0), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_0), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_0), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_0), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_0), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_0), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_0), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7a_0), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7b_0), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c80_0), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_0), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_0), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_0), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cba_0), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cbb_0), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd0_0), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd8_0), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce0_0), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce8_0), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf0_0), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf8_0), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf9_0), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cfc_0), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e10_0), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e18_0), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e20_0), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e28_0), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e30_0), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e38_0), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e39_0), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e50_0), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e58_0), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e60_0), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e68_0), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e70_0), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e78_0), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e79_0), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e90_0), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e98_0), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea0_0), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea8_0), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb0_0), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb8_0), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb9_0), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed0_0), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed8_0), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee0_0), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee8_0), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef0_0), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef8_0), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef9_0), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0efc_0), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ CPUFUNC(op_1000_0), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_0), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_0), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_0), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_0), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_0), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_0), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_0), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_0), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_0), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_0), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_0), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_0), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_0), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_0), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_0), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_0), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_0), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_0), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_0), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_0), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_0), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_0), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_0), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_0), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_0), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_0), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_0), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_0), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_0), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_0), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_0), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_0), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_0), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_0), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_0), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_0), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_0), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_0), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_0), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_0), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_0), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_0), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_0), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_0), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_0), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_0), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_0), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_0), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_0), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_0), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_0), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_0), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_0), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_0), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_0), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_0), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_0), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_0), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_0), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_0), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_0), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_0), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_0), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_0), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_0), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_0), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_0), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_0), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_0), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_0), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_0), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_0), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_0), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_0), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_0), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_0), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_0), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_0), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_0), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_0), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_0), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_0), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_0), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_0), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_0), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_0), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_0), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_0), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_0), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_0), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_0), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_0), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_0), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_0), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_0), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_0), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_0), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_0), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_0), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_0), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_0), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_0), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_0), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_0), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_0), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_0), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_0), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_0), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_0), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_0), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_0), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_0), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_0), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_0), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_0), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_0), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_0), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_0), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_0), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_0), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_0), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_0), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_0), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_0), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_0), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_0), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_0), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_0), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_0), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_0), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_0), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_0), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_0), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_0), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_0), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_0), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_0), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_0), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_0), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_0), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_0), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_0), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_0), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_0), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_0), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_0), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_0), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_0), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_0), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_0), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_0), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_0), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_0), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_0), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_0), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_0), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_0), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_0), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_0), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_0), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_0), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_0), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_0), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_0), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_0), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_0), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_0), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_0), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_0), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_0), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_0), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_0), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_0), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_0), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_0), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_0), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_0), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_0), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_0), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_0), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_0), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_0), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_0), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_0), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_0), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_0), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_0), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_0), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_0), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_0), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_0), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_0), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_0), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_0), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_0), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_0), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_0), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_0), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_0), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4100_0), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4110_0), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4118_0), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4120_0), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4128_0), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4130_0), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4138_0), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4139_0), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413a_0), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413b_0), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413c_0), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ CPUFUNC(op_4180_0), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_0), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_0), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_0), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_0), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_0), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_0), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_0), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_0), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_0), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_0), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_0), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_0), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_0), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_0), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_0), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_0), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_0), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_0), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_0), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_0), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_0), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_0), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_0), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_0), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_0), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_0), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_0), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_0), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_0), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_0), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_0), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_0), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_0), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_0), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_0), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_0), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_0), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_0), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_0), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_0), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_0), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_0), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_0), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_0), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_0), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_0), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_0), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_0), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_0), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_0), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_0), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_0), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_0), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_0), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_0), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_0), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_0), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_0), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_0), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_0), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_0), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_0), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_0), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_0), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_0), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_0), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_0), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_0), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_0), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_0), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_0), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_0), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_0), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_0), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_0), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_0), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_0), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_0), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_0), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_0), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_0), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_0), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_0), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_0), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_0), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_0), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_0), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_0), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_0), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_0), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_0), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_0), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_0), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_0), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_0), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_0), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_0), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_0), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_0), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_0), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_0), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_0), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_0), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4808_0), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ CPUFUNC(op_4810_0), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_0), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_0), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_0), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_0), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_0), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_0), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_0), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4848_0), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ CPUFUNC(op_4850_0), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_0), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_0), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_0), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_0), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_0), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_0), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_0), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_0), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_0), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_0), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_0), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_49c0_0), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ CPUFUNC(op_4a00_0), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_0), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_0), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_0), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_0), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_0), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_0), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_0), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3a_0), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3b_0), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3c_0), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a40_0), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a48_0), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a50_0), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_0), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_0), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_0), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_0), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_0), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_0), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7a_0), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7b_0), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7c_0), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a80_0), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a88_0), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a90_0), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_0), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_0), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_0), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_0), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_0), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_0), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4aba_0), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abb_0), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abc_0), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4ac0_0), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_0), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_0), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_0), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_0), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_0), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_0), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_0), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c00_0), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c10_0), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c18_0), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c20_0), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c28_0), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c30_0), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c38_0), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c39_0), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3a_0), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3b_0), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3c_0), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c40_0), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c50_0), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c58_0), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c60_0), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c68_0), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c70_0), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c78_0), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c79_0), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7a_0), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7b_0), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7c_0), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ CPUFUNC(op_4c90_0), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_0), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_0), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_0), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_0), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_0), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_0), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_0), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_0), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_0), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_0), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_0), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_0), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_0), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_0), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_0), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_0), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_0), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_0), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_0), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_0), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_0), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_0), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_0), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_0), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_0), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_0), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_0), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_0), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_0), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_0), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_0), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_0), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_0), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_0), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_0), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_0), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_0), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_0), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_0), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_0), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_0), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_0), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_0), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_0), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_0), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_0), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_0), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_0), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_0), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_0), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_0), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_0), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_0), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_0), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fa_0), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fb_0), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fc_0), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5100_0), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_0), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_0), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_0), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_0), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_0), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_0), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_0), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_0), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_0), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_0), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_0), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_0), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_0), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_0), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_0), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_0), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_0), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_0), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_0), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_0), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_0), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_0), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_0), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_0), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_0), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_0), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_0), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_0), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_0), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_0), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_0), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_0), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_0), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fa_0), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fb_0), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fc_0), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_52c0_0), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_0), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_0), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_0), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_0), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_0), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_0), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_0), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fa_0), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fb_0), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fc_0), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_53c0_0), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_0), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_0), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_0), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_0), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_0), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_0), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_0), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fa_0), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fb_0), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fc_0), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_54c0_0), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_0), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_0), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_0), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_0), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_0), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_0), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_0), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fa_0), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fb_0), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fc_0), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_55c0_0), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_0), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_0), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_0), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_0), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_0), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_0), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_0), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fa_0), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fb_0), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fc_0), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_56c0_0), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_0), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_0), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_0), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_0), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_0), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_0), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_0), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fa_0), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fb_0), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fc_0), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_57c0_0), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_0), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_0), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_0), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_0), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_0), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_0), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_0), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fa_0), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fb_0), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fc_0), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_58c0_0), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_0), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_0), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_0), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_0), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_0), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_0), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_0), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fa_0), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fb_0), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fc_0), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_59c0_0), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_0), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_0), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_0), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_0), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_0), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_0), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_0), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fa_0), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fb_0), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fc_0), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ac0_0), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_0), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_0), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_0), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afa_0), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afb_0), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afc_0), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5bc0_0), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_0), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_0), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_0), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfa_0), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfb_0), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfc_0), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5cc0_0), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_0), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfa_0), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfb_0), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfc_0), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5dc0_0), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_0), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_0), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_0), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_0), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_0), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfa_0), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfb_0), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfc_0), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ec0_0), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_0), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efa_0), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efb_0), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efc_0), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5fc0_0), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_0), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffa_0), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffb_0), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffc_0), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_6000_0), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_0), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_0), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_0), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_0), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_0), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_0), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_0), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_0), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_0), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_0), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_0), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_0), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_0), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_0), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_0), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_0), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_0), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_0), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_0), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_0), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_0), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_0), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_0), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_0), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_0), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_0), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_0), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_0), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_0), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_0), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_0), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_0), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_0), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_0), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_0), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_0), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_0), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_0), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_0), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_0), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_0), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_0), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_0), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_0), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_0), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_0), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_0), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_0), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_0), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_0), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_0), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_0), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_0), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_0), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_0), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_0), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_0), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_0), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_0), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_0), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_0), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_0), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_0), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_0), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_0), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_0), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_0), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_0), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_0), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_0), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_0), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_0), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_0), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_0), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_0), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_0), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_0), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_0), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_0), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_0), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_0), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8140_0), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8148_0), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ CPUFUNC(op_8150_0), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_0), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_0), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_0), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_0), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_0), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_0), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8180_0), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8188_0), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ CPUFUNC(op_8190_0), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_0), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_0), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_0), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_0), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_0), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_0), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_0), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_0), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_0), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_0), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_0), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_0), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_0), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_0), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_0), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_0), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_0), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_0), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_0), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_0), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_0), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_0), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_0), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_0), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_0), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_0), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_0), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_0), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_0), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_0), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_0), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_0), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_0), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_0), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_0), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_0), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_0), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_0), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_0), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_0), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_0), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_0), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_0), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_0), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_0), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_0), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_0), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_0), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_0), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_0), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_0), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_0), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_0), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_0), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_0), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_0), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_0), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_0), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_0), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_0), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_0), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_0), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_0), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_0), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_0), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_0), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_0), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_0), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_0), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_0), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_0), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_0), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_0), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_0), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_0), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_0), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_0), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_0), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_0), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_0), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_0), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_0), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_0), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_0), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_0), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_0), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_0), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_0), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_0), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_0), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_0), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_0), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_0), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_0), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_0), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_0), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_0), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_0), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_0), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_0), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_0), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_0), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_0), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_0), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_0), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_0), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_0), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_0), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_0), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_0), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_0), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_0), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_0), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_0), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_0), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_0), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_0), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_0), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_0), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_0), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_0), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_0), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_0), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_0), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_0), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_0), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_0), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_0), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_0), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_0), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_0), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_0), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_0), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_0), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_0), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_0), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_0), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_0), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_0), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_0), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_0), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_0), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_0), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_0), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_0), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_0), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_0), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_0), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_0), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_0), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_0), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_0), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_0), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_0), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_0), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_0), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_0), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_0), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_0), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_0), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_0), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_0), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_0), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_0), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_0), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_0), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_0), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_0), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_0), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_0), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_0), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_0), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_0), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_0), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_0), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_0), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_0), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_0), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_0), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_0), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_0), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_0), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_0), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_0), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_0), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_0), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_0), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_0), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_0), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_0), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_0), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_0), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_0), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_0), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_0), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_0), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_0), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_0), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_0), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_0), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_0), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_0), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_0), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_0), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_0), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_0), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_0), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_0), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_0), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_0), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_0), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_0), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_0), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_0), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_0), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_0), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_0), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_0), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_0), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_0), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_0), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_0), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_0), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_0), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_0), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_0), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_0), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_0), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_0), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_0), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_0), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_0), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_0), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_0), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_0), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_0), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_0), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_0), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_0), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_0), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_0), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_0), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_0), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_0), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_0), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_0), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_0), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_0), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_0), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_0), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_0), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_0), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_0), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_0), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_0), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_0), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_0), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_0), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_0), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_0), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_0), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_0), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_0), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_0), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_0), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_0), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_0), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_0), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_0), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_0), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_0), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_0), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_0), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_0), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_0), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_0), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_0), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_0), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_0), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_0), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_0), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_0), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_0), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_0), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_0), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_0), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_0), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_0), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_0), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_0), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_0), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_0), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_0), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_0), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_0), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_0), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_0), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_0), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_0), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_0), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_0), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_0), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8c0_0), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8d0_0), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8e8_0), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f0_0), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f8_0), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f9_0), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fa_0), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fb_0), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9c0_0), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9d0_0), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9e8_0), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f0_0), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f8_0), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f9_0), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fa_0), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fb_0), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eac0_0), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ead0_0), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eae8_0), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf0_0), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf8_0), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf9_0), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebc0_0), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebd0_0), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebe8_0), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf0_0), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf8_0), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf9_0), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfa_0), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfb_0), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecc0_0), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecd0_0), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ece8_0), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf0_0), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf8_0), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf9_0), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edc0_0), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edd0_0), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ede8_0), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf0_0), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf8_0), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf9_0), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfa_0), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfb_0), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eec0_0), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eed0_0), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eee8_0), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef0_0), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef8_0), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef9_0), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efc0_0), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efd0_0), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efe8_0), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff0_0), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff8_0), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff9_0), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f000_0), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f008_0), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f010_0), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f018_0), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f020_0), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f028_0), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f030_0), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f038_0), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f039_0), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f200_0), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f208_0), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f210_0), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f218_0), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f220_0), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f228_0), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f230_0), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f238_0), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f239_0), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23a_0), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23b_0), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23c_0), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f240_0), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f248_0), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f250_0), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f258_0), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f260_0), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f268_0), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f270_0), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f278_0), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f279_0), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27a_0), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27b_0), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27c_0), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f280_0), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f2c0_0), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f310_0), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f320_0), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f328_0), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f330_0), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f338_0), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f339_0), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f350_0), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f358_0), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f368_0), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f370_0), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f378_0), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f379_0), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37a_0), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37b_0), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f408_0), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f410_0), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f418_0), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f419_0), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41a_0), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41b_0), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41c_0), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41d_0), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41e_0), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41f_0), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f428_0), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f430_0), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f438_0), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f439_0), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43a_0), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43b_0), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43c_0), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43d_0), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43e_0), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43f_0), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f500_0), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f508_0), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f510_0), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f518_0), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f548_0), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f568_0), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f588_0), 0xf588, -1, { 0, 0 }, 0 }, /* PLPAW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f5c8_0), 0xf5c8, -1, { 0, 0 }, 0 }, /* PLPAR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f600_0), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f608_0), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f610_0), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f618_0), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f620_0), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f800_0), 0xf800, -1, { 0, 0 }, 0 }, /* LPSTOP */
#endif
{ 0, 0 }};
#endif /* CPUEMU_0 */
#ifdef CPUEMU_0
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_1)[] = {
{ CPUFUNC(op_0000_0), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_0), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_0), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_0), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_0), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_0), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_0), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_0), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_0), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_0), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_0), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_0), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_0), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_0), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_0), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_0), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_0), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_0), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_0), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_0), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_0), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_0), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_0), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_0), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_0), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_0), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_0), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_0), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_0), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_0), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_0), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_0), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_0), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_0), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_0), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_0), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_0), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_0), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_0), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_0), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_0), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_0), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_0), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_0), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_0), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_0), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_0), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_0), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_0), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_0), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_0), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_0), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_0), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_0), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_0), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_0), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_0), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_0), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_0), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_0), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_0), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_0), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_0), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_0), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_0), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_0), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_0), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_0), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_0), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_0), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_0), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_0), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_0), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_0), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_0), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_0), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_0), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_0), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_0), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_0), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_0), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_0), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_0), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_0), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_0), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_0), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_0), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_0), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_0), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_0), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_0), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_0), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_0), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_0), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_0), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_0), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_0), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_0), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_0), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_0), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_0), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_0), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_0), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_0), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_0), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_0), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_0), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_0), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_0), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_0), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_0), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_0), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_0), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_0), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_0), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_0), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_0), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_0), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_0), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_0), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_0), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_0), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_0), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_0), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_0), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_0), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_0), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_0), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_0), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_0), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_0), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_0), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_0), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_0), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_0), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_0), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_0), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_0), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_0), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_0), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_0), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_0), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_0), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_0), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_0), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_0), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_0), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_0), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_0), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_0), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_0), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_0), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_0), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_0), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_0), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_0), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_0), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_0), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_0), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_0), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_0), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_0), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_0), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_0), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_0), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_0), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_0), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_0), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_0), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_0), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_0), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_0), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_0), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_0), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_0), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_0), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_0), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_0), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_0), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_0), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_0), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_0), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_0), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_0), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_0), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_0), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_0), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_0), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_0), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_0), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_0), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_0), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_0), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_0), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_0), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_0), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_0), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_0), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_0), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_0), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_0), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_0), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_0), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_0), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_0), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_0), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_0), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_0), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_0), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_0), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_0), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_0), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_0), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_0), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_0), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_0), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_0), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_0), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_0), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_0), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_0), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_0), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_0), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_0), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_0), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_0), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_0), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_0), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_0), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_0), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_0), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_0), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_0), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_0), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_0), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_0), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_0), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_0), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_0), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_0), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_0), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_0), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_0), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_0), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_0), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_0), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_0), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_0), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_0), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_0), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_0), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_0), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_0), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_0), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_0), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_0), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_0), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_0), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_0), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_0), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_0), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_0), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_0), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_0), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_0), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_0), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_0), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_0), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_0), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_0), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_0), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_0), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_0), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_0), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_0), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_0), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_0), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_0), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_0), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_0), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_0), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_0), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_0), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_0), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_0), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_0), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_0), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_0), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_0), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_0), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_0), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_0), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_0), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_0), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_0), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_0), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_0), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_0), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_0), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_0), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_0), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_0), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_0), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_0), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_0), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_0), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_0), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_0), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_0), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_0), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_0), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_0), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_0), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_0), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_0), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_0), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_0), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_0), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_0), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_0), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_0), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_0), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_0), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_0), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_0), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_0), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_0), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_0), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_0), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_0), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_0), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_0), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_0), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_0), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_0), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_0), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_0), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_0), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_0), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_0), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_0), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_0), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_0), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_0), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_0), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_0), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_0), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_0), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_0), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_0), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_0), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_0), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_0), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_0), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_0), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_0), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_0), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_0), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_0), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_0), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_0), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_0), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_0), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_0), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_0), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_0), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_0), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_0), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_0), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_0), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_0), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_0), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_0), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_0), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_0), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_0), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_0), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_0), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_0), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_0), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_0), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_0), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_0), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_0), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_0), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_0), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_0), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_0), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_0), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_0), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_0), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_0), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_0), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_0), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_0), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_0), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_0), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_0), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_0), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_0), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_0), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_0), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_0), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_0), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_0), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_0), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_0), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_0), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_0), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_0), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_0), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_0), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_0), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_0), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_0), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_0), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_0), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_0), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_0), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_0), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_0), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_0), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_0), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_0), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_0), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_0), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_0), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_0), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_0), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_0), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_0), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_0), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_0), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_0), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_0), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_0), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_0), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_0), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_0), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_0), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_0), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_0), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_0), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_0), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_0), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_0), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_0), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_0), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_0), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_0), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_0), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_0), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_0), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_0), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_0), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_0), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_0), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_0), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_0), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_0), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_0), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_0), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_0), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_0), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_0), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_0), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_0), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_0), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_0), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_0), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_0), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_0), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_0), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_0), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_0), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_0), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_0), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_0), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_0), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_0), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_0), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_0), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_0), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_0), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_0), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_0), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_0), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_0), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_0), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_0), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_0), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_0), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_0), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_0), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_0), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_0), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_0), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_0), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_0), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_0), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_0), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_0), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_0), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_0), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_0), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_0), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_0), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_0), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_0), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_0), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_0), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_0), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_0), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_0), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_0), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_0), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_0), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_0), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_0), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_0), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_0), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_0), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_0), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_0), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_0), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_0), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_0), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_0), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_0), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_0), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_0), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_0), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_0), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_0), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_0), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_0), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_0), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_0), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_0), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_0), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_0), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_0), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_0), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_0), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_0), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_0), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_0), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_0), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_0), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_0), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_0), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_0), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_0), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_0), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_0), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_0), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_0), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_0), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_0), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_0), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_0), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_0), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_0), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_0), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_0), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_0), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_0), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_0), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_0), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_0), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_0), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_0), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_0), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_0), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_0), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_0), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_0), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_0), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_0), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_0), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_0), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_0), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_0), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_0), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_0), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_0), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_0), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_0), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_0), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_0), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_0), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_0), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_0), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_0), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_0), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_0), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_0), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_0), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_0), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_0), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_0), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_0), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_0), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_0), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_0), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_0), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_0), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_0), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_0), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_0), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_0), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_0), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_0), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_0), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_0), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_0), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_0), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_0), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_0), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_0), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_0), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_0), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_0), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_0), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_0), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_0), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_0), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_0), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_0), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_0), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_0), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_0), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_0), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_0), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_0), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_0), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_0), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_0), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_0), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_0), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_0), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_0), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_0), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_0), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_0), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_0), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_0), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_0), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_0), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_0), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_0), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_0), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_0), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_0), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_0), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_0), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_0), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_0), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_0), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_0), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_0), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_0), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_0), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_0), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_0), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_0), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_0), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_0), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_0), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_0), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_0), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_0), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_0), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_0), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_0), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_0), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_0), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_0), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_0), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_0), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_0), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_0), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_0), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_0), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_0), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_0), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_0), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_0), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_0), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_0), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_0), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_0), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_0), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_0), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_0), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_0), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_0), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_0), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_0), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_0), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_0), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_0), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_0), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_0), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_0), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_0), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_0), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_0), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_0), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_0), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_0), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_0), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_0), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_0), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_0), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_0), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_0), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_0), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_0), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_0), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_0), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_0), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_0), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_0), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_0), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_0), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_0), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_0), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_0), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_0), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_0), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_0), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_0), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_0), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_0), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_0), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_0), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_0), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_0), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_0), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_0), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_0), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_0), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_0), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_0), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_0), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_0), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_0), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_0), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_0), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_0), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_0), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_0), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_0), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_0), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_0), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_0), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_0), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_0), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_0), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_0), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_0), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_0), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_0), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_0), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_0), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_0), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_0), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_0), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_0), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_0), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_0), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_0), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_0), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_0), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_0), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_0), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_0), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_0), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_0), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_0), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_0), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_0), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_0), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_0), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_0), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_0), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_0), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_0), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_0), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_0), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_0), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_0), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_0), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_0), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_0), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_0), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_0), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_0), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_0), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_0), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_0), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_0), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_0), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_0), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_0), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_0), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_0), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_0), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_0), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_0), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_0), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_0), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_0), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_0), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_0), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_0), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_0), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_0), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_0), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_0), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_0), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_0), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_0), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_0), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_0), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_0), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_0), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_0), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_0), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_0), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_0), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_0), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_0), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_0), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_0), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_0), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_0), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_0), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_0), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_0), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_0), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_0), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_0), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_0), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_0), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_0), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_0), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_0), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_0), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_0), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_0), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_0), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_0), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_0), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_0), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_0), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_0), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_0), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_0), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_0), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_0), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_0), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_0), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_0), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_0), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_0), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_0), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_0), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_0), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_0), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_0), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_0), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_0), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_0), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_0), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_0), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_0), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_0), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_0), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_0), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_0), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_0), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_0), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_0), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_0), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_0), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_0), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_0), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_0), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_0), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_0), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_0), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_0), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_0), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_0), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_0), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_0), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_0), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_0), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_0), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_0), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_0), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_0), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_0), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_0), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_0), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_0), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_0), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_0), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_0), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_0), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_0), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_0), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_0), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_0), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_0), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_0), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_0), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_0), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_0), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_0), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_0), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_0), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_0), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_0), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_0), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_0), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_0), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_0), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_0), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_0), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_0), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_0), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_0), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_0), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_0), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_0), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_0), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_0), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_0), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_0), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_0), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_0), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_0), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_0), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_0), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_0), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_0), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_0), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_0), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_0), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_0), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_0), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_0), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_0), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_0), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_0), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_0), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_0), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_0), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_0), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_0), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_0), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_0), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_0), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_0), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_0), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_0), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_0), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_0), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_0), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_0), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_0), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_0), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_0), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_0), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_0), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_0), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_0), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_0), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_0), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_0), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_0), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_0), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_0), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_0), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_0), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_0), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_0), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_0), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_0), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_0), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_0), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_0), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_0), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_0), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_0), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_0), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_0), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_0), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_0), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_0), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_0), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_0), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_0), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_0), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_0), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_0), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_0), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_0), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_0), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_0), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_0), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_0), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_0), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_0), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_0), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_0), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_0), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_0), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_0), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_0), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_0), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_0), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_0), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_0), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_0), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_0), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_0), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_0), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_0), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_0), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_0), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_0), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_0), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_0), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_0), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_0), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_0), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_0), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_0), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_0), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_0), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_0), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_0), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_0), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_0), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_0), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_0), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_0), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_0), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_0), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_0), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_0), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_0), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_0), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_0), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_0), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_0), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_0), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_0), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_0), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_0), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_0), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_0), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_0), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_0), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_0), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_0), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_0), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_0), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_0), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_0), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_0), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_0), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_0), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_0), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_0), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_0), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_0), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_0), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_0), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_0), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_0), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_0), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_0), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_0), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_0), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_0), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_0), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_0), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_0), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_0), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_0), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_0), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_0), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_0), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_0), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_0), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_0), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_0), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_0), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_0), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_0), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_0), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_0), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_0), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_0), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_0), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_0), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_0), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_0), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_0), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_0), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_0), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_0), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_0), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_0), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_0), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_0), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_0), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_0), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_0), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_0), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_0), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_0), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_0), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_0), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_0), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_0), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_0), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_0), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_0), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_0), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_0), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_0), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_0), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_0), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_0), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_0), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_0), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_0), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_0), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_0), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_0), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_0), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_0), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_0), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_0), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_0), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_0), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_0), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_0), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_0), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_0), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_0), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_0), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_0), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_0), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_0), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_0), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_0), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_0), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_0), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_0), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_0), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_0), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_0), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_0), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_0), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_0), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_0), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_0), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_0), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_0), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_0), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_0), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_0), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_0), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_0), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_0), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_0), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_0), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_0), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_0), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_0), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_0), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_0), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_0), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_0), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_0), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_0), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_0), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_0), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_0), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_0), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_0), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_0), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_0), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_0), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_0), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_0), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_0), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_0), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_0), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_0), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_0), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_0), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_0), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_0), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_0), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_0), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_0), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_0), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_0), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_0), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_0), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_0), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_0), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_0), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_0), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_0), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_0), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_0), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_0), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_0), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_0), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_0), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_0), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_0), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_0), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_0), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_0), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_0), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_0), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_0), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_0), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_0), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_0), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_0), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_0), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_0), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_0), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_0), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_0), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_0), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_0), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_0), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_0), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_0), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_0), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_0), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_0), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_0), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_0), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_0), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_0), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_0), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_0), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_0), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_0), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_0), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_0), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_0), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_0), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_0), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_0), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_0), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_0), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_0), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_0), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_0), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_0), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_0), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_0), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_0), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_0), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_0), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_0), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_0), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_0), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_0), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_0), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_0), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_0), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_0), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_0), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_0), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_0), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_0), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_0), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_0), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_0), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_0), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_0), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_0), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_0), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_0), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_0), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_0), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_0), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_0), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_0), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_0), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_0), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_0), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_0), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_0), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_0), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_0), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_0), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_0), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_0), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_0), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_0), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_0), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_0), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_0), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_0), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_0), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_0), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_0), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_0), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_0), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_0), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_0), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_0), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_0), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_0), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_0), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_0), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_0), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_0), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_0), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_0), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_0), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_0), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_0), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_0), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_0), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_0), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_0), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_0), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_0), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_0), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_0), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_0), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_0), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_0), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_0), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f000_0), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f008_0), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f010_0), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f018_0), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f020_0), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f028_0), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f030_0), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f038_0), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f039_0), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f200_0), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_0), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_0), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_0), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_0), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_0), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_0), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_0), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_0), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_0), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_0), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_0), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_0), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_0), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_0), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_0), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_0), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_0), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_0), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_0), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_0), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_0), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_0), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_0), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_0), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_0), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_0), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_0), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_0), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_0), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_0), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_0), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_0), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_0), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_0), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_0), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_0), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_0), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_0), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_0), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f408_0), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
{ CPUFUNC(op_f410_0), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
{ CPUFUNC(op_f418_0), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f419_0), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41a_0), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41b_0), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41c_0), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41d_0), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41e_0), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41f_0), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f428_0), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
{ CPUFUNC(op_f430_0), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
{ CPUFUNC(op_f438_0), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f439_0), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43a_0), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43b_0), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43c_0), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43d_0), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43e_0), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43f_0), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f500_0), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
{ CPUFUNC(op_f508_0), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
{ CPUFUNC(op_f510_0), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
{ CPUFUNC(op_f518_0), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
{ CPUFUNC(op_f548_0), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
{ CPUFUNC(op_f568_0), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
{ CPUFUNC(op_f600_0), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f608_0), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f610_0), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f618_0), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f620_0), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_0 */
#ifdef CPUEMU_0
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_2)[] = {
{ CPUFUNC(op_0000_0), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_0), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_0), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_0), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_0), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_0), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_0), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_0), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_0), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_0), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_0), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_0), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_0), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_0), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_0), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_0), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_0), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_0), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_0), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_0), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_0), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_0), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_0), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_0), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_0), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_0), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_0), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_0), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_0), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_0), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_0), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_0), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_0), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_0), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_0), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_0), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_0), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_0), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_0), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_0), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_0), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_0), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_0), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_0), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_0), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_0), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_0), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_0), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_0), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_0), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_0), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_0), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_0), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_0), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_0), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_0), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_0), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_0), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_0), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_0), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_0), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_0), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_0), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_0), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_0), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_0), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_0), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_0), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_0), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_0), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_0), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_0), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_0), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_0), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_0), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_0), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_0), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_0), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_0), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_0), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_0), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_0), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_0), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_0), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_0), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_0), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_0), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_0), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_0), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_0), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_0), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_0), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_0), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_0), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_0), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_0), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_0), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_0), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_0), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_0), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_0), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_0), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_0), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_0), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_0), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_0), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_0), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_0), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_0), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_0), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_0), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_0), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_0), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_0), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_0), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_0), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_0), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_0), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_0), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_0), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_0), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_0), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_0), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_0), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_0), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_0), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_0), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_0), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_0), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_0), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_0), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_0), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_0), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_0), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_0), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_0), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_0), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_0), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_0), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_0), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_0), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_0), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_0), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_0), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_0), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_0), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_0), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_0), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_0), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_0), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_0), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_0), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_0), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_0), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_0), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_0), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_0), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_0), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_0), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_0), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_0), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_0), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_0), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_0), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_0), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_0), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_0), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_0), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_0), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_0), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_0), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_0), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_0), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_0), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_0), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_0), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_0), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_0), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_0), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_0), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_0), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_0), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_0), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_0), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_0), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_0), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_0), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_0), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_0), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_0), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_0), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_0), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_0), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_0), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_0), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_0), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_0), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_0), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_0), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_0), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_0), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_0), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_0), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_0), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_0), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_0), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_0), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_0), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_0), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_0), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_0), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_0), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_0), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_0), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_0), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_0), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_0), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_0), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_0), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_0), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_0), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_0), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_0), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_0), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_0), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_0), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_0), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_0), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_0), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_0), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_0), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_0), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_0), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_0), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_0), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_0), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_0), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_0), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_0), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_0), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_0), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_0), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_0), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_0), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_0), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_0), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_0), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_0), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_0), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_0), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_0), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_0), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_0), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_0), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_0), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_0), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_0), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_0), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_0), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_0), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_0), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_0), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_0), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_0), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_0), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_0), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_0), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_0), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_0), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_0), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_0), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_0), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_0), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_0), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_0), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_0), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_0), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_0), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_0), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_0), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_0), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_0), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_0), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_0), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_0), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_0), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_0), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_0), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_0), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_0), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_0), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_0), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_0), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_0), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_0), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_0), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_0), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_0), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_0), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_0), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_0), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_0), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_0), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_0), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_0), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_0), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_0), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_0), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_0), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_0), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_0), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_0), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_0), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_0), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_0), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_0), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_0), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_0), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_0), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_0), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_0), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_0), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_0), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_0), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_0), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_0), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_0), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_0), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_0), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_0), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_0), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_0), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_0), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_0), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_0), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_0), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_0), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_0), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_0), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_0), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_0), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_0), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_0), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_0), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_0), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_0), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_0), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_0), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_0), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_0), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_0), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_0), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_0), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_0), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_0), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_0), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_0), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_0), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_0), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_0), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_0), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_0), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_0), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_0), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_0), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_0), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_0), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_0), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_0), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_0), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_0), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_0), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_0), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_0), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_0), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_0), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_0), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_0), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_0), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_0), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_0), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_0), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_0), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_0), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_0), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_0), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_0), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_0), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_0), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_0), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_0), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_0), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_0), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_0), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_0), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_0), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_0), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_0), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_0), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_0), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_0), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_0), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_0), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_0), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_0), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_0), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_0), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_0), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_0), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_0), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_0), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_0), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_0), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_0), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_0), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_0), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_0), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_0), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_0), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_0), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_0), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_0), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_0), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_0), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_0), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_0), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_0), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_0), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_0), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_0), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_0), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_0), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_0), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_0), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_0), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_0), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_0), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_0), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_0), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_0), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_0), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_0), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_0), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_0), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_0), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_0), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_0), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_0), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_0), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_0), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_0), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_0), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_0), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_0), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_0), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_0), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_0), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_0), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_0), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_0), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_0), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_0), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_0), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_0), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_0), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_0), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_0), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_0), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_0), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_0), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_0), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_0), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_0), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_0), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_0), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_0), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_0), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_0), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_0), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_0), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_0), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_0), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_0), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_0), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_0), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_0), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_0), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_0), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_0), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_0), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_0), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_0), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_0), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_0), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_0), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_0), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_0), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_0), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_0), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_0), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_0), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_0), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_0), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_0), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_0), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_0), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_0), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_0), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_0), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_0), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_0), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_0), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_0), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_0), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_0), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_0), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_0), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_0), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_0), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_0), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_0), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_0), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_0), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_0), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_0), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_0), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_0), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_0), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_0), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_0), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_0), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_0), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_0), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_0), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_0), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_0), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_0), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_0), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_0), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_0), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_0), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_0), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_0), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_0), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_0), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_0), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_0), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_0), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_0), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_0), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_0), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_0), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_0), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_0), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_0), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_0), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_0), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_0), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_0), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_0), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_0), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_0), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_0), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_0), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_0), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_0), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_0), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_0), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_0), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_0), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_0), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_0), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_0), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_0), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_0), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_0), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_0), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_0), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_0), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_0), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_0), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_0), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_0), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_0), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_0), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_0), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_0), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_0), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_0), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_2), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_0), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_2), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_2), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_2), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_2), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_2), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_2), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_2), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_0), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_0), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_0), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_0), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_0), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_0), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_0), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_0), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_0), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_0), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_0), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_0), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_0), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_0), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_0), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_0), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_0), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_0), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_0), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_0), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_0), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_0), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_0), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_0), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_0), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_0), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_0), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_0), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_0), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_0), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_0), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_0), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_0), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_0), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_0), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_0), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_0), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_0), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_0), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_0), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_0), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_0), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_0), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_0), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_0), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_0), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_0), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_0), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_0), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_0), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_0), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_0), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_0), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_0), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_0), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_0), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_0), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_0), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_0), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_0), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_0), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_0), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_0), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_0), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_0), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_0), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_0), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_0), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_0), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_0), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_0), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_0), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_0), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_0), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_0), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_0), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_0), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_0), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_0), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_0), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_0), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_0), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_0), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_0), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_0), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_0), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_0), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_0), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_0), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_0), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_0), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_0), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_0), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_0), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_0), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_0), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_0), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_0), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_0), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_0), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_0), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_0), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_0), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_0), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_0), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_0), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_0), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_0), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_0), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_0), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_0), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_0), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_0), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_0), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_0), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_0), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_0), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_0), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_0), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_0), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_0), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_0), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_0), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_0), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_0), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_0), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_0), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_0), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_0), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_0), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_0), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_0), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_0), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_0), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_0), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_0), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_0), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_0), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_0), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_0), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_0), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_0), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_0), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_0), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_0), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_0), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_0), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_0), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_0), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_0), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_0), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_0), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_0), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_0), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_0), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_0), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_0), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_0), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_0), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_0), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_0), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_0), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_0), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_0), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_0), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_0), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_0), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_0), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_0), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_0), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_0), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_0), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_0), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_0), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_0), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_0), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_0), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_0), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_0), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_0), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_0), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_0), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_0), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_0), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_0), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_0), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_0), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_0), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_0), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_0), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_0), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_0), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_0), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_0), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_0), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_0), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_0), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_0), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_0), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_0), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_0), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_0), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_0), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_0), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_0), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_0), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_0), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_0), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_0), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_0), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_0), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_0), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_0), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_0), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_0), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_0), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_0), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_0), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_0), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_0), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_0), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_0), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_0), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_0), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_0), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_0), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_0), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_0), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_0), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_0), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_0), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_0), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_0), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_0), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_0), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_0), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_0), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_0), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_0), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_0), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_0), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_0), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_0), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_0), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_0), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_0), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_0), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_0), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_0), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_0), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_0), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_0), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_0), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_0), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_0), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_0), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_0), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_0), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_0), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_0), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_0), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_0), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_0), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_0), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_0), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_0), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_0), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_0), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_0), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_0), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_0), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_0), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_0), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_0), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_0), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_0), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_0), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_0), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_0), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_0), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_0), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_0), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_0), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_0), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_0), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_0), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_0), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_0), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_0), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_0), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_0), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_0), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_0), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_0), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_0), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_0), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_0), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_0), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_0), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_0), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_0), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_0), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_0), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_0), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_0), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_0), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_0), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_0), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_0), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_0), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_0), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_0), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_0), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_0), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_0), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_0), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_0), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_0), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_0), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_0), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_0), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_0), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_0), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_0), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_0), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_0), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_0), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_0), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_0), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_0), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_0), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_0), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_0), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_0), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_0), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_0), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_0), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_0), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_0), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_0), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_0), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_0), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_0), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_0), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_0), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_0), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_0), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_0), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_0), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_0), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_0), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_0), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_0), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_0), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_0), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_0), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_0), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_0), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_0), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_0), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_0), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_0), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_0), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_0), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_0), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_0), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_0), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_0), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_0), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_0), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_0), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_0), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_0), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_0), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_2), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_2), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_0), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_0), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_0), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_0), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_0), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_0), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_0), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_0), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_0), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_0), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_0), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_0), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_0), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_0), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_0), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_0), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_0), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_0), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_0), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_0), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_0), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_0), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_0), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_0), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_0), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_0), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_0), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_0), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_0), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_0), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_0), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_0), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_0), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_0), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_0), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_0), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_0), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_0), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_0), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_0), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_0), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_0), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_0), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_0), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_0), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_0), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_0), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_0), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_0), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_0), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_0), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_0), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_0), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_0), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_0), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_0), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_0), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_0), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_0), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_0), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_0), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_0), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_0), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_0), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_0), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_0), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_0), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_0), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_0), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_0), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_0), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_0), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_0), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_0), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_0), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_0), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_0), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_0), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_0), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_0), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_0), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_0), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_0), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_0), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_0), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_0), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_0), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_0), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_0), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_0), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_0), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_0), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_0), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_0), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_0), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_0), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_0), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_0), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_0), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_0), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_0), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_0), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_0), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_0), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_0), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_0), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_0), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_0), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_0), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_0), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_0), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_0), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_0), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_0), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_0), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_0), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_0), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_0), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_0), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_0), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_0), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_0), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_0), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_0), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_0), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_0), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_0), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_0), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_0), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_0), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_0), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_0), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_0), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_0), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_0), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_0), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_0), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_0), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_0), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_0), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_0), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_0), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_0), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_0), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_0), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_0), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_0), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_0), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_0), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_0), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_0), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_0), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_0), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_0), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_0), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_0), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_0), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_0), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_0), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_0), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_0), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_0), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_0), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_0), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_0), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_0), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_0), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_0), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_0), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_0), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_0), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_0), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_0), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_0), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_0), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_0), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_0), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_0), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_0), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_0), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_0), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_0), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_0), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_0), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_0), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_0), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_0), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_0), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_2), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_2), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_0), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_0), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_0), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_0), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_0), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_0), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_0), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_0), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_0), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_0), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_0), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_0), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_0), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_0), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_0), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_0), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_0), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_0), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_0), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_0), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_0), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_0), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_0), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_0), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_0), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_0), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_0), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_0), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_0), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_0), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_0), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_0), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_0), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_0), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_0), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_0), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_0), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_0), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_0), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_0), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_0), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_0), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_0), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_0), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_0), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_0), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_0), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_0), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_0), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_0), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_0), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_0), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_0), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_0), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_0), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_0), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_0), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_0), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_0), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_0), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_0), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_0), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_0), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_0), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_0), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_0), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_0), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_0), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_0), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_0), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_0), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_0), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_0), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_0), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_0), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_0), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_0), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_0), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_0), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_0), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_0), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_0), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_0), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_0), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_0), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_0), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_0), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_0), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_0), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_0), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_0), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_0), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_0), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_0), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_0), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_0), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_0), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_0), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_0), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_0), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_0), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_0), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_0), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_0), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_0), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_0), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_0), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_0), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_0), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_0), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_0), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_0), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_0), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_0), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_0), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_0), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_0), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_0), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_0), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_0), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_0), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_0), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_0), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_0), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_0), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_0), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_0), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_0), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_0), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_0), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_0), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_0), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_0), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_0), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_0), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_0), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_0), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_0), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_0), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_0), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_0), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_0), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_0), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_0), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_0), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_0), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_0), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_0), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_0), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_0), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_0), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_0), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_0), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_0), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_0), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_0), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_0), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_0), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_0), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_0), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_0), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_0), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_0), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_0), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_0), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_0), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_0), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_0), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_0), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_0), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_0), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_0), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_0), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_0), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_0), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_0), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_0), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_0), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_0), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_0), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_0), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_0), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_0), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_0), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_0), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_0), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_0), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f000_0), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f008_0), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f010_0), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f018_0), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f020_0), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f028_0), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f030_0), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f038_0), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f039_0), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f200_0), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_0), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_0), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_0), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_0), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_0), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_0), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_0), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_0), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_0), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_0), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_0), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_0), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_0), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_0), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_0), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_0), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_0), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_0), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_0), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_0), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_0), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_0), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_0), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_0), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_0), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_0), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_0), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_0), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_0), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_0), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_0), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_0), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_0), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_0), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_0), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_0), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_0), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_0), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_0), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_0 */
#ifdef CPUEMU_0
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_3)[] = {
{ CPUFUNC(op_0000_0), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_0), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_0), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_0), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_0), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_0), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_0), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_0), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_0), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_0), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_0), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_0), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_0), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_0), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_0), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_0), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_0), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_0), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_0), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_0), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_0), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_0), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_0), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_0), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_0), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_0), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_0), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_0), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_0), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_0), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_0), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_0), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_0), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_0), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_0), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_0), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_0), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_0), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_0), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_0), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_0), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_0), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_0), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_0), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_0), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_0), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_0), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_0), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_0), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_0), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_0), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_0), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_0), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_0), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_0), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_0), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_0), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_0), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_0), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_0), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_0), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_0), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_0), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_0), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_0), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_0), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_0), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_0), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_0), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_0), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_0), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_0), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_0), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_0), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_0), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_0), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_0), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_0), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_0), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_0), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_0), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_0), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_0), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_0), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_0), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_0), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_0), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_0), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_0), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_0), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_0), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_0), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_0), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_0), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_0), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_0), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_0), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_0), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_0), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_0), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_0), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_0), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_0), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_0), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_0), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_0), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_0), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_0), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_0), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_0), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_0), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_0), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_0), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_0), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_0), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_0), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_0), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_0), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_0), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_0), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_0), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_0), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_0), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_0), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_0), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_0), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_0), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_0), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_0), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_0), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_0), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_0), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_0), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_0), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_0), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_0), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_0), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_0), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_0), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_0), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_0), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_0), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_0), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_0), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_0), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_0), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_0), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_0), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_0), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_0), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_0), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_0), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_0), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_0), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_0), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_0), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_0), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_0), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_0), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_0), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_0), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_0), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_0), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_0), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_0), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_0), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_0), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_0), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_0), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_0), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_0), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_0), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_0), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_0), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_0), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_0), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_0), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_0), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_0), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_0), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_0), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_0), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_0), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_0), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_0), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_0), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_0), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_0), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_0), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_0), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_0), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_0), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_0), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_0), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_0), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_0), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_0), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_0), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_0), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_0), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_0), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_0), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_0), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_0), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_0), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_0), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_0), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_0), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_0), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_0), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_0), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_0), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_0), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_0), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_0), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_0), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_0), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_0), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_0), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_0), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_0), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_0), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_0), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_0), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_0), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_0), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_0), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_0), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_0), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_0), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_0), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_0), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_0), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_0), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_0), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_0), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_0), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_0), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_0), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_0), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_0), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_0), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_0), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_0), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_0), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_0), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_0), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_0), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_0), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_0), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_0), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_0), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_0), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_0), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_0), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_0), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_0), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_0), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_0), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_0), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_0), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_0), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_0), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_0), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_0), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_0), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_0), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_0), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_0), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_0), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_0), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_0), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_0), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_0), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_0), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_0), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_0), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_0), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_0), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_0), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_0), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_0), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_0), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_0), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_0), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_0), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_0), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_0), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_0), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_0), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_0), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_0), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_0), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_0), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_0), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_0), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_0), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_0), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_0), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_0), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_0), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_0), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_0), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_0), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_0), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_0), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_0), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_0), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_0), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_0), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_0), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_0), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_0), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_0), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_0), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_0), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_0), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_0), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_0), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_0), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_0), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_0), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_0), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_0), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_0), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_0), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_0), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_0), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_0), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_0), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_0), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_0), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_0), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_0), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_0), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_0), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_0), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_0), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_0), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_0), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_0), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_0), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_0), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_0), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_0), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_0), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_0), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_0), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_0), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_0), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_0), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_0), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_0), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_0), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_0), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_0), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_0), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_0), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_0), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_0), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_0), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_0), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_0), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_0), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_0), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_0), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_0), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_0), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_0), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_0), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_0), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_0), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_0), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_0), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_0), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_0), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_0), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_0), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_0), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_0), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_0), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_0), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_0), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_0), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_0), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_0), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_0), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_0), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_0), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_0), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_0), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_0), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_0), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_0), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_0), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_0), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_0), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_0), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_0), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_0), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_0), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_0), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_0), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_0), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_0), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_0), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_0), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_0), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_0), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_0), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_0), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_0), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_0), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_0), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_0), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_0), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_0), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_0), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_0), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_0), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_0), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_0), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_0), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_0), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_0), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_0), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_0), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_0), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_0), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_0), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_0), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_0), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_0), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_0), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_0), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_0), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_0), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_0), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_0), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_0), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_0), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_0), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_0), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_0), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_0), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_0), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_0), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_0), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_0), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_0), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_0), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_0), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_0), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_0), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_0), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_0), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_0), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_0), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_0), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_0), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_0), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_0), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_0), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_0), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_0), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_0), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_0), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_0), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_0), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_0), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_0), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_0), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_0), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_0), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_0), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_0), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_0), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_0), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_0), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_0), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_0), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_0), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_0), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_0), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_0), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_0), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_0), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_0), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_0), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_0), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_0), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_0), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_0), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_0), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_0), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_0), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_0), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_0), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_0), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_0), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_0), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_0), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_0), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_0), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_0), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_0), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_0), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_0), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_0), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_0), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_0), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_0), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_0), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_0), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_0), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_0), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_0), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_0), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_0), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_0), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_0), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_0), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_0), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_0), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_0), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_0), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_0), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_0), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_0), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_0), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_0), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_0), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_0), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_0), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_0), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_0), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_0), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_0), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_0), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_0), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_0), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_0), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_0), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_0), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_0), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_0), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_0), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_0), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_0), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_0), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_0), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_0), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_0), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_0), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_0), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_0), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_0), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_0), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_0), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_0), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_0), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_0), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_0), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_0), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_0), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_0), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_0), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_0), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_0), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_0), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_0), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_0), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_0), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_0), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_0), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_0), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_0), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_0), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_0), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_0), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_0), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_0), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_0), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_0), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_0), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_0), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_0), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_0), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_0), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_2), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_0), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_2), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_2), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_2), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_2), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_2), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_2), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_2), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_0), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_0), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_0), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_0), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_0), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_0), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_0), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_0), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_0), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_0), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_0), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_0), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_0), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_0), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_0), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_0), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_0), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_0), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_0), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_0), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_0), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_0), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_0), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_0), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_0), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_0), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_0), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_0), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_0), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_0), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_0), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_0), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_0), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_0), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_0), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_0), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_0), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_0), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_0), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_0), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_0), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_0), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_0), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_0), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_0), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_0), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_0), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_0), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_0), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_0), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_0), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_0), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_0), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_0), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_0), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_0), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_0), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_0), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_0), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_0), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_0), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_0), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_0), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_0), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_0), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_0), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_0), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_0), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_0), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_0), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_0), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_0), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_0), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_0), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_0), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_0), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_0), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_0), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_0), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_0), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_0), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_0), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_0), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_0), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_0), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_0), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_0), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_0), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_0), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_0), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_0), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_0), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_0), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_0), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_0), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_0), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_0), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_0), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_0), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_0), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_0), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_0), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_0), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_0), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_0), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_0), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_0), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_0), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_0), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_0), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_0), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_0), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_0), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_0), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_0), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_0), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_0), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_0), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_0), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_0), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_0), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_0), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_0), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_0), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_0), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_0), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_0), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_0), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_0), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_0), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_0), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_0), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_0), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_0), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_0), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_0), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_0), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_0), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_0), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_0), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_0), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_0), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_0), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_0), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_0), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_0), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_0), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_0), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_0), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_0), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_0), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_0), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_0), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_0), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_0), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_0), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_0), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_0), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_0), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_0), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_0), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_0), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_0), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_0), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_0), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_0), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_0), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_0), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_0), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_0), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_0), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_0), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_0), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_0), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_0), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_0), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_0), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_0), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_0), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_0), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_0), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_0), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_0), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_0), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_0), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_0), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_0), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_0), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_0), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_0), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_0), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_0), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_0), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_0), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_0), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_0), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_0), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_0), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_0), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_0), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_0), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_0), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_0), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_0), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_0), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_0), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_0), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_0), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_0), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_0), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_0), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_0), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_0), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_0), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_0), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_0), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_0), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_0), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_0), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_0), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_0), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_0), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_0), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_0), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_0), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_0), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_0), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_0), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_0), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_0), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_0), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_0), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_0), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_0), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_0), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_0), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_0), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_0), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_0), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_0), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_0), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_0), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_0), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_0), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_0), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_0), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_0), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_0), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_0), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_0), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_0), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_0), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_0), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_0), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_0), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_0), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_0), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_0), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_0), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_0), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_0), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_0), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_0), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_0), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_0), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_0), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_0), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_0), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_0), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_0), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_0), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_0), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_0), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_0), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_0), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_0), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_0), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_0), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_0), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_0), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_0), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_0), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_0), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_0), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_0), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_0), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_0), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_0), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_0), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_0), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_0), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_0), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_0), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_0), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_0), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_0), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_0), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_0), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_0), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_0), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_0), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_0), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_0), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_0), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_0), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_0), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_0), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_0), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_0), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_0), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_0), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_0), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_0), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_0), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_0), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_0), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_0), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_0), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_0), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_0), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_0), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_0), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_0), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_0), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_0), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_0), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_0), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_0), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_0), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_0), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_0), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_0), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_0), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_0), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_0), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_0), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_0), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_0), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_0), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_0), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_0), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_0), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_0), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_0), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_0), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_0), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_0), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_0), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_0), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_0), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_0), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_0), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_0), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_0), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_0), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_0), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_0), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_0), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_0), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_0), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_0), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_0), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_0), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_0), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_0), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_0), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_0), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_0), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_0), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_0), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_0), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_0), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_0), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_0), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_2), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_2), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_0), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_0), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_0), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_0), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_0), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_0), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_0), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_0), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_0), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_0), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_0), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_0), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_0), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_0), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_0), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_0), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_0), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_0), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_0), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_0), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_0), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_0), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_0), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_0), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_0), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_0), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_0), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_0), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_0), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_0), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_0), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_0), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_0), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_0), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_0), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_0), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_0), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_0), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_0), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_0), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_0), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_0), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_0), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_0), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_0), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_0), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_0), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_0), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_0), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_0), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_0), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_0), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_0), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_0), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_0), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_0), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_0), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_0), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_0), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_0), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_0), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_0), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_0), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_0), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_0), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_0), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_0), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_0), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_0), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_0), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_0), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_0), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_0), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_0), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_0), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_0), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_0), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_0), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_0), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_0), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_0), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_0), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_0), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_0), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_0), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_0), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_0), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_0), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_0), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_0), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_0), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_0), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_0), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_0), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_0), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_0), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_0), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_0), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_0), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_0), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_0), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_0), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_0), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_0), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_0), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_0), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_0), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_0), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_0), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_0), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_0), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_0), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_0), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_0), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_0), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_0), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_0), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_0), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_0), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_0), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_0), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_0), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_0), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_0), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_0), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_0), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_0), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_0), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_0), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_0), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_0), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_0), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_0), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_0), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_0), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_0), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_0), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_0), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_0), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_0), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_0), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_0), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_0), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_0), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_0), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_0), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_0), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_0), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_0), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_0), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_0), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_0), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_0), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_0), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_0), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_0), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_0), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_0), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_0), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_0), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_0), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_0), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_0), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_0), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_0), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_0), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_0), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_0), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_0), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_0), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_0), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_0), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_0), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_0), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_0), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_0), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_0), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_0), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_0), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_0), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_0), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_0), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_0), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_0), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_0), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_0), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_0), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_0), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_2), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_2), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_0), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_0), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_0), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_0), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_0), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_0), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_0), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_0), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_0), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_0), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_0), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_0), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_0), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_0), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_0), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_0), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_0), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_0), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_0), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_0), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_0), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_0), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_0), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_0), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_0), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_0), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_0), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_0), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_0), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_0), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_0), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_0), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_0), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_0), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_0), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_0), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_0), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_0), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_0), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_0), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_0), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_0), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_0), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_0), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_0), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_0), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_0), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_0), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_0), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_0), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_0), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_0), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_0), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_0), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_0), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_0), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_0), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_0), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_0), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_0), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_0), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_0), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_0), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_0), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_0), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_0), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_0), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_0), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_0), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_0), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_0), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_0), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_0), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_0), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_0), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_0), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_0), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_0), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_0), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_0), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_0), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_0), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_0), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_0), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_0), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_0), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_0), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_0), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_0), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_0), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_0), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_0), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_0), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_0), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_0), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_0), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_0), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_0), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_0), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_0), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_0), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_0), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_0), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_0), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_0), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_0), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_0), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_0), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_0), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_0), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_0), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_0), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_0), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_0), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_0), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_0), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_0), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_0), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_0), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_0), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_0), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_0), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_0), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_0), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_0), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_0), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_0), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_0), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_0), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_0), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_0), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_0), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_0), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_0), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_0), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_0), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_0), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_0), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_0), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_0), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_0), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_0), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_0), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_0), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_0), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_0), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_0), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_0), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_0), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_0), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_0), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_0), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_0), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_0), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_0), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_0), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_0), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_0), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_0), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_0), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_0), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_0), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_0), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_0), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_0), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_0), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_0), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_0), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_0), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_0), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_0), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_0), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_0), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_0), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_0), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_0), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_0), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_0), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_0), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_0), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_0), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_0), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_0), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_0), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_0), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_0), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_0), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f200_0), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_0), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_0), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_0), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_0), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_0), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_0), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_0), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_0), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_0), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_0), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_0), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_0), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_0), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_0), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_0), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_0), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_0), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_0), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_0), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_0), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_0), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_0), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_0), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_0), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_0), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_0), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_0), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_0), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_0), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_0), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_0), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_0), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_0), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_0), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_0), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_0), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_0), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_0), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_0), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_0 */
#ifdef CPUEMU_0
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_4)[] = {
{ CPUFUNC(op_0000_0), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_0), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_0), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_0), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_0), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_4), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_0), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_0), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_0), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_0), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_0), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_0), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_0), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_0), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_4), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_0), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_0), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_0), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_0), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_0), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_0), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_0), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_0), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_4), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_0), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_0), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_0), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_0), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_0), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_0), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_0), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_4), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_0), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_0), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_0), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_4), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_0), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_0), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_0), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_0), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_0), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_0), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_4), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_0), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_0), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_0), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_0), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_0), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_4), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_0), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_0), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_0), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_0), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_4), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_0), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_0), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_0), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_0), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_0), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_0), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_0), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_4), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_0), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_0), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_0), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_0), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_0), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_0), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_0), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_4), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_0), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_0), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_0), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_0), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_0), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_0), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_0), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_4), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_0), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_0), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_0), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_0), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_0), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_0), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_0), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_4), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_0), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_0), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_0), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_0), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_0), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_0), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_0), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_4), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_0), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_0), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_0), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_0), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_0), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_0), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_0), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_4), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_0), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_0), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_0), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_0), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_0), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_0), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_0), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_4), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_0), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_0), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_0), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_0), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_0), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_0), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_0), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_4), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_0), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_0), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_0), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_0), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_0), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_0), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_0), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_4), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_0), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_0), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_0), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_0), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_0), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_0), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_0), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_4), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_0), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_0), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_0), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_4), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_0), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_0), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_0), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_0), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_0), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_4), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_0), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_0), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_0), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_0), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_0), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_4), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_0), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_0), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_0), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_0), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_4), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_0), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_0), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_0), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_0), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_0), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_0), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_0), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_4), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_0), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_0), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_0), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_0), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_0), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_0), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_4), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_0), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_0), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_0), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_0), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_4), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_0), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_0), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_0), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_0), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_0), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_4), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_0), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_0), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_0), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_0), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_0), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_0), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_0), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_4), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_0), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_0), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_0), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_0), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_0), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_4), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_0), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_0), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_0), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_0), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_0), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_4), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_0), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_0), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_0), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_4), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_0), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_0), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_0), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_0), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_4), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_4), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_4), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_4), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_0), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_0), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_0), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_0), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_0), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_4), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_0), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_0), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_0), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_4), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_0), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_0), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_0), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_0), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_0), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_0), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_4), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_0), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_0), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_0), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_4), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_0), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_4), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_4), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_4), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_4), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_4), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_4), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_4), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_4), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_4), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_4), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_4), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_4), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_4), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_4), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_4), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_0), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_0), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_0), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_0), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_0), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_0), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_4), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_0), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_0), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_0), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_4), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_0), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_0), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_4), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_4), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_0), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_0), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_0), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_4), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_4), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_4), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_4), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_0), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_0), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_0), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_0), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_0), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_0), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_4), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_0), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_0), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_0), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_4), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_0), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_0), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_0), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_0), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_0), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_0), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_0), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_4), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_0), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_0), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_0), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_4), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_0), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_4), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_4), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_4), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_4), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_4), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_4), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_4), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_4), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_4), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_4), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_4), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_4), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_4), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_4), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_4), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_4), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_0), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_0), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_0), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_0), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_0), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_0), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_4), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_0), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_0), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_0), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_4), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_0), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_0), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_4), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_4), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_0), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_0), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_0), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_4), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_4), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_4), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_4), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_0), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_0), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_0), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_0), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_0), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_0), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_4), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_0), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_0), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_0), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_4), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_0), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_0), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_0), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_0), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_0), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_0), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_0), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_4), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_0), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_0), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_0), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_4), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_0), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_4), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_4), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_4), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_4), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_4), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_4), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_4), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_4), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_4), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_4), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_4), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_4), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_4), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_4), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_4), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_4), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_0), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_0), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_0), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_0), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_0), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_4), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_0), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_0), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_0), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_0), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_0), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_0), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_0), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_4), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_0), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_0), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_0), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_0), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_0), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_4), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_4), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_0), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_0), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_0), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_0), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_0), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_4), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_0), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_0), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_0), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_4), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_0), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_0), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_0), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_4), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_0), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_0), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_0), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_4), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_0), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_0), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_0), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_0), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_0), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_4), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_0), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_0), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_0), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_0), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_0), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_0), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_0), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_4), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_0), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_0), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_0), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_0), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_0), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_0), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_0), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_4), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_0), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_0), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_0), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_0), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_0), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_0), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_0), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_4), 0x42f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_42f8_0), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_0), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_0), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_0), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_0), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_0), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_0), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_4), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_0), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_0), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_0), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_0), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_0), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_0), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_0), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_4), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_0), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_0), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_0), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_0), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_0), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_0), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_0), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_4), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_0), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_0), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_0), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_4), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_4), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_0), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_0), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_0), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_0), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_4), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_0), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_0), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_0), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_0), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_0), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_0), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_0), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_4), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_0), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_0), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_0), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_0), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_0), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_0), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_0), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_4), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_0), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_0), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_0), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_4), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_4), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_2), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_2), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_2), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_2), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_2), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_4), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_2), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_2), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_0), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_0), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_0), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_4), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_0), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_0), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_0), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_4), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_0), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_0), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_4), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_0), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_4), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_0), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_0), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_0), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_0), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_0), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_4), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_0), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_0), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_0), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_0), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_0), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_0), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_0), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_4), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_0), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_0), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_0), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_0), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_0), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_0), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_0), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_4), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_0), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_0), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_4), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_4), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_4), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_4), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_4), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_4), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_4), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_4), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_0), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_4), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_4), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_4), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_4), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_0), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_0), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_0), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_0), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_0), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_0), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_0), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_0), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_0), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_0), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_4), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_0), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_4), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_4), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_0), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_4), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_0), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_0), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_0), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_0), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_0), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_4), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_0), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_0), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_0), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_0), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_0), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_0), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_0), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_0), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_4), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_0), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_0), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_0), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_0), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_0), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_0), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_0), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_0), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_4), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_0), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_0), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_0), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_0), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_0), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_0), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_0), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_4), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_0), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_0), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_0), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_0), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_0), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_0), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_0), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_4), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_0), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_0), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_0), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_0), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_0), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_0), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_0), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_0), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_4), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_0), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_0), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_0), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_0), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_0), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_0), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_0), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_0), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_4), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_0), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_0), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_0), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_0), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_0), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_0), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_0), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_4), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_0), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_0), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_0), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_0), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_0), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_0), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_0), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_4), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_0), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_0), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_0), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_0), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_0), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_0), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_0), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_4), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_0), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_0), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_0), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_0), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_0), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_0), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_0), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_4), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_0), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_0), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_0), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_0), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_0), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_0), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_0), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_4), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_0), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_0), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_0), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_0), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_0), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_0), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_0), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_4), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_0), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_0), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_0), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_0), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_0), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_0), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_0), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_4), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_0), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_0), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_0), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_0), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_0), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_0), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_0), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_4), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_0), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_0), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_0), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_0), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_0), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_0), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_0), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_4), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_0), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_0), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_0), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_4), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_0), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_0), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_0), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_0), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_0), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_4), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_0), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_4), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_0), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_0), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_0), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_4), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_0), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_0), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_0), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_4), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_0), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_4), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_0), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_0), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_4), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_0), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_0), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_4), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_0), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_0), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_4), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_0), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_0), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_4), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_0), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_0), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_4), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_0), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_0), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_4), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_0), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_0), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_4), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_0), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_0), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_4), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_0), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_0), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_4), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_0), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_0), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_4), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_4), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_4), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_4), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_4), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_4), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_4), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_0), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_0), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_0), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_0), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_0), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_0), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_4), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_0), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_0), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_0), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_4), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_0), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_0), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_0), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_0), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_0), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_0), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_4), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_0), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_0), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_0), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_4), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_0), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_0), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_0), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_0), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_0), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_0), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_4), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_0), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_0), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_0), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_4), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_0), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_0), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_4), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_4), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_2), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_2), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_0), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_0), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_0), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_0), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_4), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_0), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_0), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_0), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_0), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_0), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_0), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_4), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_0), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_0), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_0), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_0), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_0), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_0), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_4), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_0), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_0), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_0), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_4), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_4), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_0), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_0), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_0), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_0), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_0), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_4), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_0), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_0), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_0), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_4), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_0), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_0), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_0), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_0), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_0), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_0), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_0), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_4), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_0), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_0), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_0), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_4), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_0), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_0), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_0), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_0), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_0), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_0), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_0), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_4), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_0), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_0), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_0), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_4), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_0), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_0), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_4), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_4), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_0), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_0), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_0), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_0), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_0), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_0), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_4), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_0), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_0), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_0), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_0), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_0), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_0), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_0), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_0), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_4), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_0), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_0), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_0), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_0), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_0), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_0), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_0), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_0), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_4), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_0), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_0), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_0), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_4), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_4), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_0), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_0), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_0), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_0), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_0), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_4), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_0), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_0), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_0), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_4), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_0), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_0), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_0), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_0), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_0), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_0), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_0), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_4), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_0), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_0), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_0), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_4), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_0), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_0), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_0), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_0), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_0), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_4), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_4), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_4), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_4), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_0), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_0), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_0), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_0), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_0), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_0), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_4), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_0), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_0), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_0), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_0), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_0), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_0), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_0), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_0), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_4), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_0), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_0), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_0), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_0), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_0), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_0), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_4), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_4), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_4), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_0), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_0), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_0), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_0), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_0), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_4), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_0), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_0), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_0), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_4), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_0), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_0), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_0), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_0), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_0), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_0), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_4), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_0), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_0), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_0), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_4), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_0), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_0), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_0), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_0), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_0), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_0), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_4), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_0), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_0), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_0), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_4), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_0), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_0), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_4), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_4), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_2), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_2), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_0), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_0), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_0), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_0), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_4), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_0), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_0), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_0), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_0), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_0), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_0), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_0), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_0), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_4), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_0), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_0), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_0), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_0), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_0), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_0), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_0), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_4), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_0), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_0), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_0), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_4), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_4), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_0), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_0), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_0), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_0), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_0), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_4), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_0), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_0), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_0), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_4), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_0), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_0), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_0), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_0), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_0), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_0), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_0), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_4), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_0), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_0), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_0), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_4), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_0), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_0), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_0), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_0), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_0), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_4), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_4), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_4), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_4), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_0), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_0), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_0), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_0), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_0), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_0), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_4), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_0), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_0), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_0), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_0), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_0), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_0), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_0), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_0), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_4), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_0), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_0), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_0), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_0), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_0), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_0), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_4), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_4), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_4), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_0), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_0), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_0), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_0), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_0), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_0), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_0), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_0), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_0), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_0), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_0), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_0), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_0), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_0), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_0), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_0), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_0), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_0), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_0), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_0), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_4), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_0), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_0), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_0), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_0), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_0), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_0), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_0), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_0), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_0), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_0), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_0), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_0), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_0), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_0), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_0), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_0), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_0), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_0), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_0), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_0), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_4), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_4), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_4), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_4), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_4), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_4), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_4), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_0 */
#ifdef CPUEMU_0
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_5)[] = {
{ CPUFUNC(op_0000_0), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_0), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_0), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_0), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_0), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_4), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_0), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_0), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_0), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_0), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_0), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_0), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_0), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_0), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_4), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_0), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_0), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_0), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_0), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_0), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_0), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_0), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_0), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_4), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_0), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_0), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_0), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_0), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_0), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_0), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_0), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_4), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_0), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_0), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_0), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_4), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_0), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_0), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_0), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_0), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_0), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_0), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_4), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_0), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_0), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_0), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_0), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_0), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_4), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_0), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_0), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_0), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_0), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_4), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_0), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_0), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_0), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_0), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_0), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_0), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_0), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_4), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_0), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_0), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_0), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_0), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_0), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_0), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_0), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_4), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_0), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_0), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_0), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_0), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_0), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_0), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_0), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_4), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_0), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_0), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_0), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_0), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_0), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_0), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_0), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_4), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_0), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_0), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_0), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_0), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_0), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_0), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_0), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_4), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_0), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_0), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_0), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_0), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_0), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_0), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_0), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_4), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_0), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_0), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_0), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_0), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_0), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_0), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_0), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_4), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_0), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_0), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_0), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_0), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_0), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_0), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_0), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_4), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_0), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_0), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_0), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_0), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_0), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_0), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_0), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_4), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_0), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_0), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_0), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_0), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_0), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_0), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_0), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_4), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_0), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_0), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_0), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_4), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_0), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_0), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_0), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_0), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_0), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_4), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_0), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_0), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_0), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_0), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_0), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_4), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_0), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_0), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_0), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_0), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_4), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_0), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_0), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_0), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_0), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_0), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_0), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_0), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_4), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_0), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_0), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_0), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_0), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_0), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_0), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_4), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_0), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_0), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_0), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_0), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_4), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_0), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_0), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_0), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_0), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_0), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_4), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_0), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_0), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_0), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_0), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_0), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_0), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_0), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_4), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_0), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_0), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_0), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_0), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_0), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_4), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_0), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_0), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_0), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_0), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_0), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_4), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_0), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_0), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_0), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_4), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_0), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_0), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_0), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_0), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_4), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_4), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_4), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_4), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_0), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_0), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_0), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_0), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_0), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_4), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_0), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_0), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_0), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_4), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_0), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_0), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_0), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_0), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_0), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_0), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_4), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_0), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_0), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_0), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_4), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_0), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_4), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_4), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_4), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_4), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_4), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_4), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_4), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_4), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_4), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_4), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_4), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_4), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_4), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_4), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_4), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_0), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_0), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_0), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_0), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_0), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_0), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_4), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_0), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_0), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_0), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_4), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_0), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_0), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_4), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_4), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_0), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_0), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_0), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_4), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_4), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_4), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_4), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_0), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_0), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_0), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_0), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_0), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_0), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_4), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_0), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_0), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_0), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_4), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_0), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_0), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_0), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_0), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_0), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_0), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_0), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_4), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_0), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_0), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_0), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_4), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_0), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_4), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_4), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_4), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_4), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_4), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_4), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_4), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_4), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_4), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_4), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_4), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_4), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_4), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_4), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_4), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_4), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_0), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_0), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_0), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_0), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_0), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_0), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_4), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_0), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_0), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_0), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_4), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_0), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_0), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_4), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_4), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_0), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_0), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_0), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_4), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_4), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_4), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_4), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_0), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_0), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_0), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_0), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_0), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_0), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_4), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_0), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_0), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_0), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_4), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_0), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_0), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_0), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_0), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_0), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_0), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_0), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_4), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_0), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_0), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_0), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_4), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_0), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_4), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_4), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_4), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_4), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_4), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_4), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_4), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_4), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_4), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_4), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_4), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_4), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_4), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_4), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_4), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_4), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_0), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_0), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_0), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_0), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_0), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_4), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_0), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_0), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_0), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_0), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_0), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_0), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_0), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_4), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_0), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_0), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_0), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_0), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_0), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_4), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_5), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_5), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_5), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_5), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_5), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_5), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_5), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_5), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_0), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_0), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_0), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_0), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_0), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_4), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_0), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_0), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_0), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_4), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_0), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_0), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_0), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_4), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_0), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_0), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_0), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_4), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_5), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_5), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_5), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_5), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_5), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_5), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_5), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_5), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_5), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_5), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_5), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_5), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_5), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_5), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_5), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_5), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_5), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_5), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_5), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_5), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_5), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_5), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_5), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_5), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4400_0), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_0), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_0), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_0), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_0), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_4), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_0), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_0), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_0), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_0), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_0), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_0), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_0), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_4), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_0), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_0), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_0), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_0), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_0), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_0), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_0), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_4), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_0), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_0), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_0), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_4), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_4), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_0), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_0), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_0), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_0), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_4), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_0), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_0), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_0), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_0), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_0), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_0), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_0), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_4), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_0), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_0), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_0), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_0), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_0), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_0), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_0), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_4), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_0), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_0), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_0), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_4), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_4), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_2), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_2), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_2), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_2), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_2), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_4), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_2), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_2), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_0), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_0), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_0), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_4), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_0), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_0), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_0), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_4), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_0), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_0), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_4), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_0), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_4), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_0), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_0), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_0), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_0), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_0), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_4), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_0), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_0), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_0), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_0), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_0), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_0), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_0), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_4), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_0), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_0), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_0), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_0), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_0), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_0), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_0), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_4), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_0), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_0), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_4), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_4), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_4), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_4), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_4), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_4), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_4), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_4), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_0), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_4), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_4), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_4), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_4), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_0), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_0), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_0), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_5), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e75_0), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_0), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e90_0), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_4), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_0), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_4), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_4), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_0), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_4), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_0), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_0), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_0), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_0), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_0), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_4), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_0), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_0), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_0), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_0), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_0), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_0), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_0), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_0), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_4), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_0), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_0), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_0), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_0), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_0), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_0), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_0), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_0), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_4), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_0), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_0), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_5), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_0), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_5), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_5), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_5), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_5), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_5), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_5), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_5), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_0), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_0), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_0), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_0), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_0), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_4), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_0), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_0), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_0), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_0), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_0), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_0), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_0), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_0), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_4), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_0), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_0), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_0), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_0), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_0), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_0), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_0), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_0), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_4), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_0), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_0), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_5), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_0), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_5), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_5), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_5), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_5), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_5), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_5), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_5), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_5), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_0), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_5), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_5), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_5), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_5), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_5), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_5), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_5), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_5), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_0), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_5), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_5), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_5), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_5), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_5), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_5), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_5), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_5), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_0), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_5), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_5), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_5), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_5), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_5), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_5), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_5), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_5), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_0), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_5), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_5), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_5), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_5), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_5), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_5), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_5), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_5), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_0), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_5), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_5), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_5), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_5), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_5), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_5), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_5), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_5), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_0), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_5), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_5), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_5), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_5), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_5), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_5), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_5), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_5), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_0), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_5), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_5), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_5), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_5), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_5), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_5), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_5), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_5), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_0), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_5), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_5), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_5), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_5), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_5), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_5), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_5), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_5), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_5), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_5), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_5), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_5), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_5), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_5), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_5), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_5), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_5), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_5), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_5), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_5), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_5), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_5), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_5), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_5), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_5), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_5), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_5), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_5), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_5), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_5), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_5), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_5), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_5), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_5), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_5), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_5), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_5), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_5), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_5), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_5), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_5), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_5), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_5), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_5), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_5), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_5), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_5), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_5), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_5), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_5), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_5), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_5), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_5), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_5), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_5), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_0), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_0), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_4), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_0), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_0), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_4), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_0), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_0), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_4), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_0), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_0), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_4), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_0), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_0), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_4), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_0), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_0), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_4), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_0), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_0), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_4), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_0), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_0), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_4), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_0), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_0), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_4), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_0), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_0), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_4), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_4), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_4), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_4), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_4), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_4), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_4), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_0), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_0), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_0), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_0), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_0), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_0), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_4), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_0), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_0), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_0), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_4), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_0), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_0), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_0), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_0), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_0), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_0), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_4), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_0), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_0), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_0), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_4), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_0), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_0), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_0), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_0), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_0), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_0), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_4), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_0), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_0), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_0), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_4), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_0), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_0), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_4), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_4), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_2), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_2), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_0), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_0), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_0), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_0), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_4), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_0), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_0), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_0), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_0), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_0), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_0), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_4), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_0), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_0), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_0), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_0), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_0), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_0), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_4), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_0), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_0), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_0), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_4), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_4), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_0), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_0), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_0), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_0), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_0), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_4), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_0), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_0), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_0), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_4), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_0), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_0), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_0), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_0), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_0), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_0), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_0), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_4), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_0), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_0), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_0), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_4), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_0), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_0), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_0), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_0), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_0), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_0), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_0), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_4), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_0), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_0), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_0), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_4), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_0), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_0), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_4), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_4), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_0), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_0), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_0), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_0), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_0), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_0), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_4), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_0), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_0), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_0), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_0), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_0), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_0), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_0), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_0), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_4), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_0), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_0), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_0), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_0), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_0), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_0), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_0), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_0), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_4), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_0), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_0), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_0), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_4), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_4), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_0), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_0), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_0), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_0), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_0), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_4), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_0), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_0), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_0), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_4), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_0), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_0), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_0), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_0), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_0), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_0), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_0), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_4), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_0), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_0), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_0), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_4), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_0), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_0), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_0), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_0), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_0), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_4), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_4), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_4), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_4), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_0), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_0), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_0), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_0), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_0), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_0), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_4), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_0), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_0), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_0), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_0), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_0), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_0), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_0), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_0), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_4), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_0), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_0), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_0), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_0), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_0), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_0), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_4), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_4), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_4), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_0), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_0), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_0), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_0), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_0), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_4), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_0), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_0), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_0), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_4), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_0), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_0), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_0), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_0), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_0), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_0), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_4), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_0), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_0), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_0), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_4), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_0), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_0), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_0), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_0), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_0), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_0), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_4), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_0), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_0), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_0), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_4), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_0), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_0), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_4), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_4), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_2), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_2), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_0), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_0), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_0), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_0), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_4), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_0), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_0), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_0), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_0), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_0), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_0), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_0), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_0), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_4), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_0), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_0), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_0), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_0), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_0), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_0), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_0), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_4), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_0), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_0), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_0), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_4), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_4), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_0), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_0), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_0), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_0), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_0), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_4), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_0), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_0), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_0), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_4), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_0), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_0), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_0), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_0), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_0), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_0), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_0), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_4), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_0), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_0), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_0), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_4), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_0), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_0), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_0), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_0), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_0), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_4), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_4), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_4), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_4), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_0), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_0), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_0), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_0), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_0), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_0), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_4), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_0), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_0), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_0), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_0), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_0), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_0), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_0), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_0), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_4), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_0), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_0), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_0), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_0), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_0), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_0), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_4), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_4), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_4), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_0), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_0), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_0), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_0), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_0), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_0), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_0), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_0), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_0), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_0), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_0), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_0), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_0), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_0), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_0), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_0), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_0), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_0), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_0), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_0), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_4), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_0), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_0), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_0), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_0), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_0), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_0), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_0), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_0), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_0), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_0), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_0), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_0), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_0), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_0), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_0), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_0), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_0), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_0), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_0), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_0), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_4), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_4), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_4), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_4), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_4), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_4), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_4), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_0 */
#ifdef CPUEMU_11
const struct cputbl CPUFUNC(op_smalltbl_11)[] = {
{ CPUFUNC(op_0000_11), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_11), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_11), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_11), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_11), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_11), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_11), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_11), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_11), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_11), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_11), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_11), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_11), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_11), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_11), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_11), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_11), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_11), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_11), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_11), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_11), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_11), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_11), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_11), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_11), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_11), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_11), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_11), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_11), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_11), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_11), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_11), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_11), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_11), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_11), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_11), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_11), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_11), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_11), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_11), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_11), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_11), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_11), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_11), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_11), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_11), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_11), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_11), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_11), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_11), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_11), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_11), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_11), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_11), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_11), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_11), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_11), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_11), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_11), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_11), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_11), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_11), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_11), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_11), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_11), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_11), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_11), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_11), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_11), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_11), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_11), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_11), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_11), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_11), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_11), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_11), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_11), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_11), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_11), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_11), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_11), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_11), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_11), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_11), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_11), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_11), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_11), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_11), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_11), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_11), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_11), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_11), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_11), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_11), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_11), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_11), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_11), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_11), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_11), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_11), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_11), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_11), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_11), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_11), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_11), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_11), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_11), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_11), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_11), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_11), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_11), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_11), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_11), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_11), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_11), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_11), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_11), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_11), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_11), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_11), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_11), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_11), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_11), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_11), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_11), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_11), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_11), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_11), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_11), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_11), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_11), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_11), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_11), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_11), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_11), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_11), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_11), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_11), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_11), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_11), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_11), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_11), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_11), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_11), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_11), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_11), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_11), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_11), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_11), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_11), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_11), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_11), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_11), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_11), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_11), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_11), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_11), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_11), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_11), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_11), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_11), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_11), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_11), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_11), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_11), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_11), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_11), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_11), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_11), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_11), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_11), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_11), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_11), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_11), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_11), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_11), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_11), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_11), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_11), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_11), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_11), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_11), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_11), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_11), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_11), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_11), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_11), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_11), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_11), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_11), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_11), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_11), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_11), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_11), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_11), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_11), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_11), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_11), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_11), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_11), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_11), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_11), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_11), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_11), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_11), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_11), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_11), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_11), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_11), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_11), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_11), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_11), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_11), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_11), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_11), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_11), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_11), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_11), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_11), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_11), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_11), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_11), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_11), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_11), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_11), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_11), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_11), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_11), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_11), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_11), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_11), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_11), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_11), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_11), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_11), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_11), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_11), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_11), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_11), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_11), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_11), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_11), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_11), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_11), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_11), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_11), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_11), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_11), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_11), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_11), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_11), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_11), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_11), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_11), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_11), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_11), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_11), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_11), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_11), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_11), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_11), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_11), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_11), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_11), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_11), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_11), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_11), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_11), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_11), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_11), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_11), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_11), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_11), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_11), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_11), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_11), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_11), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_11), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_11), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_11), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_11), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_11), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_11), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_11), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_11), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_11), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_11), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_11), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_11), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_11), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_11), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_11), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_11), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_11), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_11), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_11), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_11), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_11), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_11), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_11), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_11), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_11), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_11), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_11), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_11), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_11), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_11), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_11), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_11), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_11), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_11), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_11), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_11), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_11), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_11), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_11), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_11), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_11), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_11), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_11), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_11), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_11), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_11), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_11), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_11), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_11), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_11), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_11), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_11), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_11), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_11), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_11), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_11), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_11), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_11), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_11), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_11), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_11), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_11), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_11), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_11), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_11), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_11), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_11), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_11), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_11), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_11), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_11), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_11), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_11), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_11), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_11), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_11), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_11), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_11), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_11), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_11), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_11), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_11), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_11), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_11), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_11), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_11), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_11), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_11), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_11), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_11), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_11), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_11), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_11), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_11), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_11), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_11), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_11), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_11), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_11), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_11), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_11), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_11), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_11), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_11), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_11), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_11), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_11), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_11), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_11), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_11), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_11), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_11), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_11), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_11), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_11), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_11), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_11), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_11), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_11), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_11), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_11), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_11), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_11), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_11), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_11), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_11), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_11), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_11), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_11), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_11), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_11), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_11), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_11), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_11), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_11), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_11), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_11), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_11), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_11), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_11), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_11), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_11), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_11), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_11), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_11), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_11), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_11), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_11), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_11), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_11), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_11), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_11), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_11), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_11), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_11), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_11), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_11), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_11), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_11), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_11), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_11), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_11), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_11), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_11), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_11), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_11), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_11), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_11), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_11), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_11), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_11), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_11), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_11), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_11), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_11), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_11), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_11), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_11), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_11), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_11), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_11), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_11), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_11), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_11), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_11), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_11), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_11), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_11), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_11), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_11), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_11), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_11), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_11), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_11), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_11), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_11), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_11), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_11), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_11), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_11), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_11), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_11), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_11), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_11), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_11), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_11), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_11), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_11), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_11), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_11), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_11), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_11), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_11), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_11), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_11), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_11), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_11), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_11), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_11), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_11), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_11), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_11), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_11), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_11), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_11), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_11), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_11), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_11), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_11), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_11), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_11), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_11), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_11), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_11), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_11), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_11), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_11), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_11), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_11), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_11), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_11), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_11), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_11), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_11), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_11), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_11), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_11), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_11), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_11), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_11), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_11), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_11), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_11), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_11), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_11), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_11), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_11), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_11), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_11), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_11), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_11), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_11), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_11), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_11), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_11), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_11), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_11), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_11), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_11), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_11), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_11), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_11), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_11), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_11), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_11), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_11), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_11), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_11), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_11), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_11), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_11), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_11), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_11), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_11), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_11), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_11), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_11), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_11), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_11), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_11), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_11), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_11), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_11), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_11), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_11), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_11), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_11), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_11), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_11), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_11), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_11), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_11), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_11), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_11), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_11), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_11), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_11), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_11), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_11), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_11), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_11), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_11), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_11), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_11), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_11), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_11), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_11), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_11), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_11), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_11), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_11), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_11), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_11), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_11), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_11), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_11), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_11), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_11), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_11), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_11), 0x42f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_11), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_11), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_11), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_11), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_11), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_11), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_11), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_11), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_11), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_11), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_11), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_11), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_11), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_11), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_11), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_11), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_11), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_11), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_11), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_11), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_11), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_11), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_11), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_11), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_11), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_11), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_11), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_11), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_11), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_11), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_11), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_11), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_11), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_11), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_11), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_11), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_11), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_11), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_11), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_11), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_11), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_11), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_11), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_11), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_11), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_11), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_11), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_11), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_11), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_11), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_11), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_11), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_11), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_11), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_11), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_11), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_11), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_11), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_11), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_11), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_11), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_11), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_11), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_11), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_11), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_11), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_11), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_11), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_11), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_11), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_11), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_11), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_11), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_11), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_11), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_11), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_11), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_11), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_11), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_11), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_11), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_11), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_11), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_11), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_11), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_11), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_11), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_11), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_11), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_11), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_11), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_11), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_11), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_11), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_11), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_11), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_11), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_11), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_11), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_11), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_11), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_11), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_11), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_11), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_11), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_11), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_11), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_11), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_11), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_11), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_11), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_11), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_11), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_11), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_11), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_11), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_11), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_11), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_11), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_11), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_11), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_11), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_11), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_11), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_11), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_11), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_11), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_11), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_11), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_11), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_11), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_11), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_11), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_11), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_11), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_11), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_11), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_11), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_11), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_11), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_11), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_11), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_11), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_11), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_11), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_11), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_11), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_11), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_11), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_11), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_11), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_11), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_11), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_11), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_11), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_11), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_11), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_11), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_11), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_11), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_11), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_11), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_11), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_11), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_11), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_11), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_11), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_11), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_11), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_11), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_11), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_11), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_11), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_11), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_11), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_11), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_11), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_11), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_11), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_11), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_11), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_11), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_11), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_11), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_11), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_11), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_11), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_11), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_11), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_11), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_11), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_11), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_11), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_11), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_11), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_11), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_11), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_11), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_11), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_11), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_11), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_11), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_11), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_11), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_11), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_11), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_11), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_11), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_11), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_11), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_11), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_11), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_11), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_11), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_11), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_11), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_11), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_11), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_11), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_11), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_11), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_11), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_11), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_11), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_11), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_11), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_11), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_11), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_11), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_11), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_11), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_11), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_11), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_11), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_11), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_11), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_11), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_11), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_11), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_11), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_11), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_11), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_11), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_11), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_11), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_11), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_11), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_11), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_11), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_11), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_11), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_11), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_11), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_11), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_11), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_11), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_11), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_11), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_11), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_11), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_11), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_11), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_11), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_11), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_11), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_11), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_11), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_11), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_11), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_11), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_11), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_11), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_11), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_11), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_11), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_11), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_11), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_11), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_11), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_11), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_11), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_11), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_11), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_11), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_11), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_11), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_11), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_11), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_11), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_11), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_11), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_11), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_11), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_11), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_11), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_11), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_11), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_11), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_11), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_11), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_11), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_11), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_11), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_11), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_11), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_11), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_11), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_11), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_11), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_11), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_11), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_11), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_11), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_11), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_11), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_11), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_11), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_11), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_11), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_11), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_11), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_11), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_11), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_11), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_11), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_11), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_11), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_11), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_11), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_11), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_11), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_11), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_11), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_11), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_11), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_11), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_11), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_11), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_11), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_11), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_11), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_11), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_11), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_11), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_11), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_11), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_11), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_11), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_11), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_11), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_11), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_11), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_11), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_11), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_11), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_11), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_11), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_11), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_11), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_11), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_11), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_11), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_11), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_11), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_11), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_11), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_11), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_11), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_11), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_11), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_11), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_11), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_11), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_11), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_11), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_11), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_11), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_11), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_11), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_11), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_11), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_11), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_11), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_11), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_11), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_11), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_11), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_11), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_11), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_11), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_11), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_11), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_11), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_11), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_11), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_11), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_11), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_11), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_11), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_11), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_11), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_11), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_11), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_11), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_11), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_11), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_11), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_11), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_11), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_11), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_11), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_11), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_11), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_11), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_11), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_11), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_11), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_11), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_11), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_11), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_11), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_11), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_11), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_11), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_11), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_11), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_11), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_11), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_11), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_11), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_11), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_11), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_11), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_11), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_11), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_11), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_11), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_11), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_11), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_11), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_11), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_11), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_11), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_11), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_11), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_11), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_11), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_11), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_11), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_11), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_11), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_11), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_11), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_11), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_11), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_11), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_11), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_11), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_11), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_11), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_11), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_11), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_11), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_11), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_11), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_11), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_11), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_11), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_11), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_11), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_11), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_11), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_11), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_11), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_11), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_11), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_11), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_11), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_11), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_11), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_11), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_11), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_11), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_11), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_11), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_11), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_11), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_11), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_11), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_11), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_11), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_11), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_11), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_11), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_11), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_11), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_11), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_11), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_11), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_11), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_11), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_11), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_11), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_11), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_11), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_11), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_11), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_11), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_11), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_11), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_11), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_11), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_11), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_11), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_11), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_11), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_11), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_11), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_11), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_11), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_11), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_11), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_11), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_11), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_11), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_11), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_11), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_11), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_11), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_11), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_11), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_11), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_11), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_11), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_11), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_11), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_11), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_11), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_11), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_11), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_11), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_11), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_11), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_11), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_11), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_11), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_11), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_11), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_11), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_11), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_11), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_11), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_11), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_11), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_11), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_11), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_11), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_11), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_11), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_11), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_11), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_11), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_11), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_11), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_11), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_11), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_11), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_11), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_11), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_11), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_11), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_11), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_11), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_11), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_11), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_11), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_11), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_11), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_11), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_11), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_11), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_11), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_11), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_11), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_11), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_11), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_11), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_11), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_11), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_11), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_11), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_11), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_11), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_11), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_11), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_11), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_11), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_11), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_11), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_11), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_11), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_11), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_11), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_11), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_11), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_11), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_11), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_11), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_11), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_11), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_11), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_11), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_11), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_11), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_11), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_11), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_11), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_11), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_11), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_11), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_11), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_11), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_11), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_11), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_11), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_11), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_11), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_11), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_11), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_11), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_11), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_11), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_11), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_11), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_11), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_11), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_11), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_11), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_11), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_11), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_11), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_11), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_11), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_11), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_11), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_11), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_11), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_11), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_11), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_11), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_11), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_11), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_11), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_11), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_11), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_11), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_11), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_11), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_11), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_11), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_11), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_11), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_11), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_11), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_11), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_11), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_11), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_11), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_11), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_11), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_11), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_11), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_11), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_11), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_11), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_11), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_11), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_11), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_11), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_11), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_11), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_11), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_11), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_11), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_11), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_11), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_11), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_11), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_11), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_11), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_11), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_11), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_11), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_11), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_11), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_11), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_11), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_11), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_11), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_11), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_11), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_11), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_11), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_11), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_11), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_11), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_11), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_11), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_11), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_11), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_11), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_11), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_11), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_11), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_11), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_11), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_11), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_11), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_11), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_11), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_11), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_11), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_11), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_11), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_11), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_11), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_11), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_11), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_11), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_11), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_11), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_11), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_11), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_11), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_11), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_11), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_11), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_11), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_11), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_11), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_11), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_11), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_11), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_11), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_11), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_11), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_11), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_11), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_11), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_11), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_11), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_11), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_11), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_11), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_11), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_11), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_11), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_11), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_11), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_11), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_11), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_11), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_11), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_11), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_11), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_11), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_11), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_11), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_11), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_11), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_11), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_11), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_11), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_11), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_11), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_11), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_11), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_11), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_11), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_11), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_11), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_11), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_11), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_11), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_11), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_11), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_11), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_11), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_11), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_11), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_11), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_11), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_11), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_11), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_11), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_11), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_11), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_11), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_11), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_11), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_11), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_11), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_11), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_11), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_11), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_11), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_11), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_11), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_11), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_11), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_11), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_11), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_11), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_11), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_11), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_11), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_11), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_11), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_11), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_11), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_11), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_11), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_11), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_11), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_11), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_11), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_11), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_11), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_11), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_11), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_11), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_11), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_11), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_11), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_11), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_11), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_11), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_11), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_11), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_11), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_11), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_11), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_11), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_11), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_11), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_11), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_11), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_11), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_11), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_11), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_11), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_11), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_11), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_11), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_11), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_11), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_11), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_11), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_11), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_11), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_11), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_11), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_11), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_11), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_11), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_11), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_11), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_11), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_11), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_11), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_11), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_11), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_11), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_11), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_11), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_11), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_11), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_11), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_11), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_11), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_11), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_11), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_11), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_11), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_11), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_11), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_11), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_11), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_11), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_11), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_11), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_11), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_11), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_11), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_11), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_11), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_11), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_11), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_11), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_11), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_11), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_11), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_11), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_11), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_11), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_11), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_11), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_11), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_11), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_11), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_11), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_11), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_11), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_11), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_11), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_11), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_11), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_11), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_11), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_11), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_11), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_11), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_11), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_11), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_11), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_11), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_11), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_11), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_11), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_11), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_11), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_11), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_11), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_11), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_11), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_11), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_11), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_11), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_11), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_11), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_11), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_11), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_11), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_11), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_11), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_11 */
#ifdef CPUEMU_11
const struct cputbl CPUFUNC(op_smalltbl_12)[] = {
{ CPUFUNC(op_0000_11), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_11), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_11), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_11), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_11), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_11), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_11), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_11), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_11), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_11), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_11), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_11), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_11), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_11), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_11), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_11), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_11), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_11), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_11), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_11), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_11), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_11), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_11), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_11), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_11), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_11), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_11), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_11), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_11), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_11), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_11), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_11), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_11), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_11), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_11), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_11), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_11), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_11), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_11), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_11), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_11), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_11), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_11), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_11), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_11), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_11), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_11), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_11), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_11), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_11), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_11), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_11), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_11), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_11), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_11), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_11), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_11), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_11), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_11), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_11), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_11), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_11), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_11), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_11), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_11), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_11), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_11), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_11), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_11), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_11), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_11), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_11), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_11), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_11), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_11), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_11), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_11), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_11), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_11), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_11), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_11), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_11), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_11), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_11), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_11), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_11), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_11), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_11), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_11), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_11), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_11), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_11), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_11), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_11), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_11), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_11), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_11), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_11), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_11), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_11), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_11), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_11), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_11), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_11), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_11), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_11), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_11), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_11), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_11), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_11), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_11), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_11), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_11), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_11), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_11), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_11), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_11), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_11), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_11), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_11), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_11), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_11), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_11), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_11), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_11), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_11), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_11), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_11), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_11), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_11), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_11), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_11), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_11), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_11), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_11), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_11), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_11), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_11), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_11), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_11), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_11), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_11), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_11), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_11), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_11), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_11), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_11), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_11), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_11), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_11), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_11), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_11), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_11), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_11), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_11), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_11), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_11), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_11), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_11), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_11), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_11), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_11), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_11), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_11), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_11), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_11), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_11), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_11), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_11), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_11), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_11), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_11), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_11), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_11), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_11), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_11), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_11), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_11), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_11), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_11), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_11), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_11), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_11), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_11), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_11), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_11), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_11), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_11), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_11), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_11), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_11), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_11), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_11), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_11), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_11), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_11), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_11), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_11), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_11), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_11), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_11), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_11), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_11), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_11), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_11), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_11), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_11), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_11), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_11), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_11), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_11), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_11), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_11), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_11), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_11), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_11), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_11), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_11), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_11), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_11), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_11), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_11), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_11), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_11), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_11), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_11), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_11), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_11), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_11), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_11), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_11), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_11), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_11), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_11), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_11), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_11), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_11), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_11), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_11), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_11), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_11), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_11), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_11), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_11), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_11), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_11), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_11), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_11), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_11), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_11), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_11), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_11), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_11), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_11), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_11), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_11), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_11), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_11), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_11), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_11), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_11), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_11), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_11), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_11), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_11), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_11), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_11), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_11), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_11), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_11), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_11), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_11), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_11), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_11), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_11), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_11), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_11), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_11), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_11), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_11), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_11), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_11), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_11), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_11), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_11), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_11), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_11), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_11), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_11), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_11), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_11), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_11), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_11), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_11), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_11), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_11), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_11), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_11), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_11), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_11), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_11), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_11), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_11), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_11), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_11), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_11), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_11), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_11), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_11), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_11), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_11), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_11), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_11), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_11), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_11), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_11), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_11), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_11), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_11), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_11), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_11), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_11), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_11), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_11), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_11), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_11), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_11), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_11), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_11), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_11), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_11), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_11), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_11), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_11), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_11), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_11), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_11), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_11), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_11), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_11), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_11), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_11), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_11), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_11), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_11), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_11), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_11), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_11), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_11), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_11), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_11), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_11), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_11), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_11), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_11), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_11), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_11), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_11), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_11), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_11), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_11), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_11), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_11), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_11), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_11), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_11), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_11), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_11), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_11), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_11), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_11), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_11), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_11), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_11), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_11), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_11), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_11), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_11), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_11), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_11), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_11), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_11), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_11), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_11), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_11), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_11), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_11), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_11), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_11), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_11), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_11), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_11), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_11), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_11), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_11), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_11), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_11), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_11), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_11), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_11), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_11), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_11), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_11), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_11), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_11), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_11), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_11), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_11), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_11), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_11), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_11), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_11), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_11), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_11), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_11), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_11), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_11), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_11), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_11), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_11), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_11), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_11), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_11), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_11), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_11), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_11), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_11), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_11), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_11), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_11), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_11), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_11), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_11), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_11), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_11), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_11), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_11), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_11), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_11), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_11), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_11), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_11), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_11), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_11), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_11), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_11), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_11), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_11), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_11), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_11), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_11), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_11), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_11), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_11), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_11), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_11), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_11), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_11), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_11), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_11), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_11), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_11), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_11), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_11), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_11), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_11), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_11), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_11), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_11), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_11), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_11), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_11), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_11), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_11), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_11), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_11), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_11), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_11), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_11), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_11), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_11), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_11), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_11), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_11), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_11), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_11), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_11), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_11), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_11), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_11), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_11), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_11), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_11), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_11), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_11), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_11), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_11), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_11), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_11), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_11), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_11), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_11), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_11), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_11), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_11), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_11), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_11), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_11), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_11), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_11), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_11), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_11), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_11), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_11), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_11), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_11), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_11), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_11), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_11), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_11), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_11), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_11), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_11), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_11), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_11), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_11), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_11), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_11), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_11), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_11), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_11), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_11), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_11), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_11), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_11), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_11), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_11), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_11), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_11), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_11), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_11), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_11), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_11), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_11), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_11), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_11), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_11), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_11), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_11), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_11), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_11), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_12), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_12), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_12), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_12), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_12), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_12), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_12), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_12), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_11), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_11), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_11), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_11), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_11), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_11), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_11), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_11), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_11), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_11), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_11), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_11), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_11), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_11), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_11), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_11), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_11), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_11), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_12), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_12), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_12), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_12), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_12), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_12), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_12), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_12), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_12), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_12), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_12), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_12), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_12), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_12), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_12), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_12), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_12), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_12), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_12), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_12), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_12), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_12), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_12), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_12), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4400_11), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_11), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_11), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_11), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_11), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_11), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_11), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_11), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_11), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_11), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_11), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_11), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_11), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_11), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_11), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_11), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_11), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_11), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_11), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_11), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_11), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_11), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_11), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_11), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_11), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_11), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_11), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_11), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_11), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_11), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_11), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_11), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_11), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_11), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_11), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_11), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_11), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_11), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_11), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_11), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_11), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_11), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_11), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_11), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_11), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_11), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_11), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_11), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_11), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_11), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_11), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_11), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_11), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_11), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_11), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_11), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_11), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_11), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_11), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_11), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_11), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_11), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_11), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_11), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_11), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_11), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_11), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_11), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_11), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_11), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_11), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_11), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_11), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_11), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_11), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_11), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_11), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_11), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_11), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_11), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_11), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_11), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_11), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_11), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_11), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_11), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_11), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_11), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_11), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_11), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_11), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_11), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_11), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_11), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_11), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_11), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_11), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_11), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_11), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_11), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_11), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_11), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_11), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_11), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_11), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_11), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_11), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_11), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_11), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_11), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_11), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_11), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_11), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_11), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_11), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_11), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_11), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_11), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_11), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_11), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_11), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_11), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_11), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_11), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_11), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_11), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_11), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_11), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_11), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_11), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_11), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_11), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_11), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_11), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_11), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_11), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_11), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_11), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_11), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_11), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_11), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_11), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_11), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_11), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_11), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_11), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_11), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_11), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_11), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_11), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_11), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_11), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_11), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_11), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_11), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_11), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_12), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e75_11), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_11), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_11), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e90_11), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_11), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_11), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_11), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_11), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_11), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_11), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_11), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_11), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_11), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_11), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_11), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_11), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_11), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_11), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_11), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_11), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_11), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_11), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_11), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_11), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_11), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_11), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_11), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_11), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_11), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_11), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_11), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_11), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_11), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_11), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_11), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_11), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_11), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_11), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_11), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_11), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_11), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_11), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_11), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_12), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_11), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_12), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_12), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_12), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_12), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_12), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_12), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_12), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_11), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_11), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_11), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_11), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_11), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_11), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_11), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_11), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_11), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_11), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_11), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_11), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_11), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_11), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_11), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_11), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_11), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_11), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_11), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_11), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_11), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_11), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_11), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_11), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_11), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_11), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_12), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_11), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_12), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_12), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_12), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_12), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_12), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_12), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_12), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_12), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_11), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_12), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_12), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_12), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_12), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_12), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_12), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_12), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_12), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_11), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_12), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_12), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_12), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_12), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_12), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_12), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_12), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_12), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_11), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_12), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_12), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_12), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_12), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_12), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_12), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_12), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_12), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_11), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_12), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_12), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_12), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_12), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_12), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_12), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_12), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_12), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_11), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_12), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_12), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_12), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_12), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_12), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_12), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_12), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_12), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_11), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_12), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_12), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_12), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_12), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_12), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_12), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_12), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_12), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_11), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_12), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_12), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_12), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_12), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_12), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_12), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_12), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_12), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_11), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_12), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_12), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_12), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_12), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_12), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_12), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_12), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_12), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_11), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_12), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_12), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_12), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_12), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_12), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_12), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_12), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_12), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_11), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_12), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_12), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_12), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_12), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_12), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_12), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_12), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_12), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_11), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_12), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_12), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_12), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_12), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_12), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_12), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_12), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_12), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_11), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_12), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_12), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_12), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_12), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_12), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_12), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_12), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_12), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_11), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_12), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_12), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_12), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_12), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_12), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_12), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_12), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_12), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_11), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_12), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_12), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_12), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_12), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_12), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_12), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_12), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_11), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_11), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_11), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_11), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_11), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_11), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_11), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_11), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_11), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_11), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_11), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_11), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_11), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_11), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_11), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_11), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_11), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_11), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_11), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_11), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_11), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_11), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_11), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_11), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_11), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_11), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_11), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_11), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_11), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_11), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_11), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_11), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_11), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_11), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_11), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_11), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_11), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_11), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_11), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_11), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_11), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_11), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_11), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_11), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_11), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_11), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_11), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_11), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_11), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_11), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_11), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_11), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_11), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_11), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_11), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_11), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_11), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_11), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_11), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_11), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_11), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_11), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_11), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_11), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_11), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_11), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_11), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_11), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_11), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_11), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_11), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_11), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_11), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_11), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_11), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_11), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_11), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_11), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_11), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_11), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_11), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_11), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_11), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_11), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_11), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_11), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_11), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_11), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_11), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_11), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_11), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_11), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_11), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_11), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_11), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_11), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_11), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_11), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_11), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_11), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_11), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_11), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_11), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_11), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_11), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_11), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_11), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_11), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_11), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_11), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_11), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_11), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_11), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_11), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_11), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_11), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_11), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_11), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_11), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_11), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_11), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_11), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_11), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_11), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_11), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_11), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_11), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_11), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_11), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_11), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_11), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_11), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_11), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_11), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_11), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_11), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_11), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_11), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_11), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_11), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_11), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_11), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_11), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_11), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_11), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_11), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_11), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_11), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_11), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_11), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_11), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_11), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_11), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_11), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_11), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_11), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_11), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_11), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_11), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_11), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_11), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_11), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_11), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_11), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_11), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_11), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_11), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_11), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_11), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_11), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_11), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_11), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_11), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_11), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_11), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_11), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_11), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_11), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_11), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_11), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_11), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_11), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_11), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_11), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_11), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_11), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_11), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_11), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_11), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_11), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_11), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_11), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_11), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_11), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_11), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_11), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_11), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_11), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_11), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_11), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_11), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_11), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_11), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_11), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_11), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_11), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_11), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_11), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_11), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_11), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_11), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_11), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_11), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_11), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_11), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_11), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_11), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_11), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_11), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_11), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_11), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_11), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_11), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_11), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_11), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_11), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_11), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_11), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_11), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_11), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_11), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_11), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_11), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_11), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_11), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_11), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_11), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_11), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_11), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_11), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_11), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_11), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_11), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_11), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_11), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_11), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_11), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_11), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_11), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_11), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_11), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_11), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_11), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_11), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_11), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_11), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_11), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_11), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_11), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_11), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_11), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_11), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_11), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_11), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_11), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_11), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_11), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_11), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_11), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_11), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_11), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_11), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_11), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_11), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_11), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_11), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_11), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_11), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_11), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_11), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_11), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_11), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_11), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_11), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_11), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_11), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_11), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_11), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_11), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_11), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_11), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_11), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_11), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_11), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_11), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_11), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_11), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_11), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_11), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_11), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_11), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_11), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_11), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_11), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_11), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_11), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_11), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_11), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_11), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_11), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_11), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_11), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_11), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_11), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_11), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_11), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_11), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_11), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_11), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_11), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_11), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_11), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_11), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_11), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_11), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_11), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_11), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_11), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_11), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_11), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_11), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_11), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_11), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_11), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_11), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_11), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_11), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_11), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_11), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_11), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_11), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_11), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_11), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_11), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_11), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_11), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_11), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_11), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_11), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_11), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_11), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_11), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_11), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_11), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_11), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_11), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_11), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_11), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_11), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_11), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_11), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_11), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_11), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_11), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_11), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_11), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_11), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_11), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_11), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_11), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_11), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_11), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_11), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_11), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_11), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_11), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_11), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_11), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_11), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_11), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_11), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_11), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_11), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_11), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_11), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_11), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_11), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_11), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_11), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_11), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_11), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_11), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_11), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_11), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_11), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_11), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_11), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_11), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_11), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_11), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_11), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_11), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_11), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_11), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_11), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_11), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_11), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_11), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_11), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_11), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_11), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_11), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_11), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_11), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_11), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_11), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_11), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_11), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_11), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_11), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_11), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_11), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_11), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_11), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_11), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_11), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_11), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_11), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_11), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_11), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_11), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_11), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_11), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_11), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_11), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_11), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_11), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_11), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_11), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_11), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_11), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_11), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_11), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_11), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_11), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_11), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_11), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_11), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_11), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_11), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_11), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_11), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_11), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_11), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_11), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_11), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_11), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_11), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_11), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_11), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_11), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_11), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_11), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_11), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_11), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_11), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_11), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_11), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_11), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_11), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_11), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_11), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_11), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_11), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_11), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_11), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_11), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_11), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_11), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_11), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_11), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_11), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_11), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_11), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_11), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_11), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_11), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_11), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_11), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_11), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_11), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_11), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_11), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_11), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_11), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_11), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_11), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_11), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_11), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_11), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_11), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_11), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_11), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_11), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_11), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_11), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_11), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_11), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_11), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_11), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_11), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_11), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_11), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_11), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_11), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_11), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_11), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_11), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_11), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_11), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_11), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_11), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_11), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_11), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_11), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_11), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_11), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_11), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_11), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_11), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_11), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_11), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_11), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_11), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_11), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_11), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_11), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_11), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_11), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_11), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_11), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_11), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_11), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_11), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_11), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_11), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_11), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_11), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_11), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_11), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_11), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_11), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_11), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_11), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_11), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_11), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_11), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_11), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_11), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_11), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_11), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_11), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_11), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_11), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_11), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_11), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_11), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_11), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_11), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_11), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_11 */
#ifdef CPUEMU_13
const struct cputbl CPUFUNC(op_smalltbl_13)[] = {
{ (cpuop_func*)CPUFUNC(op_0000_13), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0010_13), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0018_13), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0020_13), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0028_13), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0030_13), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0038_13), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0039_13), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_003c_13), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0040_13), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0050_13), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0058_13), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0060_13), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0068_13), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0070_13), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0078_13), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0079_13), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_007c_13), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0080_13), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0090_13), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0098_13), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a0_13), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a8_13), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b0_13), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b8_13), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b9_13), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0100_13), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0108_13), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0110_13), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0118_13), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0120_13), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0128_13), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0130_13), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0138_13), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0139_13), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013a_13), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013b_13), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013c_13), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0140_13), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0148_13), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0150_13), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0158_13), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0160_13), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0168_13), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0170_13), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0178_13), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0179_13), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0180_13), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0188_13), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_0190_13), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0198_13), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a0_13), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a8_13), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b0_13), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b8_13), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b9_13), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01c0_13), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01c8_13), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_01d0_13), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01d8_13), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e0_13), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e8_13), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f0_13), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f8_13), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f9_13), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0200_13), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0210_13), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0218_13), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0220_13), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0228_13), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0230_13), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0238_13), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0239_13), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_023c_13), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0240_13), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0250_13), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0258_13), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0260_13), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0268_13), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0270_13), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0278_13), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0279_13), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_027c_13), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0280_13), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0290_13), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0298_13), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a0_13), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a8_13), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b0_13), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b8_13), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b9_13), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0400_13), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0410_13), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0418_13), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0420_13), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0428_13), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0430_13), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0438_13), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0439_13), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0440_13), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0450_13), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0458_13), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0460_13), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0468_13), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0470_13), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0478_13), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0479_13), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0480_13), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0490_13), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0498_13), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a0_13), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a8_13), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b0_13), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b8_13), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b9_13), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0600_13), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0610_13), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0618_13), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0620_13), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0628_13), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0630_13), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0638_13), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0639_13), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0640_13), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0650_13), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0658_13), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0660_13), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0668_13), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0670_13), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0678_13), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0679_13), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0680_13), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0690_13), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0698_13), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a0_13), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a8_13), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b0_13), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b8_13), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b9_13), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0800_13), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0810_13), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0818_13), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0820_13), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0828_13), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0830_13), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0838_13), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0839_13), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083a_13), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083b_13), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0840_13), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0850_13), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0858_13), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0860_13), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0868_13), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0870_13), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0878_13), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0879_13), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0880_13), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0890_13), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0898_13), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a0_13), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a8_13), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b0_13), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b8_13), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b9_13), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08c0_13), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d0_13), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d8_13), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e0_13), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e8_13), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f0_13), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f8_13), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f9_13), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0a00_13), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a10_13), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a18_13), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a20_13), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a28_13), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a30_13), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a38_13), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a39_13), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a3c_13), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a40_13), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a50_13), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a58_13), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a60_13), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a68_13), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a70_13), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a78_13), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a79_13), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a7c_13), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a80_13), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a90_13), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a98_13), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa0_13), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa8_13), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab0_13), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab8_13), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab9_13), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0c00_13), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c10_13), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c18_13), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c20_13), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c28_13), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c30_13), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c38_13), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c39_13), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c40_13), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c50_13), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c58_13), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c60_13), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c68_13), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c70_13), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c78_13), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c79_13), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c80_13), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c90_13), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c98_13), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca0_13), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca8_13), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb0_13), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb8_13), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb9_13), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_1000_13), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1010_13), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1018_13), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1020_13), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1028_13), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1030_13), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1038_13), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1039_13), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103a_13), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103b_13), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103c_13), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1080_13), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1090_13), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1098_13), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a0_13), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a8_13), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b0_13), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b8_13), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b9_13), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10ba_13), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bb_13), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bc_13), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10c0_13), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d0_13), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d8_13), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e0_13), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e8_13), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f0_13), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f8_13), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f9_13), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fa_13), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fb_13), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fc_13), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1100_13), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1110_13), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1118_13), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1120_13), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1128_13), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1130_13), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1138_13), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1139_13), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113a_13), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113b_13), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113c_13), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1140_13), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1150_13), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1158_13), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1160_13), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1168_13), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1170_13), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1178_13), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1179_13), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117a_13), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117b_13), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117c_13), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1180_13), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1190_13), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1198_13), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a0_13), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a8_13), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b0_13), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b8_13), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b9_13), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11ba_13), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bb_13), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bc_13), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11c0_13), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d0_13), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d8_13), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e0_13), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e8_13), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f0_13), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f8_13), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f9_13), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fa_13), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fb_13), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fc_13), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13c0_13), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d0_13), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d8_13), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e0_13), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e8_13), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f0_13), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f8_13), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f9_13), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fa_13), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fb_13), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fc_13), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2000_13), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2008_13), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2010_13), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2018_13), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2020_13), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2028_13), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2030_13), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2038_13), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2039_13), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203a_13), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203b_13), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203c_13), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2040_13), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2048_13), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2050_13), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2058_13), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2060_13), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2068_13), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2070_13), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2078_13), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2079_13), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207a_13), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207b_13), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207c_13), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2080_13), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2088_13), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2090_13), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2098_13), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a0_13), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a8_13), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b0_13), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b8_13), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b9_13), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20ba_13), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bb_13), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bc_13), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c0_13), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c8_13), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d0_13), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d8_13), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e0_13), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e8_13), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f0_13), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f8_13), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f9_13), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fa_13), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fb_13), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fc_13), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2100_13), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2108_13), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2110_13), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2118_13), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2120_13), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2128_13), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2130_13), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2138_13), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2139_13), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213a_13), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213b_13), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213c_13), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2140_13), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2148_13), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2150_13), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2158_13), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2160_13), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2168_13), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2170_13), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2178_13), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2179_13), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217a_13), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217b_13), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217c_13), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2180_13), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2188_13), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2190_13), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2198_13), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a0_13), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a8_13), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b0_13), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b8_13), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b9_13), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21ba_13), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bb_13), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bc_13), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c0_13), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c8_13), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d0_13), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d8_13), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e0_13), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e8_13), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f0_13), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f8_13), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f9_13), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fa_13), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fb_13), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fc_13), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c0_13), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c8_13), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d0_13), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d8_13), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e0_13), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e8_13), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f0_13), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f8_13), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f9_13), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fa_13), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fb_13), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fc_13), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3000_13), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3008_13), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3010_13), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3018_13), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3020_13), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3028_13), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3030_13), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3038_13), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3039_13), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303a_13), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303b_13), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303c_13), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3040_13), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3048_13), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3050_13), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3058_13), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3060_13), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3068_13), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3070_13), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3078_13), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3079_13), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307a_13), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307b_13), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307c_13), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3080_13), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3088_13), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3090_13), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3098_13), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a0_13), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a8_13), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b0_13), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b8_13), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b9_13), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30ba_13), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bb_13), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bc_13), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c0_13), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c8_13), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d0_13), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d8_13), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e0_13), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e8_13), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f0_13), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f8_13), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f9_13), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fa_13), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fb_13), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fc_13), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3100_13), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3108_13), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3110_13), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3118_13), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3120_13), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3128_13), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3130_13), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3138_13), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3139_13), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313a_13), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313b_13), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313c_13), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3140_13), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3148_13), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3150_13), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3158_13), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3160_13), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3168_13), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3170_13), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3178_13), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3179_13), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317a_13), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317b_13), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317c_13), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3180_13), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3188_13), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3190_13), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3198_13), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a0_13), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a8_13), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b0_13), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b8_13), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b9_13), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31ba_13), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bb_13), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bc_13), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c0_13), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c8_13), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d0_13), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d8_13), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e0_13), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e8_13), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f0_13), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f8_13), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f9_13), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fa_13), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fb_13), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fc_13), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c0_13), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c8_13), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d0_13), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d8_13), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e0_13), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e8_13), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f0_13), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f8_13), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f9_13), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fa_13), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fb_13), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fc_13), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_4000_13), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4010_13), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4018_13), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4020_13), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4028_13), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4030_13), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4038_13), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4039_13), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4040_13), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4050_13), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4058_13), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4060_13), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4068_13), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4070_13), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4078_13), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4079_13), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4080_13), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4090_13), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4098_13), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a0_13), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a8_13), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b0_13), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b8_13), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b9_13), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40c0_13), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d0_13), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d8_13), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e0_13), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e8_13), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f0_13), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f8_13), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f9_13), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_4180_13), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4190_13), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4198_13), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a0_13), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a8_13), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b0_13), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b8_13), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b9_13), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41ba_13), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bb_13), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bc_13), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41d0_13), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41e8_13), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f0_13), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f8_13), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f9_13), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fa_13), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fb_13), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_4200_13), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4210_13), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4218_13), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4220_13), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4228_13), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4230_13), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4238_13), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4239_13), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4240_13), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4250_13), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4258_13), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4260_13), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4268_13), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4270_13), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4278_13), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4279_13), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4280_13), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4290_13), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4298_13), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a0_13), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a8_13), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b0_13), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b8_13), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b9_13), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42c0_13), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42d0_13), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42d8_13), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42e0_13), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42e8_13), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f0_13), 0x42f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f8_13), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f9_13), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ (cpuop_func*)CPUFUNC(op_4400_13), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4410_13), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4418_13), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4420_13), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4428_13), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4430_13), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4438_13), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4439_13), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4440_13), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4450_13), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4458_13), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4460_13), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4468_13), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4470_13), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4478_13), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4479_13), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4480_13), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4490_13), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4498_13), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a0_13), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a8_13), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b0_13), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b8_13), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b9_13), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44c0_13), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d0_13), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d8_13), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e0_13), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e8_13), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f0_13), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f8_13), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f9_13), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fa_13), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fb_13), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fc_13), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4600_13), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4610_13), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4618_13), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4620_13), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4628_13), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4630_13), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4638_13), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4639_13), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4640_13), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4650_13), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4658_13), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4660_13), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4668_13), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4670_13), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4678_13), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4679_13), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4680_13), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4690_13), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4698_13), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a0_13), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a8_13), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b0_13), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b8_13), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b9_13), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46c0_13), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d0_13), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d8_13), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e0_13), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e8_13), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f0_13), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f8_13), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f9_13), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fa_13), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fb_13), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fc_13), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4800_13), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4810_13), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4818_13), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4820_13), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4828_13), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4830_13), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4838_13), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4839_13), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4840_13), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ (cpuop_func*)CPUFUNC(op_4850_13), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4868_13), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4870_13), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4878_13), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4879_13), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487a_13), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487b_13), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4880_13), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_4890_13), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a0_13), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a8_13), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b0_13), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b8_13), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b9_13), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48c0_13), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_48d0_13), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e0_13), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e8_13), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f0_13), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f8_13), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f9_13), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_4a00_13), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a10_13), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a18_13), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a20_13), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a28_13), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a30_13), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a38_13), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a39_13), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a40_13), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a50_13), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a58_13), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a60_13), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a68_13), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a70_13), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a78_13), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a79_13), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a80_13), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a90_13), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a98_13), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa0_13), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa8_13), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab0_13), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab8_13), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab9_13), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ac0_13), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad0_13), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad8_13), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae0_13), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae8_13), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af0_13), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af8_13), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af9_13), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4c90_13), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4c98_13), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ca8_13), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb0_13), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb8_13), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb9_13), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cba_13), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cbb_13), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd0_13), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd8_13), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ce8_13), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf0_13), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf8_13), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf9_13), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfa_13), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfb_13), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4e40_13), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ (cpuop_func*)CPUFUNC(op_4e50_13), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ (cpuop_func*)CPUFUNC(op_4e58_13), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ (cpuop_func*)CPUFUNC(op_4e60_13), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ (cpuop_func*)CPUFUNC(op_4e68_13), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ (cpuop_func*)CPUFUNC(op_4e70_13), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ (cpuop_func*)CPUFUNC(op_4e71_13), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ (cpuop_func*)CPUFUNC(op_4e72_13), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ (cpuop_func*)CPUFUNC(op_4e73_13), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e74_13), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ (cpuop_func*)CPUFUNC(op_4e75_13), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ (cpuop_func*)CPUFUNC(op_4e76_13), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ (cpuop_func*)CPUFUNC(op_4e77_13), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e7a_13), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e7b_13), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ (cpuop_func*)CPUFUNC(op_4e90_13), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ea8_13), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb0_13), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb8_13), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb9_13), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eba_13), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ebb_13), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ed0_13), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ee8_13), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef0_13), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef8_13), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef9_13), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efa_13), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efb_13), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_5000_13), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5010_13), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5018_13), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5020_13), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5028_13), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5030_13), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5038_13), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5039_13), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5040_13), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5048_13), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5050_13), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5058_13), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5060_13), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5068_13), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5070_13), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5078_13), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5079_13), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5080_13), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5088_13), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5090_13), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5098_13), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a0_13), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a8_13), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b0_13), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b8_13), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b9_13), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50c0_13), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50c8_13), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_50d0_13), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50d8_13), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e0_13), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e8_13), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f0_13), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f8_13), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f9_13), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5100_13), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5110_13), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5118_13), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5120_13), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5128_13), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5130_13), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5138_13), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5139_13), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5140_13), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5148_13), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5150_13), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5158_13), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5160_13), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5168_13), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5170_13), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5178_13), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5179_13), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5180_13), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5188_13), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5190_13), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5198_13), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a0_13), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a8_13), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b0_13), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b8_13), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b9_13), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51c0_13), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51c8_13), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_51d0_13), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51d8_13), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e0_13), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e8_13), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f0_13), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f8_13), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f9_13), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52c0_13), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52c8_13), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_52d0_13), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52d8_13), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e0_13), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e8_13), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f0_13), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f8_13), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f9_13), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53c0_13), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53c8_13), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_53d0_13), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53d8_13), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e0_13), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e8_13), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f0_13), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f8_13), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f9_13), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54c0_13), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54c8_13), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_54d0_13), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54d8_13), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e0_13), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e8_13), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f0_13), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f8_13), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f9_13), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55c0_13), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55c8_13), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_55d0_13), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55d8_13), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e0_13), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e8_13), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f0_13), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f8_13), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f9_13), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56c0_13), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56c8_13), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_56d0_13), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56d8_13), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e0_13), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e8_13), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f0_13), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f8_13), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f9_13), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57c0_13), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57c8_13), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_57d0_13), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57d8_13), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e0_13), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e8_13), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f0_13), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f8_13), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f9_13), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58c0_13), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58c8_13), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_58d0_13), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58d8_13), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e0_13), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e8_13), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f0_13), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f8_13), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f9_13), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59c0_13), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59c8_13), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_59d0_13), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59d8_13), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e0_13), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e8_13), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f0_13), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f8_13), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f9_13), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ac0_13), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ac8_13), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ad0_13), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ad8_13), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae0_13), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae8_13), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af0_13), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af8_13), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af9_13), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bc0_13), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bc8_13), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5bd0_13), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bd8_13), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be0_13), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be8_13), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf0_13), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf8_13), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf9_13), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cc0_13), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cc8_13), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5cd0_13), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cd8_13), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce0_13), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce8_13), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf0_13), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf8_13), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf9_13), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dc0_13), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dc8_13), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5dd0_13), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dd8_13), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de0_13), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de8_13), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df0_13), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df8_13), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df9_13), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ec0_13), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ec8_13), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ed0_13), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ed8_13), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee0_13), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee8_13), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef0_13), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef8_13), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef9_13), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fc0_13), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fc8_13), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5fd0_13), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fd8_13), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe0_13), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe8_13), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff0_13), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff8_13), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff9_13), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_6000_13), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6001_13), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_60ff_13), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6100_13), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6101_13), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_61ff_13), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6200_13), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6201_13), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_62ff_13), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6300_13), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6301_13), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_63ff_13), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6400_13), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6401_13), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_64ff_13), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6500_13), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6501_13), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_65ff_13), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6600_13), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6601_13), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_66ff_13), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6700_13), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6701_13), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_67ff_13), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6800_13), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6801_13), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_68ff_13), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6900_13), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6901_13), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_69ff_13), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a00_13), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a01_13), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6aff_13), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b00_13), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b01_13), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6bff_13), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c00_13), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c01_13), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6cff_13), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d00_13), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d01_13), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6dff_13), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e00_13), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e01_13), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6eff_13), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f00_13), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f01_13), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6fff_13), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_7000_13), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_8000_13), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8010_13), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8018_13), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8020_13), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8028_13), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8030_13), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8038_13), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8039_13), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803a_13), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803b_13), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803c_13), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8040_13), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8050_13), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8058_13), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8060_13), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8068_13), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8070_13), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8078_13), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8079_13), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807a_13), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807b_13), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807c_13), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8080_13), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8090_13), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8098_13), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a0_13), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a8_13), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b0_13), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b8_13), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b9_13), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80ba_13), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bb_13), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bc_13), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80c0_13), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d0_13), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d8_13), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e0_13), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e8_13), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f0_13), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f8_13), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f9_13), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fa_13), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fb_13), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fc_13), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_8100_13), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8108_13), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8110_13), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8118_13), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8120_13), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8128_13), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8130_13), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8138_13), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8139_13), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8150_13), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8158_13), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8160_13), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8168_13), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8170_13), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8178_13), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8179_13), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8190_13), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8198_13), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a0_13), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a8_13), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b0_13), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b8_13), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b9_13), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81c0_13), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d0_13), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d8_13), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e0_13), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e8_13), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f0_13), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f8_13), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f9_13), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fa_13), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fb_13), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fc_13), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_9000_13), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9010_13), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9018_13), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9020_13), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9028_13), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9030_13), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9038_13), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9039_13), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903a_13), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903b_13), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903c_13), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9040_13), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9048_13), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9050_13), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9058_13), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9060_13), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9068_13), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9070_13), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9078_13), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9079_13), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907a_13), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907b_13), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907c_13), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9080_13), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9088_13), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9090_13), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9098_13), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a0_13), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a8_13), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b0_13), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b8_13), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b9_13), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90ba_13), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bb_13), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bc_13), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90c0_13), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90c8_13), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d0_13), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d8_13), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e0_13), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e8_13), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f0_13), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f8_13), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f9_13), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fa_13), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fb_13), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fc_13), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_9100_13), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9108_13), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9110_13), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9118_13), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9120_13), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9128_13), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9130_13), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9138_13), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9139_13), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9140_13), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9148_13), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9150_13), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9158_13), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9160_13), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9168_13), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9170_13), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9178_13), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9179_13), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9180_13), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9188_13), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9190_13), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9198_13), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a0_13), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a8_13), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b0_13), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b8_13), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b9_13), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91c0_13), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91c8_13), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d0_13), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d8_13), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e0_13), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e8_13), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f0_13), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f8_13), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f9_13), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fa_13), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fb_13), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fc_13), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_b000_13), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b010_13), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b018_13), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b020_13), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b028_13), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b030_13), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b038_13), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b039_13), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03a_13), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03b_13), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03c_13), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b040_13), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b048_13), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b050_13), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b058_13), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b060_13), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b068_13), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b070_13), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b078_13), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b079_13), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07a_13), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07b_13), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07c_13), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b080_13), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b088_13), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b090_13), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b098_13), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a0_13), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a8_13), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b0_13), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b8_13), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b9_13), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0ba_13), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bb_13), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bc_13), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0c0_13), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0c8_13), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d0_13), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d8_13), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e0_13), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e8_13), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f0_13), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f8_13), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f9_13), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fa_13), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fb_13), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fc_13), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b100_13), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b108_13), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b110_13), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b118_13), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b120_13), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b128_13), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b130_13), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b138_13), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b139_13), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b140_13), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b148_13), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b150_13), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b158_13), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b160_13), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b168_13), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b170_13), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b178_13), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b179_13), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b180_13), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b188_13), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b190_13), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b198_13), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a0_13), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a8_13), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b0_13), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b8_13), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b9_13), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1c0_13), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1c8_13), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d0_13), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d8_13), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e0_13), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e8_13), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f0_13), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f8_13), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f9_13), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fa_13), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fb_13), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fc_13), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_c000_13), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c010_13), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c018_13), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c020_13), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c028_13), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c030_13), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c038_13), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c039_13), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03a_13), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03b_13), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03c_13), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c040_13), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c050_13), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c058_13), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c060_13), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c068_13), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c070_13), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c078_13), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c079_13), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07a_13), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07b_13), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07c_13), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c080_13), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c090_13), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c098_13), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a0_13), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a8_13), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b0_13), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b8_13), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b9_13), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0ba_13), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bb_13), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bc_13), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0c0_13), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d0_13), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d8_13), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e0_13), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e8_13), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f0_13), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f8_13), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f9_13), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fa_13), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fb_13), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fc_13), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c100_13), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c108_13), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c110_13), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c118_13), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c120_13), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c128_13), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c130_13), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c138_13), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c139_13), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c140_13), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c148_13), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c150_13), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c158_13), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c160_13), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c168_13), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c170_13), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c178_13), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c179_13), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c188_13), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c190_13), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c198_13), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a0_13), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a8_13), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b0_13), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b8_13), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b9_13), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1c0_13), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d0_13), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d8_13), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e0_13), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e8_13), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f0_13), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f8_13), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f9_13), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fa_13), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fb_13), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fc_13), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_d000_13), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d010_13), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d018_13), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d020_13), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d028_13), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d030_13), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d038_13), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d039_13), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03a_13), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03b_13), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03c_13), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d040_13), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d048_13), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d050_13), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d058_13), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d060_13), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d068_13), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d070_13), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d078_13), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d079_13), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07a_13), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07b_13), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07c_13), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d080_13), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d088_13), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d090_13), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d098_13), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a0_13), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a8_13), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b0_13), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b8_13), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b9_13), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0ba_13), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bb_13), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bc_13), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0c0_13), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0c8_13), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d0_13), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d8_13), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e0_13), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e8_13), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f0_13), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f8_13), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f9_13), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fa_13), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fb_13), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fc_13), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d100_13), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d108_13), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d110_13), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d118_13), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d120_13), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d128_13), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d130_13), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d138_13), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d139_13), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d140_13), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d148_13), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d150_13), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d158_13), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d160_13), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d168_13), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d170_13), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d178_13), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d179_13), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d180_13), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d188_13), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d190_13), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d198_13), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a0_13), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a8_13), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b0_13), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b8_13), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b9_13), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1c0_13), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1c8_13), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d0_13), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d8_13), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e0_13), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e8_13), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f0_13), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f8_13), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f9_13), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fa_13), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fb_13), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fc_13), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_e000_13), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e008_13), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e010_13), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e018_13), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e020_13), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e028_13), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e030_13), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e038_13), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e040_13), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e048_13), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e050_13), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e058_13), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e060_13), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e068_13), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e070_13), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e078_13), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e080_13), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e088_13), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e090_13), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e098_13), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0a0_13), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e0a8_13), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e0b0_13), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e0b8_13), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0d0_13), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0d8_13), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e0_13), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e8_13), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f0_13), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f8_13), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f9_13), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e100_13), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e108_13), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e110_13), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e118_13), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e120_13), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e128_13), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e130_13), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e138_13), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e140_13), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e148_13), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e150_13), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e158_13), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e160_13), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e168_13), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e170_13), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e178_13), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e180_13), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e188_13), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e190_13), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e198_13), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1a0_13), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e1a8_13), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e1b0_13), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e1b8_13), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1d0_13), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1d8_13), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e0_13), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e8_13), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f0_13), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f8_13), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f9_13), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e2d0_13), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2d8_13), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e0_13), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e8_13), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f0_13), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f8_13), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f9_13), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e3d0_13), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3d8_13), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e0_13), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e8_13), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f0_13), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f8_13), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f9_13), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e4d0_13), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4d8_13), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e0_13), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e8_13), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f0_13), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f8_13), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f9_13), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e5d0_13), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5d8_13), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e0_13), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e8_13), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f0_13), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f8_13), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f9_13), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e6d0_13), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6d8_13), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e0_13), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e8_13), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f0_13), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f8_13), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f9_13), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e7d0_13), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7d8_13), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e0_13), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e8_13), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f0_13), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f8_13), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f9_13), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_13 */
const struct cputbl CPUFUNC(op_smalltbl_14)[] = {
{ (cpuop_func*)CPUFUNC(op_0000_13), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0010_13), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0018_13), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0020_13), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0028_13), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0030_13), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0038_13), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0039_13), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_003c_13), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0040_13), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0050_13), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0058_13), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0060_13), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0068_13), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0070_13), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0078_13), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0079_13), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_007c_13), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0080_13), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0090_13), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0098_13), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a0_13), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a8_13), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b0_13), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b8_13), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b9_13), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0100_13), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0108_13), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0110_13), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0118_13), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0120_13), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0128_13), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0130_13), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0138_13), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0139_13), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013a_13), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013b_13), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013c_13), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0140_13), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0148_13), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0150_13), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0158_13), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0160_13), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0168_13), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0170_13), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0178_13), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0179_13), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0180_13), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0188_13), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_0190_13), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0198_13), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a0_13), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a8_13), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b0_13), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b8_13), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b9_13), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01c0_13), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01c8_13), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_01d0_13), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01d8_13), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e0_13), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e8_13), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f0_13), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f8_13), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f9_13), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0200_13), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0210_13), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0218_13), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0220_13), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0228_13), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0230_13), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0238_13), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0239_13), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_023c_13), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0240_13), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0250_13), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0258_13), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0260_13), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0268_13), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0270_13), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0278_13), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0279_13), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_027c_13), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0280_13), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0290_13), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0298_13), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a0_13), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a8_13), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b0_13), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b8_13), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b9_13), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0400_13), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0410_13), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0418_13), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0420_13), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0428_13), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0430_13), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0438_13), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0439_13), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0440_13), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0450_13), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0458_13), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0460_13), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0468_13), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0470_13), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0478_13), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0479_13), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0480_13), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0490_13), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0498_13), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a0_13), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a8_13), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b0_13), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b8_13), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b9_13), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0600_13), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0610_13), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0618_13), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0620_13), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0628_13), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0630_13), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0638_13), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0639_13), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0640_13), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0650_13), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0658_13), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0660_13), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0668_13), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0670_13), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0678_13), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0679_13), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0680_13), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0690_13), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0698_13), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a0_13), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a8_13), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b0_13), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b8_13), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b9_13), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0800_13), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0810_13), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0818_13), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0820_13), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0828_13), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0830_13), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0838_13), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0839_13), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083a_13), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083b_13), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0840_13), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0850_13), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0858_13), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0860_13), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0868_13), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0870_13), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0878_13), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0879_13), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0880_13), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0890_13), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0898_13), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a0_13), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a8_13), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b0_13), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b8_13), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b9_13), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08c0_13), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d0_13), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d8_13), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e0_13), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e8_13), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f0_13), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f8_13), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f9_13), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0a00_13), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a10_13), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a18_13), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a20_13), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a28_13), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a30_13), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a38_13), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a39_13), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a3c_13), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a40_13), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a50_13), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a58_13), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a60_13), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a68_13), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a70_13), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a78_13), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a79_13), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a7c_13), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a80_13), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a90_13), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a98_13), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa0_13), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa8_13), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab0_13), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab8_13), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab9_13), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0c00_13), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c10_13), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c18_13), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c20_13), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c28_13), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c30_13), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c38_13), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c39_13), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c40_13), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c50_13), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c58_13), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c60_13), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c68_13), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c70_13), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c78_13), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c79_13), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c80_13), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c90_13), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c98_13), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca0_13), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca8_13), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb0_13), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb8_13), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb9_13), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_1000_13), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1010_13), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1018_13), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1020_13), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1028_13), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1030_13), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1038_13), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1039_13), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103a_13), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103b_13), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103c_13), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1080_13), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1090_13), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1098_13), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a0_13), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a8_13), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b0_13), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b8_13), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b9_13), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10ba_13), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bb_13), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bc_13), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10c0_13), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d0_13), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d8_13), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e0_13), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e8_13), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f0_13), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f8_13), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f9_13), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fa_13), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fb_13), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fc_13), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1100_13), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1110_13), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1118_13), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1120_13), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1128_13), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1130_13), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1138_13), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1139_13), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113a_13), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113b_13), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113c_13), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1140_13), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1150_13), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1158_13), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1160_13), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1168_13), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1170_13), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1178_13), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1179_13), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117a_13), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117b_13), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117c_13), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1180_13), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1190_13), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1198_13), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a0_13), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a8_13), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b0_13), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b8_13), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b9_13), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11ba_13), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bb_13), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bc_13), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11c0_13), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d0_13), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d8_13), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e0_13), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e8_13), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f0_13), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f8_13), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f9_13), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fa_13), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fb_13), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fc_13), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13c0_13), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d0_13), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d8_13), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e0_13), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e8_13), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f0_13), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f8_13), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f9_13), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fa_13), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fb_13), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fc_13), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2000_13), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2008_13), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2010_13), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2018_13), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2020_13), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2028_13), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2030_13), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2038_13), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2039_13), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203a_13), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203b_13), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203c_13), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2040_13), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2048_13), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2050_13), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2058_13), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2060_13), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2068_13), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2070_13), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2078_13), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2079_13), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207a_13), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207b_13), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207c_13), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2080_13), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2088_13), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2090_13), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2098_13), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a0_13), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a8_13), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b0_13), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b8_13), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b9_13), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20ba_13), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bb_13), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bc_13), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c0_13), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c8_13), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d0_13), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d8_13), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e0_13), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e8_13), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f0_13), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f8_13), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f9_13), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fa_13), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fb_13), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fc_13), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2100_13), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2108_13), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2110_13), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2118_13), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2120_13), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2128_13), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2130_13), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2138_13), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2139_13), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213a_13), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213b_13), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213c_13), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2140_13), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2148_13), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2150_13), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2158_13), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2160_13), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2168_13), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2170_13), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2178_13), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2179_13), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217a_13), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217b_13), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217c_13), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2180_13), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2188_13), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2190_13), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2198_13), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a0_13), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a8_13), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b0_13), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b8_13), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b9_13), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21ba_13), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bb_13), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bc_13), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c0_13), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c8_13), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d0_13), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d8_13), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e0_13), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e8_13), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f0_13), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f8_13), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f9_13), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fa_13), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fb_13), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fc_13), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c0_13), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c8_13), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d0_13), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d8_13), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e0_13), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e8_13), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f0_13), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f8_13), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f9_13), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fa_13), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fb_13), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fc_13), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3000_13), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3008_13), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3010_13), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3018_13), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3020_13), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3028_13), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3030_13), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3038_13), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3039_13), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303a_13), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303b_13), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303c_13), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3040_13), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3048_13), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3050_13), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3058_13), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3060_13), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3068_13), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3070_13), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3078_13), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3079_13), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307a_13), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307b_13), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307c_13), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3080_13), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3088_13), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3090_13), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3098_13), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a0_13), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a8_13), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b0_13), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b8_13), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b9_13), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30ba_13), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bb_13), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bc_13), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c0_13), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c8_13), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d0_13), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d8_13), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e0_13), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e8_13), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f0_13), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f8_13), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f9_13), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fa_13), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fb_13), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fc_13), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3100_13), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3108_13), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3110_13), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3118_13), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3120_13), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3128_13), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3130_13), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3138_13), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3139_13), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313a_13), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313b_13), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313c_13), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3140_13), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3148_13), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3150_13), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3158_13), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3160_13), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3168_13), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3170_13), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3178_13), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3179_13), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317a_13), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317b_13), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317c_13), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3180_13), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3188_13), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3190_13), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3198_13), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a0_13), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a8_13), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b0_13), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b8_13), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b9_13), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31ba_13), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bb_13), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bc_13), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c0_13), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c8_13), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d0_13), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d8_13), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e0_13), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e8_13), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f0_13), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f8_13), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f9_13), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fa_13), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fb_13), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fc_13), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c0_13), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c8_13), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d0_13), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d8_13), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e0_13), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e8_13), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f0_13), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f8_13), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f9_13), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fa_13), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fb_13), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fc_13), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_4000_13), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4010_13), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4018_13), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4020_13), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4028_13), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4030_13), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4038_13), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4039_13), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4040_13), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4050_13), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4058_13), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4060_13), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4068_13), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4070_13), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4078_13), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4079_13), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4080_13), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4090_13), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4098_13), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a0_13), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a8_13), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b0_13), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b8_13), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b9_13), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40c0_14), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d0_14), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d8_14), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e0_14), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e8_14), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f0_14), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f8_14), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f9_14), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_4180_13), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4190_13), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4198_13), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a0_13), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a8_13), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b0_13), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b8_13), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b9_13), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41ba_13), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bb_13), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bc_13), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41d0_13), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41e8_13), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f0_13), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f8_13), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f9_13), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fa_13), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fb_13), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_4200_14), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4210_14), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4218_14), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4220_14), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4228_14), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4230_14), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4238_14), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4239_14), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4240_14), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4250_14), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4258_14), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4260_14), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4268_14), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4270_14), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4278_14), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4279_14), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4280_14), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4290_14), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4298_14), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a0_14), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a8_14), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b0_14), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b8_14), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b9_14), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4400_13), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4410_13), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4418_13), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4420_13), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4428_13), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4430_13), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4438_13), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4439_13), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4440_13), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4450_13), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4458_13), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4460_13), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4468_13), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4470_13), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4478_13), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4479_13), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4480_13), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4490_13), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4498_13), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a0_13), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a8_13), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b0_13), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b8_13), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b9_13), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44c0_13), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d0_13), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d8_13), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e0_13), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e8_13), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f0_13), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f8_13), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f9_13), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fa_13), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fb_13), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fc_13), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4600_13), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4610_13), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4618_13), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4620_13), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4628_13), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4630_13), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4638_13), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4639_13), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4640_13), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4650_13), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4658_13), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4660_13), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4668_13), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4670_13), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4678_13), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4679_13), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4680_13), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4690_13), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4698_13), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a0_13), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a8_13), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b0_13), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b8_13), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b9_13), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46c0_13), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d0_13), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d8_13), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e0_13), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e8_13), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f0_13), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f8_13), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f9_13), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fa_13), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fb_13), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fc_13), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4800_13), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4810_13), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4818_13), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4820_13), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4828_13), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4830_13), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4838_13), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4839_13), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4840_13), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ (cpuop_func*)CPUFUNC(op_4850_13), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4868_13), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4870_13), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4878_13), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4879_13), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487a_13), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487b_13), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4880_13), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_4890_13), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a0_13), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a8_13), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b0_13), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b8_13), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b9_13), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48c0_13), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_48d0_13), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e0_13), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e8_13), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f0_13), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f8_13), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f9_13), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_4a00_13), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a10_13), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a18_13), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a20_13), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a28_13), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a30_13), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a38_13), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a39_13), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a40_13), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a50_13), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a58_13), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a60_13), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a68_13), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a70_13), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a78_13), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a79_13), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a80_13), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a90_13), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a98_13), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa0_13), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa8_13), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab0_13), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab8_13), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab9_13), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ac0_13), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad0_13), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad8_13), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae0_13), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae8_13), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af0_13), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af8_13), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af9_13), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4c90_13), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4c98_13), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ca8_13), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb0_13), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb8_13), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb9_13), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cba_13), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cbb_13), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd0_13), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd8_13), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ce8_13), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf0_13), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf8_13), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf9_13), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfa_13), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfb_13), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4e40_13), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ (cpuop_func*)CPUFUNC(op_4e50_13), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ (cpuop_func*)CPUFUNC(op_4e58_13), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ (cpuop_func*)CPUFUNC(op_4e60_13), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ (cpuop_func*)CPUFUNC(op_4e68_13), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ (cpuop_func*)CPUFUNC(op_4e70_13), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ (cpuop_func*)CPUFUNC(op_4e71_13), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ (cpuop_func*)CPUFUNC(op_4e72_13), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ (cpuop_func*)CPUFUNC(op_4e73_14), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ (cpuop_func*)CPUFUNC(op_4e75_13), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ (cpuop_func*)CPUFUNC(op_4e76_13), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ (cpuop_func*)CPUFUNC(op_4e77_13), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ (cpuop_func*)CPUFUNC(op_4e90_13), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ea8_13), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb0_13), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb8_13), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb9_13), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eba_13), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ebb_13), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ed0_13), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ee8_13), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef0_13), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef8_13), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef9_13), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efa_13), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efb_13), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_5000_13), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5010_13), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5018_13), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5020_13), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5028_13), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5030_13), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5038_13), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5039_13), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5040_13), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5048_13), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5050_13), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5058_13), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5060_13), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5068_13), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5070_13), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5078_13), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5079_13), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5080_13), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5088_13), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5090_13), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5098_13), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a0_13), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a8_13), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b0_13), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b8_13), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b9_13), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50c0_14), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50c8_13), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_50d0_14), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50d8_14), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e0_14), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e8_14), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f0_14), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f8_14), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f9_14), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5100_13), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5110_13), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5118_13), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5120_13), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5128_13), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5130_13), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5138_13), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5139_13), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5140_13), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5148_13), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5150_13), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5158_13), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5160_13), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5168_13), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5170_13), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5178_13), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5179_13), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5180_13), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5188_13), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5190_13), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5198_13), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a0_13), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a8_13), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b0_13), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b8_13), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b9_13), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51c0_14), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51c8_13), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_51d0_14), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51d8_14), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e0_14), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e8_14), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f0_14), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f8_14), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f9_14), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52c0_14), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52c8_13), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_52d0_14), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52d8_14), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e0_14), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e8_14), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f0_14), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f8_14), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f9_14), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53c0_14), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53c8_13), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_53d0_14), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53d8_14), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e0_14), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e8_14), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f0_14), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f8_14), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f9_14), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54c0_14), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54c8_13), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_54d0_14), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54d8_14), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e0_14), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e8_14), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f0_14), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f8_14), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f9_14), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55c0_14), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55c8_13), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_55d0_14), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55d8_14), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e0_14), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e8_14), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f0_14), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f8_14), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f9_14), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56c0_14), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56c8_13), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_56d0_14), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56d8_14), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e0_14), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e8_14), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f0_14), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f8_14), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f9_14), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57c0_14), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57c8_13), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_57d0_14), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57d8_14), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e0_14), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e8_14), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f0_14), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f8_14), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f9_14), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58c0_14), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58c8_13), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_58d0_14), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58d8_14), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e0_14), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e8_14), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f0_14), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f8_14), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f9_14), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59c0_14), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59c8_13), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_59d0_14), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59d8_14), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e0_14), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e8_14), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f0_14), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f8_14), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f9_14), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ac0_14), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ac8_13), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ad0_14), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ad8_14), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae0_14), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae8_14), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af0_14), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af8_14), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af9_14), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bc0_14), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bc8_13), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5bd0_14), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bd8_14), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be0_14), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be8_14), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf0_14), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf8_14), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf9_14), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cc0_14), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cc8_13), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5cd0_14), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cd8_14), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce0_14), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce8_14), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf0_14), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf8_14), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf9_14), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dc0_14), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dc8_13), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5dd0_14), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dd8_14), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de0_14), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de8_14), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df0_14), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df8_14), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df9_14), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ec0_14), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ec8_13), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ed0_14), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ed8_14), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee0_14), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee8_14), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef0_14), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef8_14), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef9_14), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fc0_14), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fc8_13), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5fd0_14), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fd8_14), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe0_14), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe8_14), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff0_14), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff8_14), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff9_14), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_6000_13), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6001_13), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_60ff_13), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6100_13), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6101_13), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_61ff_13), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6200_13), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6201_13), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_62ff_13), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6300_13), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6301_13), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_63ff_13), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6400_13), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6401_13), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_64ff_13), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6500_13), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6501_13), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_65ff_13), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6600_13), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6601_13), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_66ff_13), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6700_13), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6701_13), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_67ff_13), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6800_13), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6801_13), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_68ff_13), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6900_13), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6901_13), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_69ff_13), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a00_13), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a01_13), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6aff_13), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b00_13), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b01_13), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6bff_13), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c00_13), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c01_13), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6cff_13), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d00_13), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d01_13), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6dff_13), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e00_13), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e01_13), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6eff_13), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f00_13), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f01_13), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6fff_13), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_7000_13), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_8000_13), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8010_13), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8018_13), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8020_13), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8028_13), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8030_13), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8038_13), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8039_13), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803a_13), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803b_13), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803c_13), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8040_13), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8050_13), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8058_13), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8060_13), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8068_13), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8070_13), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8078_13), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8079_13), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807a_13), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807b_13), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807c_13), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8080_13), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8090_13), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8098_13), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a0_13), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a8_13), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b0_13), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b8_13), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b9_13), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80ba_13), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bb_13), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bc_13), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80c0_13), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d0_13), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d8_13), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e0_13), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e8_13), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f0_13), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f8_13), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f9_13), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fa_13), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fb_13), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fc_13), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_8100_13), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8108_13), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8110_13), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8118_13), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8120_13), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8128_13), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8130_13), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8138_13), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8139_13), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8150_13), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8158_13), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8160_13), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8168_13), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8170_13), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8178_13), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8179_13), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8190_13), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8198_13), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a0_13), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a8_13), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b0_13), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b8_13), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b9_13), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81c0_13), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d0_13), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d8_13), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e0_13), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e8_13), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f0_13), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f8_13), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f9_13), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fa_13), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fb_13), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fc_13), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_9000_13), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9010_13), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9018_13), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9020_13), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9028_13), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9030_13), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9038_13), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9039_13), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903a_13), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903b_13), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903c_13), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9040_13), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9048_13), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9050_13), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9058_13), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9060_13), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9068_13), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9070_13), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9078_13), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9079_13), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907a_13), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907b_13), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907c_13), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9080_13), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9088_13), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9090_13), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9098_13), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a0_13), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a8_13), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b0_13), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b8_13), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b9_13), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90ba_13), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bb_13), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bc_13), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90c0_13), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90c8_13), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d0_13), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d8_13), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e0_13), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e8_13), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f0_13), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f8_13), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f9_13), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fa_13), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fb_13), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fc_13), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_9100_13), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9108_13), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9110_13), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9118_13), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9120_13), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9128_13), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9130_13), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9138_13), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9139_13), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9140_13), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9148_13), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9150_13), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9158_13), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9160_13), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9168_13), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9170_13), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9178_13), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9179_13), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9180_13), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9188_13), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9190_13), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9198_13), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a0_13), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a8_13), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b0_13), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b8_13), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b9_13), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91c0_13), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91c8_13), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d0_13), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d8_13), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e0_13), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e8_13), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f0_13), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f8_13), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f9_13), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fa_13), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fb_13), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fc_13), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_b000_13), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b010_13), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b018_13), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b020_13), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b028_13), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b030_13), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b038_13), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b039_13), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03a_13), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03b_13), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03c_13), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b040_13), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b048_13), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b050_13), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b058_13), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b060_13), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b068_13), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b070_13), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b078_13), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b079_13), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07a_13), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07b_13), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07c_13), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b080_13), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b088_13), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b090_13), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b098_13), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a0_13), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a8_13), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b0_13), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b8_13), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b9_13), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0ba_13), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bb_13), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bc_13), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0c0_13), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0c8_13), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d0_13), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d8_13), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e0_13), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e8_13), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f0_13), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f8_13), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f9_13), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fa_13), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fb_13), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fc_13), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b100_13), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b108_13), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b110_13), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b118_13), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b120_13), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b128_13), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b130_13), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b138_13), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b139_13), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b140_13), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b148_13), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b150_13), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b158_13), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b160_13), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b168_13), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b170_13), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b178_13), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b179_13), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b180_13), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b188_13), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b190_13), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b198_13), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a0_13), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a8_13), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b0_13), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b8_13), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b9_13), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1c0_13), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1c8_13), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d0_13), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d8_13), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e0_13), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e8_13), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f0_13), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f8_13), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f9_13), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fa_13), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fb_13), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fc_13), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_c000_13), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c010_13), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c018_13), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c020_13), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c028_13), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c030_13), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c038_13), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c039_13), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03a_13), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03b_13), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03c_13), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c040_13), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c050_13), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c058_13), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c060_13), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c068_13), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c070_13), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c078_13), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c079_13), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07a_13), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07b_13), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07c_13), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c080_13), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c090_13), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c098_13), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a0_13), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a8_13), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b0_13), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b8_13), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b9_13), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0ba_13), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bb_13), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bc_13), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0c0_13), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d0_13), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d8_13), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e0_13), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e8_13), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f0_13), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f8_13), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f9_13), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fa_13), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fb_13), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fc_13), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c100_13), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c108_13), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c110_13), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c118_13), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c120_13), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c128_13), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c130_13), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c138_13), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c139_13), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c140_13), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c148_13), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c150_13), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c158_13), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c160_13), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c168_13), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c170_13), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c178_13), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c179_13), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c188_13), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c190_13), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c198_13), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a0_13), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a8_13), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b0_13), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b8_13), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b9_13), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1c0_13), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d0_13), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d8_13), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e0_13), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e8_13), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f0_13), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f8_13), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f9_13), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fa_13), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fb_13), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fc_13), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_d000_13), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d010_13), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d018_13), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d020_13), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d028_13), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d030_13), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d038_13), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d039_13), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03a_13), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03b_13), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03c_13), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d040_13), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d048_13), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d050_13), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d058_13), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d060_13), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d068_13), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d070_13), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d078_13), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d079_13), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07a_13), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07b_13), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07c_13), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d080_13), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d088_13), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d090_13), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d098_13), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a0_13), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a8_13), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b0_13), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b8_13), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b9_13), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0ba_13), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bb_13), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bc_13), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0c0_13), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0c8_13), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d0_13), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d8_13), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e0_13), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e8_13), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f0_13), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f8_13), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f9_13), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fa_13), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fb_13), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fc_13), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d100_13), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d108_13), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d110_13), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d118_13), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d120_13), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d128_13), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d130_13), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d138_13), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d139_13), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d140_13), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d148_13), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d150_13), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d158_13), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d160_13), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d168_13), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d170_13), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d178_13), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d179_13), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d180_13), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d188_13), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d190_13), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d198_13), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a0_13), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a8_13), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b0_13), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b8_13), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b9_13), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1c0_13), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1c8_13), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d0_13), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d8_13), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e0_13), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e8_13), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f0_13), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f8_13), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f9_13), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fa_13), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fb_13), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fc_13), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_e000_13), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e008_13), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e010_13), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e018_13), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e020_13), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e028_13), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e030_13), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e038_13), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e040_13), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e048_13), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e050_13), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e058_13), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e060_13), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e068_13), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e070_13), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e078_13), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e080_13), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e088_13), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e090_13), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e098_13), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0a0_13), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e0a8_13), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e0b0_13), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e0b8_13), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0d0_13), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0d8_13), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e0_13), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e8_13), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f0_13), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f8_13), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f9_13), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e100_13), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e108_13), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e110_13), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e118_13), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e120_13), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e128_13), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e130_13), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e138_13), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e140_13), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e148_13), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e150_13), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e158_13), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e160_13), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e168_13), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e170_13), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e178_13), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e180_13), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e188_13), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e190_13), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e198_13), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1a0_13), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e1a8_13), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e1b0_13), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e1b8_13), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1d0_13), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1d8_13), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e0_13), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e8_13), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f0_13), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f8_13), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f9_13), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e2d0_13), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2d8_13), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e0_13), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e8_13), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f0_13), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f8_13), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f9_13), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e3d0_13), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3d8_13), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e0_13), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e8_13), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f0_13), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f8_13), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f9_13), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e4d0_13), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4d8_13), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e0_13), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e8_13), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f0_13), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f8_13), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f9_13), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e5d0_13), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5d8_13), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e0_13), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e8_13), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f0_13), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f8_13), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f9_13), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e6d0_13), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6d8_13), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e0_13), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e8_13), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f0_13), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f8_13), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f9_13), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e7d0_13), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7d8_13), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e0_13), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e8_13), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f0_13), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f8_13), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f9_13), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#ifdef CPUEMU_20
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_20)[] = {
{ CPUFUNC(op_0000_20), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_20), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_20), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_20), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_20), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_20), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_20), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_20), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_20), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_20), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_20), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_20), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_20), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_20), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_20), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_20), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_20), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_20), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_20), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_20), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_20), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_20), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_20), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_20), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_20), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_20), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00d0_20), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00e8_20), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f0_20), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f8_20), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f9_20), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fa_20), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fb_20), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0100_20), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_20), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_20), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_20), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_20), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_20), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_20), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_20), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_20), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_20), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_20), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_20), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_20), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_20), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_20), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_20), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_20), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_20), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_20), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_20), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_20), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_20), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_20), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_20), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_20), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_20), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_20), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_20), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_20), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_20), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_20), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_20), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_20), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_20), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_20), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_20), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_20), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_20), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_20), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_20), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_20), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_20), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_20), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_20), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_20), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_20), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_20), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_20), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_20), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_20), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_20), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_20), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_20), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_20), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_20), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_20), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_20), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_20), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_20), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_20), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_20), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_20), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_20), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_20), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_20), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02d0_20), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02e8_20), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f0_20), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f8_20), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f9_20), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fa_20), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fb_20), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0400_20), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_20), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_20), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_20), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_20), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_20), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_20), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_20), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_20), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_20), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_20), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_20), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_20), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_20), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_20), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_20), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_20), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_20), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_20), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_20), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_20), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_20), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_20), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_20), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04d0_20), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04e8_20), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f0_20), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f8_20), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f9_20), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fa_20), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fb_20), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0600_20), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_20), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_20), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_20), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_20), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_20), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_20), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_20), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_20), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_20), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_20), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_20), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_20), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_20), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_20), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_20), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_20), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_20), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_20), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_20), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_20), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_20), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_20), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_20), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c0_20), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c8_20), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06d0_20), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06e8_20), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f0_20), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f8_20), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f9_20), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fa_20), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fb_20), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ CPUFUNC(op_0800_20), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_20), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_20), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_20), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_20), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_20), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_20), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_20), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_20), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_20), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_20), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_20), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_20), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_20), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_20), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_20), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_20), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_20), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_20), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_20), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_20), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_20), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_20), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_20), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_20), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_20), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_20), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_20), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_20), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_20), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_20), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_20), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_20), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_20), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_20), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_20), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_20), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_20), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_20), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_20), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_20), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_20), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_20), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_20), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_20), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_20), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_20), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_20), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_20), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_20), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_20), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_20), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_20), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_20), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_20), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_20), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_20), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_20), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_20), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_20), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad0_20), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad8_20), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae0_20), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae8_20), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af0_20), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af8_20), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af9_20), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ CPUFUNC(op_0c00_20), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_20), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_20), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_20), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_20), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_20), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_20), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_20), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3a_20), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3b_20), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c40_20), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_20), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_20), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_20), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_20), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_20), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_20), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_20), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7a_20), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7b_20), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c80_20), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_20), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_20), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_20), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_20), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_20), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_20), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_20), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cba_20), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cbb_20), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd0_20), 0x0cd0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd8_20), 0x0cd8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce0_20), 0x0ce0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce8_20), 0x0ce8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf0_20), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf8_20), 0x0cf8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf9_20), 0x0cf9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cfc_20), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e10_20), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e18_20), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e20_20), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e28_20), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e30_20), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e38_20), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e39_20), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e50_20), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e58_20), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e60_20), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e68_20), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e70_20), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e78_20), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e79_20), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e90_20), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e98_20), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea0_20), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea8_20), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb0_20), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb8_20), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb9_20), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed0_20), 0x0ed0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed8_20), 0x0ed8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee0_20), 0x0ee0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee8_20), 0x0ee8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef0_20), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef8_20), 0x0ef8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef9_20), 0x0ef9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0efc_20), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ CPUFUNC(op_1000_20), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_20), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_20), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_20), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_20), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_20), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_20), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_20), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_20), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_20), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_20), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_20), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_20), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_20), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_20), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_20), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_20), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_20), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_20), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_20), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_20), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_20), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_20), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_20), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_20), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_20), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_20), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_20), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_20), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_20), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_20), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_20), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_20), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_20), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_20), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_20), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_20), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_20), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_20), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_20), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_20), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_20), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_20), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_20), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_20), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_20), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_20), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_20), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_20), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_20), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_20), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_20), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_20), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_20), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_20), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_20), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_20), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_20), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_20), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_20), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_20), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_20), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_20), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_20), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_20), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_20), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_20), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_20), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_20), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_20), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_20), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_20), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_20), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_20), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_20), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_20), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_20), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_20), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_20), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_20), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_20), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_20), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_20), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_20), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_20), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_20), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_20), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_20), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_20), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_20), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_20), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_20), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_20), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_20), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_20), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_20), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_20), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_20), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_20), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_20), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_20), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_20), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_20), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_20), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_20), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_20), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_20), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_20), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_20), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_20), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_20), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_20), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_20), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_20), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_20), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_20), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_20), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_20), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_20), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_20), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_20), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_20), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_20), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_20), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_20), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_20), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_20), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_20), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_20), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_20), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_20), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_20), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_20), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_20), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_20), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_20), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_20), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_20), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_20), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_20), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_20), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_20), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_20), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_20), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_20), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_20), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_20), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_20), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_20), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_20), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_20), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_20), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_20), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_20), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_20), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_20), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_20), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_20), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_20), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_20), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_20), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_20), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_20), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_20), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_20), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_20), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_20), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_20), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_20), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_20), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_20), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_20), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_20), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_20), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_20), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_20), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_20), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_20), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_20), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_20), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_20), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_20), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_20), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_20), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_20), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_20), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_20), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_20), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_20), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_20), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_20), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_20), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_20), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_20), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_20), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_20), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_20), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_20), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_20), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_20), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_20), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_20), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_20), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_20), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_20), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_20), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_20), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_20), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_20), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_20), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_20), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_20), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_20), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_20), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_20), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_20), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_20), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_20), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_20), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_20), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_20), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_20), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_20), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_20), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_20), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_20), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_20), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_20), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_20), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_20), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_20), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_20), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_20), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_20), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_20), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_20), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_20), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_20), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_20), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_20), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_20), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_20), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_20), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_20), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_20), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_20), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_20), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_20), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_20), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_20), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_20), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_20), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_20), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_20), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_20), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_20), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_20), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_20), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_20), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_20), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_20), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_20), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_20), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_20), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_20), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_20), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_20), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_20), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_20), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_20), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_20), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_20), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_20), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_20), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_20), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_20), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_20), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_20), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_20), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_20), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_20), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_20), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_20), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_20), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_20), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_20), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_20), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_20), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_20), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_20), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_20), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_20), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_20), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_20), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_20), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_20), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_20), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_20), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_20), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_20), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_20), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_20), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_20), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_20), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_20), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_20), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_20), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_20), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_20), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_20), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_20), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_20), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_20), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_20), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_20), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_20), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_20), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_20), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_20), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_20), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_20), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_20), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_20), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_20), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_20), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_20), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_20), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_20), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_20), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_20), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_20), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_20), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_20), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_20), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_20), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_20), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4100_20), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4110_20), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4118_20), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4120_20), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4128_20), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4130_20), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4138_20), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4139_20), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413a_20), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413b_20), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413c_20), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ CPUFUNC(op_4180_20), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_20), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_20), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_20), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_20), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_20), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_20), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_20), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_20), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_20), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_20), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_20), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_20), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_20), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_20), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_20), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_20), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_20), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_20), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_20), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_20), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_20), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_20), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_20), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_20), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_20), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_20), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_20), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_20), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_20), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_20), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_20), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_20), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_20), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_20), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_20), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_20), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_20), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_20), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_20), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_20), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_20), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_20), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_20), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_20), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_20), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_20), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_20), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_20), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_20), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_20), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_20), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_20), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_20), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_20), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_20), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_20), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_20), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_20), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_20), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_20), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_20), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_20), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_20), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_20), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_20), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_20), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_20), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_20), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_20), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_20), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_20), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_20), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_20), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_20), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_20), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_20), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_20), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_20), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_20), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_20), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_20), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_20), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_20), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_20), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_20), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_20), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_20), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_20), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_20), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_20), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_20), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_20), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_20), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_20), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_20), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_20), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_20), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_20), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_20), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_20), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_20), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_20), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_20), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_20), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_20), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_20), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_20), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_20), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_20), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_20), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_20), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_20), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_20), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_20), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_20), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_20), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_20), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_20), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_20), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_20), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4808_20), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ CPUFUNC(op_4810_20), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_20), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_20), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_20), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_20), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_20), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_20), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_20), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4848_20), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ CPUFUNC(op_4850_20), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_20), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_20), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_20), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_20), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_20), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_20), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_20), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_20), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_20), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_20), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_20), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_20), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_20), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_20), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_20), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_20), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_20), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_20), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_20), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_20), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_49c0_20), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ CPUFUNC(op_4a00_20), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_20), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_20), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_20), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_20), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_20), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_20), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_20), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3a_20), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3b_20), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3c_20), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a40_20), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a48_20), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a50_20), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_20), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_20), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_20), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_20), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_20), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_20), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7a_20), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7b_20), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7c_20), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a80_20), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a88_20), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a90_20), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_20), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_20), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_20), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_20), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_20), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_20), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4aba_20), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abb_20), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abc_20), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4ac0_20), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_20), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_20), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_20), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_20), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_20), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_20), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_20), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c00_20), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c10_20), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c18_20), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c20_20), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c28_20), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c30_20), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c38_20), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c39_20), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3a_20), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3b_20), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3c_20), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c40_20), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c50_20), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c58_20), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c60_20), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c68_20), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c70_20), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c78_20), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c79_20), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7a_20), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7b_20), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7c_20), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ CPUFUNC(op_4c90_20), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_20), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_20), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_20), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_20), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_20), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_20), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_20), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_20), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_20), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_20), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_20), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_20), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_20), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_20), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_20), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_20), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_20), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_20), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_20), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_20), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_20), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_20), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_20), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_20), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_20), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_20), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_20), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_20), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_20), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_20), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_20), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_20), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_20), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_20), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_20), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_20), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_20), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_20), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_20), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_20), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_20), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_20), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_20), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_20), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_20), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_20), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_20), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_20), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_20), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_20), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_20), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_20), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_20), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_20), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_20), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_20), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_20), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_20), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_20), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_20), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_20), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_20), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_20), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_20), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_20), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_20), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_20), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_20), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_20), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_20), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_20), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_20), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_20), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_20), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_20), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_20), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_20), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_20), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_20), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fa_20), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fb_20), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fc_20), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5100_20), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_20), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_20), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_20), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_20), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_20), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_20), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_20), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_20), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_20), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_20), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_20), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_20), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_20), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_20), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_20), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_20), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_20), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_20), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_20), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_20), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_20), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_20), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_20), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_20), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_20), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_20), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_20), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_20), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_20), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_20), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_20), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_20), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_20), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_20), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fa_20), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fb_20), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fc_20), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_52c0_20), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_20), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_20), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_20), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_20), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_20), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_20), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_20), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_20), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fa_20), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fb_20), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fc_20), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_53c0_20), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_20), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_20), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_20), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_20), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_20), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_20), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_20), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_20), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fa_20), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fb_20), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fc_20), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_54c0_20), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_20), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_20), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_20), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_20), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_20), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_20), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_20), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_20), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fa_20), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fb_20), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fc_20), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_55c0_20), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_20), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_20), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_20), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_20), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_20), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_20), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_20), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_20), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fa_20), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fb_20), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fc_20), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_56c0_20), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_20), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_20), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_20), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_20), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_20), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_20), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_20), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_20), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fa_20), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fb_20), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fc_20), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_57c0_20), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_20), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_20), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_20), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_20), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_20), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_20), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_20), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_20), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fa_20), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fb_20), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fc_20), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_58c0_20), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_20), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_20), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_20), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_20), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_20), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_20), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_20), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_20), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fa_20), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fb_20), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fc_20), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_59c0_20), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_20), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_20), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_20), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_20), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_20), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_20), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_20), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_20), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fa_20), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fb_20), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fc_20), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ac0_20), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_20), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_20), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_20), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_20), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_20), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_20), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_20), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_20), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afa_20), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afb_20), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afc_20), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5bc0_20), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_20), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_20), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_20), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_20), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_20), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_20), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_20), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_20), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfa_20), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfb_20), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfc_20), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5cc0_20), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_20), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_20), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_20), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_20), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_20), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_20), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_20), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_20), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfa_20), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfb_20), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfc_20), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5dc0_20), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_20), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_20), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_20), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_20), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_20), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_20), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_20), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_20), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfa_20), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfb_20), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfc_20), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ec0_20), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_20), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_20), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_20), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_20), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_20), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_20), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_20), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_20), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efa_20), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efb_20), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efc_20), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5fc0_20), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_20), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_20), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_20), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_20), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_20), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_20), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_20), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_20), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffa_20), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffb_20), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffc_20), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_6000_20), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_20), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_20), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_20), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_20), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_20), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_20), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_20), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_20), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_20), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_20), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_20), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_20), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_20), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_20), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_20), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_20), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_20), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_20), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_20), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_20), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_20), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_20), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_20), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_20), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_20), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_20), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_20), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_20), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_20), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_20), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_20), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_20), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_20), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_20), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_20), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_20), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_20), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_20), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_20), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_20), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_20), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_20), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_20), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_20), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_20), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_20), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_20), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_20), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_20), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_20), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_20), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_20), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_20), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_20), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_20), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_20), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_20), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_20), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_20), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_20), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_20), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_20), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_20), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_20), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_20), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_20), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_20), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_20), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_20), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_20), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_20), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_20), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_20), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_20), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_20), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_20), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_20), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_20), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_20), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_20), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_20), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_20), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_20), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_20), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_20), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_20), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_20), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_20), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_20), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_20), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_20), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_20), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_20), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_20), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_20), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_20), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_20), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_20), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_20), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_20), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_20), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8140_20), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8148_20), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ CPUFUNC(op_8150_20), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_20), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_20), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_20), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_20), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_20), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_20), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8180_20), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8188_20), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ CPUFUNC(op_8190_20), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_20), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_20), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_20), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_20), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_20), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_20), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_20), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_20), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_20), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_20), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_20), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_20), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_20), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_20), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_20), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_20), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_20), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_20), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_20), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_20), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_20), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_20), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_20), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_20), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_20), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_20), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_20), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_20), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_20), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_20), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_20), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_20), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_20), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_20), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_20), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_20), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_20), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_20), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_20), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_20), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_20), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_20), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_20), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_20), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_20), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_20), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_20), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_20), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_20), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_20), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_20), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_20), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_20), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_20), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_20), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_20), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_20), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_20), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_20), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_20), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_20), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_20), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_20), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_20), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_20), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_20), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_20), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_20), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_20), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_20), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_20), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_20), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_20), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_20), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_20), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_20), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_20), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_20), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_20), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_20), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_20), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_20), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_20), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_20), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_20), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_20), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_20), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_20), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_20), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_20), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_20), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_20), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_20), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_20), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_20), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_20), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_20), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_20), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_20), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_20), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_20), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_20), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_20), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_20), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_20), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_20), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_20), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_20), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_20), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_20), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_20), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_20), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_20), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_20), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_20), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_20), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_20), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_20), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_20), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_20), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_20), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_20), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_20), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_20), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_20), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_20), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_20), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_20), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_20), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_20), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_20), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_20), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_20), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_20), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_20), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_20), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_20), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_20), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_20), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_20), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_20), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_20), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_20), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_20), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_20), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_20), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_20), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_20), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_20), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_20), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_20), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_20), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_20), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_20), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_20), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_20), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_20), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_20), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_20), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_20), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_20), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_20), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_20), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_20), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_20), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_20), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_20), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_20), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_20), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_20), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_20), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_20), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_20), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_20), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_20), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_20), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_20), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_20), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_20), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_20), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_20), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_20), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_20), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_20), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_20), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_20), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_20), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_20), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_20), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_20), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_20), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_20), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_20), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_20), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_20), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_20), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_20), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_20), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_20), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_20), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_20), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_20), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_20), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_20), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_20), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_20), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_20), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_20), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_20), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_20), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_20), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_20), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_20), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_20), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_20), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_20), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_20), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_20), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_20), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_20), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_20), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_20), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_20), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_20), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_20), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_20), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_20), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_20), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_20), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_20), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_20), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_20), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_20), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_20), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_20), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_20), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_20), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_20), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_20), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_20), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_20), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_20), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_20), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_20), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_20), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_20), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_20), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_20), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_20), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_20), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_20), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_20), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_20), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_20), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_20), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_20), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_20), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_20), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_20), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_20), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_20), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_20), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_20), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_20), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_20), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_20), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_20), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_20), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_20), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_20), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_20), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_20), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_20), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_20), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_20), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_20), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_20), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_20), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_20), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_20), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_20), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_20), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_20), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_20), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_20), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_20), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_20), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_20), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_20), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_20), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_20), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_20), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_20), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_20), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_20), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_20), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_20), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_20), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_20), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_20), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_20), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_20), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_20), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_20), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_20), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_20), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_20), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_20), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_20), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_20), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_20), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_20), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_20), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_20), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_20), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_20), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_20), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_20), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_20), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_20), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_20), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_20), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_20), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_20), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_20), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_20), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_20), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_20), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_20), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_20), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_20), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_20), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_20), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_20), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_20), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_20), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_20), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_20), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_20), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_20), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_20), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_20), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_20), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_20), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_20), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_20), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_20), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_20), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_20), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_20), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_20), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_20), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_20), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_20), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_20), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_20), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_20), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_20), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_20), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_20), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_20), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_20), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_20), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_20), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_20), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_20), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_20), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_20), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_20), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_20), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_20), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_20), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_20), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_20), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_20), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_20), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_20), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_20), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_20), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_20), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_20), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_20), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_20), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_20), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_20), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_20), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_20), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_20), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_20), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_20), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_20), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_20), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_20), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_20), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_20), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_20), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_20), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_20), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_20), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_20), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_20), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_20), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_20), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_20), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_20), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_20), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_20), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_20), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_20), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_20), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_20), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_20), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_20), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_20), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_20), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_20), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_20), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_20), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_20), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_20), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_20), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_20), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_20), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_20), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_20), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_20), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_20), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_20), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_20), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_20), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_20), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_20), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_20), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_20), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_20), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_20), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_20), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_20), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_20), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_20), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_20), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_20), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_20), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_20), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_20), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_20), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_20), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_20), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_20), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_20), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_20), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_20), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_20), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_20), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_20), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_20), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_20), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_20), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_20), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_20), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8c0_20), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8d0_20), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8e8_20), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f0_20), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f8_20), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f9_20), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fa_20), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fb_20), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9c0_20), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9d0_20), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9e8_20), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f0_20), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f8_20), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f9_20), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fa_20), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fb_20), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eac0_20), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ead0_20), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eae8_20), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf0_20), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf8_20), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf9_20), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebc0_20), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebd0_20), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebe8_20), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf0_20), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf8_20), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf9_20), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfa_20), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfb_20), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecc0_20), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecd0_20), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ece8_20), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf0_20), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf8_20), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf9_20), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edc0_20), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edd0_20), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ede8_20), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf0_20), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf8_20), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf9_20), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfa_20), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfb_20), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eec0_20), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eed0_20), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eee8_20), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef0_20), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef8_20), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef9_20), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efc0_20), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efd0_20), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efe8_20), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff0_20), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff8_20), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff9_20), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f200_20), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f208_20), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f210_20), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f218_20), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f220_20), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f228_20), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f230_20), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f238_20), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f239_20), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23a_20), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23b_20), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23c_20), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f240_20), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f248_20), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f250_20), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f258_20), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f260_20), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f268_20), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f270_20), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f278_20), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f279_20), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27a_20), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27b_20), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27c_20), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f280_20), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f2c0_20), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f310_20), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f320_20), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f328_20), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f330_20), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f338_20), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f339_20), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f350_20), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f358_20), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f368_20), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f370_20), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f378_20), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f379_20), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37a_20), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37b_20), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_20 */
#ifdef CPUEMU_21
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_21)[] = {
{ (cpuop_func*)CPUFUNC(op_0000_21), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0010_21), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0018_21), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0020_21), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0028_21), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0030_21), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0038_21), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0039_21), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_003c_21), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0040_21), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0050_21), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0058_21), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0060_21), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0068_21), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0070_21), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0078_21), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0079_21), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_007c_21), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0080_21), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0090_21), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0098_21), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a0_21), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a8_21), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b0_21), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b8_21), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b9_21), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00d0_21), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00e8_21), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f0_21), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f8_21), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f9_21), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00fa_21), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00fb_21), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0100_21), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0108_21), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0110_21), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0118_21), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0120_21), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0128_21), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0130_21), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0138_21), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0139_21), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013a_21), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013b_21), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013c_21), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0140_21), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0148_21), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0150_21), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0158_21), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0160_21), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0168_21), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0170_21), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0178_21), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0179_21), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0180_21), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0188_21), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_0190_21), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0198_21), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a0_21), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a8_21), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b0_21), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b8_21), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b9_21), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01c0_21), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01c8_21), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_01d0_21), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01d8_21), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e0_21), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e8_21), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f0_21), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f8_21), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f9_21), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0200_21), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0210_21), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0218_21), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0220_21), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0228_21), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0230_21), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0238_21), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0239_21), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_023c_21), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0240_21), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0250_21), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0258_21), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0260_21), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0268_21), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0270_21), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0278_21), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0279_21), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_027c_21), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0280_21), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0290_21), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0298_21), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a0_21), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a8_21), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b0_21), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b8_21), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b9_21), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02d0_21), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02e8_21), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f0_21), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f8_21), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f9_21), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02fa_21), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02fb_21), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0400_21), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0410_21), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0418_21), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0420_21), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0428_21), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0430_21), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0438_21), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0439_21), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0440_21), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0450_21), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0458_21), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0460_21), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0468_21), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0470_21), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0478_21), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0479_21), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0480_21), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0490_21), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0498_21), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a0_21), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a8_21), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b0_21), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b8_21), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b9_21), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04d0_21), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04e8_21), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f0_21), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f8_21), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f9_21), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04fa_21), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04fb_21), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0600_21), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0610_21), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0618_21), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0620_21), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0628_21), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0630_21), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0638_21), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0639_21), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0640_21), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0650_21), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0658_21), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0660_21), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0668_21), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0670_21), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0678_21), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0679_21), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0680_21), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0690_21), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0698_21), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a0_21), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a8_21), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b0_21), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b8_21), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b9_21), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06c0_21), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06c8_21), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06d0_21), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06e8_21), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f0_21), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f8_21), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f9_21), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06fa_21), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06fb_21), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ (cpuop_func*)CPUFUNC(op_0800_21), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0810_21), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0818_21), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0820_21), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0828_21), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0830_21), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0838_21), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0839_21), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083a_21), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083b_21), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0840_21), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0850_21), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0858_21), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0860_21), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0868_21), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0870_21), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0878_21), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0879_21), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0880_21), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0890_21), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0898_21), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a0_21), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a8_21), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b0_21), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b8_21), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b9_21), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08c0_21), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d0_21), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d8_21), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e0_21), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e8_21), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f0_21), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f8_21), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f9_21), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0a00_21), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a10_21), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a18_21), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a20_21), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a28_21), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a30_21), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a38_21), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a39_21), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a3c_21), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a40_21), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a50_21), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a58_21), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a60_21), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a68_21), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a70_21), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a78_21), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a79_21), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a7c_21), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a80_21), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a90_21), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a98_21), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa0_21), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa8_21), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab0_21), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab8_21), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab9_21), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ad0_21), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ad8_21), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ae0_21), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ae8_21), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af0_21), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af8_21), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af9_21), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ (cpuop_func*)CPUFUNC(op_0c00_21), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c10_21), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c18_21), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c20_21), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c28_21), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c30_21), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c38_21), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c39_21), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c3a_21), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c3b_21), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ (cpuop_func*)CPUFUNC(op_0c40_21), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c50_21), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c58_21), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c60_21), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c68_21), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c70_21), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c78_21), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c79_21), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c7a_21), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c7b_21), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ (cpuop_func*)CPUFUNC(op_0c80_21), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c90_21), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c98_21), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca0_21), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca8_21), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb0_21), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb8_21), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb9_21), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cba_21), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cbb_21), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cd0_21), 0x0cd0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cd8_21), 0x0cd8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ce0_21), 0x0ce0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ce8_21), 0x0ce8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf0_21), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf8_21), 0x0cf8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf9_21), 0x0cf9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cfc_21), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e10_21), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e18_21), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e20_21), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e28_21), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e30_21), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e38_21), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e39_21), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e50_21), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e58_21), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e60_21), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e68_21), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e70_21), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e78_21), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e79_21), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e90_21), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e98_21), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ea0_21), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ea8_21), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb0_21), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb8_21), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb9_21), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ed0_21), 0x0ed0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ed8_21), 0x0ed8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ee0_21), 0x0ee0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ee8_21), 0x0ee8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef0_21), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef8_21), 0x0ef8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef9_21), 0x0ef9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0efc_21), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ (cpuop_func*)CPUFUNC(op_1000_21), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1010_21), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1018_21), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1020_21), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1028_21), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1030_21), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1038_21), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1039_21), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103a_21), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103b_21), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103c_21), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1080_21), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1090_21), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1098_21), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a0_21), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a8_21), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b0_21), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b8_21), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b9_21), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10ba_21), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bb_21), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bc_21), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10c0_21), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d0_21), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d8_21), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e0_21), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e8_21), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f0_21), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f8_21), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f9_21), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fa_21), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fb_21), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fc_21), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1100_21), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1110_21), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1118_21), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1120_21), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1128_21), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1130_21), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1138_21), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1139_21), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113a_21), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113b_21), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113c_21), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1140_21), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1150_21), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1158_21), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1160_21), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1168_21), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1170_21), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1178_21), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1179_21), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117a_21), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117b_21), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117c_21), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1180_21), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1190_21), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1198_21), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a0_21), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a8_21), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b0_21), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b8_21), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b9_21), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11ba_21), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bb_21), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bc_21), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11c0_21), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d0_21), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d8_21), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e0_21), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e8_21), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f0_21), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f8_21), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f9_21), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fa_21), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fb_21), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fc_21), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13c0_21), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d0_21), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d8_21), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e0_21), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e8_21), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f0_21), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f8_21), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f9_21), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fa_21), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fb_21), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fc_21), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2000_21), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2008_21), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2010_21), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2018_21), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2020_21), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2028_21), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2030_21), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2038_21), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2039_21), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203a_21), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203b_21), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203c_21), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2040_21), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2048_21), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2050_21), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2058_21), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2060_21), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2068_21), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2070_21), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2078_21), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2079_21), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207a_21), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207b_21), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207c_21), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2080_21), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2088_21), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2090_21), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2098_21), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a0_21), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a8_21), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b0_21), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b8_21), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b9_21), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20ba_21), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bb_21), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bc_21), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c0_21), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c8_21), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d0_21), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d8_21), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e0_21), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e8_21), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f0_21), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f8_21), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f9_21), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fa_21), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fb_21), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fc_21), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2100_21), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2108_21), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2110_21), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2118_21), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2120_21), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2128_21), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2130_21), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2138_21), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2139_21), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213a_21), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213b_21), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213c_21), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2140_21), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2148_21), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2150_21), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2158_21), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2160_21), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2168_21), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2170_21), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2178_21), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2179_21), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217a_21), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217b_21), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217c_21), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2180_21), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2188_21), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2190_21), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2198_21), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a0_21), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a8_21), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b0_21), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b8_21), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b9_21), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21ba_21), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bb_21), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bc_21), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c0_21), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c8_21), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d0_21), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d8_21), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e0_21), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e8_21), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f0_21), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f8_21), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f9_21), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fa_21), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fb_21), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fc_21), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c0_21), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c8_21), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d0_21), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d8_21), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e0_21), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e8_21), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f0_21), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f8_21), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f9_21), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fa_21), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fb_21), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fc_21), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3000_21), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3008_21), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3010_21), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3018_21), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3020_21), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3028_21), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3030_21), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3038_21), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3039_21), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303a_21), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303b_21), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303c_21), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3040_21), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3048_21), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3050_21), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3058_21), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3060_21), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3068_21), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3070_21), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3078_21), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3079_21), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307a_21), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307b_21), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307c_21), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3080_21), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3088_21), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3090_21), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3098_21), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a0_21), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a8_21), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b0_21), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b8_21), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b9_21), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30ba_21), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bb_21), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bc_21), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c0_21), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c8_21), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d0_21), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d8_21), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e0_21), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e8_21), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f0_21), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f8_21), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f9_21), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fa_21), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fb_21), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fc_21), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3100_21), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3108_21), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3110_21), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3118_21), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3120_21), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3128_21), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3130_21), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3138_21), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3139_21), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313a_21), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313b_21), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313c_21), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3140_21), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3148_21), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3150_21), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3158_21), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3160_21), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3168_21), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3170_21), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3178_21), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3179_21), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317a_21), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317b_21), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317c_21), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3180_21), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3188_21), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3190_21), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3198_21), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a0_21), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a8_21), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b0_21), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b8_21), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b9_21), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31ba_21), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bb_21), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bc_21), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c0_21), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c8_21), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d0_21), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d8_21), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e0_21), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e8_21), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f0_21), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f8_21), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f9_21), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fa_21), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fb_21), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fc_21), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c0_21), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c8_21), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d0_21), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d8_21), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e0_21), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e8_21), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f0_21), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f8_21), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f9_21), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fa_21), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fb_21), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fc_21), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_4000_21), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4010_21), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4018_21), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4020_21), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4028_21), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4030_21), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4038_21), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4039_21), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4040_21), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4050_21), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4058_21), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4060_21), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4068_21), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4070_21), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4078_21), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4079_21), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4080_21), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4090_21), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4098_21), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a0_21), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a8_21), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b0_21), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b8_21), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b9_21), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40c0_21), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d0_21), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d8_21), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e0_21), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e8_21), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f0_21), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f8_21), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f9_21), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4100_21), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4110_21), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4118_21), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4120_21), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4128_21), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4130_21), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4138_21), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4139_21), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413a_21), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413b_21), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413c_21), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ (cpuop_func*)CPUFUNC(op_4180_21), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4190_21), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4198_21), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a0_21), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a8_21), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b0_21), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b8_21), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b9_21), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41ba_21), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bb_21), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bc_21), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41d0_21), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41e8_21), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f0_21), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f8_21), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f9_21), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fa_21), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fb_21), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_4200_21), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4210_21), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4218_21), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4220_21), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4228_21), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4230_21), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4238_21), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4239_21), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4240_21), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4250_21), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4258_21), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4260_21), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4268_21), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4270_21), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4278_21), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4279_21), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4280_21), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4290_21), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4298_21), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a0_21), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a8_21), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b0_21), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b8_21), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b9_21), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42c0_21), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42d0_21), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42d8_21), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42e0_21), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42e8_21), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f0_21), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f8_21), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f9_21), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ (cpuop_func*)CPUFUNC(op_4400_21), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4410_21), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4418_21), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4420_21), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4428_21), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4430_21), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4438_21), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4439_21), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4440_21), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4450_21), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4458_21), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4460_21), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4468_21), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4470_21), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4478_21), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4479_21), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4480_21), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4490_21), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4498_21), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a0_21), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a8_21), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b0_21), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b8_21), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b9_21), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44c0_21), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d0_21), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d8_21), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e0_21), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e8_21), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f0_21), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f8_21), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f9_21), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fa_21), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fb_21), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fc_21), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4600_21), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4610_21), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4618_21), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4620_21), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4628_21), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4630_21), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4638_21), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4639_21), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4640_21), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4650_21), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4658_21), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4660_21), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4668_21), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4670_21), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4678_21), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4679_21), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4680_21), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4690_21), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4698_21), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a0_21), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a8_21), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b0_21), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b8_21), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b9_21), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46c0_21), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d0_21), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d8_21), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e0_21), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e8_21), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f0_21), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f8_21), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f9_21), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fa_21), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fb_21), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fc_21), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4800_21), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4808_21), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ (cpuop_func*)CPUFUNC(op_4810_21), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4818_21), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4820_21), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4828_21), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4830_21), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4838_21), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4839_21), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4840_21), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4848_21), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ (cpuop_func*)CPUFUNC(op_4850_21), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4868_21), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4870_21), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4878_21), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4879_21), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487a_21), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487b_21), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4880_21), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_4890_21), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a0_21), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a8_21), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b0_21), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b8_21), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b9_21), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48c0_21), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_48d0_21), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e0_21), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e8_21), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f0_21), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f8_21), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f9_21), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_49c0_21), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ (cpuop_func*)CPUFUNC(op_4a00_21), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a10_21), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a18_21), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a20_21), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a28_21), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a30_21), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a38_21), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a39_21), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3a_21), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3b_21), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3c_21), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a40_21), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a48_21), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a50_21), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a58_21), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a60_21), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a68_21), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a70_21), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a78_21), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a79_21), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7a_21), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7b_21), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7c_21), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a80_21), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a88_21), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a90_21), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a98_21), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa0_21), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa8_21), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab0_21), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab8_21), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab9_21), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4aba_21), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4abb_21), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4abc_21), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4ac0_21), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad0_21), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad8_21), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae0_21), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae8_21), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af0_21), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af8_21), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af9_21), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c00_21), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c10_21), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c18_21), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c20_21), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c28_21), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c30_21), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c38_21), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c39_21), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3a_21), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3b_21), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3c_21), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c40_21), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c50_21), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c58_21), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c60_21), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c68_21), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c70_21), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c78_21), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c79_21), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7a_21), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7b_21), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7c_21), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ (cpuop_func*)CPUFUNC(op_4c90_21), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4c98_21), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ca8_21), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb0_21), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb8_21), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb9_21), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cba_21), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cbb_21), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd0_21), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd8_21), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ce8_21), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf0_21), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf8_21), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf9_21), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfa_21), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfb_21), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4e40_21), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ (cpuop_func*)CPUFUNC(op_4e50_21), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ (cpuop_func*)CPUFUNC(op_4e58_21), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ (cpuop_func*)CPUFUNC(op_4e60_21), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ (cpuop_func*)CPUFUNC(op_4e68_21), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ (cpuop_func*)CPUFUNC(op_4e70_21), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ (cpuop_func*)CPUFUNC(op_4e71_21), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ (cpuop_func*)CPUFUNC(op_4e72_21), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ (cpuop_func*)CPUFUNC(op_4e73_21), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e74_21), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ (cpuop_func*)CPUFUNC(op_4e75_21), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ (cpuop_func*)CPUFUNC(op_4e76_21), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ (cpuop_func*)CPUFUNC(op_4e77_21), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e7a_21), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e7b_21), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ (cpuop_func*)CPUFUNC(op_4e90_21), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ea8_21), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb0_21), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb8_21), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb9_21), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eba_21), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ebb_21), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ed0_21), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ee8_21), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef0_21), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef8_21), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef9_21), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efa_21), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efb_21), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_5000_21), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5010_21), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5018_21), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5020_21), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5028_21), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5030_21), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5038_21), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5039_21), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5040_21), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5048_21), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5050_21), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5058_21), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5060_21), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5068_21), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5070_21), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5078_21), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5079_21), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5080_21), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5088_21), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5090_21), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5098_21), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a0_21), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a8_21), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b0_21), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b8_21), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b9_21), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50c0_21), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50c8_21), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_50d0_21), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50d8_21), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e0_21), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e8_21), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f0_21), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f8_21), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f9_21), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fa_21), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fb_21), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fc_21), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5100_21), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5110_21), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5118_21), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5120_21), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5128_21), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5130_21), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5138_21), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5139_21), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5140_21), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5148_21), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5150_21), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5158_21), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5160_21), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5168_21), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5170_21), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5178_21), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5179_21), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5180_21), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5188_21), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5190_21), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5198_21), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a0_21), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a8_21), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b0_21), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b8_21), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b9_21), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51c0_21), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51c8_21), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_51d0_21), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51d8_21), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e0_21), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e8_21), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f0_21), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f8_21), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f9_21), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fa_21), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fb_21), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fc_21), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_52c0_21), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52c8_21), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_52d0_21), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52d8_21), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e0_21), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e8_21), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f0_21), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f8_21), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f9_21), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fa_21), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fb_21), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fc_21), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_53c0_21), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53c8_21), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_53d0_21), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53d8_21), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e0_21), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e8_21), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f0_21), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f8_21), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f9_21), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fa_21), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fb_21), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fc_21), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_54c0_21), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54c8_21), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_54d0_21), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54d8_21), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e0_21), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e8_21), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f0_21), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f8_21), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f9_21), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fa_21), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fb_21), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fc_21), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_55c0_21), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55c8_21), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_55d0_21), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55d8_21), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e0_21), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e8_21), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f0_21), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f8_21), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f9_21), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fa_21), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fb_21), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fc_21), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_56c0_21), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56c8_21), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_56d0_21), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56d8_21), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e0_21), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e8_21), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f0_21), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f8_21), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f9_21), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fa_21), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fb_21), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fc_21), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_57c0_21), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57c8_21), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_57d0_21), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57d8_21), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e0_21), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e8_21), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f0_21), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f8_21), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f9_21), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fa_21), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fb_21), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fc_21), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_58c0_21), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58c8_21), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_58d0_21), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58d8_21), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e0_21), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e8_21), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f0_21), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f8_21), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f9_21), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fa_21), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fb_21), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fc_21), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_59c0_21), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59c8_21), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_59d0_21), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59d8_21), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e0_21), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e8_21), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f0_21), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f8_21), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f9_21), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fa_21), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fb_21), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fc_21), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5ac0_21), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ac8_21), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ad0_21), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ad8_21), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae0_21), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae8_21), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af0_21), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af8_21), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af9_21), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afa_21), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afb_21), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afc_21), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5bc0_21), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bc8_21), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5bd0_21), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bd8_21), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be0_21), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be8_21), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf0_21), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf8_21), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf9_21), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfa_21), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfb_21), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfc_21), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5cc0_21), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cc8_21), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5cd0_21), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cd8_21), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce0_21), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce8_21), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf0_21), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf8_21), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf9_21), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfa_21), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfb_21), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfc_21), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5dc0_21), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dc8_21), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5dd0_21), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dd8_21), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de0_21), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de8_21), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df0_21), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df8_21), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df9_21), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfa_21), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfb_21), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfc_21), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5ec0_21), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ec8_21), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ed0_21), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ed8_21), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee0_21), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee8_21), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef0_21), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef8_21), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef9_21), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efa_21), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efb_21), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efc_21), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5fc0_21), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fc8_21), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5fd0_21), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fd8_21), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe0_21), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe8_21), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff0_21), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff8_21), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff9_21), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffa_21), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffb_21), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffc_21), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_6000_21), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6001_21), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_60ff_21), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6100_21), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6101_21), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_61ff_21), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6200_21), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6201_21), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_62ff_21), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6300_21), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6301_21), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_63ff_21), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6400_21), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6401_21), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_64ff_21), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6500_21), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6501_21), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_65ff_21), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6600_21), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6601_21), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_66ff_21), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6700_21), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6701_21), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_67ff_21), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6800_21), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6801_21), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_68ff_21), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6900_21), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6901_21), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_69ff_21), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a00_21), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a01_21), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6aff_21), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b00_21), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b01_21), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6bff_21), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c00_21), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c01_21), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6cff_21), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d00_21), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d01_21), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6dff_21), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e00_21), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e01_21), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6eff_21), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f00_21), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f01_21), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6fff_21), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_7000_21), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_8000_21), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8010_21), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8018_21), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8020_21), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8028_21), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8030_21), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8038_21), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8039_21), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803a_21), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803b_21), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803c_21), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8040_21), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8050_21), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8058_21), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8060_21), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8068_21), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8070_21), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8078_21), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8079_21), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807a_21), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807b_21), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807c_21), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8080_21), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8090_21), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8098_21), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a0_21), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a8_21), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b0_21), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b8_21), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b9_21), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80ba_21), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bb_21), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bc_21), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80c0_21), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d0_21), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d8_21), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e0_21), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e8_21), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f0_21), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f8_21), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f9_21), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fa_21), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fb_21), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fc_21), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_8100_21), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8108_21), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8110_21), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8118_21), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8120_21), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8128_21), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8130_21), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8138_21), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8139_21), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8140_21), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8148_21), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ (cpuop_func*)CPUFUNC(op_8150_21), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8158_21), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8160_21), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8168_21), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8170_21), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8178_21), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8179_21), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8180_21), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8188_21), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ (cpuop_func*)CPUFUNC(op_8190_21), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8198_21), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a0_21), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a8_21), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b0_21), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b8_21), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b9_21), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81c0_21), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d0_21), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d8_21), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e0_21), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e8_21), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f0_21), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f8_21), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f9_21), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fa_21), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fb_21), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fc_21), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_9000_21), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9010_21), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9018_21), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9020_21), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9028_21), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9030_21), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9038_21), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9039_21), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903a_21), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903b_21), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903c_21), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9040_21), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9048_21), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9050_21), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9058_21), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9060_21), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9068_21), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9070_21), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9078_21), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9079_21), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907a_21), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907b_21), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907c_21), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9080_21), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9088_21), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9090_21), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9098_21), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a0_21), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a8_21), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b0_21), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b8_21), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b9_21), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90ba_21), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bb_21), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bc_21), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90c0_21), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90c8_21), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d0_21), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d8_21), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e0_21), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e8_21), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f0_21), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f8_21), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f9_21), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fa_21), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fb_21), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fc_21), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_9100_21), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9108_21), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9110_21), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9118_21), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9120_21), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9128_21), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9130_21), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9138_21), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9139_21), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9140_21), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9148_21), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9150_21), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9158_21), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9160_21), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9168_21), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9170_21), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9178_21), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9179_21), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9180_21), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9188_21), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9190_21), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9198_21), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a0_21), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a8_21), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b0_21), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b8_21), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b9_21), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91c0_21), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91c8_21), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d0_21), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d8_21), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e0_21), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e8_21), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f0_21), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f8_21), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f9_21), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fa_21), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fb_21), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fc_21), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_b000_21), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b010_21), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b018_21), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b020_21), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b028_21), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b030_21), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b038_21), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b039_21), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03a_21), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03b_21), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03c_21), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b040_21), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b048_21), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b050_21), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b058_21), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b060_21), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b068_21), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b070_21), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b078_21), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b079_21), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07a_21), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07b_21), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07c_21), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b080_21), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b088_21), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b090_21), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b098_21), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a0_21), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a8_21), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b0_21), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b8_21), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b9_21), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0ba_21), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bb_21), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bc_21), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0c0_21), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0c8_21), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d0_21), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d8_21), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e0_21), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e8_21), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f0_21), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f8_21), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f9_21), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fa_21), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fb_21), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fc_21), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b100_21), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b108_21), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b110_21), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b118_21), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b120_21), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b128_21), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b130_21), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b138_21), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b139_21), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b140_21), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b148_21), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b150_21), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b158_21), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b160_21), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b168_21), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b170_21), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b178_21), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b179_21), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b180_21), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b188_21), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b190_21), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b198_21), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a0_21), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a8_21), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b0_21), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b8_21), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b9_21), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1c0_21), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1c8_21), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d0_21), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d8_21), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e0_21), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e8_21), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f0_21), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f8_21), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f9_21), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fa_21), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fb_21), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fc_21), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_c000_21), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c010_21), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c018_21), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c020_21), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c028_21), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c030_21), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c038_21), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c039_21), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03a_21), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03b_21), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03c_21), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c040_21), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c050_21), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c058_21), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c060_21), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c068_21), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c070_21), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c078_21), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c079_21), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07a_21), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07b_21), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07c_21), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c080_21), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c090_21), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c098_21), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a0_21), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a8_21), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b0_21), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b8_21), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b9_21), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0ba_21), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bb_21), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bc_21), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0c0_21), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d0_21), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d8_21), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e0_21), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e8_21), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f0_21), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f8_21), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f9_21), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fa_21), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fb_21), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fc_21), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c100_21), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c108_21), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c110_21), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c118_21), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c120_21), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c128_21), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c130_21), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c138_21), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c139_21), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c140_21), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c148_21), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c150_21), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c158_21), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c160_21), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c168_21), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c170_21), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c178_21), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c179_21), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c188_21), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c190_21), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c198_21), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a0_21), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a8_21), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b0_21), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b8_21), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b9_21), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1c0_21), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d0_21), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d8_21), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e0_21), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e8_21), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f0_21), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f8_21), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f9_21), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fa_21), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fb_21), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fc_21), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_d000_21), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d010_21), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d018_21), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d020_21), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d028_21), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d030_21), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d038_21), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d039_21), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03a_21), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03b_21), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03c_21), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d040_21), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d048_21), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d050_21), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d058_21), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d060_21), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d068_21), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d070_21), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d078_21), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d079_21), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07a_21), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07b_21), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07c_21), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d080_21), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d088_21), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d090_21), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d098_21), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a0_21), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a8_21), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b0_21), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b8_21), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b9_21), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0ba_21), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bb_21), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bc_21), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0c0_21), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0c8_21), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d0_21), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d8_21), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e0_21), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e8_21), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f0_21), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f8_21), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f9_21), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fa_21), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fb_21), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fc_21), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d100_21), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d108_21), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d110_21), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d118_21), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d120_21), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d128_21), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d130_21), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d138_21), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d139_21), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d140_21), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d148_21), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d150_21), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d158_21), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d160_21), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d168_21), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d170_21), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d178_21), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d179_21), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d180_21), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d188_21), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d190_21), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d198_21), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a0_21), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a8_21), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b0_21), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b8_21), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b9_21), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1c0_21), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1c8_21), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d0_21), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d8_21), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e0_21), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e8_21), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f0_21), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f8_21), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f9_21), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fa_21), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fb_21), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fc_21), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_e000_21), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e008_21), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e010_21), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e018_21), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e020_21), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e028_21), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e030_21), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e038_21), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e040_21), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e048_21), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e050_21), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e058_21), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e060_21), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e068_21), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e070_21), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e078_21), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e080_21), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e088_21), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e090_21), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e098_21), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0a0_21), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e0a8_21), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e0b0_21), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e0b8_21), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0d0_21), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0d8_21), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e0_21), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e8_21), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f0_21), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f8_21), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f9_21), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e100_21), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e108_21), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e110_21), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e118_21), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e120_21), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e128_21), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e130_21), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e138_21), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e140_21), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e148_21), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e150_21), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e158_21), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e160_21), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e168_21), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e170_21), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e178_21), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e180_21), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e188_21), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e190_21), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e198_21), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1a0_21), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e1a8_21), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e1b0_21), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e1b8_21), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1d0_21), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1d8_21), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e0_21), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e8_21), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f0_21), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f8_21), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f9_21), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e2d0_21), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2d8_21), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e0_21), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e8_21), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f0_21), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f8_21), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f9_21), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e3d0_21), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3d8_21), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e0_21), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e8_21), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f0_21), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f8_21), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f9_21), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e4d0_21), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4d8_21), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e0_21), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e8_21), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f0_21), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f8_21), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f9_21), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e5d0_21), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5d8_21), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e0_21), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e8_21), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f0_21), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f8_21), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f9_21), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e6d0_21), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6d8_21), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e0_21), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e8_21), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f0_21), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f8_21), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f9_21), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e7d0_21), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7d8_21), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e0_21), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e8_21), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f0_21), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f8_21), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f9_21), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8c0_21), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8d0_21), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8e8_21), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f0_21), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f8_21), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f9_21), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8fa_21), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8fb_21), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9c0_21), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9d0_21), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9e8_21), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f0_21), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f8_21), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f9_21), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9fa_21), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9fb_21), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eac0_21), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ead0_21), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eae8_21), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf0_21), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf8_21), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf9_21), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebc0_21), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebd0_21), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebe8_21), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf0_21), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf8_21), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf9_21), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebfa_21), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebfb_21), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecc0_21), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecd0_21), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ece8_21), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf0_21), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf8_21), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf9_21), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edc0_21), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edd0_21), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ede8_21), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf0_21), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf8_21), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf9_21), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edfa_21), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edfb_21), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eec0_21), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eed0_21), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eee8_21), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef0_21), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef8_21), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef9_21), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efc0_21), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efd0_21), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efe8_21), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff0_21), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff8_21), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff9_21), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f200_21), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f208_21), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f210_21), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f218_21), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f220_21), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f228_21), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f230_21), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f238_21), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f239_21), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23a_21), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23b_21), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23c_21), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f240_21), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f248_21), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f250_21), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f258_21), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f260_21), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f268_21), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f270_21), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f278_21), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f279_21), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27a_21), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27b_21), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27c_21), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f280_21), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f2c0_21), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f310_21), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f320_21), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f328_21), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f330_21), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f338_21), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f339_21), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f350_21), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f358_21), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f368_21), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f370_21), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f378_21), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f379_21), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f37a_21), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f37b_21), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_21 */
#ifdef CPUEMU_22
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_22)[] = {
{ CPUFUNC(op_0000_22), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_22), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_22), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_22), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_22), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_22), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_22), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_22), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_22), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_22), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_22), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_22), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_22), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_22), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_22), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_22), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_22), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_22), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_22), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_22), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_22), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_22), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_22), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_22), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_22), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_22), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00d0_22), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00e8_22), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f0_22), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f8_22), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f9_22), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fa_22), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fb_22), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0100_22), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_22), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_22), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_22), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_22), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_22), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_22), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_22), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_22), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_22), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_22), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_22), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_22), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_22), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_22), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_22), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_22), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_22), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_22), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_22), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_22), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_22), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_22), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_22), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_22), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_22), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_22), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_22), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_22), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_22), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_22), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_22), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_22), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_22), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_22), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_22), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_22), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_22), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_22), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_22), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_22), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_22), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_22), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_22), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_22), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_22), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_22), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_22), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_22), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_22), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_22), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_22), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_22), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_22), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_22), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_22), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_22), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_22), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_22), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_22), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_22), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_22), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_22), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_22), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_22), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02d0_22), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02e8_22), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f0_22), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f8_22), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f9_22), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fa_22), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fb_22), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0400_22), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_22), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_22), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_22), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_22), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_22), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_22), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_22), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_22), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_22), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_22), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_22), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_22), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_22), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_22), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_22), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_22), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_22), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_22), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_22), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_22), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_22), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_22), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_22), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04d0_22), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04e8_22), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f0_22), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f8_22), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f9_22), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fa_22), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fb_22), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0600_22), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_22), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_22), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_22), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_22), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_22), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_22), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_22), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_22), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_22), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_22), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_22), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_22), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_22), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_22), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_22), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_22), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_22), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_22), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_22), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_22), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_22), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_22), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_22), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c0_22), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c8_22), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06d0_22), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06e8_22), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f0_22), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f8_22), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f9_22), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fa_22), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fb_22), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ CPUFUNC(op_0800_22), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_22), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_22), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_22), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_22), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_22), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_22), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_22), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_22), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_22), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_22), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_22), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_22), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_22), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_22), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_22), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_22), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_22), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_22), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_22), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_22), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_22), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_22), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_22), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_22), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_22), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_22), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_22), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_22), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_22), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_22), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_22), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_22), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_22), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_22), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_22), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_22), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_22), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_22), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_22), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_22), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_22), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_22), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_22), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_22), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_22), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_22), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_22), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_22), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_22), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_22), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_22), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_22), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_22), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_22), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_22), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_22), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_22), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_22), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_22), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad0_22), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad8_22), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae0_22), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae8_22), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af0_22), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af8_22), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af9_22), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ CPUFUNC(op_0c00_22), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_22), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_22), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_22), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_22), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_22), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_22), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_22), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3a_22), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3b_22), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c40_22), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_22), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_22), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_22), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_22), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_22), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_22), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_22), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7a_22), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7b_22), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c80_22), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_22), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_22), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_22), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_22), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_22), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_22), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_22), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cba_22), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cbb_22), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd0_22), 0x0cd0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd8_22), 0x0cd8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce0_22), 0x0ce0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce8_22), 0x0ce8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf0_22), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf8_22), 0x0cf8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf9_22), 0x0cf9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cfc_22), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e10_22), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e18_22), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e20_22), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e28_22), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e30_22), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e38_22), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e39_22), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e50_22), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e58_22), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e60_22), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e68_22), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e70_22), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e78_22), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e79_22), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e90_22), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e98_22), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea0_22), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea8_22), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb0_22), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb8_22), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb9_22), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed0_22), 0x0ed0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed8_22), 0x0ed8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee0_22), 0x0ee0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee8_22), 0x0ee8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef0_22), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef8_22), 0x0ef8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef9_22), 0x0ef9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0efc_22), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ CPUFUNC(op_1000_22), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_22), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_22), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_22), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_22), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_22), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_22), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_22), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_22), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_22), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_22), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_22), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_22), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_22), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_22), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_22), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_22), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_22), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_22), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_22), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_22), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_22), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_22), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_22), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_22), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_22), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_22), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_22), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_22), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_22), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_22), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_22), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_22), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_22), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_22), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_22), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_22), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_22), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_22), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_22), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_22), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_22), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_22), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_22), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_22), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_22), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_22), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_22), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_22), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_22), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_22), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_22), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_22), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_22), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_22), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_22), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_22), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_22), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_22), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_22), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_22), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_22), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_22), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_22), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_22), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_22), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_22), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_22), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_22), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_22), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_22), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_22), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_22), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_22), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_22), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_22), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_22), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_22), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_22), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_22), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_22), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_22), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_22), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_22), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_22), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_22), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_22), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_22), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_22), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_22), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_22), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_22), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_22), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_22), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_22), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_22), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_22), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_22), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_22), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_22), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_22), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_22), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_22), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_22), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_22), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_22), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_22), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_22), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_22), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_22), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_22), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_22), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_22), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_22), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_22), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_22), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_22), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_22), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_22), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_22), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_22), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_22), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_22), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_22), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_22), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_22), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_22), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_22), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_22), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_22), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_22), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_22), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_22), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_22), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_22), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_22), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_22), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_22), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_22), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_22), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_22), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_22), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_22), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_22), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_22), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_22), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_22), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_22), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_22), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_22), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_22), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_22), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_22), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_22), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_22), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_22), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_22), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_22), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_22), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_22), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_22), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_22), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_22), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_22), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_22), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_22), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_22), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_22), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_22), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_22), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_22), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_22), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_22), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_22), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_22), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_22), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_22), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_22), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_22), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_22), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_22), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_22), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_22), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_22), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_22), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_22), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_22), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_22), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_22), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_22), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_22), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_22), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_22), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_22), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_22), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_22), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_22), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_22), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_22), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_22), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_22), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_22), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_22), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_22), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_22), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_22), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_22), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_22), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_22), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_22), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_22), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_22), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_22), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_22), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_22), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_22), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_22), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_22), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_22), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_22), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_22), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_22), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_22), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_22), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_22), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_22), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_22), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_22), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_22), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_22), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_22), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_22), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_22), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_22), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_22), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_22), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_22), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_22), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_22), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_22), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_22), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_22), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_22), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_22), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_22), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_22), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_22), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_22), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_22), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_22), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_22), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_22), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_22), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_22), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_22), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_22), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_22), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_22), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_22), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_22), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_22), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_22), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_22), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_22), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_22), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_22), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_22), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_22), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_22), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_22), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_22), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_22), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_22), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_22), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_22), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_22), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_22), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_22), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_22), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_22), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_22), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_22), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_22), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_22), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_22), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_22), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_22), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_22), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_22), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_22), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_22), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_22), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_22), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_22), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_22), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_22), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_22), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_22), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_22), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_22), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_22), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_22), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_22), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_22), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_22), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_22), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_22), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_22), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_22), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_22), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_22), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_22), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_22), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_22), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_22), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_22), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_22), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_22), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_22), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_22), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_22), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_22), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_22), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_22), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_22), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_22), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_22), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_22), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_22), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_22), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_22), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_22), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_22), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_22), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_22), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_22), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4100_22), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4110_22), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4118_22), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4120_22), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4128_22), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4130_22), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4138_22), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4139_22), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413a_22), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413b_22), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413c_22), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ CPUFUNC(op_4180_22), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_22), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_22), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_22), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_22), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_22), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_22), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_22), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_22), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_22), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_22), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_22), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_22), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_22), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_22), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_22), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_22), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_22), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_22), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_22), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_22), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_22), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_22), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_22), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_22), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_22), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_22), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_22), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_22), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_22), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_22), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_22), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_22), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_22), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_22), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_22), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_22), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_22), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_22), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_22), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_22), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_22), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_22), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_22), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_22), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_22), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_22), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_22), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_22), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_22), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_22), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_22), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_22), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_22), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_22), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_22), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_22), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_22), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_22), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_22), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_22), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_22), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_22), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_22), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_22), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_22), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_22), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_22), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_22), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_22), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_22), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_22), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_22), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_22), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_22), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_22), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_22), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_22), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_22), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_22), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_22), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_22), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_22), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_22), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_22), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_22), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_22), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_22), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_22), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_22), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_22), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_22), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_22), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_22), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_22), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_22), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_22), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_22), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_22), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_22), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_22), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_22), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_22), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_22), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_22), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_22), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_22), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_22), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_22), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_22), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_22), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_22), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_22), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_22), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_22), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_22), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_22), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_22), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_22), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_22), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_22), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4808_22), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ CPUFUNC(op_4810_22), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_22), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_22), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_22), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_22), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_22), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_22), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_22), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4848_22), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ CPUFUNC(op_4850_22), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_22), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_22), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_22), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_22), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_22), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_22), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_22), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_22), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_22), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_22), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_22), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_22), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_22), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_22), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_22), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_22), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_22), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_22), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_22), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_22), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_49c0_22), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ CPUFUNC(op_4a00_22), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_22), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_22), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_22), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_22), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_22), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_22), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_22), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3a_22), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3b_22), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3c_22), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a40_22), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a48_22), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a50_22), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_22), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_22), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_22), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_22), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_22), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_22), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7a_22), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7b_22), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7c_22), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a80_22), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a88_22), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a90_22), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_22), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_22), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_22), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_22), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_22), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_22), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4aba_22), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abb_22), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abc_22), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4ac0_22), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_22), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_22), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_22), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_22), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_22), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_22), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_22), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c00_22), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c10_22), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c18_22), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c20_22), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c28_22), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c30_22), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c38_22), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c39_22), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3a_22), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3b_22), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3c_22), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c40_22), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c50_22), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c58_22), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c60_22), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c68_22), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c70_22), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c78_22), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c79_22), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7a_22), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7b_22), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7c_22), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ CPUFUNC(op_4c90_22), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_22), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_22), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_22), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_22), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_22), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_22), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_22), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_22), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_22), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_22), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_22), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_22), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_22), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_22), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_22), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_22), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_22), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_22), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_22), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_22), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_22), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_22), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_22), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_22), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_22), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_22), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_22), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_22), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_22), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_22), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_22), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_22), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_22), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_22), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_22), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_22), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_22), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_22), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_22), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_22), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_22), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_22), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_22), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_22), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_22), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_22), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_22), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_22), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_22), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_22), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_22), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_22), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_22), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_22), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_22), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_22), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_22), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_22), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_22), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_22), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_22), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_22), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_22), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_22), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_22), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_22), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_22), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_22), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_22), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_22), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_22), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_22), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_22), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_22), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_22), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_22), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_22), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_22), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_22), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fa_22), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fb_22), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fc_22), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5100_22), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_22), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_22), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_22), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_22), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_22), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_22), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_22), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_22), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_22), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_22), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_22), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_22), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_22), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_22), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_22), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_22), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_22), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_22), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_22), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_22), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_22), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_22), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_22), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_22), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_22), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_22), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_22), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_22), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_22), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_22), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_22), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_22), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_22), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_22), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fa_22), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fb_22), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fc_22), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_52c0_22), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_22), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_22), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_22), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_22), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_22), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_22), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_22), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_22), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fa_22), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fb_22), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fc_22), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_53c0_22), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_22), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_22), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_22), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_22), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_22), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_22), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_22), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_22), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fa_22), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fb_22), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fc_22), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_54c0_22), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_22), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_22), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_22), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_22), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_22), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_22), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_22), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_22), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fa_22), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fb_22), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fc_22), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_55c0_22), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_22), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_22), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_22), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_22), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_22), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_22), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_22), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_22), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fa_22), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fb_22), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fc_22), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_56c0_22), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_22), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_22), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_22), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_22), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_22), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_22), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_22), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_22), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fa_22), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fb_22), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fc_22), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_57c0_22), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_22), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_22), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_22), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_22), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_22), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_22), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_22), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_22), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fa_22), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fb_22), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fc_22), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_58c0_22), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_22), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_22), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_22), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_22), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_22), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_22), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_22), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_22), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fa_22), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fb_22), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fc_22), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_59c0_22), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_22), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_22), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_22), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_22), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_22), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_22), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_22), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_22), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fa_22), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fb_22), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fc_22), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ac0_22), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_22), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_22), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_22), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_22), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_22), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_22), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_22), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_22), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afa_22), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afb_22), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afc_22), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5bc0_22), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_22), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_22), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_22), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_22), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_22), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_22), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_22), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_22), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfa_22), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfb_22), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfc_22), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5cc0_22), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_22), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_22), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_22), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_22), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_22), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_22), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_22), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_22), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfa_22), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfb_22), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfc_22), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5dc0_22), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_22), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_22), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_22), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_22), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_22), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_22), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_22), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_22), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfa_22), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfb_22), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfc_22), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ec0_22), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_22), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_22), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_22), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_22), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_22), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_22), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_22), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_22), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efa_22), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efb_22), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efc_22), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5fc0_22), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_22), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_22), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_22), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_22), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_22), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_22), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_22), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_22), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffa_22), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffb_22), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffc_22), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_6000_22), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_22), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_22), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_22), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_22), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_22), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_22), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_22), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_22), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_22), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_22), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_22), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_22), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_22), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_22), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_22), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_22), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_22), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_22), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_22), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_22), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_22), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_22), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_22), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_22), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_22), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_22), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_22), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_22), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_22), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_22), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_22), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_22), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_22), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_22), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_22), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_22), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_22), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_22), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_22), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_22), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_22), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_22), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_22), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_22), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_22), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_22), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_22), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_22), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_22), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_22), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_22), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_22), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_22), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_22), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_22), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_22), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_22), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_22), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_22), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_22), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_22), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_22), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_22), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_22), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_22), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_22), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_22), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_22), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_22), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_22), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_22), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_22), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_22), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_22), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_22), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_22), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_22), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_22), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_22), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_22), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_22), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_22), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_22), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_22), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_22), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_22), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_22), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_22), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_22), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_22), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_22), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_22), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_22), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_22), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_22), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_22), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_22), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_22), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_22), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_22), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_22), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8140_22), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8148_22), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ CPUFUNC(op_8150_22), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_22), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_22), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_22), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_22), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_22), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_22), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8180_22), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8188_22), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ CPUFUNC(op_8190_22), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_22), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_22), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_22), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_22), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_22), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_22), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_22), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_22), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_22), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_22), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_22), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_22), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_22), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_22), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_22), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_22), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_22), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_22), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_22), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_22), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_22), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_22), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_22), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_22), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_22), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_22), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_22), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_22), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_22), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_22), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_22), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_22), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_22), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_22), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_22), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_22), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_22), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_22), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_22), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_22), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_22), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_22), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_22), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_22), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_22), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_22), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_22), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_22), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_22), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_22), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_22), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_22), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_22), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_22), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_22), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_22), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_22), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_22), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_22), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_22), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_22), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_22), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_22), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_22), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_22), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_22), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_22), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_22), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_22), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_22), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_22), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_22), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_22), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_22), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_22), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_22), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_22), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_22), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_22), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_22), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_22), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_22), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_22), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_22), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_22), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_22), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_22), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_22), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_22), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_22), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_22), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_22), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_22), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_22), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_22), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_22), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_22), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_22), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_22), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_22), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_22), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_22), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_22), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_22), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_22), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_22), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_22), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_22), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_22), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_22), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_22), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_22), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_22), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_22), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_22), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_22), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_22), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_22), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_22), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_22), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_22), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_22), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_22), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_22), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_22), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_22), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_22), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_22), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_22), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_22), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_22), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_22), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_22), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_22), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_22), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_22), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_22), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_22), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_22), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_22), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_22), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_22), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_22), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_22), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_22), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_22), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_22), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_22), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_22), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_22), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_22), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_22), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_22), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_22), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_22), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_22), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_22), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_22), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_22), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_22), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_22), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_22), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_22), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_22), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_22), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_22), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_22), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_22), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_22), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_22), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_22), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_22), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_22), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_22), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_22), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_22), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_22), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_22), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_22), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_22), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_22), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_22), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_22), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_22), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_22), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_22), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_22), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_22), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_22), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_22), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_22), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_22), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_22), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_22), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_22), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_22), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_22), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_22), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_22), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_22), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_22), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_22), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_22), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_22), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_22), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_22), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_22), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_22), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_22), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_22), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_22), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_22), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_22), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_22), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_22), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_22), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_22), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_22), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_22), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_22), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_22), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_22), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_22), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_22), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_22), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_22), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_22), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_22), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_22), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_22), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_22), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_22), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_22), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_22), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_22), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_22), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_22), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_22), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_22), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_22), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_22), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_22), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_22), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_22), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_22), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_22), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_22), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_22), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_22), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_22), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_22), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_22), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_22), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_22), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_22), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_22), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_22), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_22), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_22), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_22), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_22), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_22), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_22), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_22), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_22), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_22), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_22), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_22), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_22), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_22), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_22), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_22), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_22), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_22), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_22), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_22), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_22), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_22), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_22), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_22), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_22), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_22), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_22), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_22), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_22), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_22), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_22), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_22), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_22), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_22), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_22), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_22), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_22), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_22), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_22), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_22), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_22), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_22), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_22), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_22), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_22), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_22), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_22), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_22), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_22), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_22), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_22), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_22), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_22), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_22), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_22), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_22), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_22), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_22), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_22), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_22), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_22), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_22), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_22), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_22), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_22), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_22), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_22), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_22), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_22), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_22), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_22), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_22), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_22), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_22), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_22), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_22), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_22), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_22), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_22), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_22), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_22), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_22), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_22), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_22), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_22), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_22), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_22), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_22), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_22), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_22), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_22), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_22), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_22), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_22), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_22), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_22), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_22), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_22), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_22), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_22), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_22), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_22), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_22), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_22), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_22), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_22), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_22), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_22), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_22), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_22), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_22), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_22), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_22), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_22), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_22), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_22), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_22), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_22), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_22), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_22), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_22), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_22), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_22), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_22), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_22), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_22), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_22), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_22), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_22), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_22), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_22), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_22), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_22), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_22), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_22), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_22), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_22), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_22), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_22), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_22), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_22), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_22), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_22), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_22), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_22), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_22), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_22), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_22), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_22), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_22), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_22), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_22), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_22), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_22), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_22), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_22), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_22), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_22), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_22), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_22), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_22), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_22), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_22), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_22), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_22), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_22), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_22), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_22), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_22), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_22), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_22), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_22), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_22), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_22), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_22), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_22), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_22), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_22), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_22), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_22), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_22), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_22), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_22), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_22), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_22), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_22), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_22), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_22), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_22), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_22), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_22), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_22), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_22), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_22), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_22), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_22), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_22), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_22), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_22), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_22), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_22), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_22), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_22), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_22), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8c0_22), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8d0_22), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8e8_22), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f0_22), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f8_22), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f9_22), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fa_22), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fb_22), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9c0_22), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9d0_22), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9e8_22), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f0_22), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f8_22), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f9_22), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fa_22), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fb_22), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eac0_22), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ead0_22), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eae8_22), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf0_22), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf8_22), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf9_22), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebc0_22), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebd0_22), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebe8_22), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf0_22), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf8_22), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf9_22), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfa_22), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfb_22), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecc0_22), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecd0_22), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ece8_22), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf0_22), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf8_22), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf9_22), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edc0_22), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edd0_22), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ede8_22), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf0_22), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf8_22), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf9_22), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfa_22), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfb_22), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eec0_22), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eed0_22), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eee8_22), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef0_22), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef8_22), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef9_22), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efc0_22), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efd0_22), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efe8_22), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff0_22), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff8_22), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff9_22), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f000_22), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f008_22), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f010_22), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f018_22), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f020_22), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f028_22), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f030_22), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f038_22), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f039_22), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f200_22), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f208_22), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f210_22), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f218_22), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f220_22), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f228_22), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f230_22), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f238_22), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f239_22), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23a_22), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23b_22), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23c_22), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f240_22), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f248_22), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f250_22), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f258_22), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f260_22), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f268_22), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f270_22), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f278_22), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f279_22), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27a_22), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27b_22), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27c_22), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f280_22), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f2c0_22), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f310_22), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f320_22), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f328_22), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f330_22), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f338_22), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f339_22), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f350_22), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f358_22), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f368_22), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f370_22), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f378_22), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f379_22), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37a_22), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37b_22), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_22 */
#ifdef CPUEMU_23
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_23)[] = {
{ (cpuop_func*)CPUFUNC(op_0000_23), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0010_23), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0018_23), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0020_23), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0028_23), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0030_23), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0038_23), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0039_23), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_003c_23), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0040_23), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0050_23), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0058_23), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0060_23), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0068_23), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0070_23), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0078_23), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0079_23), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_007c_23), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0080_23), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0090_23), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0098_23), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a0_23), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a8_23), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b0_23), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b8_23), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b9_23), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00d0_23), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00e8_23), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f0_23), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f8_23), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f9_23), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00fa_23), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00fb_23), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0100_23), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0108_23), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0110_23), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0118_23), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0120_23), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0128_23), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0130_23), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0138_23), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0139_23), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013a_23), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013b_23), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013c_23), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0140_23), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0148_23), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0150_23), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0158_23), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0160_23), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0168_23), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0170_23), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0178_23), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0179_23), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0180_23), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0188_23), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_0190_23), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0198_23), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a0_23), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a8_23), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b0_23), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b8_23), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b9_23), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01c0_23), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01c8_23), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_01d0_23), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01d8_23), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e0_23), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e8_23), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f0_23), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f8_23), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f9_23), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0200_23), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0210_23), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0218_23), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0220_23), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0228_23), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0230_23), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0238_23), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0239_23), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_023c_23), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0240_23), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0250_23), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0258_23), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0260_23), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0268_23), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0270_23), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0278_23), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0279_23), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_027c_23), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0280_23), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0290_23), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0298_23), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a0_23), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a8_23), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b0_23), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b8_23), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b9_23), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02d0_23), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02e8_23), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f0_23), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f8_23), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f9_23), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02fa_23), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02fb_23), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0400_23), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0410_23), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0418_23), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0420_23), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0428_23), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0430_23), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0438_23), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0439_23), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0440_23), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0450_23), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0458_23), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0460_23), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0468_23), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0470_23), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0478_23), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0479_23), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0480_23), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0490_23), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0498_23), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a0_23), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a8_23), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b0_23), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b8_23), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b9_23), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04d0_23), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04e8_23), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f0_23), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f8_23), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f9_23), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04fa_23), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04fb_23), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0600_23), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0610_23), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0618_23), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0620_23), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0628_23), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0630_23), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0638_23), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0639_23), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0640_23), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0650_23), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0658_23), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0660_23), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0668_23), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0670_23), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0678_23), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0679_23), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0680_23), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0690_23), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0698_23), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a0_23), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a8_23), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b0_23), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b8_23), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b9_23), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06c0_23), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06c8_23), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06d0_23), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06e8_23), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f0_23), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f8_23), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f9_23), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06fa_23), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06fb_23), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ (cpuop_func*)CPUFUNC(op_0800_23), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0810_23), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0818_23), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0820_23), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0828_23), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0830_23), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0838_23), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0839_23), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083a_23), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083b_23), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0840_23), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0850_23), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0858_23), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0860_23), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0868_23), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0870_23), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0878_23), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0879_23), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0880_23), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0890_23), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0898_23), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a0_23), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a8_23), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b0_23), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b8_23), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b9_23), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08c0_23), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d0_23), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d8_23), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e0_23), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e8_23), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f0_23), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f8_23), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f9_23), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0a00_23), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a10_23), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a18_23), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a20_23), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a28_23), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a30_23), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a38_23), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a39_23), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a3c_23), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a40_23), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a50_23), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a58_23), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a60_23), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a68_23), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a70_23), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a78_23), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a79_23), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a7c_23), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a80_23), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a90_23), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a98_23), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa0_23), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa8_23), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab0_23), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab8_23), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab9_23), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ad0_23), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ad8_23), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ae0_23), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ae8_23), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af0_23), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af8_23), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af9_23), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ (cpuop_func*)CPUFUNC(op_0c00_23), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c10_23), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c18_23), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c20_23), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c28_23), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c30_23), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c38_23), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c39_23), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c3a_23), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c3b_23), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ (cpuop_func*)CPUFUNC(op_0c40_23), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c50_23), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c58_23), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c60_23), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c68_23), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c70_23), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c78_23), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c79_23), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c7a_23), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c7b_23), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ (cpuop_func*)CPUFUNC(op_0c80_23), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c90_23), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c98_23), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca0_23), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca8_23), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb0_23), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb8_23), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb9_23), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cba_23), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cbb_23), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cd0_23), 0x0cd0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cd8_23), 0x0cd8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ce0_23), 0x0ce0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ce8_23), 0x0ce8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf0_23), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf8_23), 0x0cf8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf9_23), 0x0cf9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cfc_23), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e10_23), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e18_23), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e20_23), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e28_23), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e30_23), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e38_23), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e39_23), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e50_23), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e58_23), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e60_23), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e68_23), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e70_23), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e78_23), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e79_23), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e90_23), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e98_23), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ea0_23), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ea8_23), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb0_23), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb8_23), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb9_23), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ed0_23), 0x0ed0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ed8_23), 0x0ed8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ee0_23), 0x0ee0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ee8_23), 0x0ee8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef0_23), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef8_23), 0x0ef8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef9_23), 0x0ef9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0efc_23), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ (cpuop_func*)CPUFUNC(op_1000_23), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1010_23), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1018_23), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1020_23), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1028_23), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1030_23), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1038_23), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1039_23), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103a_23), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103b_23), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103c_23), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1080_23), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1090_23), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1098_23), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a0_23), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a8_23), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b0_23), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b8_23), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b9_23), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10ba_23), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bb_23), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bc_23), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10c0_23), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d0_23), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d8_23), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e0_23), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e8_23), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f0_23), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f8_23), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f9_23), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fa_23), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fb_23), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fc_23), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1100_23), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1110_23), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1118_23), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1120_23), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1128_23), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1130_23), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1138_23), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1139_23), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113a_23), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113b_23), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113c_23), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1140_23), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1150_23), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1158_23), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1160_23), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1168_23), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1170_23), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1178_23), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1179_23), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117a_23), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117b_23), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117c_23), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1180_23), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1190_23), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1198_23), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a0_23), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a8_23), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b0_23), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b8_23), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b9_23), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11ba_23), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bb_23), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bc_23), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11c0_23), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d0_23), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d8_23), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e0_23), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e8_23), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f0_23), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f8_23), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f9_23), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fa_23), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fb_23), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fc_23), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13c0_23), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d0_23), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d8_23), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e0_23), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e8_23), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f0_23), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f8_23), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f9_23), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fa_23), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fb_23), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fc_23), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2000_23), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2008_23), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2010_23), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2018_23), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2020_23), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2028_23), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2030_23), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2038_23), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2039_23), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203a_23), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203b_23), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203c_23), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2040_23), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2048_23), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2050_23), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2058_23), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2060_23), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2068_23), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2070_23), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2078_23), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2079_23), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207a_23), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207b_23), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207c_23), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2080_23), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2088_23), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2090_23), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2098_23), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a0_23), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a8_23), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b0_23), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b8_23), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b9_23), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20ba_23), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bb_23), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bc_23), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c0_23), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c8_23), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d0_23), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d8_23), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e0_23), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e8_23), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f0_23), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f8_23), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f9_23), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fa_23), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fb_23), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fc_23), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2100_23), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2108_23), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2110_23), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2118_23), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2120_23), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2128_23), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2130_23), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2138_23), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2139_23), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213a_23), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213b_23), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213c_23), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2140_23), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2148_23), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2150_23), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2158_23), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2160_23), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2168_23), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2170_23), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2178_23), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2179_23), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217a_23), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217b_23), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217c_23), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2180_23), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2188_23), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2190_23), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2198_23), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a0_23), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a8_23), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b0_23), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b8_23), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b9_23), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21ba_23), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bb_23), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bc_23), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c0_23), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c8_23), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d0_23), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d8_23), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e0_23), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e8_23), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f0_23), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f8_23), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f9_23), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fa_23), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fb_23), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fc_23), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c0_23), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c8_23), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d0_23), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d8_23), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e0_23), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e8_23), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f0_23), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f8_23), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f9_23), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fa_23), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fb_23), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fc_23), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3000_23), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3008_23), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3010_23), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3018_23), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3020_23), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3028_23), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3030_23), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3038_23), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3039_23), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303a_23), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303b_23), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303c_23), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3040_23), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3048_23), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3050_23), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3058_23), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3060_23), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3068_23), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3070_23), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3078_23), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3079_23), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307a_23), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307b_23), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307c_23), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3080_23), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3088_23), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3090_23), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3098_23), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a0_23), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a8_23), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b0_23), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b8_23), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b9_23), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30ba_23), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bb_23), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bc_23), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c0_23), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c8_23), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d0_23), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d8_23), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e0_23), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e8_23), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f0_23), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f8_23), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f9_23), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fa_23), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fb_23), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fc_23), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3100_23), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3108_23), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3110_23), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3118_23), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3120_23), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3128_23), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3130_23), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3138_23), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3139_23), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313a_23), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313b_23), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313c_23), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3140_23), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3148_23), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3150_23), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3158_23), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3160_23), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3168_23), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3170_23), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3178_23), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3179_23), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317a_23), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317b_23), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317c_23), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3180_23), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3188_23), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3190_23), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3198_23), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a0_23), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a8_23), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b0_23), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b8_23), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b9_23), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31ba_23), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bb_23), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bc_23), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c0_23), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c8_23), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d0_23), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d8_23), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e0_23), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e8_23), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f0_23), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f8_23), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f9_23), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fa_23), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fb_23), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fc_23), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c0_23), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c8_23), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d0_23), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d8_23), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e0_23), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e8_23), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f0_23), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f8_23), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f9_23), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fa_23), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fb_23), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fc_23), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_4000_23), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4010_23), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4018_23), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4020_23), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4028_23), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4030_23), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4038_23), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4039_23), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4040_23), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4050_23), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4058_23), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4060_23), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4068_23), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4070_23), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4078_23), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4079_23), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4080_23), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4090_23), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4098_23), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a0_23), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a8_23), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b0_23), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b8_23), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b9_23), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40c0_23), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d0_23), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d8_23), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e0_23), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e8_23), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f0_23), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f8_23), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f9_23), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4100_23), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4110_23), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4118_23), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4120_23), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4128_23), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4130_23), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4138_23), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4139_23), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413a_23), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413b_23), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413c_23), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ (cpuop_func*)CPUFUNC(op_4180_23), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4190_23), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4198_23), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a0_23), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a8_23), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b0_23), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b8_23), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b9_23), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41ba_23), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bb_23), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bc_23), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41d0_23), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41e8_23), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f0_23), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f8_23), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f9_23), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fa_23), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fb_23), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_4200_23), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4210_23), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4218_23), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4220_23), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4228_23), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4230_23), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4238_23), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4239_23), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4240_23), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4250_23), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4258_23), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4260_23), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4268_23), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4270_23), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4278_23), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4279_23), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4280_23), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4290_23), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4298_23), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a0_23), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a8_23), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b0_23), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b8_23), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b9_23), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42c0_23), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42d0_23), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42d8_23), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42e0_23), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42e8_23), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f0_23), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f8_23), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f9_23), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ (cpuop_func*)CPUFUNC(op_4400_23), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4410_23), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4418_23), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4420_23), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4428_23), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4430_23), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4438_23), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4439_23), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4440_23), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4450_23), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4458_23), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4460_23), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4468_23), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4470_23), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4478_23), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4479_23), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4480_23), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4490_23), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4498_23), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a0_23), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a8_23), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b0_23), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b8_23), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b9_23), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44c0_23), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d0_23), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d8_23), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e0_23), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e8_23), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f0_23), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f8_23), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f9_23), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fa_23), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fb_23), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fc_23), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4600_23), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4610_23), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4618_23), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4620_23), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4628_23), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4630_23), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4638_23), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4639_23), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4640_23), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4650_23), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4658_23), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4660_23), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4668_23), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4670_23), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4678_23), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4679_23), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4680_23), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4690_23), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4698_23), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a0_23), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a8_23), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b0_23), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b8_23), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b9_23), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46c0_23), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d0_23), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d8_23), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e0_23), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e8_23), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f0_23), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f8_23), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f9_23), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fa_23), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fb_23), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fc_23), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4800_23), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4808_23), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ (cpuop_func*)CPUFUNC(op_4810_23), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4818_23), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4820_23), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4828_23), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4830_23), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4838_23), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4839_23), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4840_23), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4848_23), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ (cpuop_func*)CPUFUNC(op_4850_23), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4868_23), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4870_23), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4878_23), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4879_23), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487a_23), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487b_23), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4880_23), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_4890_23), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a0_23), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a8_23), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b0_23), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b8_23), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b9_23), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48c0_23), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_48d0_23), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e0_23), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e8_23), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f0_23), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f8_23), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f9_23), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_49c0_23), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ (cpuop_func*)CPUFUNC(op_4a00_23), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a10_23), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a18_23), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a20_23), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a28_23), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a30_23), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a38_23), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a39_23), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3a_23), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3b_23), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3c_23), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a40_23), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a48_23), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a50_23), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a58_23), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a60_23), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a68_23), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a70_23), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a78_23), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a79_23), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7a_23), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7b_23), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7c_23), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a80_23), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a88_23), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a90_23), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a98_23), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa0_23), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa8_23), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab0_23), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab8_23), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab9_23), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4aba_23), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4abb_23), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4abc_23), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4ac0_23), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad0_23), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad8_23), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae0_23), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae8_23), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af0_23), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af8_23), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af9_23), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c00_23), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c10_23), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c18_23), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c20_23), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c28_23), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c30_23), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c38_23), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c39_23), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3a_23), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3b_23), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3c_23), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c40_23), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c50_23), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c58_23), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c60_23), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c68_23), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c70_23), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c78_23), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c79_23), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7a_23), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7b_23), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7c_23), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ (cpuop_func*)CPUFUNC(op_4c90_23), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4c98_23), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ca8_23), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb0_23), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb8_23), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb9_23), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cba_23), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cbb_23), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd0_23), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd8_23), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ce8_23), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf0_23), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf8_23), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf9_23), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfa_23), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfb_23), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4e40_23), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ (cpuop_func*)CPUFUNC(op_4e50_23), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ (cpuop_func*)CPUFUNC(op_4e58_23), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ (cpuop_func*)CPUFUNC(op_4e60_23), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ (cpuop_func*)CPUFUNC(op_4e68_23), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ (cpuop_func*)CPUFUNC(op_4e70_23), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ (cpuop_func*)CPUFUNC(op_4e71_23), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ (cpuop_func*)CPUFUNC(op_4e72_23), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ (cpuop_func*)CPUFUNC(op_4e73_23), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e74_23), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ (cpuop_func*)CPUFUNC(op_4e75_23), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ (cpuop_func*)CPUFUNC(op_4e76_23), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ (cpuop_func*)CPUFUNC(op_4e77_23), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e7a_23), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e7b_23), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ (cpuop_func*)CPUFUNC(op_4e90_23), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ea8_23), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb0_23), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb8_23), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb9_23), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eba_23), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ebb_23), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ed0_23), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ee8_23), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef0_23), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef8_23), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef9_23), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efa_23), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efb_23), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_5000_23), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5010_23), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5018_23), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5020_23), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5028_23), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5030_23), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5038_23), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5039_23), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5040_23), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5048_23), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5050_23), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5058_23), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5060_23), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5068_23), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5070_23), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5078_23), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5079_23), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5080_23), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5088_23), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5090_23), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5098_23), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a0_23), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a8_23), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b0_23), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b8_23), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b9_23), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50c0_23), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50c8_23), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_50d0_23), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50d8_23), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e0_23), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e8_23), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f0_23), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f8_23), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f9_23), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fa_23), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fb_23), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fc_23), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5100_23), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5110_23), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5118_23), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5120_23), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5128_23), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5130_23), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5138_23), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5139_23), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5140_23), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5148_23), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5150_23), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5158_23), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5160_23), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5168_23), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5170_23), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5178_23), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5179_23), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5180_23), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5188_23), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5190_23), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5198_23), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a0_23), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a8_23), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b0_23), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b8_23), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b9_23), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51c0_23), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51c8_23), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_51d0_23), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51d8_23), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e0_23), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e8_23), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f0_23), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f8_23), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f9_23), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fa_23), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fb_23), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fc_23), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_52c0_23), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52c8_23), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_52d0_23), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52d8_23), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e0_23), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e8_23), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f0_23), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f8_23), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f9_23), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fa_23), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fb_23), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fc_23), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_53c0_23), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53c8_23), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_53d0_23), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53d8_23), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e0_23), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e8_23), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f0_23), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f8_23), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f9_23), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fa_23), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fb_23), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fc_23), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_54c0_23), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54c8_23), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_54d0_23), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54d8_23), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e0_23), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e8_23), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f0_23), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f8_23), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f9_23), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fa_23), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fb_23), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fc_23), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_55c0_23), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55c8_23), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_55d0_23), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55d8_23), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e0_23), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e8_23), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f0_23), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f8_23), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f9_23), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fa_23), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fb_23), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fc_23), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_56c0_23), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56c8_23), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_56d0_23), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56d8_23), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e0_23), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e8_23), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f0_23), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f8_23), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f9_23), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fa_23), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fb_23), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fc_23), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_57c0_23), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57c8_23), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_57d0_23), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57d8_23), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e0_23), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e8_23), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f0_23), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f8_23), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f9_23), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fa_23), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fb_23), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fc_23), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_58c0_23), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58c8_23), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_58d0_23), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58d8_23), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e0_23), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e8_23), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f0_23), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f8_23), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f9_23), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fa_23), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fb_23), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fc_23), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_59c0_23), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59c8_23), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_59d0_23), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59d8_23), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e0_23), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e8_23), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f0_23), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f8_23), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f9_23), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fa_23), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fb_23), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fc_23), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5ac0_23), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ac8_23), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ad0_23), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ad8_23), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae0_23), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae8_23), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af0_23), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af8_23), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af9_23), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afa_23), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afb_23), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afc_23), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5bc0_23), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bc8_23), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5bd0_23), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bd8_23), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be0_23), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be8_23), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf0_23), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf8_23), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf9_23), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfa_23), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfb_23), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfc_23), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5cc0_23), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cc8_23), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5cd0_23), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cd8_23), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce0_23), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce8_23), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf0_23), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf8_23), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf9_23), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfa_23), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfb_23), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfc_23), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5dc0_23), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dc8_23), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5dd0_23), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dd8_23), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de0_23), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de8_23), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df0_23), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df8_23), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df9_23), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfa_23), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfb_23), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfc_23), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5ec0_23), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ec8_23), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ed0_23), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ed8_23), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee0_23), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee8_23), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef0_23), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef8_23), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef9_23), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efa_23), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efb_23), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efc_23), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5fc0_23), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fc8_23), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5fd0_23), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fd8_23), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe0_23), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe8_23), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff0_23), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff8_23), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff9_23), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffa_23), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffb_23), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffc_23), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_6000_23), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6001_23), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_60ff_23), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6100_23), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6101_23), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_61ff_23), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6200_23), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6201_23), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_62ff_23), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6300_23), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6301_23), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_63ff_23), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6400_23), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6401_23), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_64ff_23), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6500_23), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6501_23), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_65ff_23), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6600_23), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6601_23), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_66ff_23), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6700_23), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6701_23), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_67ff_23), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6800_23), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6801_23), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_68ff_23), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6900_23), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6901_23), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_69ff_23), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a00_23), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a01_23), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6aff_23), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b00_23), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b01_23), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6bff_23), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c00_23), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c01_23), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6cff_23), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d00_23), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d01_23), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6dff_23), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e00_23), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e01_23), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6eff_23), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f00_23), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f01_23), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6fff_23), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_7000_23), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_8000_23), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8010_23), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8018_23), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8020_23), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8028_23), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8030_23), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8038_23), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8039_23), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803a_23), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803b_23), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803c_23), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8040_23), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8050_23), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8058_23), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8060_23), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8068_23), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8070_23), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8078_23), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8079_23), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807a_23), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807b_23), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807c_23), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8080_23), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8090_23), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8098_23), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a0_23), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a8_23), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b0_23), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b8_23), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b9_23), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80ba_23), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bb_23), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bc_23), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80c0_23), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d0_23), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d8_23), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e0_23), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e8_23), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f0_23), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f8_23), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f9_23), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fa_23), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fb_23), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fc_23), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_8100_23), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8108_23), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8110_23), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8118_23), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8120_23), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8128_23), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8130_23), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8138_23), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8139_23), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8140_23), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8148_23), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ (cpuop_func*)CPUFUNC(op_8150_23), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8158_23), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8160_23), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8168_23), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8170_23), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8178_23), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8179_23), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8180_23), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8188_23), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ (cpuop_func*)CPUFUNC(op_8190_23), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8198_23), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a0_23), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a8_23), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b0_23), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b8_23), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b9_23), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81c0_23), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d0_23), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d8_23), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e0_23), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e8_23), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f0_23), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f8_23), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f9_23), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fa_23), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fb_23), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fc_23), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_9000_23), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9010_23), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9018_23), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9020_23), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9028_23), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9030_23), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9038_23), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9039_23), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903a_23), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903b_23), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903c_23), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9040_23), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9048_23), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9050_23), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9058_23), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9060_23), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9068_23), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9070_23), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9078_23), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9079_23), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907a_23), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907b_23), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907c_23), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9080_23), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9088_23), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9090_23), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9098_23), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a0_23), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a8_23), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b0_23), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b8_23), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b9_23), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90ba_23), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bb_23), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bc_23), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90c0_23), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90c8_23), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d0_23), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d8_23), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e0_23), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e8_23), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f0_23), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f8_23), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f9_23), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fa_23), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fb_23), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fc_23), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_9100_23), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9108_23), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9110_23), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9118_23), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9120_23), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9128_23), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9130_23), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9138_23), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9139_23), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9140_23), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9148_23), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9150_23), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9158_23), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9160_23), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9168_23), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9170_23), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9178_23), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9179_23), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9180_23), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9188_23), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9190_23), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9198_23), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a0_23), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a8_23), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b0_23), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b8_23), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b9_23), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91c0_23), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91c8_23), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d0_23), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d8_23), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e0_23), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e8_23), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f0_23), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f8_23), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f9_23), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fa_23), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fb_23), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fc_23), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_b000_23), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b010_23), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b018_23), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b020_23), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b028_23), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b030_23), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b038_23), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b039_23), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03a_23), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03b_23), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03c_23), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b040_23), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b048_23), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b050_23), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b058_23), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b060_23), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b068_23), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b070_23), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b078_23), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b079_23), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07a_23), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07b_23), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07c_23), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b080_23), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b088_23), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b090_23), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b098_23), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a0_23), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a8_23), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b0_23), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b8_23), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b9_23), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0ba_23), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bb_23), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bc_23), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0c0_23), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0c8_23), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d0_23), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d8_23), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e0_23), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e8_23), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f0_23), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f8_23), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f9_23), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fa_23), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fb_23), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fc_23), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b100_23), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b108_23), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b110_23), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b118_23), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b120_23), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b128_23), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b130_23), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b138_23), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b139_23), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b140_23), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b148_23), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b150_23), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b158_23), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b160_23), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b168_23), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b170_23), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b178_23), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b179_23), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b180_23), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b188_23), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b190_23), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b198_23), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a0_23), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a8_23), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b0_23), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b8_23), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b9_23), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1c0_23), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1c8_23), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d0_23), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d8_23), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e0_23), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e8_23), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f0_23), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f8_23), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f9_23), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fa_23), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fb_23), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fc_23), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_c000_23), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c010_23), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c018_23), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c020_23), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c028_23), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c030_23), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c038_23), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c039_23), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03a_23), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03b_23), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03c_23), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c040_23), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c050_23), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c058_23), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c060_23), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c068_23), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c070_23), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c078_23), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c079_23), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07a_23), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07b_23), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07c_23), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c080_23), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c090_23), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c098_23), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a0_23), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a8_23), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b0_23), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b8_23), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b9_23), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0ba_23), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bb_23), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bc_23), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0c0_23), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d0_23), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d8_23), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e0_23), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e8_23), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f0_23), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f8_23), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f9_23), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fa_23), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fb_23), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fc_23), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c100_23), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c108_23), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c110_23), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c118_23), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c120_23), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c128_23), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c130_23), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c138_23), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c139_23), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c140_23), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c148_23), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c150_23), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c158_23), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c160_23), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c168_23), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c170_23), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c178_23), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c179_23), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c188_23), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c190_23), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c198_23), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a0_23), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a8_23), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b0_23), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b8_23), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b9_23), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1c0_23), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d0_23), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d8_23), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e0_23), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e8_23), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f0_23), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f8_23), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f9_23), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fa_23), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fb_23), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fc_23), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_d000_23), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d010_23), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d018_23), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d020_23), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d028_23), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d030_23), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d038_23), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d039_23), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03a_23), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03b_23), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03c_23), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d040_23), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d048_23), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d050_23), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d058_23), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d060_23), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d068_23), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d070_23), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d078_23), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d079_23), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07a_23), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07b_23), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07c_23), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d080_23), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d088_23), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d090_23), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d098_23), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a0_23), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a8_23), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b0_23), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b8_23), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b9_23), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0ba_23), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bb_23), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bc_23), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0c0_23), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0c8_23), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d0_23), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d8_23), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e0_23), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e8_23), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f0_23), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f8_23), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f9_23), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fa_23), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fb_23), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fc_23), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d100_23), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d108_23), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d110_23), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d118_23), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d120_23), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d128_23), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d130_23), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d138_23), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d139_23), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d140_23), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d148_23), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d150_23), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d158_23), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d160_23), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d168_23), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d170_23), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d178_23), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d179_23), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d180_23), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d188_23), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d190_23), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d198_23), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a0_23), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a8_23), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b0_23), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b8_23), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b9_23), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1c0_23), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1c8_23), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d0_23), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d8_23), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e0_23), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e8_23), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f0_23), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f8_23), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f9_23), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fa_23), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fb_23), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fc_23), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_e000_23), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e008_23), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e010_23), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e018_23), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e020_23), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e028_23), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e030_23), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e038_23), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e040_23), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e048_23), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e050_23), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e058_23), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e060_23), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e068_23), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e070_23), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e078_23), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e080_23), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e088_23), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e090_23), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e098_23), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0a0_23), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e0a8_23), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e0b0_23), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e0b8_23), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0d0_23), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0d8_23), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e0_23), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e8_23), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f0_23), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f8_23), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f9_23), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e100_23), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e108_23), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e110_23), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e118_23), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e120_23), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e128_23), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e130_23), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e138_23), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e140_23), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e148_23), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e150_23), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e158_23), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e160_23), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e168_23), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e170_23), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e178_23), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e180_23), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e188_23), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e190_23), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e198_23), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1a0_23), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e1a8_23), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e1b0_23), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e1b8_23), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1d0_23), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1d8_23), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e0_23), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e8_23), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f0_23), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f8_23), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f9_23), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e2d0_23), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2d8_23), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e0_23), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e8_23), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f0_23), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f8_23), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f9_23), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e3d0_23), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3d8_23), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e0_23), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e8_23), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f0_23), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f8_23), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f9_23), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e4d0_23), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4d8_23), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e0_23), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e8_23), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f0_23), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f8_23), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f9_23), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e5d0_23), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5d8_23), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e0_23), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e8_23), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f0_23), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f8_23), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f9_23), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e6d0_23), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6d8_23), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e0_23), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e8_23), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f0_23), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f8_23), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f9_23), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e7d0_23), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7d8_23), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e0_23), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e8_23), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f0_23), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f8_23), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f9_23), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8c0_23), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8d0_23), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8e8_23), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f0_23), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f8_23), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f9_23), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8fa_23), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8fb_23), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9c0_23), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9d0_23), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9e8_23), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f0_23), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f8_23), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f9_23), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9fa_23), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9fb_23), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eac0_23), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ead0_23), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eae8_23), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf0_23), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf8_23), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf9_23), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebc0_23), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebd0_23), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebe8_23), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf0_23), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf8_23), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf9_23), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebfa_23), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebfb_23), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecc0_23), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecd0_23), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ece8_23), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf0_23), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf8_23), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf9_23), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edc0_23), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edd0_23), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ede8_23), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf0_23), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf8_23), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf9_23), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edfa_23), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edfb_23), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eec0_23), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eed0_23), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eee8_23), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef0_23), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef8_23), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef9_23), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efc0_23), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efd0_23), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efe8_23), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff0_23), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff8_23), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff9_23), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f000_23), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f008_23), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f010_23), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f018_23), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f020_23), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f028_23), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f030_23), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f038_23), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f039_23), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f200_23), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f208_23), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f210_23), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f218_23), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f220_23), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f228_23), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f230_23), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f238_23), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f239_23), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23a_23), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23b_23), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23c_23), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f240_23), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f248_23), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f250_23), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f258_23), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f260_23), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f268_23), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f270_23), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f278_23), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f279_23), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27a_23), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27b_23), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27c_23), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f280_23), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f2c0_23), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f310_23), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f320_23), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f328_23), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f330_23), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f338_23), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f339_23), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f350_23), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f358_23), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f368_23), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f370_23), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f378_23), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f379_23), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f37a_23), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f37b_23), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_23 */
#ifdef CPUEMU_24
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_24)[] = {
{ (cpuop_func*)CPUFUNC(op_0000_24), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0010_24), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0018_24), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0020_24), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0028_24), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0030_24), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0038_24), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0039_24), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_003c_24), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0040_24), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0050_24), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0058_24), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0060_24), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0068_24), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0070_24), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0078_24), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0079_24), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_007c_24), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0080_24), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0090_24), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0098_24), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a0_24), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a8_24), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b0_24), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b8_24), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b9_24), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00d0_24), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00e8_24), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f0_24), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f8_24), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00f9_24), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00fa_24), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_00fb_24), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0100_24), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0108_24), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0110_24), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0118_24), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0120_24), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0128_24), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0130_24), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0138_24), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0139_24), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013a_24), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013b_24), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013c_24), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0140_24), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0148_24), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0150_24), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0158_24), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0160_24), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0168_24), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0170_24), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0178_24), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0179_24), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0180_24), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0188_24), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_0190_24), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0198_24), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a0_24), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a8_24), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b0_24), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b8_24), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b9_24), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01c0_24), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01c8_24), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_01d0_24), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01d8_24), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e0_24), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e8_24), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f0_24), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f8_24), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f9_24), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0200_24), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0210_24), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0218_24), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0220_24), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0228_24), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0230_24), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0238_24), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0239_24), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_023c_24), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0240_24), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0250_24), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0258_24), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0260_24), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0268_24), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0270_24), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0278_24), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0279_24), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_027c_24), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0280_24), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0290_24), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0298_24), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a0_24), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a8_24), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b0_24), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b8_24), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b9_24), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02d0_24), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02e8_24), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f0_24), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f8_24), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02f9_24), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02fa_24), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_02fb_24), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0400_24), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0410_24), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0418_24), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0420_24), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0428_24), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0430_24), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0438_24), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0439_24), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0440_24), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0450_24), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0458_24), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0460_24), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0468_24), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0470_24), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0478_24), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0479_24), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0480_24), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0490_24), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0498_24), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a0_24), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a8_24), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b0_24), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b8_24), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b9_24), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04d0_24), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04e8_24), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f0_24), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f8_24), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04f9_24), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04fa_24), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_04fb_24), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ (cpuop_func*)CPUFUNC(op_0600_24), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0610_24), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0618_24), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0620_24), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0628_24), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0630_24), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0638_24), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0639_24), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0640_24), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0650_24), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0658_24), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0660_24), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0668_24), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0670_24), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0678_24), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0679_24), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0680_24), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0690_24), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0698_24), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a0_24), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a8_24), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b0_24), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b8_24), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b9_24), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06c0_24), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06c8_24), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06d0_24), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06e8_24), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f0_24), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f8_24), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06f9_24), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06fa_24), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_06fb_24), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ (cpuop_func*)CPUFUNC(op_0800_24), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0810_24), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0818_24), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0820_24), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0828_24), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0830_24), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0838_24), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0839_24), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083a_24), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083b_24), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0840_24), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0850_24), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0858_24), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0860_24), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0868_24), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0870_24), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0878_24), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0879_24), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0880_24), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0890_24), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0898_24), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a0_24), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a8_24), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b0_24), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b8_24), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b9_24), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08c0_24), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d0_24), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d8_24), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e0_24), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e8_24), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f0_24), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f8_24), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f9_24), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0a00_24), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a10_24), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a18_24), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a20_24), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a28_24), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a30_24), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a38_24), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a39_24), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a3c_24), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a40_24), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a50_24), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a58_24), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a60_24), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a68_24), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a70_24), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a78_24), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a79_24), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a7c_24), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a80_24), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a90_24), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a98_24), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa0_24), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa8_24), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab0_24), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab8_24), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab9_24), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ad0_24), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ad8_24), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ae0_24), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ae8_24), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af0_24), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af8_24), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0af9_24), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ (cpuop_func*)CPUFUNC(op_0c00_24), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c10_24), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c18_24), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c20_24), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c28_24), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c30_24), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c38_24), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c39_24), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c3a_24), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c3b_24), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ (cpuop_func*)CPUFUNC(op_0c40_24), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c50_24), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c58_24), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c60_24), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c68_24), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c70_24), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c78_24), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c79_24), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c7a_24), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0c7b_24), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ (cpuop_func*)CPUFUNC(op_0c80_24), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c90_24), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c98_24), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca0_24), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca8_24), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb0_24), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb8_24), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb9_24), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cba_24), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cbb_24), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cd0_24), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cd8_24), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ce0_24), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ce8_24), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf0_24), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf8_24), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cf9_24), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0cfc_24), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e10_24), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e18_24), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e20_24), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e28_24), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e30_24), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e38_24), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e39_24), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e50_24), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e58_24), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e60_24), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e68_24), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e70_24), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e78_24), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e79_24), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e90_24), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0e98_24), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ea0_24), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ea8_24), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb0_24), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb8_24), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0eb9_24), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ed0_24), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ed8_24), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ee0_24), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ee8_24), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef0_24), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef8_24), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0ef9_24), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_0efc_24), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ (cpuop_func*)CPUFUNC(op_1000_24), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1010_24), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1018_24), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1020_24), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1028_24), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1030_24), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1038_24), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1039_24), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103a_24), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103b_24), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103c_24), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1080_24), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1090_24), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1098_24), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a0_24), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a8_24), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b0_24), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b8_24), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b9_24), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10ba_24), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bb_24), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bc_24), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10c0_24), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d0_24), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d8_24), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e0_24), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e8_24), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f0_24), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f8_24), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f9_24), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fa_24), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fb_24), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fc_24), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1100_24), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1110_24), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1118_24), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1120_24), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1128_24), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1130_24), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1138_24), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1139_24), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113a_24), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113b_24), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113c_24), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1140_24), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1150_24), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1158_24), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1160_24), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1168_24), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1170_24), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1178_24), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1179_24), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117a_24), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117b_24), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117c_24), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1180_24), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1190_24), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1198_24), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a0_24), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a8_24), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b0_24), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b8_24), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b9_24), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11ba_24), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bb_24), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bc_24), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11c0_24), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d0_24), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d8_24), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e0_24), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e8_24), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f0_24), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f8_24), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f9_24), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fa_24), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fb_24), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fc_24), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13c0_24), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d0_24), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d8_24), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e0_24), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e8_24), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f0_24), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f8_24), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f9_24), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fa_24), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fb_24), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fc_24), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2000_24), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2008_24), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2010_24), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2018_24), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2020_24), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2028_24), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2030_24), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2038_24), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2039_24), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203a_24), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203b_24), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203c_24), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2040_24), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2048_24), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2050_24), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2058_24), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2060_24), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2068_24), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2070_24), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2078_24), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2079_24), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207a_24), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207b_24), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207c_24), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2080_24), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2088_24), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2090_24), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2098_24), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a0_24), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a8_24), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b0_24), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b8_24), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b9_24), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20ba_24), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bb_24), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bc_24), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c0_24), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c8_24), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d0_24), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d8_24), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e0_24), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e8_24), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f0_24), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f8_24), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f9_24), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fa_24), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fb_24), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fc_24), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2100_24), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2108_24), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2110_24), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2118_24), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2120_24), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2128_24), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2130_24), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2138_24), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2139_24), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213a_24), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213b_24), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213c_24), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2140_24), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2148_24), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2150_24), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2158_24), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2160_24), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2168_24), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2170_24), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2178_24), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2179_24), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217a_24), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217b_24), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217c_24), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2180_24), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2188_24), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2190_24), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2198_24), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a0_24), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a8_24), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b0_24), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b8_24), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b9_24), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21ba_24), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bb_24), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bc_24), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c0_24), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c8_24), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d0_24), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d8_24), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e0_24), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e8_24), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f0_24), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f8_24), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f9_24), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fa_24), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fb_24), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fc_24), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c0_24), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c8_24), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d0_24), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d8_24), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e0_24), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e8_24), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f0_24), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f8_24), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f9_24), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fa_24), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fb_24), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fc_24), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3000_24), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3008_24), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3010_24), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3018_24), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3020_24), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3028_24), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3030_24), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3038_24), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3039_24), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303a_24), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303b_24), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303c_24), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3040_24), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3048_24), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3050_24), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3058_24), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3060_24), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3068_24), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3070_24), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3078_24), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3079_24), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307a_24), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307b_24), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307c_24), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3080_24), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3088_24), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3090_24), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3098_24), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a0_24), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a8_24), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b0_24), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b8_24), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b9_24), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30ba_24), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bb_24), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bc_24), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c0_24), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c8_24), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d0_24), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d8_24), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e0_24), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e8_24), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f0_24), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f8_24), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f9_24), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fa_24), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fb_24), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fc_24), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3100_24), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3108_24), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3110_24), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3118_24), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3120_24), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3128_24), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3130_24), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3138_24), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3139_24), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313a_24), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313b_24), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313c_24), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3140_24), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3148_24), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3150_24), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3158_24), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3160_24), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3168_24), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3170_24), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3178_24), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3179_24), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317a_24), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317b_24), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317c_24), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3180_24), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3188_24), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3190_24), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3198_24), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a0_24), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a8_24), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b0_24), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b8_24), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b9_24), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31ba_24), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bb_24), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bc_24), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c0_24), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c8_24), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d0_24), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d8_24), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e0_24), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e8_24), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f0_24), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f8_24), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f9_24), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fa_24), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fb_24), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fc_24), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c0_24), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c8_24), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d0_24), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d8_24), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e0_24), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e8_24), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f0_24), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f8_24), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f9_24), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fa_24), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fb_24), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fc_24), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_4000_24), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4010_24), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4018_24), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4020_24), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4028_24), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4030_24), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4038_24), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4039_24), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4040_24), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4050_24), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4058_24), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4060_24), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4068_24), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4070_24), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4078_24), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4079_24), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4080_24), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4090_24), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4098_24), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a0_24), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a8_24), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b0_24), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b8_24), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b9_24), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40c0_24), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d0_24), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d8_24), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e0_24), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e8_24), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f0_24), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f8_24), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f9_24), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4100_24), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4110_24), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4118_24), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4120_24), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4128_24), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4130_24), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4138_24), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4139_24), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413a_24), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413b_24), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_413c_24), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ (cpuop_func*)CPUFUNC(op_4180_24), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4190_24), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4198_24), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a0_24), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a8_24), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b0_24), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b8_24), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b9_24), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41ba_24), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bb_24), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bc_24), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41d0_24), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41e8_24), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f0_24), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f8_24), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f9_24), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fa_24), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fb_24), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_4200_24), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4210_24), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4218_24), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4220_24), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4228_24), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4230_24), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4238_24), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4239_24), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4240_24), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4250_24), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4258_24), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4260_24), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4268_24), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4270_24), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4278_24), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4279_24), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4280_24), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4290_24), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4298_24), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a0_24), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a8_24), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b0_24), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b8_24), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b9_24), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42c0_24), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42d0_24), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42d8_24), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42e0_24), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42e8_24), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f0_24), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f8_24), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_42f9_24), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ (cpuop_func*)CPUFUNC(op_4400_24), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4410_24), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4418_24), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4420_24), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4428_24), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4430_24), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4438_24), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4439_24), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4440_24), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4450_24), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4458_24), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4460_24), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4468_24), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4470_24), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4478_24), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4479_24), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4480_24), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4490_24), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4498_24), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a0_24), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a8_24), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b0_24), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b8_24), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b9_24), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44c0_24), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d0_24), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d8_24), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e0_24), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e8_24), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f0_24), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f8_24), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f9_24), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fa_24), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fb_24), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fc_24), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4600_24), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4610_24), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4618_24), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4620_24), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4628_24), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4630_24), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4638_24), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4639_24), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4640_24), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4650_24), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4658_24), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4660_24), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4668_24), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4670_24), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4678_24), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4679_24), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4680_24), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4690_24), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4698_24), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a0_24), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a8_24), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b0_24), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b8_24), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b9_24), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46c0_24), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d0_24), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d8_24), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e0_24), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e8_24), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f0_24), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f8_24), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f9_24), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fa_24), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fb_24), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fc_24), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4800_24), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4808_24), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ (cpuop_func*)CPUFUNC(op_4810_24), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4818_24), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4820_24), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4828_24), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4830_24), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4838_24), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4839_24), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4840_24), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4848_24), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ (cpuop_func*)CPUFUNC(op_4850_24), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4868_24), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4870_24), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4878_24), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4879_24), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487a_24), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487b_24), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4880_24), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_4890_24), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a0_24), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a8_24), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b0_24), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b8_24), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b9_24), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48c0_24), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_48d0_24), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e0_24), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e8_24), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f0_24), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f8_24), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f9_24), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_49c0_24), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ (cpuop_func*)CPUFUNC(op_4a00_24), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a10_24), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a18_24), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a20_24), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a28_24), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a30_24), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a38_24), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a39_24), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3a_24), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3b_24), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a3c_24), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a40_24), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a48_24), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a50_24), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a58_24), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a60_24), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a68_24), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a70_24), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a78_24), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a79_24), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7a_24), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7b_24), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a7c_24), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a80_24), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4a88_24), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4a90_24), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a98_24), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa0_24), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa8_24), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab0_24), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab8_24), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab9_24), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4aba_24), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4abb_24), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4abc_24), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ (cpuop_func*)CPUFUNC(op_4ac0_24), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad0_24), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad8_24), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae0_24), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae8_24), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af0_24), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af8_24), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af9_24), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c00_24), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c10_24), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c18_24), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c20_24), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c28_24), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c30_24), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c38_24), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c39_24), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3a_24), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3b_24), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c3c_24), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c40_24), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c50_24), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c58_24), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c60_24), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c68_24), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c70_24), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c78_24), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c79_24), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7a_24), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7b_24), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4c7c_24), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ (cpuop_func*)CPUFUNC(op_4c90_24), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4c98_24), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ca8_24), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb0_24), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb8_24), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb9_24), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cba_24), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cbb_24), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd0_24), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd8_24), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ce8_24), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf0_24), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf8_24), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf9_24), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfa_24), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfb_24), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4e40_24), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ (cpuop_func*)CPUFUNC(op_4e50_24), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ (cpuop_func*)CPUFUNC(op_4e58_24), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ (cpuop_func*)CPUFUNC(op_4e60_24), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ (cpuop_func*)CPUFUNC(op_4e68_24), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ (cpuop_func*)CPUFUNC(op_4e70_24), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ (cpuop_func*)CPUFUNC(op_4e71_24), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ (cpuop_func*)CPUFUNC(op_4e72_24), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ (cpuop_func*)CPUFUNC(op_4e73_24), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e74_24), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ (cpuop_func*)CPUFUNC(op_4e75_24), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ (cpuop_func*)CPUFUNC(op_4e76_24), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ (cpuop_func*)CPUFUNC(op_4e77_24), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e7a_24), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_4e7b_24), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ (cpuop_func*)CPUFUNC(op_4e90_24), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ea8_24), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb0_24), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb8_24), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb9_24), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eba_24), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ebb_24), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ed0_24), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ee8_24), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef0_24), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef8_24), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef9_24), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efa_24), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efb_24), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_5000_24), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5010_24), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5018_24), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5020_24), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5028_24), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5030_24), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5038_24), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5039_24), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5040_24), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5048_24), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5050_24), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5058_24), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5060_24), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5068_24), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5070_24), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5078_24), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5079_24), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5080_24), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5088_24), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5090_24), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5098_24), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a0_24), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a8_24), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b0_24), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b8_24), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b9_24), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50c0_24), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50c8_24), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_50d0_24), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50d8_24), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e0_24), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e8_24), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f0_24), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f8_24), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f9_24), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fa_24), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fb_24), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_50fc_24), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5100_24), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5110_24), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5118_24), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5120_24), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5128_24), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5130_24), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5138_24), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5139_24), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5140_24), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5148_24), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5150_24), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5158_24), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5160_24), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5168_24), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5170_24), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5178_24), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5179_24), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5180_24), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5188_24), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5190_24), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5198_24), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a0_24), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a8_24), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b0_24), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b8_24), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b9_24), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51c0_24), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51c8_24), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_51d0_24), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51d8_24), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e0_24), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e8_24), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f0_24), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f8_24), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f9_24), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fa_24), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fb_24), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_51fc_24), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_52c0_24), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52c8_24), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_52d0_24), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52d8_24), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e0_24), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e8_24), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f0_24), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f8_24), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f9_24), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fa_24), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fb_24), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_52fc_24), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_53c0_24), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53c8_24), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_53d0_24), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53d8_24), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e0_24), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e8_24), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f0_24), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f8_24), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f9_24), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fa_24), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fb_24), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_53fc_24), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_54c0_24), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54c8_24), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_54d0_24), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54d8_24), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e0_24), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e8_24), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f0_24), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f8_24), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f9_24), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fa_24), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fb_24), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_54fc_24), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_55c0_24), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55c8_24), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_55d0_24), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55d8_24), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e0_24), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e8_24), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f0_24), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f8_24), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f9_24), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fa_24), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fb_24), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_55fc_24), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_56c0_24), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56c8_24), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_56d0_24), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56d8_24), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e0_24), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e8_24), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f0_24), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f8_24), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f9_24), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fa_24), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fb_24), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_56fc_24), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_57c0_24), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57c8_24), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_57d0_24), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57d8_24), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e0_24), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e8_24), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f0_24), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f8_24), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f9_24), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fa_24), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fb_24), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_57fc_24), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_58c0_24), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58c8_24), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_58d0_24), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58d8_24), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e0_24), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e8_24), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f0_24), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f8_24), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f9_24), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fa_24), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fb_24), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_58fc_24), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_59c0_24), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59c8_24), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_59d0_24), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59d8_24), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e0_24), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e8_24), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f0_24), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f8_24), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f9_24), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fa_24), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fb_24), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_59fc_24), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5ac0_24), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ac8_24), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ad0_24), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ad8_24), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae0_24), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae8_24), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af0_24), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af8_24), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af9_24), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afa_24), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afb_24), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5afc_24), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5bc0_24), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bc8_24), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5bd0_24), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bd8_24), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be0_24), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be8_24), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf0_24), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf8_24), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf9_24), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfa_24), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfb_24), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5bfc_24), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5cc0_24), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cc8_24), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5cd0_24), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cd8_24), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce0_24), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce8_24), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf0_24), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf8_24), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf9_24), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfa_24), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfb_24), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5cfc_24), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5dc0_24), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dc8_24), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5dd0_24), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dd8_24), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de0_24), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de8_24), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df0_24), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df8_24), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df9_24), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfa_24), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfb_24), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5dfc_24), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5ec0_24), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ec8_24), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ed0_24), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ed8_24), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee0_24), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee8_24), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef0_24), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef8_24), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef9_24), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efa_24), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efb_24), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5efc_24), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_5fc0_24), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fc8_24), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5fd0_24), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fd8_24), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe0_24), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe8_24), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff0_24), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff8_24), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff9_24), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffa_24), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffb_24), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_5ffc_24), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ (cpuop_func*)CPUFUNC(op_6000_24), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6001_24), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_60ff_24), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6100_24), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6101_24), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_61ff_24), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6200_24), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6201_24), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_62ff_24), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6300_24), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6301_24), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_63ff_24), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6400_24), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6401_24), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_64ff_24), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6500_24), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6501_24), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_65ff_24), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6600_24), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6601_24), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_66ff_24), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6700_24), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6701_24), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_67ff_24), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6800_24), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6801_24), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_68ff_24), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6900_24), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6901_24), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_69ff_24), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a00_24), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a01_24), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6aff_24), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b00_24), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b01_24), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6bff_24), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c00_24), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c01_24), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6cff_24), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d00_24), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d01_24), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6dff_24), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e00_24), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e01_24), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6eff_24), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f00_24), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f01_24), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6fff_24), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_7000_24), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_8000_24), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8010_24), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8018_24), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8020_24), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8028_24), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8030_24), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8038_24), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8039_24), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803a_24), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803b_24), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803c_24), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8040_24), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8050_24), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8058_24), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8060_24), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8068_24), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8070_24), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8078_24), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8079_24), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807a_24), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807b_24), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807c_24), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8080_24), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8090_24), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8098_24), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a0_24), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a8_24), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b0_24), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b8_24), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b9_24), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80ba_24), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bb_24), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bc_24), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80c0_24), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d0_24), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d8_24), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e0_24), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e8_24), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f0_24), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f8_24), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f9_24), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fa_24), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fb_24), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fc_24), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_8100_24), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8108_24), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8110_24), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8118_24), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8120_24), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8128_24), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8130_24), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8138_24), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8139_24), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8140_24), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8148_24), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ (cpuop_func*)CPUFUNC(op_8150_24), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8158_24), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8160_24), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8168_24), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8170_24), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8178_24), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8179_24), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8180_24), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_8188_24), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ (cpuop_func*)CPUFUNC(op_8190_24), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8198_24), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a0_24), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a8_24), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b0_24), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b8_24), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b9_24), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81c0_24), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d0_24), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d8_24), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e0_24), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e8_24), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f0_24), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f8_24), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f9_24), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fa_24), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fb_24), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fc_24), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_9000_24), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9010_24), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9018_24), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9020_24), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9028_24), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9030_24), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9038_24), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9039_24), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903a_24), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903b_24), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903c_24), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9040_24), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9048_24), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9050_24), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9058_24), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9060_24), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9068_24), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9070_24), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9078_24), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9079_24), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907a_24), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907b_24), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907c_24), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9080_24), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9088_24), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9090_24), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9098_24), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a0_24), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a8_24), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b0_24), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b8_24), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b9_24), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90ba_24), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bb_24), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bc_24), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90c0_24), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90c8_24), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d0_24), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d8_24), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e0_24), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e8_24), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f0_24), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f8_24), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f9_24), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fa_24), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fb_24), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fc_24), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_9100_24), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9108_24), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9110_24), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9118_24), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9120_24), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9128_24), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9130_24), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9138_24), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9139_24), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9140_24), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9148_24), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9150_24), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9158_24), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9160_24), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9168_24), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9170_24), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9178_24), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9179_24), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9180_24), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9188_24), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9190_24), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9198_24), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a0_24), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a8_24), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b0_24), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b8_24), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b9_24), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91c0_24), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91c8_24), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d0_24), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d8_24), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e0_24), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e8_24), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f0_24), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f8_24), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f9_24), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fa_24), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fb_24), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fc_24), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_b000_24), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b010_24), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b018_24), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b020_24), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b028_24), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b030_24), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b038_24), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b039_24), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03a_24), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03b_24), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03c_24), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b040_24), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b048_24), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b050_24), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b058_24), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b060_24), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b068_24), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b070_24), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b078_24), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b079_24), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07a_24), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07b_24), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07c_24), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b080_24), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b088_24), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b090_24), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b098_24), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a0_24), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a8_24), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b0_24), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b8_24), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b9_24), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0ba_24), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bb_24), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bc_24), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0c0_24), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0c8_24), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d0_24), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d8_24), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e0_24), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e8_24), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f0_24), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f8_24), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f9_24), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fa_24), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fb_24), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fc_24), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b100_24), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b108_24), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b110_24), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b118_24), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b120_24), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b128_24), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b130_24), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b138_24), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b139_24), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b140_24), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b148_24), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b150_24), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b158_24), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b160_24), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b168_24), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b170_24), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b178_24), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b179_24), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b180_24), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b188_24), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b190_24), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b198_24), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a0_24), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a8_24), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b0_24), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b8_24), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b9_24), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1c0_24), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1c8_24), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d0_24), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d8_24), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e0_24), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e8_24), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f0_24), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f8_24), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f9_24), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fa_24), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fb_24), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fc_24), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_c000_24), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c010_24), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c018_24), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c020_24), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c028_24), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c030_24), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c038_24), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c039_24), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03a_24), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03b_24), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03c_24), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c040_24), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c050_24), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c058_24), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c060_24), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c068_24), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c070_24), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c078_24), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c079_24), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07a_24), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07b_24), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07c_24), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c080_24), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c090_24), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c098_24), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a0_24), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a8_24), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b0_24), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b8_24), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b9_24), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0ba_24), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bb_24), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bc_24), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0c0_24), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d0_24), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d8_24), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e0_24), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e8_24), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f0_24), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f8_24), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f9_24), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fa_24), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fb_24), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fc_24), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c100_24), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c108_24), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c110_24), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c118_24), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c120_24), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c128_24), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c130_24), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c138_24), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c139_24), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c140_24), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c148_24), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c150_24), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c158_24), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c160_24), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c168_24), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c170_24), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c178_24), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c179_24), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c188_24), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c190_24), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c198_24), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a0_24), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a8_24), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b0_24), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b8_24), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b9_24), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1c0_24), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d0_24), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d8_24), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e0_24), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e8_24), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f0_24), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f8_24), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f9_24), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fa_24), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fb_24), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fc_24), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_d000_24), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d010_24), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d018_24), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d020_24), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d028_24), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d030_24), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d038_24), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d039_24), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03a_24), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03b_24), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03c_24), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d040_24), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d048_24), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d050_24), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d058_24), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d060_24), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d068_24), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d070_24), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d078_24), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d079_24), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07a_24), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07b_24), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07c_24), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d080_24), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d088_24), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d090_24), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d098_24), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a0_24), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a8_24), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b0_24), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b8_24), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b9_24), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0ba_24), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bb_24), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bc_24), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0c0_24), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0c8_24), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d0_24), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d8_24), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e0_24), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e8_24), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f0_24), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f8_24), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f9_24), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fa_24), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fb_24), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fc_24), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d100_24), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d108_24), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d110_24), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d118_24), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d120_24), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d128_24), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d130_24), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d138_24), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d139_24), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d140_24), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d148_24), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d150_24), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d158_24), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d160_24), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d168_24), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d170_24), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d178_24), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d179_24), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d180_24), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d188_24), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d190_24), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d198_24), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a0_24), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a8_24), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b0_24), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b8_24), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b9_24), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1c0_24), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1c8_24), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d0_24), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d8_24), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e0_24), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e8_24), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f0_24), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f8_24), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f9_24), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fa_24), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fb_24), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fc_24), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_e000_24), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e008_24), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e010_24), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e018_24), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e020_24), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e028_24), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e030_24), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e038_24), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e040_24), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e048_24), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e050_24), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e058_24), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e060_24), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e068_24), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e070_24), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e078_24), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e080_24), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e088_24), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e090_24), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e098_24), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0a0_24), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e0a8_24), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e0b0_24), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e0b8_24), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0d0_24), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0d8_24), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e0_24), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e8_24), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f0_24), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f8_24), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f9_24), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e100_24), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e108_24), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e110_24), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e118_24), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e120_24), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e128_24), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e130_24), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e138_24), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e140_24), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e148_24), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e150_24), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e158_24), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e160_24), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e168_24), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e170_24), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e178_24), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e180_24), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e188_24), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e190_24), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e198_24), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1a0_24), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e1a8_24), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e1b0_24), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e1b8_24), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1d0_24), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1d8_24), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e0_24), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e8_24), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f0_24), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f8_24), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f9_24), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e2d0_24), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2d8_24), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e0_24), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e8_24), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f0_24), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f8_24), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f9_24), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e3d0_24), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3d8_24), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e0_24), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e8_24), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f0_24), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f8_24), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f9_24), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e4d0_24), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4d8_24), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e0_24), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e8_24), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f0_24), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f8_24), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f9_24), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e5d0_24), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5d8_24), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e0_24), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e8_24), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f0_24), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f8_24), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f9_24), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e6d0_24), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6d8_24), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e0_24), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e8_24), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f0_24), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f8_24), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f9_24), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e7d0_24), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7d8_24), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e0_24), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e8_24), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f0_24), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f8_24), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f9_24), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8c0_24), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8d0_24), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8e8_24), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f0_24), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f8_24), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8f9_24), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8fa_24), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e8fb_24), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9c0_24), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9d0_24), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9e8_24), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f0_24), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f8_24), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9f9_24), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9fa_24), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_e9fb_24), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eac0_24), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ead0_24), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eae8_24), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf0_24), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf8_24), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eaf9_24), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebc0_24), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebd0_24), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebe8_24), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf0_24), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf8_24), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebf9_24), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebfa_24), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ebfb_24), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecc0_24), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecd0_24), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ece8_24), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf0_24), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf8_24), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ecf9_24), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edc0_24), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edd0_24), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_ede8_24), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf0_24), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf8_24), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edf9_24), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edfa_24), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_edfb_24), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eec0_24), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eed0_24), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eee8_24), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef0_24), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef8_24), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eef9_24), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efc0_24), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efd0_24), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_efe8_24), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff0_24), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff8_24), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_eff9_24), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f000_24), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f008_24), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f010_24), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f018_24), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f020_24), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f028_24), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f030_24), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f038_24), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f039_24), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f200_24), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f208_24), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f210_24), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f218_24), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f220_24), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f228_24), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f230_24), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f238_24), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f239_24), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23a_24), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23b_24), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f23c_24), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f240_24), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f248_24), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f250_24), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f258_24), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f260_24), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f268_24), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f270_24), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f278_24), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f279_24), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27a_24), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27b_24), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f27c_24), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f280_24), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f2c0_24), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f310_24), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f320_24), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f328_24), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f330_24), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f338_24), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f339_24), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f350_24), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f358_24), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f368_24), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f370_24), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f378_24), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f379_24), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f37a_24), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f37b_24), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f408_24), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f410_24), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f418_24), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f419_24), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f41a_24), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f41b_24), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f41c_24), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f41d_24), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f41e_24), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f41f_24), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f428_24), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f430_24), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f438_24), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f439_24), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f43a_24), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f43b_24), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f43c_24), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f43d_24), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f43e_24), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f43f_24), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f500_24), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f508_24), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f510_24), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f518_24), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f548_24), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f568_24), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f588_24), 0xf588, -1, { 0, 0 }, 0 }, /* PLPAW */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f5c8_24), 0xf5c8, -1, { 0, 0 }, 0 }, /* PLPAR */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f600_24), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f608_24), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f610_24), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f618_24), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f620_24), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ (cpuop_func*)CPUFUNC(op_f800_24), 0xf800, -1, { 0, 0 }, 0 }, /* LPSTOP */
#endif
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_24 */
#ifdef CPUEMU_25
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_25)[] = {
{ (cpuop_func*)CPUFUNC(op_0000_24), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0010_24), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0018_24), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0020_24), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0028_24), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0030_24), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0038_24), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0039_24), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_003c_24), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0040_24), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0050_24), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0058_24), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0060_24), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0068_24), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0070_24), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0078_24), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0079_24), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_007c_24), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ (cpuop_func*)CPUFUNC(op_0080_24), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0090_24), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_0098_24), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a0_24), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00a8_24), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b0_24), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b8_24), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00b9_24), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_00d0_24), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_00e8_24), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_00f0_24), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_00f8_24), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_00f9_24), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_00fa_24), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_00fb_24), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_0100_24), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0108_24), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0110_24), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0118_24), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0120_24), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0128_24), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0130_24), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0138_24), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0139_24), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013a_24), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013b_24), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_013c_24), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0140_24), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0148_24), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ (cpuop_func*)CPUFUNC(op_0150_24), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0158_24), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0160_24), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0168_24), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0170_24), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0178_24), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0179_24), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0180_24), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0188_24), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_0190_24), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0198_24), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a0_24), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01a8_24), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b0_24), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b8_24), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01b9_24), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_01c0_24), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01c8_24), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ (cpuop_func*)CPUFUNC(op_01d0_24), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01d8_24), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e0_24), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01e8_24), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f0_24), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f8_24), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_01f9_24), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0200_24), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0210_24), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0218_24), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0220_24), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0228_24), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0230_24), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0238_24), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0239_24), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_023c_24), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0240_24), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0250_24), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0258_24), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0260_24), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0268_24), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0270_24), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0278_24), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0279_24), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_027c_24), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ (cpuop_func*)CPUFUNC(op_0280_24), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0290_24), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_0298_24), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a0_24), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02a8_24), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b0_24), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b8_24), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02b9_24), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_02d0_24), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_02e8_24), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_02f0_24), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_02f8_24), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_02f9_24), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_02fa_24), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_02fb_24), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_0400_24), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0410_24), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0418_24), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0420_24), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0428_24), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0430_24), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0438_24), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0439_24), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0440_24), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0450_24), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0458_24), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0460_24), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0468_24), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0470_24), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0478_24), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0479_24), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0480_24), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0490_24), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_0498_24), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a0_24), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04a8_24), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b0_24), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b8_24), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04b9_24), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_04d0_24), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_04e8_24), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_04f0_24), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_04f8_24), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_04f9_24), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_04fa_24), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_04fb_24), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ (cpuop_func*)CPUFUNC(op_0600_24), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0610_24), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0618_24), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0620_24), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0628_24), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0630_24), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0638_24), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0639_24), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0640_24), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0650_24), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0658_24), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0660_24), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0668_24), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0670_24), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0678_24), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0679_24), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0680_24), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0690_24), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_0698_24), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a0_24), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06a8_24), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b0_24), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b8_24), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06b9_24), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_06c0_24), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ (cpuop_func*)CPUFUNC(op_06c8_24), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ (cpuop_func*)CPUFUNC(op_06d0_24), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ (cpuop_func*)CPUFUNC(op_06e8_24), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ (cpuop_func*)CPUFUNC(op_06f0_24), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ (cpuop_func*)CPUFUNC(op_06f8_24), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ (cpuop_func*)CPUFUNC(op_06f9_24), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ (cpuop_func*)CPUFUNC(op_06fa_24), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ (cpuop_func*)CPUFUNC(op_06fb_24), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ (cpuop_func*)CPUFUNC(op_0800_24), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0810_24), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0818_24), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0820_24), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0828_24), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0830_24), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0838_24), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0839_24), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083a_24), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_083b_24), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ (cpuop_func*)CPUFUNC(op_0840_24), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0850_24), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0858_24), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0860_24), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0868_24), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0870_24), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0878_24), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0879_24), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ (cpuop_func*)CPUFUNC(op_0880_24), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0890_24), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_0898_24), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a0_24), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08a8_24), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b0_24), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b8_24), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08b9_24), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ (cpuop_func*)CPUFUNC(op_08c0_24), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d0_24), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08d8_24), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e0_24), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08e8_24), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f0_24), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f8_24), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_08f9_24), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ (cpuop_func*)CPUFUNC(op_0a00_24), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a10_24), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a18_24), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a20_24), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a28_24), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a30_24), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a38_24), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a39_24), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a3c_24), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a40_24), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a50_24), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a58_24), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a60_24), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a68_24), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a70_24), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a78_24), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a79_24), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a7c_24), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ (cpuop_func*)CPUFUNC(op_0a80_24), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a90_24), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0a98_24), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa0_24), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0aa8_24), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab0_24), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab8_24), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ab9_24), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_0ad0_24), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ad8_24), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ae0_24), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ae8_24), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0af0_24), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0af8_24), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0af9_24), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0c00_24), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c10_24), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c18_24), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c20_24), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c28_24), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c30_24), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c38_24), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c39_24), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c3a_24), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c3b_24), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c40_24), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c50_24), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c58_24), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c60_24), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c68_24), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c70_24), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c78_24), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c79_24), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c7a_24), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c7b_24), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c80_24), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c90_24), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0c98_24), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca0_24), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0ca8_24), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb0_24), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb8_24), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cb9_24), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cba_24), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cbb_24), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_0cd0_24), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0cd8_24), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ce0_24), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ce8_24), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0cf0_24), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0cf8_24), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0cf9_24), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0cfc_24), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ (cpuop_func*)CPUFUNC(op_0e10_24), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e18_24), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e20_24), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e28_24), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e30_24), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e38_24), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e39_24), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e50_24), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e58_24), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e60_24), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e68_24), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e70_24), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e78_24), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e79_24), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e90_24), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0e98_24), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0ea0_24), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0ea8_24), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0eb0_24), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0eb8_24), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0eb9_24), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ (cpuop_func*)CPUFUNC(op_0ed0_24), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ed8_24), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ee0_24), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ee8_24), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ef0_24), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ef8_24), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0ef9_24), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ (cpuop_func*)CPUFUNC(op_0efc_24), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ (cpuop_func*)CPUFUNC(op_1000_24), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1010_24), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1018_24), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1020_24), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1028_24), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1030_24), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1038_24), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1039_24), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103a_24), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103b_24), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_103c_24), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1080_24), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1090_24), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1098_24), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a0_24), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10a8_24), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b0_24), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b8_24), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10b9_24), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10ba_24), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bb_24), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10bc_24), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10c0_24), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d0_24), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10d8_24), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e0_24), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10e8_24), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f0_24), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f8_24), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10f9_24), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fa_24), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fb_24), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_10fc_24), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1100_24), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1110_24), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1118_24), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1120_24), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1128_24), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1130_24), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1138_24), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1139_24), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113a_24), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113b_24), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_113c_24), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1140_24), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1150_24), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1158_24), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1160_24), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1168_24), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1170_24), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1178_24), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1179_24), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117a_24), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117b_24), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_117c_24), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1180_24), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1190_24), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_1198_24), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a0_24), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11a8_24), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b0_24), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b8_24), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11b9_24), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11ba_24), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bb_24), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11bc_24), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11c0_24), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d0_24), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11d8_24), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e0_24), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11e8_24), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f0_24), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f8_24), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11f9_24), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fa_24), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fb_24), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_11fc_24), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13c0_24), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d0_24), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13d8_24), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e0_24), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13e8_24), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f0_24), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f8_24), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13f9_24), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fa_24), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fb_24), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_13fc_24), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2000_24), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2008_24), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2010_24), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2018_24), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2020_24), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2028_24), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2030_24), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2038_24), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2039_24), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203a_24), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203b_24), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_203c_24), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2040_24), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2048_24), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2050_24), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2058_24), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2060_24), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2068_24), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2070_24), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2078_24), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2079_24), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207a_24), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207b_24), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_207c_24), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_2080_24), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2088_24), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2090_24), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2098_24), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a0_24), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20a8_24), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b0_24), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b8_24), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20b9_24), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20ba_24), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bb_24), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20bc_24), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c0_24), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20c8_24), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d0_24), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20d8_24), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e0_24), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20e8_24), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f0_24), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f8_24), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20f9_24), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fa_24), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fb_24), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_20fc_24), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2100_24), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2108_24), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2110_24), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2118_24), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2120_24), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2128_24), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2130_24), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2138_24), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2139_24), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213a_24), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213b_24), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_213c_24), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2140_24), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2148_24), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2150_24), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2158_24), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2160_24), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2168_24), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2170_24), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2178_24), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2179_24), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217a_24), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217b_24), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_217c_24), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2180_24), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2188_24), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2190_24), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_2198_24), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a0_24), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21a8_24), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b0_24), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b8_24), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21b9_24), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21ba_24), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bb_24), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21bc_24), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c0_24), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21c8_24), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d0_24), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21d8_24), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e0_24), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21e8_24), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f0_24), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f8_24), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21f9_24), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fa_24), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fb_24), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_21fc_24), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c0_24), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23c8_24), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d0_24), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23d8_24), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e0_24), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23e8_24), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f0_24), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f8_24), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23f9_24), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fa_24), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fb_24), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_23fc_24), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3000_24), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3008_24), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3010_24), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3018_24), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3020_24), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3028_24), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3030_24), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3038_24), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3039_24), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303a_24), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303b_24), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_303c_24), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3040_24), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3048_24), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3050_24), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3058_24), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3060_24), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3068_24), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3070_24), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3078_24), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3079_24), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307a_24), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307b_24), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_307c_24), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ (cpuop_func*)CPUFUNC(op_3080_24), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3088_24), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3090_24), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3098_24), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a0_24), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30a8_24), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b0_24), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b8_24), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30b9_24), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30ba_24), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bb_24), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30bc_24), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c0_24), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30c8_24), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d0_24), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30d8_24), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e0_24), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30e8_24), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f0_24), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f8_24), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30f9_24), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fa_24), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fb_24), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_30fc_24), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3100_24), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3108_24), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3110_24), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3118_24), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3120_24), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3128_24), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3130_24), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3138_24), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3139_24), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313a_24), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313b_24), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_313c_24), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3140_24), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3148_24), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3150_24), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3158_24), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3160_24), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3168_24), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3170_24), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3178_24), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3179_24), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317a_24), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317b_24), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_317c_24), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3180_24), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3188_24), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3190_24), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_3198_24), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a0_24), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31a8_24), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b0_24), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b8_24), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31b9_24), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31ba_24), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bb_24), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31bc_24), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c0_24), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31c8_24), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d0_24), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31d8_24), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e0_24), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31e8_24), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f0_24), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f8_24), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31f9_24), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fa_24), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fb_24), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_31fc_24), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c0_24), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33c8_24), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d0_24), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33d8_24), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e0_24), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33e8_24), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f0_24), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f8_24), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33f9_24), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fa_24), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fb_24), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_33fc_24), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_4000_24), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4010_24), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4018_24), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4020_24), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4028_24), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4030_24), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4038_24), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4039_24), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4040_24), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4050_24), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4058_24), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4060_24), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4068_24), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4070_24), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4078_24), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4079_24), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4080_24), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4090_24), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_4098_24), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a0_24), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40a8_24), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b0_24), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b8_24), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40b9_24), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ (cpuop_func*)CPUFUNC(op_40c0_24), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d0_24), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40d8_24), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e0_24), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40e8_24), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f0_24), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f8_24), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_40f9_24), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_4100_24), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4110_24), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4118_24), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4120_24), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4128_24), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4130_24), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4138_24), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4139_24), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_413a_24), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_413b_24), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_413c_24), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4180_24), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4190_24), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_4198_24), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a0_24), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41a8_24), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b0_24), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b8_24), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41b9_24), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41ba_24), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bb_24), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41bc_24), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ (cpuop_func*)CPUFUNC(op_41d0_24), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41e8_24), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f0_24), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f8_24), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41f9_24), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fa_24), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_41fb_24), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ (cpuop_func*)CPUFUNC(op_4200_24), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4210_24), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4218_24), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4220_24), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4228_24), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4230_24), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4238_24), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4239_24), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4240_24), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4250_24), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4258_24), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4260_24), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4268_24), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4270_24), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4278_24), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4279_24), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4280_24), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4290_24), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_4298_24), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a0_24), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42a8_24), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b0_24), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b8_24), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42b9_24), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ (cpuop_func*)CPUFUNC(op_42c0_24), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_42d0_24), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_42d8_24), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_42e0_24), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_42e8_24), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_42f0_24), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_42f8_24), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_42f9_24), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ (cpuop_func*)CPUFUNC(op_4400_24), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4410_24), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4418_24), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4420_24), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4428_24), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4430_24), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4438_24), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4439_24), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4440_24), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4450_24), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4458_24), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4460_24), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4468_24), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4470_24), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4478_24), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4479_24), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4480_24), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4490_24), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_4498_24), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a0_24), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44a8_24), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b0_24), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b8_24), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44b9_24), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ (cpuop_func*)CPUFUNC(op_44c0_24), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d0_24), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44d8_24), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e0_24), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44e8_24), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f0_24), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f8_24), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44f9_24), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fa_24), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fb_24), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_44fc_24), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4600_24), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4610_24), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4618_24), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4620_24), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4628_24), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4630_24), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4638_24), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4639_24), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4640_24), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4650_24), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4658_24), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4660_24), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4668_24), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4670_24), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4678_24), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4679_24), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4680_24), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4690_24), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_4698_24), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a0_24), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46a8_24), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b0_24), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b8_24), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46b9_24), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ (cpuop_func*)CPUFUNC(op_46c0_24), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d0_24), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46d8_24), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e0_24), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46e8_24), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f0_24), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f8_24), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46f9_24), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fa_24), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fb_24), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_46fc_24), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ (cpuop_func*)CPUFUNC(op_4800_24), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4808_24), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ (cpuop_func*)CPUFUNC(op_4810_24), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4818_24), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4820_24), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4828_24), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4830_24), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4838_24), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4839_24), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ (cpuop_func*)CPUFUNC(op_4840_24), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ (cpuop_func*)CPUFUNC(op_4848_24), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ (cpuop_func*)CPUFUNC(op_4850_24), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4868_24), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4870_24), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4878_24), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4879_24), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487a_24), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_487b_24), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ (cpuop_func*)CPUFUNC(op_4880_24), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_4890_24), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a0_24), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48a8_24), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b0_24), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b8_24), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48b9_24), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48c0_24), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_48d0_24), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e0_24), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48e8_24), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f0_24), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f8_24), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_48f9_24), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ (cpuop_func*)CPUFUNC(op_49c0_24), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ (cpuop_func*)CPUFUNC(op_4a00_24), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a10_24), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a18_24), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a20_24), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a28_24), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a30_24), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a38_24), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a39_24), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a3a_24), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a3b_24), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a3c_24), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a40_24), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a48_24), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a50_24), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a58_24), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a60_24), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a68_24), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a70_24), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a78_24), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a79_24), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a7a_24), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a7b_24), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a7c_24), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a80_24), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a88_24), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a90_24), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4a98_24), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa0_24), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aa8_24), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab0_24), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab8_24), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ab9_24), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4aba_24), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4abb_24), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4abc_24), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ (cpuop_func*)CPUFUNC(op_4ac0_24), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad0_24), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ad8_24), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae0_24), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4ae8_24), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af0_24), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af8_24), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4af9_24), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ (cpuop_func*)CPUFUNC(op_4c00_24), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c10_24), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c18_24), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c20_24), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c28_24), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c30_24), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c38_24), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c39_24), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c3a_24), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c3b_24), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c3c_24), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ (cpuop_func*)CPUFUNC(op_4c40_24), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c50_24), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c58_24), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c60_24), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c68_24), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c70_24), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c78_24), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c79_24), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c7a_24), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c7b_24), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c7c_24), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ (cpuop_func*)CPUFUNC(op_4c90_24), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4c98_24), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ca8_24), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb0_24), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb8_24), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cb9_24), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cba_24), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cbb_24), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd0_24), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cd8_24), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4ce8_24), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf0_24), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf8_24), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cf9_24), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfa_24), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4cfb_24), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ (cpuop_func*)CPUFUNC(op_4e40_24), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ (cpuop_func*)CPUFUNC(op_4e50_24), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ (cpuop_func*)CPUFUNC(op_4e58_24), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ (cpuop_func*)CPUFUNC(op_4e60_24), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ (cpuop_func*)CPUFUNC(op_4e68_24), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ (cpuop_func*)CPUFUNC(op_4e70_24), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ (cpuop_func*)CPUFUNC(op_4e71_24), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ (cpuop_func*)CPUFUNC(op_4e72_24), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ (cpuop_func*)CPUFUNC(op_4e73_24), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ (cpuop_func*)CPUFUNC(op_4e74_24), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ (cpuop_func*)CPUFUNC(op_4e75_24), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ (cpuop_func*)CPUFUNC(op_4e76_24), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ (cpuop_func*)CPUFUNC(op_4e77_24), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ (cpuop_func*)CPUFUNC(op_4e7a_24), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ (cpuop_func*)CPUFUNC(op_4e7b_24), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ (cpuop_func*)CPUFUNC(op_4e90_24), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ea8_24), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb0_24), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb8_24), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eb9_24), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4eba_24), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ebb_24), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ (cpuop_func*)CPUFUNC(op_4ed0_24), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ee8_24), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef0_24), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef8_24), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4ef9_24), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efa_24), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_4efb_24), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ (cpuop_func*)CPUFUNC(op_5000_24), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5010_24), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5018_24), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5020_24), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5028_24), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5030_24), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5038_24), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5039_24), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5040_24), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5048_24), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5050_24), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5058_24), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5060_24), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5068_24), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5070_24), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5078_24), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5079_24), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5080_24), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5088_24), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_5090_24), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_5098_24), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a0_24), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50a8_24), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b0_24), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b8_24), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50b9_24), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_50c0_24), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50c8_24), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_50d0_24), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50d8_24), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e0_24), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50e8_24), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f0_24), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f8_24), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50f9_24), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_50fa_24), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_50fb_24), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_50fc_24), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5100_24), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5110_24), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5118_24), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5120_24), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5128_24), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5130_24), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5138_24), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5139_24), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5140_24), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5148_24), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5150_24), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5158_24), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5160_24), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5168_24), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5170_24), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5178_24), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5179_24), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5180_24), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5188_24), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_5190_24), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_5198_24), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a0_24), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51a8_24), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b0_24), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b8_24), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51b9_24), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_51c0_24), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51c8_24), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_51d0_24), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51d8_24), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e0_24), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51e8_24), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f0_24), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f8_24), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51f9_24), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_51fa_24), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_51fb_24), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_51fc_24), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_52c0_24), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52c8_24), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_52d0_24), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52d8_24), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e0_24), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52e8_24), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f0_24), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f8_24), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52f9_24), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_52fa_24), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_52fb_24), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_52fc_24), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_53c0_24), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53c8_24), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_53d0_24), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53d8_24), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e0_24), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53e8_24), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f0_24), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f8_24), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53f9_24), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_53fa_24), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_53fb_24), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_53fc_24), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_54c0_24), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54c8_24), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_54d0_24), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54d8_24), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e0_24), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54e8_24), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f0_24), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f8_24), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54f9_24), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_54fa_24), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_54fb_24), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_54fc_24), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_55c0_24), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55c8_24), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_55d0_24), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55d8_24), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e0_24), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55e8_24), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f0_24), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f8_24), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55f9_24), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_55fa_24), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_55fb_24), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_55fc_24), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_56c0_24), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56c8_24), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_56d0_24), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56d8_24), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e0_24), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56e8_24), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f0_24), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f8_24), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56f9_24), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_56fa_24), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_56fb_24), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_56fc_24), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_57c0_24), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57c8_24), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_57d0_24), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57d8_24), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e0_24), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57e8_24), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f0_24), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f8_24), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57f9_24), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_57fa_24), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_57fb_24), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_57fc_24), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_58c0_24), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58c8_24), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_58d0_24), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58d8_24), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e0_24), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58e8_24), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f0_24), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f8_24), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58f9_24), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_58fa_24), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_58fb_24), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_58fc_24), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_59c0_24), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59c8_24), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_59d0_24), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59d8_24), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e0_24), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59e8_24), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f0_24), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f8_24), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59f9_24), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_59fa_24), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_59fb_24), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_59fc_24), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5ac0_24), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ac8_24), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ad0_24), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ad8_24), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae0_24), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ae8_24), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af0_24), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af8_24), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5af9_24), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5afa_24), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5afb_24), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5afc_24), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5bc0_24), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bc8_24), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5bd0_24), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bd8_24), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be0_24), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5be8_24), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf0_24), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf8_24), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bf9_24), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5bfa_24), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5bfb_24), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5bfc_24), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5cc0_24), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cc8_24), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5cd0_24), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cd8_24), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce0_24), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ce8_24), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf0_24), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf8_24), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cf9_24), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5cfa_24), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5cfb_24), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5cfc_24), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5dc0_24), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dc8_24), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5dd0_24), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dd8_24), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de0_24), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5de8_24), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df0_24), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df8_24), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5df9_24), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5dfa_24), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5dfb_24), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5dfc_24), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5ec0_24), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ec8_24), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5ed0_24), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ed8_24), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee0_24), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ee8_24), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef0_24), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef8_24), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ef9_24), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5efa_24), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5efb_24), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5efc_24), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5fc0_24), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fc8_24), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ (cpuop_func*)CPUFUNC(op_5fd0_24), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fd8_24), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe0_24), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5fe8_24), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff0_24), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff8_24), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ff9_24), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ (cpuop_func*)CPUFUNC(op_5ffa_24), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5ffb_24), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_5ffc_24), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ (cpuop_func*)CPUFUNC(op_6000_24), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6001_24), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_60ff_24), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6100_24), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6101_24), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_61ff_24), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ (cpuop_func*)CPUFUNC(op_6200_24), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6201_24), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_62ff_24), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6300_24), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6301_24), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_63ff_24), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6400_24), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6401_24), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_64ff_24), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6500_24), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6501_24), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_65ff_24), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6600_24), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6601_24), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_66ff_24), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6700_24), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6701_24), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_67ff_24), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6800_24), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6801_24), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_68ff_24), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6900_24), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6901_24), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_69ff_24), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a00_24), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6a01_24), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6aff_24), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b00_24), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6b01_24), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6bff_24), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c00_24), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6c01_24), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6cff_24), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d00_24), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6d01_24), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6dff_24), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e00_24), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6e01_24), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6eff_24), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f00_24), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6f01_24), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_6fff_24), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ (cpuop_func*)CPUFUNC(op_7000_24), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ (cpuop_func*)CPUFUNC(op_8000_24), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8010_24), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8018_24), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8020_24), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8028_24), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8030_24), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8038_24), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8039_24), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803a_24), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803b_24), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_803c_24), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8040_24), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8050_24), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8058_24), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8060_24), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8068_24), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8070_24), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8078_24), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8079_24), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807a_24), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807b_24), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_807c_24), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8080_24), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8090_24), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8098_24), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a0_24), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80a8_24), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b0_24), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b8_24), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80b9_24), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80ba_24), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bb_24), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80bc_24), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_80c0_24), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d0_24), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80d8_24), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e0_24), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80e8_24), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f0_24), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f8_24), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80f9_24), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fa_24), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fb_24), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_80fc_24), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ (cpuop_func*)CPUFUNC(op_8100_24), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8108_24), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ (cpuop_func*)CPUFUNC(op_8110_24), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8118_24), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8120_24), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8128_24), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8130_24), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8138_24), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8139_24), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8140_24), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ (cpuop_func*)CPUFUNC(op_8148_24), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ (cpuop_func*)CPUFUNC(op_8150_24), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8158_24), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8160_24), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8168_24), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8170_24), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8178_24), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8179_24), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8180_24), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ (cpuop_func*)CPUFUNC(op_8188_24), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ (cpuop_func*)CPUFUNC(op_8190_24), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_8198_24), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a0_24), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81a8_24), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b0_24), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b8_24), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81b9_24), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ (cpuop_func*)CPUFUNC(op_81c0_24), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d0_24), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81d8_24), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e0_24), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81e8_24), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f0_24), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f8_24), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81f9_24), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fa_24), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fb_24), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_81fc_24), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ (cpuop_func*)CPUFUNC(op_9000_24), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9010_24), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9018_24), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9020_24), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9028_24), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9030_24), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9038_24), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9039_24), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903a_24), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903b_24), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_903c_24), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9040_24), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9048_24), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9050_24), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9058_24), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9060_24), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9068_24), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9070_24), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9078_24), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9079_24), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907a_24), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907b_24), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_907c_24), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9080_24), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9088_24), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9090_24), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9098_24), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a0_24), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90a8_24), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b0_24), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b8_24), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90b9_24), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90ba_24), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bb_24), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90bc_24), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_90c0_24), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90c8_24), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d0_24), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90d8_24), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e0_24), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90e8_24), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f0_24), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f8_24), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90f9_24), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fa_24), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fb_24), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_90fc_24), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_9100_24), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9108_24), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9110_24), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9118_24), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9120_24), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9128_24), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9130_24), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9138_24), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9139_24), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9140_24), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9148_24), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9150_24), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9158_24), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9160_24), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9168_24), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9170_24), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9178_24), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9179_24), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9180_24), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9188_24), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ (cpuop_func*)CPUFUNC(op_9190_24), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_9198_24), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a0_24), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91a8_24), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b0_24), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b8_24), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91b9_24), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ (cpuop_func*)CPUFUNC(op_91c0_24), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91c8_24), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d0_24), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91d8_24), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e0_24), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91e8_24), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f0_24), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f8_24), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91f9_24), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fa_24), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fb_24), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_91fc_24), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ (cpuop_func*)CPUFUNC(op_b000_24), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b010_24), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b018_24), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b020_24), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b028_24), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b030_24), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b038_24), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b039_24), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03a_24), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03b_24), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b03c_24), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b040_24), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b048_24), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b050_24), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b058_24), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b060_24), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b068_24), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b070_24), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b078_24), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b079_24), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07a_24), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07b_24), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b07c_24), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b080_24), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b088_24), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b090_24), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b098_24), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a0_24), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0a8_24), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b0_24), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b8_24), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0b9_24), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0ba_24), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bb_24), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0bc_24), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ (cpuop_func*)CPUFUNC(op_b0c0_24), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0c8_24), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d0_24), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0d8_24), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e0_24), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0e8_24), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f0_24), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f8_24), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0f9_24), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fa_24), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fb_24), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b0fc_24), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b100_24), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b108_24), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b110_24), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b118_24), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b120_24), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b128_24), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b130_24), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b138_24), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b139_24), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b140_24), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b148_24), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b150_24), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b158_24), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b160_24), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b168_24), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b170_24), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b178_24), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b179_24), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b180_24), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b188_24), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ (cpuop_func*)CPUFUNC(op_b190_24), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b198_24), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a0_24), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1a8_24), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b0_24), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b8_24), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1b9_24), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ (cpuop_func*)CPUFUNC(op_b1c0_24), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1c8_24), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d0_24), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1d8_24), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e0_24), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1e8_24), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f0_24), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f8_24), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1f9_24), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fa_24), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fb_24), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_b1fc_24), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ (cpuop_func*)CPUFUNC(op_c000_24), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c010_24), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c018_24), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c020_24), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c028_24), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c030_24), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c038_24), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c039_24), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03a_24), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03b_24), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c03c_24), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c040_24), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c050_24), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c058_24), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c060_24), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c068_24), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c070_24), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c078_24), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c079_24), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07a_24), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07b_24), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c07c_24), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c080_24), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c090_24), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c098_24), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a0_24), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0a8_24), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b0_24), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b8_24), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0b9_24), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0ba_24), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bb_24), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0bc_24), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c0c0_24), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d0_24), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0d8_24), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e0_24), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0e8_24), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f0_24), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f8_24), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0f9_24), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fa_24), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fb_24), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c0fc_24), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ (cpuop_func*)CPUFUNC(op_c100_24), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c108_24), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ (cpuop_func*)CPUFUNC(op_c110_24), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c118_24), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c120_24), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c128_24), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c130_24), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c138_24), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c139_24), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c140_24), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c148_24), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c150_24), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c158_24), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c160_24), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c168_24), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c170_24), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c178_24), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c179_24), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c188_24), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ (cpuop_func*)CPUFUNC(op_c190_24), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c198_24), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a0_24), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1a8_24), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b0_24), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b8_24), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1b9_24), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ (cpuop_func*)CPUFUNC(op_c1c0_24), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d0_24), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1d8_24), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e0_24), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1e8_24), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f0_24), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f8_24), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1f9_24), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fa_24), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fb_24), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_c1fc_24), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ (cpuop_func*)CPUFUNC(op_d000_24), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d010_24), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d018_24), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d020_24), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d028_24), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d030_24), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d038_24), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d039_24), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03a_24), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03b_24), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d03c_24), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d040_24), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d048_24), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d050_24), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d058_24), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d060_24), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d068_24), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d070_24), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d078_24), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d079_24), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07a_24), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07b_24), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d07c_24), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d080_24), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d088_24), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d090_24), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d098_24), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a0_24), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0a8_24), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b0_24), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b8_24), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0b9_24), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0ba_24), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bb_24), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0bc_24), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d0c0_24), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0c8_24), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d0_24), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0d8_24), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e0_24), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0e8_24), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f0_24), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f8_24), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0f9_24), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fa_24), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fb_24), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d0fc_24), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d100_24), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d108_24), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d110_24), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d118_24), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d120_24), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d128_24), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d130_24), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d138_24), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d139_24), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d140_24), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d148_24), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d150_24), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d158_24), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d160_24), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d168_24), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d170_24), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d178_24), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d179_24), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d180_24), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d188_24), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ (cpuop_func*)CPUFUNC(op_d190_24), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d198_24), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a0_24), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1a8_24), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b0_24), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b8_24), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1b9_24), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ (cpuop_func*)CPUFUNC(op_d1c0_24), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1c8_24), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d0_24), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1d8_24), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e0_24), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1e8_24), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f0_24), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f8_24), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1f9_24), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fa_24), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fb_24), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_d1fc_24), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ (cpuop_func*)CPUFUNC(op_e000_24), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e008_24), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e010_24), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e018_24), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e020_24), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e028_24), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e030_24), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e038_24), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e040_24), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e048_24), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e050_24), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e058_24), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e060_24), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e068_24), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e070_24), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e078_24), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e080_24), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e088_24), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e090_24), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e098_24), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0a0_24), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ (cpuop_func*)CPUFUNC(op_e0a8_24), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ (cpuop_func*)CPUFUNC(op_e0b0_24), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ (cpuop_func*)CPUFUNC(op_e0b8_24), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ (cpuop_func*)CPUFUNC(op_e0d0_24), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0d8_24), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e0_24), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0e8_24), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f0_24), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f8_24), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e0f9_24), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ (cpuop_func*)CPUFUNC(op_e100_24), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e108_24), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e110_24), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e118_24), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e120_24), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e128_24), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e130_24), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e138_24), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e140_24), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e148_24), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e150_24), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e158_24), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e160_24), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e168_24), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e170_24), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e178_24), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e180_24), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e188_24), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e190_24), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e198_24), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1a0_24), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ (cpuop_func*)CPUFUNC(op_e1a8_24), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ (cpuop_func*)CPUFUNC(op_e1b0_24), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ (cpuop_func*)CPUFUNC(op_e1b8_24), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ (cpuop_func*)CPUFUNC(op_e1d0_24), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1d8_24), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e0_24), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1e8_24), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f0_24), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f8_24), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e1f9_24), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ (cpuop_func*)CPUFUNC(op_e2d0_24), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2d8_24), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e0_24), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2e8_24), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f0_24), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f8_24), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e2f9_24), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ (cpuop_func*)CPUFUNC(op_e3d0_24), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3d8_24), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e0_24), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3e8_24), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f0_24), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f8_24), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e3f9_24), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ (cpuop_func*)CPUFUNC(op_e4d0_24), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4d8_24), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e0_24), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4e8_24), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f0_24), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f8_24), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e4f9_24), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ (cpuop_func*)CPUFUNC(op_e5d0_24), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5d8_24), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e0_24), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5e8_24), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f0_24), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f8_24), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e5f9_24), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ (cpuop_func*)CPUFUNC(op_e6d0_24), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6d8_24), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e0_24), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6e8_24), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f0_24), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f8_24), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e6f9_24), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ (cpuop_func*)CPUFUNC(op_e7d0_24), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7d8_24), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e0_24), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7e8_24), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f0_24), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f8_24), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e7f9_24), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ (cpuop_func*)CPUFUNC(op_e8c0_24), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ (cpuop_func*)CPUFUNC(op_e8d0_24), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ (cpuop_func*)CPUFUNC(op_e8e8_24), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ (cpuop_func*)CPUFUNC(op_e8f0_24), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ (cpuop_func*)CPUFUNC(op_e8f8_24), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ (cpuop_func*)CPUFUNC(op_e8f9_24), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ (cpuop_func*)CPUFUNC(op_e8fa_24), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ (cpuop_func*)CPUFUNC(op_e8fb_24), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ (cpuop_func*)CPUFUNC(op_e9c0_24), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ (cpuop_func*)CPUFUNC(op_e9d0_24), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ (cpuop_func*)CPUFUNC(op_e9e8_24), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ (cpuop_func*)CPUFUNC(op_e9f0_24), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ (cpuop_func*)CPUFUNC(op_e9f8_24), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ (cpuop_func*)CPUFUNC(op_e9f9_24), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ (cpuop_func*)CPUFUNC(op_e9fa_24), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ (cpuop_func*)CPUFUNC(op_e9fb_24), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ (cpuop_func*)CPUFUNC(op_eac0_24), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ (cpuop_func*)CPUFUNC(op_ead0_24), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ (cpuop_func*)CPUFUNC(op_eae8_24), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ (cpuop_func*)CPUFUNC(op_eaf0_24), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ (cpuop_func*)CPUFUNC(op_eaf8_24), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ (cpuop_func*)CPUFUNC(op_eaf9_24), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ (cpuop_func*)CPUFUNC(op_ebc0_24), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ (cpuop_func*)CPUFUNC(op_ebd0_24), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ (cpuop_func*)CPUFUNC(op_ebe8_24), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ (cpuop_func*)CPUFUNC(op_ebf0_24), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ (cpuop_func*)CPUFUNC(op_ebf8_24), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ (cpuop_func*)CPUFUNC(op_ebf9_24), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ (cpuop_func*)CPUFUNC(op_ebfa_24), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ (cpuop_func*)CPUFUNC(op_ebfb_24), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ (cpuop_func*)CPUFUNC(op_ecc0_24), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ (cpuop_func*)CPUFUNC(op_ecd0_24), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ (cpuop_func*)CPUFUNC(op_ece8_24), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ (cpuop_func*)CPUFUNC(op_ecf0_24), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ (cpuop_func*)CPUFUNC(op_ecf8_24), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ (cpuop_func*)CPUFUNC(op_ecf9_24), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ (cpuop_func*)CPUFUNC(op_edc0_24), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ (cpuop_func*)CPUFUNC(op_edd0_24), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ (cpuop_func*)CPUFUNC(op_ede8_24), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ (cpuop_func*)CPUFUNC(op_edf0_24), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ (cpuop_func*)CPUFUNC(op_edf8_24), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ (cpuop_func*)CPUFUNC(op_edf9_24), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ (cpuop_func*)CPUFUNC(op_edfa_24), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ (cpuop_func*)CPUFUNC(op_edfb_24), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ (cpuop_func*)CPUFUNC(op_eec0_24), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ (cpuop_func*)CPUFUNC(op_eed0_24), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ (cpuop_func*)CPUFUNC(op_eee8_24), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ (cpuop_func*)CPUFUNC(op_eef0_24), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ (cpuop_func*)CPUFUNC(op_eef8_24), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ (cpuop_func*)CPUFUNC(op_eef9_24), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ (cpuop_func*)CPUFUNC(op_efc0_24), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ (cpuop_func*)CPUFUNC(op_efd0_24), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ (cpuop_func*)CPUFUNC(op_efe8_24), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ (cpuop_func*)CPUFUNC(op_eff0_24), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ (cpuop_func*)CPUFUNC(op_eff8_24), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ (cpuop_func*)CPUFUNC(op_eff9_24), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ (cpuop_func*)CPUFUNC(op_f000_24), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f008_24), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f010_24), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f018_24), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f020_24), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f028_24), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f030_24), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f038_24), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f039_24), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ (cpuop_func*)CPUFUNC(op_f200_24), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f208_24), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f210_24), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f218_24), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f220_24), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f228_24), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f230_24), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f238_24), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f239_24), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f23a_24), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f23b_24), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f23c_24), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ (cpuop_func*)CPUFUNC(op_f240_24), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ (cpuop_func*)CPUFUNC(op_f248_24), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ (cpuop_func*)CPUFUNC(op_f250_24), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ (cpuop_func*)CPUFUNC(op_f258_24), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ (cpuop_func*)CPUFUNC(op_f260_24), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ (cpuop_func*)CPUFUNC(op_f268_24), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ (cpuop_func*)CPUFUNC(op_f270_24), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ (cpuop_func*)CPUFUNC(op_f278_24), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ (cpuop_func*)CPUFUNC(op_f279_24), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ (cpuop_func*)CPUFUNC(op_f27a_24), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ (cpuop_func*)CPUFUNC(op_f27b_24), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ (cpuop_func*)CPUFUNC(op_f27c_24), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ (cpuop_func*)CPUFUNC(op_f280_24), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ (cpuop_func*)CPUFUNC(op_f2c0_24), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ (cpuop_func*)CPUFUNC(op_f310_24), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ (cpuop_func*)CPUFUNC(op_f320_24), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ (cpuop_func*)CPUFUNC(op_f328_24), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ (cpuop_func*)CPUFUNC(op_f330_24), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ (cpuop_func*)CPUFUNC(op_f338_24), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ (cpuop_func*)CPUFUNC(op_f339_24), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ (cpuop_func*)CPUFUNC(op_f350_24), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ (cpuop_func*)CPUFUNC(op_f358_24), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ (cpuop_func*)CPUFUNC(op_f368_24), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ (cpuop_func*)CPUFUNC(op_f370_24), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ (cpuop_func*)CPUFUNC(op_f378_24), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ (cpuop_func*)CPUFUNC(op_f379_24), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ (cpuop_func*)CPUFUNC(op_f37a_24), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ (cpuop_func*)CPUFUNC(op_f37b_24), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ (cpuop_func*)CPUFUNC(op_f408_24), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
{ (cpuop_func*)CPUFUNC(op_f410_24), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
{ (cpuop_func*)CPUFUNC(op_f418_24), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
{ (cpuop_func*)CPUFUNC(op_f419_24), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
{ (cpuop_func*)CPUFUNC(op_f41a_24), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
{ (cpuop_func*)CPUFUNC(op_f41b_24), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
{ (cpuop_func*)CPUFUNC(op_f41c_24), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
{ (cpuop_func*)CPUFUNC(op_f41d_24), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
{ (cpuop_func*)CPUFUNC(op_f41e_24), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
{ (cpuop_func*)CPUFUNC(op_f41f_24), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
{ (cpuop_func*)CPUFUNC(op_f428_24), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
{ (cpuop_func*)CPUFUNC(op_f430_24), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
{ (cpuop_func*)CPUFUNC(op_f438_24), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ (cpuop_func*)CPUFUNC(op_f439_24), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ (cpuop_func*)CPUFUNC(op_f43a_24), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ (cpuop_func*)CPUFUNC(op_f43b_24), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ (cpuop_func*)CPUFUNC(op_f43c_24), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ (cpuop_func*)CPUFUNC(op_f43d_24), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ (cpuop_func*)CPUFUNC(op_f43e_24), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ (cpuop_func*)CPUFUNC(op_f43f_24), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ (cpuop_func*)CPUFUNC(op_f500_24), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
{ (cpuop_func*)CPUFUNC(op_f508_24), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
{ (cpuop_func*)CPUFUNC(op_f510_24), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
{ (cpuop_func*)CPUFUNC(op_f518_24), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
{ (cpuop_func*)CPUFUNC(op_f548_24), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
{ (cpuop_func*)CPUFUNC(op_f568_24), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
{ (cpuop_func*)CPUFUNC(op_f600_24), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ (cpuop_func*)CPUFUNC(op_f608_24), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ (cpuop_func*)CPUFUNC(op_f610_24), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ (cpuop_func*)CPUFUNC(op_f618_24), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ (cpuop_func*)CPUFUNC(op_f620_24), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_25 */
#ifdef CPUEMU_31
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_31)[] = {
{ CPUFUNC(op_0000_31), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_31), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_31), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_31), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_31), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_31), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_31), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_31), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_31), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_31), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_31), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_31), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_31), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_31), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_31), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_31), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_31), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_31), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_31), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_31), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_31), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_31), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_31), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_31), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_31), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_31), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00d0_31), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00e8_31), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f0_31), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f8_31), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f9_31), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fa_31), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fb_31), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0100_31), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_31), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_31), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_31), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_31), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_31), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_31), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_31), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_31), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_31), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_31), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_31), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_31), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_31), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_31), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_31), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_31), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_31), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_31), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_31), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_31), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_31), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_31), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_31), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_31), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_31), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_31), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_31), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_31), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_31), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_31), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_31), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_31), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_31), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_31), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_31), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_31), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_31), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_31), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_31), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_31), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_31), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_31), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_31), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_31), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_31), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_31), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_31), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_31), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_31), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_31), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_31), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_31), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_31), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_31), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_31), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_31), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_31), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_31), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_31), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_31), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_31), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_31), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_31), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_31), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02d0_31), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02e8_31), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f0_31), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f8_31), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f9_31), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fa_31), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fb_31), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0400_31), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_31), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_31), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_31), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_31), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_31), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_31), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_31), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_31), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_31), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_31), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_31), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_31), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_31), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_31), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_31), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_31), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_31), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_31), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_31), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_31), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_31), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_31), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_31), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04d0_31), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04e8_31), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f0_31), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f8_31), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f9_31), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fa_31), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fb_31), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0600_31), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_31), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_31), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_31), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_31), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_31), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_31), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_31), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_31), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_31), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_31), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_31), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_31), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_31), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_31), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_31), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_31), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_31), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_31), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_31), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_31), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_31), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_31), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_31), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c0_31), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c8_31), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06d0_31), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06e8_31), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f0_31), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f8_31), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f9_31), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fa_31), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fb_31), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ CPUFUNC(op_0800_31), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_31), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_31), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_31), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_31), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_31), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_31), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_31), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_31), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_31), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_31), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_31), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_31), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_31), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_31), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_31), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_31), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_31), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_31), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_31), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_31), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_31), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_31), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_31), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_31), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_31), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_31), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_31), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_31), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_31), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_31), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_31), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_31), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_31), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_31), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_31), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_31), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_31), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_31), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_31), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_31), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_31), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_31), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_31), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_31), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_31), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_31), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_31), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_31), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_31), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_31), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_31), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_31), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_31), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_31), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_31), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_31), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_31), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_31), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_31), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad0_31), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad8_31), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae0_31), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae8_31), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af0_31), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af8_31), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af9_31), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ CPUFUNC(op_0c00_31), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_31), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_31), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_31), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_31), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_31), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_31), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_31), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3a_31), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3b_31), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c40_31), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_31), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_31), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_31), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_31), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_31), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_31), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_31), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7a_31), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7b_31), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c80_31), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_31), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_31), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_31), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_31), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_31), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_31), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_31), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cba_31), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cbb_31), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd0_31), 0x0cd0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd8_31), 0x0cd8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce0_31), 0x0ce0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce8_31), 0x0ce8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf0_31), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf8_31), 0x0cf8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf9_31), 0x0cf9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cfc_31), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e10_31), 0x0e10, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e18_31), 0x0e18, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e20_31), 0x0e20, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e28_31), 0x0e28, 12, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e30_31), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e38_31), 0x0e38, 12, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e39_31), 0x0e39, 16, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e50_31), 0x0e50, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e58_31), 0x0e58, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e60_31), 0x0e60, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e68_31), 0x0e68, 12, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e70_31), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e78_31), 0x0e78, 12, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e79_31), 0x0e79, 16, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e90_31), 0x0e90, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e98_31), 0x0e98, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea0_31), 0x0ea0, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea8_31), 0x0ea8, 12, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb0_31), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb8_31), 0x0eb8, 12, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb9_31), 0x0eb9, 16, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed0_31), 0x0ed0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed8_31), 0x0ed8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee0_31), 0x0ee0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee8_31), 0x0ee8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef0_31), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef8_31), 0x0ef8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef9_31), 0x0ef9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0efc_31), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ CPUFUNC(op_1000_31), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_31), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_31), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_31), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_31), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_31), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_31), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_31), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_31), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_31), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_31), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_31), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_31), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_31), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_31), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_31), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_31), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_31), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_31), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_31), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_31), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_31), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_31), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_31), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_31), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_31), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_31), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_31), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_31), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_31), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_31), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_31), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_31), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_31), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_31), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_31), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_31), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_31), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_31), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_31), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_31), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_31), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_31), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_31), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_31), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_31), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_31), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_31), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_31), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_31), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_31), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_31), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_31), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_31), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_31), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_31), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_31), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_31), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_31), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_31), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_31), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_31), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_31), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_31), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_31), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_31), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_31), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_31), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_31), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_31), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_31), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_31), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_31), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_31), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_31), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_31), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_31), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_31), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_31), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_31), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_31), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_31), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_31), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_31), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_31), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_31), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_31), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_31), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_31), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_31), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_31), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_31), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_31), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_31), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_31), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_31), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_31), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_31), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_31), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_31), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_31), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_31), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_31), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_31), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_31), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_31), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_31), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_31), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_31), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_31), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_31), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_31), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_31), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_31), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_31), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_31), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_31), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_31), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_31), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_31), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_31), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_31), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_31), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_31), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_31), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_31), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_31), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_31), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_31), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_31), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_31), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_31), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_31), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_31), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_31), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_31), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_31), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_31), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_31), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_31), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_31), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_31), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_31), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_31), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_31), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_31), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_31), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_31), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_31), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_31), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_31), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_31), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_31), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_31), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_31), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_31), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_31), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_31), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_31), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_31), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_31), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_31), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_31), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_31), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_31), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_31), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_31), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_31), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_31), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_31), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_31), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_31), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_31), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_31), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_31), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_31), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_31), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_31), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_31), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_31), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_31), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_31), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_31), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_31), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_31), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_31), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_31), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_31), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_31), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_31), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_31), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_31), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_31), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_31), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_31), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_31), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_31), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_31), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_31), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_31), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_31), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_31), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_31), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_31), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_31), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_31), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_31), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_31), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_31), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_31), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_31), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_31), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_31), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_31), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_31), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_31), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_31), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_31), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_31), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_31), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_31), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_31), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_31), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_31), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_31), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_31), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_31), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_31), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_31), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_31), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_31), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_31), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_31), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_31), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_31), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_31), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_31), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_31), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_31), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_31), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_31), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_31), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_31), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_31), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_31), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_31), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_31), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_31), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_31), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_31), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_31), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_31), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_31), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_31), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_31), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_31), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_31), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_31), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_31), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_31), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_31), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_31), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_31), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_31), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_31), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_31), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_31), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_31), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_31), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_31), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_31), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_31), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_31), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_31), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_31), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_31), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_31), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_31), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_31), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_31), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_31), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_31), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_31), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_31), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_31), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_31), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_31), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_31), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_31), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_31), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_31), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_31), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_31), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_31), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_31), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_31), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_31), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_31), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_31), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_31), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_31), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_31), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_31), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_31), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_31), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_31), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_31), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_31), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_31), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_31), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_31), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_31), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_31), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_31), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_31), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_31), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_31), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_31), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_31), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_31), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_31), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_31), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_31), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_31), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_31), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_31), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_31), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_31), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_31), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_31), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_31), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_31), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_31), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_31), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_31), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_31), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4100_31), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4110_31), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4118_31), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4120_31), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4128_31), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4130_31), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4138_31), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4139_31), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413a_31), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413b_31), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413c_31), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ CPUFUNC(op_4180_31), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_31), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_31), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_31), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_31), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_31), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_31), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_31), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_31), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_31), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_31), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_31), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_31), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_31), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_31), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_31), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_31), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_31), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_31), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_31), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_31), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_31), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_31), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_31), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_31), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_31), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_31), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_31), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_31), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_31), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_31), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_31), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_31), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_31), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_31), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_31), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_31), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_31), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_31), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_31), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_31), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_31), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_31), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_31), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_31), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_31), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_31), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_31), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_31), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_31), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_31), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_31), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_31), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_31), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_31), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_31), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_31), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_31), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_31), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_31), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_31), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_31), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_31), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_31), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_31), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_31), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_31), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_31), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_31), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_31), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_31), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_31), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_31), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_31), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_31), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_31), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_31), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_31), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_31), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_31), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_31), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_31), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_31), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_31), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_31), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_31), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_31), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_31), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_31), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_31), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_31), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_31), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_31), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_31), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_31), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_31), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_31), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_31), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_31), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_31), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_31), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_31), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_31), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_31), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_31), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_31), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_31), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_31), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_31), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_31), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_31), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_31), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_31), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_31), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_31), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_31), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_31), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_31), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_31), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_31), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_31), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4808_31), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ CPUFUNC(op_4810_31), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_31), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_31), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_31), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_31), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_31), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_31), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_31), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4848_31), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ CPUFUNC(op_4850_31), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_31), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_31), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_31), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_31), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_31), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_31), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_31), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_31), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_31), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_31), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_31), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_31), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_31), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_31), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_31), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_31), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_31), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_31), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_31), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_31), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_49c0_31), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ CPUFUNC(op_4a00_31), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_31), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_31), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_31), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_31), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_31), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_31), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_31), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3a_31), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3b_31), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3c_31), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a40_31), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a48_31), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a50_31), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_31), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_31), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_31), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_31), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_31), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_31), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7a_31), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7b_31), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7c_31), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a80_31), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a88_31), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a90_31), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_31), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_31), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_31), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_31), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_31), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_31), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4aba_31), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abb_31), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abc_31), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4ac0_31), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_31), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_31), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_31), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_31), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_31), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_31), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_31), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c00_31), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c10_31), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c18_31), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c20_31), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c28_31), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c30_31), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c38_31), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c39_31), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3a_31), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3b_31), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3c_31), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c40_31), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c50_31), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c58_31), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c60_31), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c68_31), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c70_31), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c78_31), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c79_31), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7a_31), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7b_31), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7c_31), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ CPUFUNC(op_4c90_31), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_31), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_31), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_31), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_31), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_31), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_31), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_31), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_31), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_31), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_31), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_31), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_31), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_31), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_31), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_31), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_31), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_31), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_31), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_31), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_31), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_31), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_31), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_31), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_31), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_31), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_31), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_31), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_31), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_31), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_31), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_31), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_31), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_31), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_31), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_31), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_31), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_31), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_31), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_31), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_31), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_31), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_31), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_31), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_31), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_31), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_31), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_31), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_31), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_31), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_31), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_31), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_31), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_31), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_31), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_31), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_31), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_31), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_31), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_31), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_31), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_31), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_31), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_31), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_31), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_31), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_31), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_31), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_31), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_31), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_31), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_31), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_31), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_31), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_31), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_31), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_31), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_31), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_31), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_31), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fa_31), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fb_31), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fc_31), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5100_31), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_31), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_31), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_31), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_31), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_31), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_31), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_31), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_31), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_31), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_31), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_31), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_31), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_31), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_31), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_31), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_31), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_31), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_31), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_31), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_31), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_31), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_31), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_31), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_31), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_31), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_31), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_31), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_31), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_31), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_31), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_31), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_31), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_31), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_31), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fa_31), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fb_31), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fc_31), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_52c0_31), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_31), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_31), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_31), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_31), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_31), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_31), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_31), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_31), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fa_31), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fb_31), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fc_31), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_53c0_31), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_31), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_31), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_31), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_31), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_31), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_31), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_31), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_31), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fa_31), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fb_31), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fc_31), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_54c0_31), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_31), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_31), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_31), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_31), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_31), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_31), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_31), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_31), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fa_31), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fb_31), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fc_31), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_55c0_31), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_31), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_31), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_31), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_31), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_31), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_31), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_31), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_31), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fa_31), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fb_31), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fc_31), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_56c0_31), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_31), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_31), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_31), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_31), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_31), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_31), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_31), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_31), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fa_31), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fb_31), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fc_31), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_57c0_31), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_31), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_31), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_31), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_31), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_31), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_31), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_31), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_31), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fa_31), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fb_31), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fc_31), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_58c0_31), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_31), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_31), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_31), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_31), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_31), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_31), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_31), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_31), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fa_31), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fb_31), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fc_31), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_59c0_31), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_31), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_31), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_31), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_31), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_31), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_31), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_31), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_31), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fa_31), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fb_31), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fc_31), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ac0_31), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_31), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_31), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_31), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_31), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_31), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_31), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_31), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_31), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afa_31), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afb_31), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afc_31), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5bc0_31), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_31), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_31), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_31), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_31), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_31), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_31), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_31), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_31), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfa_31), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfb_31), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfc_31), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5cc0_31), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_31), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_31), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_31), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_31), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_31), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_31), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_31), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_31), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfa_31), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfb_31), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfc_31), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5dc0_31), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_31), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_31), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_31), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_31), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_31), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_31), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_31), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_31), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfa_31), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfb_31), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfc_31), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ec0_31), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_31), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_31), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_31), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_31), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_31), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_31), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_31), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_31), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efa_31), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efb_31), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efc_31), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5fc0_31), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_31), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_31), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_31), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_31), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_31), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_31), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_31), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_31), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffa_31), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffb_31), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffc_31), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_6000_31), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_31), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_31), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_31), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_31), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_31), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_31), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_31), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_31), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_31), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_31), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_31), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_31), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_31), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_31), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_31), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_31), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_31), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_31), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_31), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_31), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_31), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_31), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_31), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_31), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_31), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_31), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_31), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_31), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_31), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_31), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_31), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_31), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_31), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_31), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_31), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_31), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_31), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_31), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_31), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_31), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_31), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_31), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_31), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_31), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_31), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_31), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_31), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_31), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_31), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_31), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_31), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_31), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_31), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_31), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_31), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_31), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_31), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_31), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_31), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_31), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_31), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_31), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_31), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_31), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_31), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_31), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_31), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_31), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_31), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_31), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_31), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_31), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_31), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_31), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_31), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_31), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_31), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_31), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_31), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_31), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_31), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_31), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_31), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_31), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_31), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_31), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_31), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_31), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_31), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_31), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_31), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_31), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_31), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_31), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_31), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_31), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_31), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_31), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_31), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_31), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_31), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8140_31), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8148_31), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ CPUFUNC(op_8150_31), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_31), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_31), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_31), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_31), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_31), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_31), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8180_31), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8188_31), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ CPUFUNC(op_8190_31), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_31), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_31), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_31), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_31), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_31), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_31), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_31), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_31), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_31), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_31), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_31), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_31), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_31), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_31), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_31), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_31), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_31), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_31), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_31), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_31), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_31), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_31), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_31), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_31), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_31), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_31), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_31), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_31), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_31), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_31), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_31), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_31), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_31), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_31), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_31), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_31), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_31), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_31), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_31), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_31), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_31), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_31), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_31), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_31), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_31), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_31), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_31), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_31), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_31), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_31), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_31), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_31), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_31), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_31), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_31), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_31), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_31), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_31), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_31), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_31), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_31), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_31), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_31), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_31), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_31), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_31), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_31), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_31), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_31), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_31), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_31), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_31), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_31), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_31), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_31), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_31), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_31), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_31), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_31), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_31), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_31), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_31), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_31), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_31), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_31), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_31), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_31), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_31), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_31), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_31), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_31), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_31), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_31), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_31), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_31), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_31), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_31), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_31), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_31), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_31), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_31), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_31), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_31), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_31), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_31), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_31), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_31), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_31), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_31), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_31), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_31), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_31), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_31), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_31), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_31), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_31), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_31), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_31), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_31), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_31), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_31), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_31), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_31), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_31), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_31), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_31), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_31), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_31), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_31), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_31), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_31), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_31), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_31), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_31), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_31), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_31), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_31), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_31), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_31), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_31), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_31), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_31), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_31), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_31), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_31), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_31), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_31), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_31), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_31), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_31), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_31), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_31), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_31), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_31), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_31), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_31), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_31), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_31), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_31), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_31), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_31), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_31), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_31), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_31), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_31), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_31), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_31), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_31), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_31), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_31), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_31), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_31), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_31), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_31), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_31), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_31), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_31), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_31), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_31), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_31), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_31), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_31), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_31), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_31), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_31), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_31), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_31), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_31), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_31), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_31), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_31), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_31), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_31), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_31), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_31), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_31), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_31), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_31), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_31), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_31), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_31), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_31), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_31), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_31), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_31), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_31), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_31), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_31), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_31), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_31), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_31), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_31), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_31), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_31), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_31), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_31), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_31), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_31), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_31), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_31), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_31), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_31), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_31), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_31), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_31), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_31), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_31), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_31), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_31), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_31), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_31), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_31), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_31), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_31), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_31), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_31), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_31), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_31), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_31), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_31), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_31), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_31), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_31), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_31), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_31), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_31), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_31), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_31), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_31), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_31), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_31), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_31), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_31), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_31), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_31), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_31), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_31), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_31), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_31), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_31), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_31), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_31), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_31), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_31), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_31), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_31), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_31), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_31), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_31), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_31), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_31), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_31), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_31), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_31), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_31), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_31), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_31), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_31), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_31), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_31), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_31), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_31), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_31), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_31), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_31), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_31), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_31), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_31), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_31), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_31), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_31), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_31), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_31), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_31), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_31), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_31), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_31), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_31), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_31), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_31), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_31), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_31), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_31), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_31), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_31), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_31), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_31), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_31), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_31), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_31), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_31), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_31), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_31), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_31), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_31), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_31), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_31), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_31), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_31), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_31), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_31), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_31), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_31), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_31), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_31), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_31), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_31), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_31), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_31), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_31), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_31), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_31), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_31), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_31), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_31), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_31), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_31), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_31), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_31), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_31), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_31), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_31), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_31), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_31), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_31), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_31), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_31), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_31), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_31), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_31), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_31), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_31), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_31), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_31), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_31), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_31), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_31), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_31), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_31), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_31), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_31), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_31), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_31), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_31), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_31), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_31), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_31), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_31), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_31), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_31), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_31), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_31), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_31), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_31), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_31), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_31), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_31), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_31), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_31), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_31), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_31), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_31), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_31), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_31), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_31), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_31), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_31), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_31), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_31), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_31), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_31), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_31), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_31), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_31), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_31), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_31), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_31), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_31), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_31), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_31), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_31), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_31), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_31), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_31), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_31), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_31), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_31), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_31), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_31), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_31), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_31), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_31), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_31), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_31), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_31), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_31), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_31), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_31), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_31), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_31), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_31), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_31), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_31), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_31), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_31), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_31), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_31), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_31), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_31), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_31), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_31), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_31), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_31), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_31), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_31), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_31), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_31), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_31), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_31), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_31), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_31), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_31), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_31), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_31), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_31), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_31), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_31), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_31), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_31), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_31), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_31), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_31), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_31), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_31), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_31), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_31), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_31), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_31), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_31), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_31), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8c0_31), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8d0_31), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8e8_31), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f0_31), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f8_31), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f9_31), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fa_31), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fb_31), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9c0_31), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9d0_31), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9e8_31), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f0_31), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f8_31), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f9_31), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fa_31), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fb_31), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eac0_31), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ead0_31), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eae8_31), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf0_31), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf8_31), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf9_31), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebc0_31), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebd0_31), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebe8_31), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf0_31), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf8_31), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf9_31), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfa_31), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfb_31), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecc0_31), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecd0_31), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ece8_31), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf0_31), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf8_31), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf9_31), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edc0_31), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edd0_31), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ede8_31), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf0_31), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf8_31), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf9_31), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfa_31), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfb_31), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eec0_31), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eed0_31), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eee8_31), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef0_31), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef8_31), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef9_31), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efc0_31), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efd0_31), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efe8_31), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff0_31), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff8_31), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff9_31), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f000_31), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f008_31), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f010_31), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f018_31), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f020_31), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f028_31), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f030_31), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f038_31), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f039_31), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f200_31), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f208_31), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f210_31), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f218_31), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f220_31), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f228_31), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f230_31), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f238_31), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f239_31), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23a_31), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23b_31), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23c_31), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f240_31), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f248_31), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f250_31), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f258_31), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f260_31), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f268_31), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f270_31), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f278_31), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f279_31), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27a_31), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27b_31), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27c_31), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f280_31), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f2c0_31), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f310_31), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f320_31), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f328_31), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f330_31), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f338_31), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f339_31), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f350_31), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f358_31), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f368_31), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f370_31), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f378_31), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f379_31), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37a_31), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37b_31), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f408_31), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f410_31), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f418_31), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f419_31), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41a_31), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41b_31), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41c_31), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41d_31), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41e_31), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41f_31), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f428_31), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f430_31), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f438_31), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f439_31), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43a_31), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43b_31), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43c_31), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43d_31), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43e_31), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43f_31), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f500_31), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f508_31), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f510_31), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f518_31), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f548_31), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f568_31), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f600_31), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f608_31), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f610_31), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f618_31), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f620_31), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_31 */
#ifdef CPUEMU_32
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_32)[] = {
{ CPUFUNC(op_0000_32), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_32), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_32), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_32), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_32), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_32), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_32), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_32), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_32), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_32), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_32), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_32), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_32), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_32), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_32), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_32), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_32), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_32), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_32), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_32), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_32), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_32), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_32), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_32), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_32), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_32), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00d0_32), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00e8_32), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f0_32), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f8_32), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f9_32), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fa_32), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fb_32), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0100_32), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_32), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_32), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_32), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_32), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_32), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_32), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_32), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_32), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_32), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_32), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_32), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_32), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_32), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_32), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_32), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_32), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_32), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_32), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_32), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_32), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_32), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_32), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_32), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_32), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_32), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_32), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_32), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_32), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_32), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_32), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_32), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_32), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_32), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_32), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_32), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_32), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_32), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_32), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_32), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_32), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_32), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_32), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_32), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_32), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_32), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_32), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_32), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_32), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_32), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_32), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_32), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_32), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_32), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_32), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_32), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_32), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_32), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_32), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_32), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_32), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_32), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_32), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_32), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_32), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02d0_32), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02e8_32), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f0_32), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f8_32), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f9_32), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fa_32), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fb_32), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0400_32), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_32), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_32), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_32), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_32), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_32), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_32), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_32), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_32), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_32), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_32), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_32), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_32), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_32), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_32), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_32), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_32), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_32), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_32), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_32), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_32), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_32), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_32), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_32), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04d0_32), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04e8_32), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f0_32), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f8_32), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f9_32), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fa_32), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fb_32), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0600_32), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_32), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_32), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_32), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_32), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_32), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_32), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_32), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_32), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_32), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_32), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_32), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_32), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_32), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_32), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_32), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_32), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_32), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_32), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_32), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_32), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_32), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_32), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_32), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c0_32), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c8_32), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06d0_32), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06e8_32), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f0_32), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f8_32), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f9_32), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fa_32), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fb_32), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ CPUFUNC(op_0800_32), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_32), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_32), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_32), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_32), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_32), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_32), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_32), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_32), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_32), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_32), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_32), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_32), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_32), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_32), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_32), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_32), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_32), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_32), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_32), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_32), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_32), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_32), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_32), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_32), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_32), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_32), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_32), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_32), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_32), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_32), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_32), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_32), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_32), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_32), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_32), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_32), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_32), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_32), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_32), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_32), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_32), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_32), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_32), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_32), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_32), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_32), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_32), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_32), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_32), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_32), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_32), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_32), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_32), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_32), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_32), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_32), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_32), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_32), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_32), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad0_32), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad8_32), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae0_32), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae8_32), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af0_32), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af8_32), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af9_32), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ CPUFUNC(op_0c00_32), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_32), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_32), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_32), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_32), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_32), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_32), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_32), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3a_32), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3b_32), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c40_32), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_32), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_32), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_32), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_32), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_32), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_32), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_32), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7a_32), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7b_32), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c80_32), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_32), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_32), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_32), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_32), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_32), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_32), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_32), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cba_32), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cbb_32), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd0_32), 0x0cd0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd8_32), 0x0cd8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce0_32), 0x0ce0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce8_32), 0x0ce8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf0_32), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf8_32), 0x0cf8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf9_32), 0x0cf9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cfc_32), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e10_32), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e18_32), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e20_32), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e28_32), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e30_32), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e38_32), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e39_32), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e50_32), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e58_32), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e60_32), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e68_32), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e70_32), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e78_32), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e79_32), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e90_32), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e98_32), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea0_32), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea8_32), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb0_32), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb8_32), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb9_32), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed0_32), 0x0ed0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed8_32), 0x0ed8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee0_32), 0x0ee0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee8_32), 0x0ee8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef0_32), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef8_32), 0x0ef8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef9_32), 0x0ef9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0efc_32), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ CPUFUNC(op_1000_32), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_32), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_32), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_32), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_32), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_32), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_32), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_32), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_32), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_32), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_32), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_32), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_32), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_32), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_32), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_32), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_32), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_32), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_32), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_32), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_32), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_32), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_32), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_32), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_32), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_32), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_32), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_32), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_32), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_32), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_32), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_32), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_32), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_32), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_32), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_32), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_32), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_32), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_32), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_32), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_32), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_32), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_32), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_32), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_32), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_32), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_32), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_32), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_32), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_32), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_32), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_32), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_32), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_32), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_32), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_32), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_32), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_32), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_32), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_32), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_32), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_32), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_32), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_32), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_32), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_32), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_32), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_32), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_32), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_32), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_32), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_32), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_32), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_32), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_32), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_32), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_32), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_32), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_32), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_32), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_32), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_32), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_32), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_32), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_32), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_32), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_32), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_32), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_32), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_32), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_32), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_32), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_32), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_32), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_32), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_32), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_32), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_32), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_32), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_32), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_32), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_32), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_32), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_32), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_32), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_32), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_32), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_32), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_32), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_32), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_32), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_32), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_32), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_32), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_32), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_32), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_32), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_32), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_32), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_32), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_32), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_32), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_32), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_32), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_32), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_32), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_32), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_32), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_32), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_32), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_32), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_32), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_32), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_32), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_32), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_32), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_32), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_32), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_32), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_32), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_32), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_32), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_32), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_32), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_32), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_32), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_32), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_32), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_32), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_32), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_32), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_32), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_32), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_32), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_32), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_32), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_32), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_32), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_32), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_32), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_32), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_32), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_32), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_32), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_32), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_32), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_32), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_32), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_32), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_32), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_32), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_32), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_32), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_32), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_32), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_32), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_32), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_32), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_32), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_32), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_32), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_32), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_32), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_32), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_32), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_32), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_32), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_32), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_32), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_32), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_32), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_32), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_32), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_32), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_32), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_32), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_32), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_32), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_32), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_32), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_32), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_32), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_32), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_32), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_32), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_32), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_32), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_32), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_32), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_32), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_32), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_32), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_32), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_32), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_32), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_32), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_32), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_32), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_32), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_32), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_32), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_32), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_32), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_32), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_32), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_32), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_32), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_32), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_32), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_32), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_32), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_32), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_32), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_32), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_32), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_32), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_32), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_32), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_32), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_32), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_32), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_32), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_32), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_32), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_32), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_32), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_32), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_32), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_32), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_32), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_32), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_32), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_32), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_32), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_32), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_32), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_32), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_32), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_32), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_32), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_32), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_32), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_32), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_32), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_32), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_32), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_32), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_32), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_32), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_32), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_32), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_32), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_32), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_32), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_32), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_32), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_32), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_32), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_32), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_32), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_32), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_32), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_32), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_32), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_32), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_32), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_32), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_32), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_32), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_32), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_32), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_32), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_32), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_32), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_32), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_32), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_32), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_32), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_32), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_32), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_32), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_32), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_32), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_32), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_32), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_32), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_32), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_32), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_32), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_32), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_32), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_32), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_32), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_32), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_32), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_32), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_32), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_32), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_32), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_32), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_32), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_32), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_32), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_32), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_32), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_32), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_32), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_32), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_32), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_32), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_32), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_32), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_32), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_32), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_32), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_32), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4100_32), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4110_32), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4118_32), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4120_32), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4128_32), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4130_32), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4138_32), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4139_32), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413a_32), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413b_32), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413c_32), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ CPUFUNC(op_4180_32), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_32), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_32), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_32), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_32), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_32), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_32), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_32), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_32), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_32), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_32), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_32), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_32), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_32), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_32), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_32), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_32), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_32), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_32), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_32), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_32), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_32), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_32), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_32), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_32), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_32), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_32), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_32), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_32), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_32), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_32), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_32), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_32), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_32), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_32), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_32), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_32), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_32), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_32), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_32), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_32), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_32), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_32), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_32), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_32), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_32), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_32), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_32), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_32), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_32), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_32), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_32), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_32), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_32), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_32), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_32), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_32), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_32), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_32), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_32), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_32), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_32), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_32), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_32), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_32), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_32), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_32), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_32), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_32), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_32), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_32), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_32), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_32), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_32), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_32), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_32), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_32), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_32), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_32), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_32), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_32), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_32), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_32), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_32), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_32), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_32), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_32), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_32), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_32), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_32), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_32), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_32), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_32), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_32), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_32), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_32), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_32), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_32), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_32), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_32), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_32), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_32), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_32), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_32), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_32), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_32), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_32), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_32), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_32), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_32), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_32), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_32), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_32), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_32), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_32), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_32), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_32), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_32), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_32), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_32), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_32), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4808_32), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ CPUFUNC(op_4810_32), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_32), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_32), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_32), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_32), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_32), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_32), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_32), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4848_32), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ CPUFUNC(op_4850_32), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_32), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_32), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_32), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_32), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_32), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_32), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_32), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_32), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_32), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_32), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_32), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_32), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_32), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_32), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_32), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_32), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_32), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_32), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_32), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_32), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_49c0_32), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ CPUFUNC(op_4a00_32), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_32), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_32), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_32), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_32), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_32), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_32), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_32), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3a_32), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3b_32), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3c_32), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a40_32), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a48_32), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a50_32), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_32), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_32), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_32), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_32), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_32), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_32), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7a_32), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7b_32), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7c_32), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a80_32), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a88_32), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a90_32), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_32), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_32), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_32), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_32), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_32), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_32), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4aba_32), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abb_32), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abc_32), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4ac0_32), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_32), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_32), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_32), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_32), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_32), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_32), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_32), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c00_32), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c10_32), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c18_32), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c20_32), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c28_32), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c30_32), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c38_32), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c39_32), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3a_32), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3b_32), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3c_32), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c40_32), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c50_32), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c58_32), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c60_32), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c68_32), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c70_32), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c78_32), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c79_32), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7a_32), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7b_32), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7c_32), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ CPUFUNC(op_4c90_32), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_32), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_32), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_32), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_32), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_32), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_32), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_32), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_32), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_32), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_32), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_32), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_32), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_32), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_32), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_32), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_32), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_32), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_32), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_32), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_32), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_32), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_32), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_32), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_32), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_32), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_32), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_32), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_32), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_32), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_32), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_32), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_32), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_32), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_32), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_32), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_32), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_32), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_32), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_32), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_32), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_32), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_32), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_32), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_32), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_32), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_32), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_32), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_32), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_32), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_32), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_32), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_32), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_32), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_32), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_32), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_32), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_32), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_32), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_32), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_32), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_32), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_32), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_32), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_32), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_32), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_32), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_32), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_32), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_32), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_32), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_32), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_32), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_32), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_32), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_32), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_32), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_32), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_32), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_32), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fa_32), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fb_32), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fc_32), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5100_32), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_32), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_32), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_32), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_32), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_32), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_32), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_32), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_32), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_32), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_32), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_32), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_32), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_32), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_32), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_32), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_32), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_32), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_32), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_32), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_32), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_32), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_32), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_32), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_32), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_32), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_32), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_32), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_32), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_32), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_32), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_32), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_32), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_32), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_32), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fa_32), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fb_32), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fc_32), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_52c0_32), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_32), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_32), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_32), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_32), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_32), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_32), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_32), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_32), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fa_32), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fb_32), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fc_32), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_53c0_32), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_32), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_32), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_32), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_32), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_32), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_32), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_32), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_32), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fa_32), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fb_32), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fc_32), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_54c0_32), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_32), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_32), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_32), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_32), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_32), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_32), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_32), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_32), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fa_32), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fb_32), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fc_32), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_55c0_32), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_32), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_32), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_32), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_32), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_32), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_32), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_32), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_32), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fa_32), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fb_32), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fc_32), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_56c0_32), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_32), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_32), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_32), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_32), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_32), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_32), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_32), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_32), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fa_32), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fb_32), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fc_32), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_57c0_32), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_32), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_32), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_32), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_32), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_32), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_32), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_32), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_32), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fa_32), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fb_32), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fc_32), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_58c0_32), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_32), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_32), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_32), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_32), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_32), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_32), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_32), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_32), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fa_32), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fb_32), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fc_32), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_59c0_32), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_32), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_32), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_32), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_32), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_32), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_32), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_32), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_32), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fa_32), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fb_32), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fc_32), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ac0_32), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_32), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_32), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_32), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_32), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_32), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_32), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_32), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_32), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afa_32), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afb_32), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afc_32), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5bc0_32), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_32), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_32), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_32), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_32), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_32), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_32), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_32), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_32), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfa_32), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfb_32), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfc_32), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5cc0_32), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_32), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_32), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_32), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_32), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_32), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_32), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_32), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_32), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfa_32), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfb_32), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfc_32), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5dc0_32), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_32), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_32), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_32), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_32), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_32), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_32), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_32), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_32), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfa_32), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfb_32), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfc_32), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ec0_32), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_32), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_32), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_32), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_32), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_32), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_32), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_32), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_32), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efa_32), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efb_32), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efc_32), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5fc0_32), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_32), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_32), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_32), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_32), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_32), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_32), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_32), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_32), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffa_32), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffb_32), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffc_32), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_6000_32), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_32), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_32), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_32), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_32), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_32), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_32), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_32), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_32), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_32), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_32), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_32), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_32), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_32), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_32), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_32), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_32), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_32), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_32), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_32), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_32), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_32), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_32), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_32), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_32), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_32), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_32), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_32), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_32), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_32), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_32), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_32), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_32), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_32), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_32), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_32), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_32), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_32), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_32), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_32), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_32), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_32), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_32), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_32), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_32), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_32), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_32), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_32), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_32), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_32), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_32), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_32), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_32), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_32), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_32), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_32), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_32), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_32), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_32), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_32), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_32), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_32), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_32), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_32), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_32), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_32), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_32), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_32), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_32), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_32), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_32), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_32), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_32), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_32), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_32), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_32), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_32), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_32), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_32), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_32), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_32), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_32), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_32), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_32), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_32), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_32), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_32), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_32), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_32), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_32), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_32), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_32), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_32), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_32), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_32), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_32), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_32), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_32), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_32), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_32), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_32), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_32), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8140_32), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8148_32), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ CPUFUNC(op_8150_32), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_32), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_32), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_32), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_32), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_32), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_32), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8180_32), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8188_32), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ CPUFUNC(op_8190_32), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_32), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_32), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_32), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_32), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_32), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_32), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_32), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_32), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_32), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_32), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_32), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_32), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_32), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_32), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_32), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_32), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_32), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_32), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_32), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_32), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_32), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_32), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_32), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_32), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_32), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_32), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_32), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_32), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_32), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_32), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_32), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_32), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_32), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_32), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_32), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_32), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_32), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_32), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_32), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_32), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_32), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_32), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_32), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_32), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_32), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_32), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_32), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_32), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_32), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_32), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_32), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_32), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_32), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_32), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_32), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_32), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_32), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_32), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_32), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_32), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_32), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_32), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_32), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_32), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_32), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_32), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_32), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_32), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_32), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_32), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_32), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_32), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_32), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_32), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_32), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_32), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_32), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_32), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_32), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_32), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_32), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_32), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_32), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_32), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_32), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_32), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_32), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_32), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_32), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_32), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_32), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_32), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_32), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_32), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_32), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_32), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_32), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_32), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_32), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_32), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_32), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_32), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_32), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_32), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_32), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_32), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_32), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_32), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_32), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_32), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_32), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_32), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_32), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_32), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_32), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_32), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_32), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_32), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_32), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_32), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_32), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_32), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_32), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_32), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_32), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_32), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_32), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_32), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_32), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_32), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_32), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_32), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_32), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_32), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_32), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_32), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_32), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_32), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_32), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_32), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_32), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_32), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_32), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_32), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_32), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_32), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_32), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_32), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_32), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_32), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_32), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_32), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_32), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_32), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_32), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_32), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_32), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_32), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_32), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_32), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_32), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_32), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_32), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_32), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_32), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_32), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_32), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_32), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_32), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_32), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_32), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_32), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_32), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_32), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_32), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_32), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_32), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_32), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_32), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_32), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_32), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_32), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_32), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_32), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_32), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_32), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_32), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_32), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_32), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_32), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_32), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_32), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_32), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_32), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_32), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_32), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_32), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_32), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_32), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_32), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_32), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_32), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_32), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_32), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_32), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_32), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_32), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_32), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_32), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_32), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_32), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_32), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_32), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_32), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_32), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_32), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_32), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_32), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_32), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_32), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_32), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_32), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_32), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_32), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_32), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_32), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_32), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_32), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_32), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_32), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_32), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_32), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_32), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_32), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_32), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_32), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_32), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_32), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_32), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_32), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_32), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_32), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_32), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_32), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_32), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_32), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_32), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_32), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_32), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_32), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_32), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_32), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_32), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_32), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_32), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_32), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_32), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_32), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_32), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_32), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_32), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_32), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_32), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_32), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_32), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_32), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_32), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_32), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_32), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_32), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_32), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_32), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_32), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_32), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_32), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_32), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_32), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_32), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_32), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_32), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_32), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_32), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_32), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_32), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_32), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_32), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_32), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_32), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_32), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_32), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_32), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_32), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_32), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_32), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_32), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_32), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_32), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_32), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_32), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_32), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_32), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_32), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_32), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_32), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_32), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_32), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_32), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_32), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_32), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_32), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_32), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_32), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_32), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_32), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_32), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_32), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_32), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_32), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_32), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_32), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_32), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_32), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_32), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_32), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_32), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_32), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_32), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_32), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_32), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_32), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_32), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_32), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_32), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_32), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_32), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_32), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_32), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_32), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_32), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_32), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_32), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_32), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_32), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_32), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_32), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_32), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_32), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_32), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_32), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_32), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_32), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_32), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_32), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_32), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_32), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_32), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_32), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_32), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_32), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_32), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_32), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_32), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_32), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_32), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_32), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_32), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_32), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_32), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_32), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_32), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_32), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_32), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_32), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_32), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_32), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_32), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_32), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_32), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_32), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_32), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_32), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_32), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_32), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_32), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_32), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_32), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_32), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_32), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_32), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_32), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_32), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_32), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_32), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_32), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_32), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_32), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_32), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_32), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_32), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_32), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_32), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_32), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_32), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_32), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_32), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_32), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_32), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_32), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_32), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_32), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_32), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_32), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_32), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_32), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_32), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_32), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_32), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_32), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_32), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_32), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_32), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_32), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_32), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_32), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_32), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_32), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_32), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_32), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_32), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_32), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_32), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_32), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_32), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_32), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_32), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_32), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_32), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_32), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_32), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_32), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_32), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_32), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_32), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_32), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_32), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_32), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_32), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_32), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_32), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_32), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_32), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_32), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_32), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_32), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_32), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_32), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_32), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_32), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_32), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_32), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8c0_32), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8d0_32), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8e8_32), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f0_32), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f8_32), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f9_32), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fa_32), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fb_32), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9c0_32), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9d0_32), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9e8_32), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f0_32), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f8_32), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f9_32), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fa_32), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fb_32), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eac0_32), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ead0_32), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eae8_32), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf0_32), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf8_32), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf9_32), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebc0_32), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebd0_32), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebe8_32), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf0_32), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf8_32), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf9_32), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfa_32), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfb_32), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecc0_32), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecd0_32), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ece8_32), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf0_32), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf8_32), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf9_32), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edc0_32), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edd0_32), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ede8_32), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf0_32), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf8_32), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf9_32), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfa_32), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfb_32), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eec0_32), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eed0_32), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eee8_32), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef0_32), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef8_32), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef9_32), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efc0_32), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efd0_32), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efe8_32), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff0_32), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff8_32), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff9_32), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f000_32), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f008_32), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f010_32), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f018_32), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f020_32), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f028_32), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f030_32), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f038_32), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f039_32), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f200_32), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f208_32), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f210_32), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f218_32), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f220_32), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f228_32), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f230_32), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f238_32), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f239_32), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23a_32), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23b_32), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23c_32), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f240_32), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f248_32), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f250_32), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f258_32), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f260_32), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f268_32), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f270_32), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f278_32), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f279_32), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27a_32), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27b_32), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27c_32), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f280_32), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f2c0_32), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f310_32), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f320_32), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f328_32), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f330_32), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f338_32), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f339_32), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f350_32), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f358_32), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f368_32), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f370_32), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f378_32), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f379_32), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37a_32), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37b_32), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_32 */
#ifdef CPUEMU_33
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_33)[] = {
{ CPUFUNC(op_0000_33), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_33), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_33), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_33), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_33), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_33), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_33), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_33), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_33), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_33), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_33), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_33), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_33), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_33), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_33), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_33), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_33), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_33), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_33), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_33), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_33), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_33), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_33), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_33), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_33), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_33), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00d0_33), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00e8_33), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f0_33), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f8_33), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f9_33), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fa_33), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fb_33), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0100_33), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_33), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_33), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_33), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_33), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_33), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_33), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_33), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_33), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_33), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_33), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_33), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_33), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_33), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_33), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_33), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_33), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_33), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_33), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_33), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_33), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_33), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_33), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_33), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_33), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_33), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_33), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_33), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_33), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_33), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_33), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_33), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_33), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_33), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_33), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_33), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_33), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_33), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_33), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_33), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_33), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_33), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_33), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_33), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_33), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_33), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_33), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_33), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_33), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_33), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_33), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_33), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_33), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_33), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_33), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_33), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_33), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_33), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_33), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_33), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_33), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_33), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_33), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_33), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_33), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02d0_33), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02e8_33), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f0_33), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f8_33), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f9_33), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fa_33), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fb_33), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0400_33), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_33), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_33), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_33), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_33), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_33), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_33), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_33), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_33), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_33), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_33), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_33), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_33), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_33), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_33), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_33), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_33), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_33), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_33), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_33), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_33), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_33), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_33), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_33), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04d0_33), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04e8_33), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f0_33), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f8_33), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f9_33), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fa_33), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fb_33), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0600_33), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_33), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_33), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_33), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_33), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_33), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_33), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_33), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_33), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_33), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_33), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_33), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_33), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_33), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_33), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_33), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_33), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_33), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_33), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_33), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_33), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_33), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_33), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_33), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c0_33), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c8_33), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06d0_33), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06e8_33), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f0_33), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f8_33), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f9_33), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fa_33), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fb_33), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ CPUFUNC(op_0800_33), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_33), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_33), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_33), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_33), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_33), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_33), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_33), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_33), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_33), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_33), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_33), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_33), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_33), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_33), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_33), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_33), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_33), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_33), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_33), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_33), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_33), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_33), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_33), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_33), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_33), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_33), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_33), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_33), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_33), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_33), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_33), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_33), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_33), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_33), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_33), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_33), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_33), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_33), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_33), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_33), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_33), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_33), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_33), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_33), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_33), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_33), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_33), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_33), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_33), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_33), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_33), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_33), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_33), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_33), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_33), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_33), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_33), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_33), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_33), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad0_33), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad8_33), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae0_33), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae8_33), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af0_33), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af8_33), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af9_33), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ CPUFUNC(op_0c00_33), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_33), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_33), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_33), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_33), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_33), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_33), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_33), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3a_33), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3b_33), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c40_33), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_33), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_33), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_33), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_33), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_33), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_33), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_33), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7a_33), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7b_33), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c80_33), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_33), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_33), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_33), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_33), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_33), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_33), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_33), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cba_33), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cbb_33), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd0_33), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd8_33), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce0_33), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce8_33), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf0_33), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf8_33), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf9_33), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cfc_33), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e10_33), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e18_33), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e20_33), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e28_33), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e30_33), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e38_33), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e39_33), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e50_33), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e58_33), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e60_33), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e68_33), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e70_33), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e78_33), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e79_33), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e90_33), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e98_33), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea0_33), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea8_33), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb0_33), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb8_33), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb9_33), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed0_33), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed8_33), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee0_33), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee8_33), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef0_33), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef8_33), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef9_33), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0efc_33), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ CPUFUNC(op_1000_33), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_33), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_33), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_33), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_33), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_33), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_33), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_33), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_33), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_33), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_33), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_33), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_33), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_33), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_33), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_33), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_33), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_33), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_33), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_33), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_33), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_33), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_33), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_33), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_33), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_33), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_33), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_33), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_33), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_33), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_33), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_33), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_33), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_33), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_33), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_33), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_33), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_33), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_33), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_33), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_33), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_33), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_33), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_33), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_33), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_33), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_33), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_33), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_33), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_33), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_33), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_33), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_33), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_33), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_33), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_33), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_33), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_33), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_33), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_33), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_33), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_33), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_33), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_33), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_33), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_33), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_33), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_33), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_33), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_33), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_33), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_33), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_33), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_33), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_33), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_33), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_33), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_33), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_33), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_33), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_33), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_33), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_33), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_33), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_33), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_33), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_33), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_33), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_33), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_33), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_33), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_33), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_33), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_33), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_33), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_33), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_33), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_33), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_33), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_33), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_33), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_33), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_33), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_33), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_33), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_33), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_33), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_33), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_33), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_33), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_33), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_33), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_33), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_33), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_33), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_33), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_33), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_33), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_33), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_33), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_33), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_33), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_33), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_33), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_33), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_33), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_33), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_33), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_33), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_33), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_33), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_33), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_33), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_33), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_33), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_33), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_33), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_33), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_33), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_33), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_33), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_33), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_33), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_33), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_33), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_33), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_33), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_33), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_33), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_33), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_33), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_33), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_33), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_33), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_33), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_33), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_33), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_33), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_33), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_33), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_33), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_33), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_33), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_33), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_33), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_33), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_33), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_33), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_33), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_33), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_33), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_33), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_33), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_33), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_33), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_33), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_33), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_33), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_33), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_33), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_33), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_33), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_33), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_33), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_33), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_33), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_33), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_33), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_33), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_33), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_33), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_33), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_33), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_33), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_33), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_33), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_33), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_33), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_33), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_33), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_33), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_33), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_33), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_33), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_33), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_33), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_33), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_33), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_33), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_33), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_33), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_33), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_33), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_33), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_33), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_33), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_33), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_33), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_33), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_33), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_33), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_33), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_33), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_33), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_33), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_33), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_33), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_33), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_33), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_33), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_33), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_33), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_33), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_33), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_33), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_33), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_33), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_33), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_33), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_33), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_33), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_33), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_33), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_33), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_33), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_33), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_33), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_33), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_33), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_33), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_33), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_33), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_33), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_33), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_33), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_33), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_33), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_33), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_33), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_33), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_33), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_33), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_33), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_33), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_33), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_33), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_33), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_33), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_33), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_33), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_33), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_33), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_33), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_33), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_33), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_33), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_33), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_33), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_33), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_33), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_33), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_33), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_33), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_33), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_33), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_33), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_33), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_33), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_33), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_33), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_33), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_33), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_33), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_33), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_33), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_33), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_33), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_33), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_33), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_33), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_33), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_33), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_33), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_33), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_33), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_33), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_33), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_33), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_33), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_33), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_33), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_33), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_33), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_33), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_33), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_33), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_33), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_33), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_33), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_33), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_33), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_33), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_33), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_33), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_33), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_33), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_33), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_33), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_33), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_33), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_33), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_33), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_33), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_33), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_33), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_33), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4100_33), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4110_33), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4118_33), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4120_33), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4128_33), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4130_33), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4138_33), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4139_33), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413a_33), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413b_33), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413c_33), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ CPUFUNC(op_4180_33), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_33), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_33), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_33), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_33), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_33), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_33), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_33), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_33), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_33), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_33), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_33), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_33), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_33), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_33), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_33), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_33), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_33), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_33), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_33), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_33), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_33), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_33), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_33), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_33), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_33), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_33), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_33), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_33), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_33), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_33), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_33), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_33), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_33), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_33), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_33), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_33), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_33), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_33), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_33), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_33), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_33), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_33), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_33), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_33), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_33), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_33), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_33), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_33), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_33), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_33), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_33), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_33), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_33), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_33), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_33), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_33), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_33), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_33), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_33), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_33), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_33), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_33), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_33), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_33), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_33), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_33), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_33), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_33), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_33), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_33), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_33), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_33), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_33), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_33), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_33), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_33), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_33), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_33), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_33), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_33), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_33), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_33), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_33), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_33), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_33), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_33), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_33), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_33), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_33), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_33), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_33), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_33), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_33), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_33), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_33), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_33), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_33), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_33), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_33), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_33), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_33), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_33), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_33), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_33), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_33), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_33), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_33), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_33), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_33), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_33), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_33), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_33), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_33), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_33), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_33), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_33), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_33), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_33), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_33), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_33), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4808_33), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ CPUFUNC(op_4810_33), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_33), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_33), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_33), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_33), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_33), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_33), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_33), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4848_33), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ CPUFUNC(op_4850_33), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_33), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_33), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_33), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_33), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_33), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_33), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_33), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_33), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_33), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_33), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_33), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_33), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_33), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_33), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_33), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_33), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_33), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_33), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_33), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_33), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_49c0_33), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ CPUFUNC(op_4a00_33), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_33), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_33), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_33), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_33), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_33), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_33), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_33), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3a_33), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3b_33), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3c_33), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a40_33), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a48_33), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a50_33), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_33), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_33), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_33), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_33), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_33), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_33), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7a_33), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7b_33), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7c_33), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a80_33), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a88_33), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a90_33), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_33), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_33), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_33), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_33), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_33), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_33), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4aba_33), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abb_33), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abc_33), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4ac0_33), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_33), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_33), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_33), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_33), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_33), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_33), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_33), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c00_33), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c10_33), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c18_33), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c20_33), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c28_33), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c30_33), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c38_33), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c39_33), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3a_33), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3b_33), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3c_33), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c40_33), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c50_33), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c58_33), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c60_33), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c68_33), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c70_33), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c78_33), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c79_33), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7a_33), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7b_33), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7c_33), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ CPUFUNC(op_4c90_33), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_33), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_33), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_33), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_33), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_33), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_33), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_33), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_33), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_33), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_33), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_33), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_33), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_33), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_33), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_33), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_33), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_33), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_33), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_33), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_33), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_33), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_33), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_33), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_33), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_33), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_33), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_33), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_33), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_33), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_33), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_33), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_33), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_33), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_33), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_33), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_33), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_33), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_33), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_33), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_33), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_33), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_33), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_33), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_33), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_33), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_33), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_33), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_33), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_33), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_33), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_33), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_33), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_33), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_33), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_33), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_33), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_33), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_33), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_33), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_33), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_33), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_33), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_33), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_33), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_33), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_33), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_33), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_33), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_33), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_33), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_33), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_33), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_33), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_33), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_33), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_33), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_33), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_33), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_33), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fa_33), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fb_33), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fc_33), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5100_33), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_33), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_33), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_33), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_33), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_33), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_33), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_33), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_33), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_33), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_33), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_33), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_33), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_33), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_33), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_33), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_33), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_33), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_33), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_33), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_33), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_33), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_33), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_33), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_33), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_33), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_33), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_33), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_33), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_33), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_33), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_33), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_33), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_33), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_33), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fa_33), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fb_33), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fc_33), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_52c0_33), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_33), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_33), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_33), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_33), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_33), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_33), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_33), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_33), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fa_33), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fb_33), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fc_33), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_53c0_33), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_33), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_33), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_33), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_33), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_33), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_33), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_33), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_33), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fa_33), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fb_33), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fc_33), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_54c0_33), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_33), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_33), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_33), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_33), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_33), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_33), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_33), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_33), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fa_33), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fb_33), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fc_33), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_55c0_33), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_33), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_33), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_33), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_33), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_33), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_33), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_33), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_33), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fa_33), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fb_33), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fc_33), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_56c0_33), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_33), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_33), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_33), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_33), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_33), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_33), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_33), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_33), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fa_33), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fb_33), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fc_33), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_57c0_33), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_33), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_33), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_33), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_33), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_33), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_33), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_33), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_33), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fa_33), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fb_33), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fc_33), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_58c0_33), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_33), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_33), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_33), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_33), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_33), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_33), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_33), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_33), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fa_33), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fb_33), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fc_33), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_59c0_33), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_33), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_33), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_33), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_33), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_33), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_33), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_33), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_33), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fa_33), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fb_33), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fc_33), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ac0_33), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_33), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_33), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_33), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_33), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_33), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_33), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_33), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_33), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afa_33), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afb_33), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afc_33), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5bc0_33), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_33), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_33), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_33), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_33), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_33), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_33), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_33), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_33), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfa_33), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfb_33), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfc_33), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5cc0_33), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_33), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_33), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_33), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_33), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_33), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_33), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_33), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_33), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfa_33), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfb_33), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfc_33), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5dc0_33), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_33), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_33), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_33), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_33), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_33), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_33), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_33), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_33), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfa_33), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfb_33), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfc_33), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ec0_33), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_33), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_33), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_33), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_33), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_33), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_33), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_33), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_33), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efa_33), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efb_33), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efc_33), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5fc0_33), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_33), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_33), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_33), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_33), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_33), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_33), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_33), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_33), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffa_33), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffb_33), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffc_33), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_6000_33), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_33), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_33), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_33), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_33), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_33), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_33), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_33), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_33), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_33), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_33), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_33), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_33), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_33), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_33), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_33), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_33), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_33), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_33), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_33), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_33), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_33), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_33), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_33), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_33), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_33), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_33), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_33), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_33), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_33), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_33), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_33), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_33), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_33), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_33), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_33), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_33), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_33), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_33), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_33), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_33), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_33), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_33), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_33), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_33), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_33), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_33), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_33), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_33), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_33), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_33), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_33), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_33), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_33), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_33), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_33), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_33), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_33), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_33), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_33), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_33), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_33), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_33), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_33), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_33), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_33), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_33), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_33), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_33), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_33), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_33), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_33), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_33), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_33), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_33), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_33), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_33), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_33), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_33), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_33), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_33), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_33), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_33), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_33), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_33), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_33), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_33), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_33), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_33), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_33), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_33), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_33), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_33), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_33), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_33), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_33), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_33), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_33), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_33), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_33), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_33), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_33), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8140_33), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8148_33), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ CPUFUNC(op_8150_33), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_33), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_33), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_33), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_33), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_33), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_33), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8180_33), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8188_33), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ CPUFUNC(op_8190_33), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_33), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_33), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_33), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_33), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_33), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_33), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_33), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_33), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_33), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_33), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_33), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_33), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_33), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_33), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_33), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_33), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_33), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_33), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_33), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_33), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_33), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_33), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_33), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_33), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_33), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_33), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_33), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_33), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_33), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_33), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_33), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_33), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_33), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_33), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_33), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_33), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_33), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_33), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_33), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_33), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_33), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_33), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_33), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_33), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_33), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_33), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_33), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_33), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_33), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_33), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_33), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_33), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_33), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_33), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_33), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_33), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_33), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_33), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_33), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_33), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_33), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_33), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_33), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_33), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_33), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_33), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_33), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_33), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_33), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_33), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_33), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_33), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_33), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_33), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_33), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_33), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_33), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_33), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_33), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_33), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_33), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_33), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_33), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_33), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_33), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_33), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_33), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_33), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_33), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_33), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_33), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_33), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_33), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_33), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_33), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_33), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_33), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_33), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_33), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_33), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_33), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_33), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_33), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_33), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_33), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_33), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_33), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_33), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_33), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_33), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_33), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_33), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_33), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_33), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_33), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_33), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_33), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_33), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_33), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_33), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_33), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_33), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_33), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_33), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_33), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_33), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_33), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_33), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_33), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_33), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_33), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_33), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_33), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_33), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_33), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_33), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_33), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_33), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_33), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_33), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_33), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_33), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_33), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_33), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_33), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_33), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_33), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_33), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_33), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_33), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_33), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_33), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_33), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_33), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_33), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_33), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_33), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_33), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_33), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_33), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_33), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_33), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_33), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_33), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_33), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_33), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_33), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_33), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_33), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_33), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_33), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_33), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_33), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_33), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_33), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_33), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_33), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_33), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_33), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_33), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_33), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_33), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_33), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_33), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_33), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_33), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_33), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_33), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_33), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_33), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_33), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_33), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_33), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_33), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_33), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_33), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_33), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_33), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_33), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_33), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_33), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_33), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_33), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_33), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_33), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_33), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_33), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_33), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_33), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_33), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_33), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_33), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_33), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_33), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_33), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_33), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_33), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_33), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_33), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_33), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_33), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_33), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_33), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_33), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_33), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_33), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_33), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_33), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_33), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_33), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_33), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_33), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_33), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_33), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_33), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_33), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_33), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_33), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_33), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_33), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_33), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_33), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_33), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_33), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_33), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_33), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_33), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_33), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_33), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_33), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_33), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_33), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_33), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_33), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_33), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_33), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_33), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_33), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_33), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_33), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_33), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_33), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_33), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_33), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_33), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_33), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_33), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_33), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_33), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_33), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_33), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_33), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_33), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_33), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_33), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_33), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_33), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_33), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_33), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_33), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_33), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_33), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_33), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_33), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_33), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_33), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_33), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_33), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_33), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_33), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_33), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_33), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_33), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_33), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_33), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_33), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_33), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_33), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_33), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_33), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_33), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_33), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_33), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_33), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_33), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_33), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_33), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_33), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_33), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_33), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_33), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_33), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_33), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_33), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_33), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_33), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_33), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_33), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_33), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_33), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_33), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_33), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_33), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_33), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_33), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_33), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_33), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_33), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_33), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_33), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_33), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_33), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_33), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_33), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_33), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_33), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_33), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_33), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_33), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_33), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_33), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_33), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_33), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_33), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_33), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_33), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_33), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_33), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_33), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_33), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_33), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_33), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_33), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_33), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_33), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_33), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_33), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_33), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_33), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_33), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_33), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_33), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_33), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_33), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_33), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_33), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_33), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_33), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_33), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_33), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_33), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_33), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_33), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_33), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_33), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_33), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_33), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_33), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_33), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_33), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_33), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_33), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_33), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_33), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_33), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_33), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_33), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_33), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_33), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_33), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_33), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_33), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_33), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_33), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_33), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_33), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_33), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_33), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_33), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_33), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_33), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_33), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_33), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_33), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_33), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_33), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_33), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_33), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_33), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_33), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_33), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_33), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_33), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_33), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_33), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_33), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_33), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_33), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_33), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_33), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_33), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_33), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_33), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_33), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_33), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_33), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_33), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_33), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_33), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_33), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_33), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_33), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_33), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_33), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_33), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_33), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_33), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_33), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_33), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_33), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_33), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_33), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_33), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_33), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_33), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_33), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_33), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_33), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_33), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_33), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_33), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_33), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_33), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_33), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_33), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_33), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_33), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_33), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_33), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_33), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8c0_33), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8d0_33), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8e8_33), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f0_33), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f8_33), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f9_33), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fa_33), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fb_33), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9c0_33), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9d0_33), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9e8_33), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f0_33), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f8_33), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f9_33), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fa_33), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fb_33), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eac0_33), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ead0_33), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eae8_33), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf0_33), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf8_33), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf9_33), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebc0_33), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebd0_33), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebe8_33), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf0_33), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf8_33), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf9_33), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfa_33), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfb_33), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecc0_33), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecd0_33), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ece8_33), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf0_33), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf8_33), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf9_33), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edc0_33), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edd0_33), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ede8_33), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf0_33), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf8_33), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf9_33), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfa_33), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfb_33), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eec0_33), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eed0_33), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eee8_33), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef0_33), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef8_33), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef9_33), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efc0_33), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efd0_33), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efe8_33), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff0_33), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff8_33), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff9_33), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f000_33), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f008_33), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f010_33), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f018_33), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f020_33), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f028_33), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f030_33), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f038_33), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f039_33), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f200_33), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f208_33), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f210_33), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f218_33), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f220_33), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f228_33), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f230_33), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f238_33), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f239_33), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23a_33), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23b_33), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23c_33), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f240_33), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f248_33), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f250_33), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f258_33), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f260_33), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f268_33), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f270_33), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f278_33), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f279_33), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27a_33), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27b_33), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27c_33), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f280_33), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f2c0_33), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f310_33), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f320_33), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f328_33), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f330_33), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f338_33), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f339_33), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f350_33), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f358_33), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f368_33), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f370_33), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f378_33), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f379_33), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37a_33), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37b_33), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f408_33), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f410_33), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f418_33), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f419_33), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41a_33), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41b_33), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41c_33), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41d_33), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41e_33), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41f_33), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f428_33), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f430_33), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f438_33), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f439_33), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43a_33), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43b_33), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43c_33), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43d_33), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43e_33), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43f_33), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f500_33), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f508_33), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f510_33), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f518_33), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f548_33), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f568_33), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f588_33), 0xf588, -1, { 0, 0 }, 0 }, /* PLPAW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f5c8_33), 0xf5c8, -1, { 0, 0 }, 0 }, /* PLPAR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f600_33), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f608_33), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f610_33), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f618_33), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f620_33), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f800_33), 0xf800, -1, { 0, 0 }, 0 }, /* LPSTOP */
#endif
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_33 */
#ifdef CPUEMU_40
const struct cputbl CPUFUNC(op_smalltbl_40)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_40), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_40), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_40), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00d0_40), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00e8_40), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f0_40), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f8_40), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f9_40), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fa_40), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fb_40), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_40), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_40), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_40), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_40), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_40), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_40), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_40), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_40), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02d0_40), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02e8_40), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f0_40), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f8_40), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f9_40), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fa_40), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fb_40), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_40), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_40), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_40), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04d0_40), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04e8_40), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f0_40), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f8_40), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f9_40), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fa_40), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fb_40), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_40), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_40), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_40), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c0_40), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c8_40), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06d0_40), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06e8_40), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f0_40), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f8_40), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f9_40), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fa_40), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fb_40), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_40), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_40), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_40), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_40), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_40), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_40), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_40), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_40), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad0_40), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad8_40), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae0_40), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae8_40), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af0_40), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af8_40), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af9_40), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_40), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3a_40), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3b_40), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_40), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7a_40), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7b_40), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_40), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cba_40), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cbb_40), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd0_40), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd8_40), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce0_40), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce8_40), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf0_40), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf8_40), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf9_40), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cfc_40), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e10_40), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e18_40), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e20_40), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e28_40), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e30_40), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e38_40), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e39_40), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e50_40), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e58_40), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e60_40), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e68_40), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e70_40), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e78_40), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e79_40), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e90_40), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e98_40), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea0_40), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea8_40), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb0_40), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb8_40), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb9_40), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed0_40), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed8_40), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee0_40), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee8_40), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef0_40), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef8_40), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef9_40), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0efc_40), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_40), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_40), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_40), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_40), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_40), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_40), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_40), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_40), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_40), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_40), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_40), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_40), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_40), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_40), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_40), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_40), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_40), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_40), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_40), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_40), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_40), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_40), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_40), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_40), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_40), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_40), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_40), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_40), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_40), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_40), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_40), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_40), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_40), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_40), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_40), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_40), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_40), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_40), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_40), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_40), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_40), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_40), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_40), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_40), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_40), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_40), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_40), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_40), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_40), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_40), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_40), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_40), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_40), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_40), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_40), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_40), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_40), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_40), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_40), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_40), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_40), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_40), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_40), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_40), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_40), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_40), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_40), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_40), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_40), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_40), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_40), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_40), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_40), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_40), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_40), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_40), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_40), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_40), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_40), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_40), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_40), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_40), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_40), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_40), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_40), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_40), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_40), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_40), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_40), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_40), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_40), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_40), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4100_40), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4110_40), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4118_40), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4120_40), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4128_40), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4130_40), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4138_40), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4139_40), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413a_40), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413b_40), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413c_40), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_40), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_40), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_40), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_40), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_40), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_40), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_40), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_40), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_40), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_40), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_40), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_40), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_40), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_40), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_40), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_40), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_40), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_40), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_40), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_40), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_40), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_40), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_40), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_40), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_40), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_40), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_40), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_40), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_40), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_40), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_40), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_40), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_40), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_40), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_40), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_40), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_40), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_40), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_40), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_40), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_40), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_40), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_40), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_40), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_40), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_40), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_40), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4808_40), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ CPUFUNC(op_4810_40), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_40), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_40), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_40), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_40), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_40), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_40), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4848_40), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_40), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_40), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_40), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_40), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_49c0_40), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_40), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3a_40), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3b_40), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3c_40), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a48_40), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_40), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7a_40), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7b_40), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7c_40), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a88_40), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_40), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4aba_40), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abb_40), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abc_40), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4ac0_40), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_40), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_40), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_40), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_40), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_40), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_40), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_40), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c00_40), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c10_40), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c18_40), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c20_40), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c28_40), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c30_40), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c38_40), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c39_40), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3a_40), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3b_40), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3c_40), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c40_40), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c50_40), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c58_40), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c60_40), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c68_40), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c70_40), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c78_40), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c79_40), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7a_40), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7b_40), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7c_40), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_40), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_40), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_40), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_40), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_40), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_40), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_40), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_40), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_40), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_40), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_40), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_40), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_40), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_40), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_40), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_40), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_40), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_40), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_40), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_40), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_40), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_40), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_40), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fa_40), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fb_40), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fc_40), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_40), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_40), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_40), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_40), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_40), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_40), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_40), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_40), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_40), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_40), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_40), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fa_40), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fb_40), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fc_40), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_52c0_40), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_40), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_40), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_40), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_40), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_40), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_40), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_40), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fa_40), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fb_40), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fc_40), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_53c0_40), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_40), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_40), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_40), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_40), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_40), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_40), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_40), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fa_40), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fb_40), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fc_40), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_54c0_40), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_40), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_40), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_40), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_40), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_40), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_40), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_40), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fa_40), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fb_40), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fc_40), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_55c0_40), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_40), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_40), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_40), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_40), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_40), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_40), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_40), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fa_40), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fb_40), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fc_40), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_56c0_40), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_40), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_40), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_40), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_40), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_40), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_40), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_40), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fa_40), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fb_40), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fc_40), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_57c0_40), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_40), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_40), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_40), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_40), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_40), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_40), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_40), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fa_40), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fb_40), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fc_40), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_58c0_40), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_40), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_40), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_40), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_40), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_40), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_40), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_40), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fa_40), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fb_40), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fc_40), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_59c0_40), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_40), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_40), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_40), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_40), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_40), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_40), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_40), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fa_40), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fb_40), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fc_40), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ac0_40), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_40), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_40), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_40), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_40), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_40), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_40), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_40), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afa_40), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afb_40), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afc_40), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5bc0_40), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_40), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_40), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_40), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_40), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_40), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_40), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_40), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfa_40), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfb_40), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfc_40), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5cc0_40), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_40), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_40), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_40), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_40), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_40), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_40), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_40), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfa_40), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfb_40), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfc_40), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5dc0_40), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_40), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_40), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_40), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_40), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_40), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_40), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_40), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfa_40), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfb_40), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfc_40), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ec0_40), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_40), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_40), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_40), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_40), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_40), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_40), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_40), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efa_40), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efb_40), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efc_40), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5fc0_40), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_40), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_40), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_40), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_40), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_40), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_40), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_40), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffa_40), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffb_40), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffc_40), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_40), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_40), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_40), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_40), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_40), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_40), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_40), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_40), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_40), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_40), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_40), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_40), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_40), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_40), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_40), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_40), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_40), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_40), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_40), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_40), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_40), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_40), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_40), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_40), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_40), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_40), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_40), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8140_40), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8148_40), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_40), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8180_40), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8188_40), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_40), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_40), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_40), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_40), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_40), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_40), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_40), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_40), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_40), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_40), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_40), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_40), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_40), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_40), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_40), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_40), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_40), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_40), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_40), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_40), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_40), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_40), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_40), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_40), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_40), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_40), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_40), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_40), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_40), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_40), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_40), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_40), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_40), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_40), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_40), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_40), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_40), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_40), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_40), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_40), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_40), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_40), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_40), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_40), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_40), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_40), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_40), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_40), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_40), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_40), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_40), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_40), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_40), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_40), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_40), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_40), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_40), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_40), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_40), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_40), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_40), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_40), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_40), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_40), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_40), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8c0_40), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8d0_40), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8e8_40), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f0_40), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f8_40), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f9_40), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fa_40), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fb_40), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9c0_40), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9d0_40), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9e8_40), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f0_40), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f8_40), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f9_40), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fa_40), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fb_40), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eac0_40), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ead0_40), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eae8_40), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf0_40), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf8_40), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf9_40), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebc0_40), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebd0_40), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebe8_40), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf0_40), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf8_40), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf9_40), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfa_40), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfb_40), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecc0_40), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecd0_40), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ece8_40), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf0_40), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf8_40), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf9_40), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edc0_40), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edd0_40), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ede8_40), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf0_40), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf8_40), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf9_40), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfa_40), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfb_40), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eec0_40), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eed0_40), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eee8_40), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef0_40), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef8_40), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef9_40), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efc0_40), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efd0_40), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efe8_40), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff0_40), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff8_40), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff9_40), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f000_40), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f008_40), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f010_40), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f018_40), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f020_40), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f028_40), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f030_40), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f038_40), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f039_40), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f200_40), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f208_40), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f210_40), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f218_40), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f220_40), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f228_40), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f230_40), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f238_40), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f239_40), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23a_40), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23b_40), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23c_40), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f240_40), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f248_40), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f250_40), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f258_40), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f260_40), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f268_40), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f270_40), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f278_40), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f279_40), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27a_40), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27b_40), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27c_40), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f280_40), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f2c0_40), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f310_40), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f320_40), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f328_40), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f330_40), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f338_40), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f339_40), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f350_40), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f358_40), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f368_40), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f370_40), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f378_40), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f379_40), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37a_40), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37b_40), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f408_40), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f410_40), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f418_40), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f419_40), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41a_40), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41b_40), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41c_40), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41d_40), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41e_40), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41f_40), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f428_40), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f430_40), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f438_40), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f439_40), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43a_40), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43b_40), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43c_40), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43d_40), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43e_40), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43f_40), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f500_40), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f508_40), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f510_40), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f518_40), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f548_40), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f568_40), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f588_40), 0xf588, -1, { 0, 0 }, 0 }, /* PLPAW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f5c8_40), 0xf5c8, -1, { 0, 0 }, 0 }, /* PLPAR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f600_40), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f608_40), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f610_40), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f618_40), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f620_40), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f800_40), 0xf800, -1, { 0, 0 }, 0 }, /* LPSTOP */
#endif
{ 0, 0 }};
#endif /* CPUEMU_40 */
#ifdef CPUEMU_40
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_41)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_40), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_40), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_40), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_40), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_40), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_40), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_40), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_40), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_40), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_40), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_40), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_40), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_40), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_40), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_40), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_40), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_40), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_40), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_40), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_40), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_40), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_40), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_40), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_40), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_40), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_40), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_40), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_40), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_40), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_40), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_40), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_40), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_40), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_40), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_40), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_40), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_40), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_40), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_40), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_40), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_40), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_40), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_40), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_40), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_40), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_40), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_40), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_40), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_40), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_40), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_40), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_40), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_40), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_40), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_40), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_40), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_40), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_40), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_40), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_40), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_40), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_40), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_40), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_40), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_40), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_40), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_40), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_40), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_40), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_40), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_40), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_40), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_40), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_40), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_40), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_40), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_40), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_40), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_40), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_40), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_40), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_40), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_40), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_40), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_40), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_40), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_40), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_40), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_40), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_40), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_40), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_40), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_40), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_40), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_40), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_40), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_40), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_40), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_40), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_40), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_40), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_40), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_40), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_40), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_40), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_40), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_40), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_40), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_40), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_40), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_40), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_40), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_40), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_40), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_40), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_40), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_40), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_40), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_40), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_40), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_40), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_40), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_40), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_40), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_40), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_40), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_40), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_40), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_40), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_40), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_40), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_40), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_40), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_40), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_40), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_40), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_40), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_40), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_40), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_40), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_40), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_40), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_40), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_40), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_40), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_40), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_40), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_40), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_40), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_40), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_40), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_40), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_40), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_40), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_40), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_40), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_40), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_40), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_40), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_40), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_40), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_40), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_40), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_40), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_40), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_40), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_40), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_40), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_40), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_40), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_40), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_40), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_40), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_40), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_40), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_40), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_40), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_40), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_40), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_40), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_40), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_40), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_40), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_40), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_40), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_40), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_40), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_40), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_40), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_40), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_40), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_40), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_40), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_40), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_40), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_40), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_40), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_40), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_40), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_40), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_40), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_40), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_40), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_40), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_40), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_40), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_40), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_40), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_40), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_40), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_40), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_40), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_40), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_40), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_40), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_40), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_40), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_40), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_40), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_40), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_40), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_40), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_40), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_40), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_40), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_40), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_40), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_40), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_40), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_40), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_40), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_40), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_40), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_40), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_40), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_40), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_40), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_40), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_40), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_40), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_40), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_40), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_40), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_40), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_40), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_40), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_40), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_40), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_40), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_40), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_40), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_40), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_40), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_40), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_40), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_40), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_40), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_40), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_40), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_40), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_40), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_40), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_40), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_40), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_40), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_40), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_40), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_40), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_40), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_40), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_40), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_40), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_40), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_40), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_40), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_40), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_40), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_40), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_40), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_40), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_40), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_40), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_40), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_40), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_40), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_40), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_40), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_40), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_40), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_40), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_40), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_40), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_40), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_40), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_40), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_40), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_40), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_40), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_40), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_40), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_40), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_40), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_40), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_40), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_40), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_40), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_40), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_40), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_40), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_40), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_40), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_40), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_40), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_40), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_40), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_40), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_40), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_40), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_40), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_40), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_40), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_40), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_40), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_40), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_40), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_40), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_40), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_40), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_40), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_40), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_40), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_40), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_40), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_40), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_40), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_40), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_40), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_40), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_40), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_40), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_40), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_40), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_40), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_40), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_40), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_40), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_40), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_40), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_40), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_40), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_40), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_40), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_40), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_40), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_40), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_40), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_40), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_40), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_40), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_40), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_40), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_40), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_40), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_40), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_40), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_40), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_40), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_40), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_40), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_40), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_40), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_40), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_40), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_40), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_40), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_40), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_40), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_40), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_40), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_40), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_40), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_40), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_40), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_40), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_40), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_40), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_40), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_40), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_40), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_40), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_40), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_40), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_40), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_40), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_40), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_40), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_40), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_40), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_40), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_40), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_40), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_40), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_40), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_40), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_40), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_40), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_40), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_40), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_40), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_40), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_40), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_40), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_40), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_40), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_40), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_40), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_40), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_40), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_40), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_40), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_40), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_40), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_40), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_40), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_40), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_40), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_40), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_40), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_40), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_40), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_40), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_40), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_40), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_40), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_40), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_40), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_40), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_40), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_40), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_40), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_40), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_40), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_40), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_40), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_40), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_40), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_40), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_40), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_40), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_40), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_40), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_40), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_40), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_40), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_40), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_40), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_40), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_40), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_40), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_40), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_40), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_40), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_40), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_40), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_40), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_40), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_40), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_40), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_40), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_40), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_40), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_40), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_40), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_40), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_40), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_40), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_40), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_40), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_40), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_40), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_40), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_40), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_40), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_40), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_40), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_40), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_40), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_40), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_40), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_40), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_40), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_40), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_40), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_40), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_40), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_40), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_40), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_40), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_40), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_40), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_40), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_40), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_40), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_40), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_40), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_40), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_40), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_40), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_40), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_40), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_40), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_40), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_40), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_40), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_40), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_40), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_40), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_40), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_40), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_40), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_40), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_40), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_40), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_40), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_40), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_40), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_40), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_40), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_40), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_40), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_40), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_40), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_40), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_40), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_40), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_40), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_40), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_40), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_40), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_40), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_40), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_40), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_40), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_40), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_40), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_40), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_40), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_40), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_40), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_40), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_40), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_40), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_40), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_40), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_40), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_40), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_40), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_40), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_40), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_40), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_40), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_40), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_40), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_40), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_40), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_40), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_40), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_40), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_40), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_40), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_40), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_40), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_40), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_40), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_40), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_40), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_40), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_40), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_40), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_40), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_40), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_40), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_40), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_40), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_40), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_40), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_40), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_40), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_40), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_40), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_40), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_40), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_40), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_40), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_40), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_40), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_40), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_40), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_40), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_40), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_40), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_40), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_40), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_40), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_40), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_40), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_40), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_40), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_40), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_40), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_40), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_40), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_40), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_40), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_40), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_40), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_40), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_40), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_40), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_40), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_40), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_40), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_40), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_40), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_40), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_40), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_40), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_40), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_40), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_40), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_40), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_40), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_40), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_40), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_40), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_40), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_40), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_40), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_40), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_40), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_40), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_40), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_40), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_40), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_40), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_40), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_40), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_40), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_40), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_40), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_40), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_40), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_40), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_40), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_40), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_40), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_40), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_40), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_40), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_40), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_40), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_40), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_40), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f000_40), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f008_40), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f010_40), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f018_40), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f020_40), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f028_40), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f030_40), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f038_40), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f039_40), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f200_40), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_40), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_40), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_40), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_40), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_40), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_40), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_40), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_40), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_40), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_40), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_40), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_40), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_40), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_40), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_40), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_40), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_40), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_40), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_40), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_40), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_40), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_40), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_40), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_40), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_40), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_40), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_40), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_40), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_40), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_40), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_40), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_40), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_40), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_40), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_40), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_40), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_40), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_40), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_40), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f408_40), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
{ CPUFUNC(op_f410_40), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
{ CPUFUNC(op_f418_40), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f419_40), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41a_40), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41b_40), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41c_40), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41d_40), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41e_40), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41f_40), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f428_40), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
{ CPUFUNC(op_f430_40), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
{ CPUFUNC(op_f438_40), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f439_40), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43a_40), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43b_40), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43c_40), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43d_40), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43e_40), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43f_40), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f500_40), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
{ CPUFUNC(op_f508_40), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
{ CPUFUNC(op_f510_40), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
{ CPUFUNC(op_f518_40), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
{ CPUFUNC(op_f548_40), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
{ CPUFUNC(op_f568_40), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
{ CPUFUNC(op_f600_40), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f608_40), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f610_40), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f618_40), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f620_40), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_40 */
#ifdef CPUEMU_40
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_42)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_40), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_40), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_40), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_40), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_40), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_40), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_40), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_40), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_40), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_40), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_40), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_40), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_40), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_40), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_40), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_40), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_40), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_40), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_40), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_40), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_40), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_40), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_40), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_40), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_40), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_40), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_40), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_40), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_40), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_40), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_40), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_40), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_40), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_40), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_40), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_40), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_40), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_40), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_40), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_40), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_40), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_40), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_40), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_40), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_40), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_40), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_40), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_40), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_40), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_40), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_40), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_40), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_40), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_40), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_40), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_40), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_40), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_40), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_40), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_40), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_40), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_40), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_40), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_40), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_40), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_40), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_40), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_40), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_40), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_40), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_40), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_40), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_40), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_40), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_40), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_40), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_40), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_40), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_40), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_40), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_40), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_40), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_40), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_40), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_40), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_40), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_40), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_40), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_40), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_40), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_40), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_40), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_40), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_40), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_40), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_40), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_40), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_40), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_40), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_40), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_40), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_40), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_40), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_40), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_40), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_40), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_40), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_40), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_40), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_40), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_40), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_40), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_40), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_40), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_40), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_40), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_40), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_40), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_40), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_40), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_40), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_40), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_40), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_40), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_40), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_40), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_40), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_40), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_40), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_40), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_40), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_40), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_40), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_40), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_40), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_40), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_40), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_40), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_40), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_40), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_40), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_40), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_40), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_40), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_40), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_40), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_40), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_40), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_40), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_40), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_40), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_40), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_40), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_40), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_40), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_40), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_40), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_40), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_40), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_40), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_40), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_40), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_40), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_40), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_40), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_40), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_40), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_40), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_40), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_40), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_40), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_40), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_40), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_40), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_40), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_40), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_40), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_40), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_40), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_40), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_40), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_40), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_40), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_40), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_40), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_40), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_40), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_40), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_40), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_40), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_40), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_40), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_40), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_40), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_40), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_40), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_40), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_40), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_40), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_40), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_40), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_40), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_40), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_40), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_40), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_40), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_40), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_40), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_40), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_40), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_40), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_40), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_40), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_40), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_40), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_40), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_40), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_40), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_40), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_40), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_40), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_40), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_40), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_40), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_40), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_40), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_40), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_40), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_40), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_40), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_40), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_40), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_40), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_40), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_40), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_40), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_40), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_40), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_40), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_40), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_40), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_40), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_40), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_40), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_40), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_40), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_40), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_40), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_40), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_40), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_40), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_40), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_40), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_40), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_40), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_40), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_40), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_42), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_40), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_42), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_42), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_42), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_42), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_42), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_42), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_42), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_40), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_40), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_40), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_40), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_40), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_40), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_40), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_40), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_40), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_40), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_40), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_40), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_40), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_40), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_40), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_40), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_40), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_40), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_40), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_40), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_40), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_40), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_40), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_40), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_40), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_40), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_40), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_40), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_40), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_40), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_40), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_40), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_40), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_40), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_40), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_40), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_40), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_40), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_40), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_40), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_40), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_40), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_40), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_40), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_40), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_40), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_40), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_40), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_40), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_40), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_40), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_40), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_40), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_40), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_40), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_40), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_40), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_40), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_40), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_40), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_40), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_40), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_40), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_40), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_40), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_40), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_40), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_40), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_40), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_40), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_40), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_40), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_40), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_40), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_40), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_40), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_40), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_40), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_40), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_40), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_40), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_40), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_40), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_40), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_40), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_40), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_40), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_40), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_40), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_40), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_40), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_40), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_40), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_40), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_40), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_40), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_40), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_40), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_40), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_40), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_40), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_40), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_40), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_40), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_40), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_40), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_40), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_40), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_40), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_40), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_40), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_40), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_40), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_40), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_40), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_40), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_40), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_40), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_40), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_40), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_40), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_40), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_40), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_40), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_40), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_40), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_40), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_40), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_40), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_40), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_40), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_40), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_40), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_40), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_40), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_40), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_40), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_40), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_40), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_40), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_40), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_40), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_40), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_40), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_40), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_40), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_40), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_40), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_40), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_40), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_40), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_40), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_40), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_40), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_40), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_40), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_40), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_40), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_40), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_40), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_40), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_40), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_40), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_40), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_40), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_40), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_40), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_40), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_40), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_40), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_40), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_40), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_40), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_40), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_40), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_40), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_40), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_40), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_40), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_40), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_40), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_40), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_40), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_40), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_40), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_40), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_40), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_40), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_40), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_40), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_40), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_40), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_40), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_40), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_40), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_40), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_40), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_40), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_40), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_40), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_40), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_40), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_40), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_40), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_40), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_40), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_40), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_40), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_40), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_40), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_40), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_40), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_40), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_40), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_40), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_40), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_40), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_40), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_40), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_40), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_40), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_40), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_40), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_40), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_40), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_40), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_40), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_40), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_40), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_40), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_40), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_40), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_40), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_40), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_40), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_40), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_40), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_40), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_40), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_40), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_40), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_40), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_40), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_40), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_40), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_40), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_40), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_40), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_40), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_40), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_40), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_40), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_40), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_40), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_40), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_40), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_40), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_40), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_40), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_40), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_40), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_40), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_40), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_40), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_40), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_40), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_40), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_40), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_42), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_42), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_40), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_40), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_40), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_40), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_40), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_40), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_40), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_40), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_40), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_40), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_40), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_40), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_40), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_40), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_40), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_40), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_40), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_40), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_40), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_40), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_40), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_40), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_40), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_40), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_40), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_40), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_40), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_40), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_40), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_40), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_40), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_40), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_40), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_40), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_40), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_40), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_40), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_40), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_40), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_40), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_40), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_40), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_40), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_42), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_42), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_40), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_40), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_40), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_40), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_40), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_40), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_40), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_40), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_40), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_40), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_40), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_40), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_40), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_40), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_40), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_40), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_40), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_40), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_40), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_40), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_40), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_40), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_40), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_40), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_40), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_40), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_40), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_40), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_40), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_40), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_40), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_40), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_40), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_40), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_40), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_40), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_40), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_40), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_40), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_40), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_40), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_40), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_40), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_40), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_40), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_40), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_40), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_40), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_40), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_40), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_40), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_40), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_40), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_40), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_40), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_40), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_40), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_40), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_40), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_40), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_40), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_40), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_40), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_40), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_40), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_40), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_40), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_40), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_40), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_40), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_40), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_40), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_40), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_40), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_40), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_40), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_40), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_40), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_40), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_40), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_40), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_40), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f000_40), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f008_40), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f010_40), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f018_40), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f020_40), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f028_40), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f030_40), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f038_40), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f039_40), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f200_40), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_40), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_40), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_40), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_40), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_40), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_40), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_40), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_40), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_40), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_40), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_40), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_40), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_40), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_40), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_40), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_40), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_40), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_40), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_40), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_40), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_40), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_40), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_40), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_40), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_40), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_40), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_40), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_40), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_40), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_40), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_40), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_40), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_40), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_40), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_40), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_40), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_40), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_40), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_40), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_40 */
#ifdef CPUEMU_40
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_43)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_40), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_40), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_40), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_40), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_40), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_40), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_40), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_40), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_40), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_40), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_40), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_40), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_40), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_40), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_40), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_40), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_40), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_40), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_40), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_40), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_40), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_40), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_40), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_40), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_40), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_40), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_40), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_40), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_40), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_40), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_40), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_40), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_40), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_40), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_40), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_40), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_40), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_40), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_40), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_40), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_40), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_40), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_40), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_40), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_40), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_40), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_40), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_40), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_40), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_40), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_40), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_40), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_40), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_40), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_40), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_40), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_40), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_40), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_40), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_40), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_40), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_40), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_40), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_40), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_40), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_40), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_40), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_40), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_40), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_40), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_40), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_40), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_40), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_40), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_40), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_40), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_40), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_40), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_40), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_40), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_40), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_40), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_40), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_40), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_40), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_40), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_40), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_40), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_40), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_40), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_40), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_40), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_40), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_40), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_40), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_40), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_40), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_40), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_40), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_40), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_40), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_40), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_40), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_40), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_40), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_40), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_40), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_40), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_40), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_40), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_40), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_40), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_40), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_40), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_40), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_40), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_40), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_40), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_40), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_40), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_40), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_40), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_40), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_40), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_40), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_40), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_40), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_40), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_40), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_40), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_40), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_40), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_40), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_40), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_40), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_40), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_40), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_40), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_40), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_40), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_40), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_40), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_40), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_40), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_40), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_40), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_40), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_40), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_40), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_40), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_40), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_40), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_40), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_40), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_40), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_40), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_40), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_40), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_40), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_40), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_40), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_40), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_40), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_40), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_40), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_40), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_40), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_40), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_40), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_40), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_40), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_40), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_40), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_40), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_40), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_40), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_40), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_40), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_40), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_40), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_40), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_40), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_40), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_40), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_40), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_40), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_40), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_40), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_40), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_40), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_40), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_40), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_40), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_40), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_40), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_40), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_40), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_40), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_40), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_40), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_40), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_40), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_40), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_40), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_40), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_40), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_40), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_40), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_40), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_40), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_40), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_40), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_40), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_40), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_40), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_40), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_40), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_40), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_40), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_40), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_40), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_40), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_40), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_40), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_40), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_40), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_40), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_40), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_40), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_40), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_40), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_40), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_40), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_40), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_40), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_40), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_40), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_40), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_40), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_40), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_40), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_40), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_40), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_40), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_40), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_40), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_40), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_40), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_40), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_40), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_40), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_40), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_40), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_40), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_40), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_40), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_40), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_42), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_40), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_42), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_42), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_42), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_42), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_42), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_42), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_42), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_40), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_40), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_40), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_40), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_40), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_40), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_40), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_40), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_40), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_40), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_40), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_40), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_40), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_40), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_40), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_40), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_40), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_40), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_40), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_40), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_40), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_40), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_40), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_40), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_40), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_40), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_40), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_40), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_40), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_40), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_40), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_40), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_40), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_40), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_40), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_40), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_40), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_40), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_40), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_40), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_40), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_40), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_40), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_40), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_40), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_40), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_40), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_40), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_40), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_40), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_40), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_40), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_40), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_40), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_40), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_40), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_40), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_40), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_40), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_40), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_40), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_40), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_40), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_40), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_40), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_40), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_40), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_40), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_40), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_40), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_40), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_40), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_40), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_40), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_40), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_40), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_40), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_40), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_40), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_40), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_40), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_40), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_40), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_40), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_40), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_40), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_40), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_40), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_40), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_40), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_40), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_40), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_40), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_40), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_40), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_40), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_40), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_40), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_40), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_40), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_40), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_40), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_40), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_40), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_40), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_40), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_40), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_40), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_40), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_40), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_40), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_40), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_40), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_40), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_40), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_40), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_40), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_40), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_40), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_40), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_40), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_40), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_40), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_40), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_40), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_40), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_40), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_40), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_40), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_40), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_40), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_40), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_40), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_40), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_40), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_40), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_40), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_40), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_40), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_40), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_40), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_40), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_40), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_40), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_40), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_40), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_40), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_40), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_40), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_40), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_40), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_40), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_40), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_40), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_40), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_40), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_40), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_40), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_40), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_40), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_40), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_40), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_40), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_40), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_40), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_40), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_40), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_40), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_40), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_40), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_40), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_40), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_40), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_40), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_40), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_40), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_40), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_40), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_40), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_40), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_40), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_40), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_40), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_40), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_40), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_40), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_40), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_40), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_40), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_40), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_40), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_40), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_40), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_40), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_40), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_40), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_40), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_40), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_40), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_40), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_40), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_40), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_40), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_40), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_40), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_40), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_40), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_40), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_40), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_40), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_40), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_40), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_40), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_40), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_40), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_40), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_40), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_40), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_40), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_40), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_40), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_40), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_40), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_40), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_40), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_40), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_40), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_40), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_40), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_40), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_40), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_40), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_40), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_40), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_40), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_40), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_40), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_40), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_40), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_40), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_40), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_40), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_40), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_40), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_40), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_40), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_40), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_40), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_40), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_40), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_40), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_40), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_40), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_40), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_40), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_40), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_40), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_40), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_40), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_40), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_40), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_40), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_40), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_40), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_40), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_40), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_40), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_40), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_42), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_42), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_40), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_40), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_40), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_40), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_40), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_40), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_40), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_40), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_40), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_40), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_40), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_40), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_40), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_40), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_40), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_40), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_40), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_40), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_40), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_40), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_40), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_40), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_40), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_40), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_40), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_40), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_40), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_40), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_40), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_40), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_40), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_40), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_40), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_40), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_40), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_40), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_40), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_40), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_40), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_40), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_40), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_40), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_40), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_42), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_42), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_40), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_40), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_40), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_40), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_40), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_40), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_40), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_40), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_40), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_40), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_40), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_40), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_40), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_40), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_40), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_40), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_40), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_40), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_40), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_40), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_40), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_40), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_40), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_40), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_40), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_40), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_40), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_40), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_40), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_40), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_40), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_40), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_40), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_40), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_40), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_40), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_40), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_40), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_40), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_40), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_40), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_40), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_40), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_40), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_40), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_40), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_40), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_40), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_40), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_40), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_40), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_40), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_40), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_40), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_40), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_40), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_40), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_40), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_40), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_40), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_40), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_40), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_40), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_40), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_40), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_40), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_40), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_40), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_40), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_40), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_40), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_40), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_40), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_40), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_40), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_40), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_40), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_40), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_40), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_40), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_40), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_40), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f200_40), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_40), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_40), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_40), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_40), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_40), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_40), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_40), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_40), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_40), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_40), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_40), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_40), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_40), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_40), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_40), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_40), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_40), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_40), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_40), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_40), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_40), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_40), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_40), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_40), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_40), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_40), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_40), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_40), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_40), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_40), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_40), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_40), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_40), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_40), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_40), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_40), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_40), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_40), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_40), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_40 */
#ifdef CPUEMU_40
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_44)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_44), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_44), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_44), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_44), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_44), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_44), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_44), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_44), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_44), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_44), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_44), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_44), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_44), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_44), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_44), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_44), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_44), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_44), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_44), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_44), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_44), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_44), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_44), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_44), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_44), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_44), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_44), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_44), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_44), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_44), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_44), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_44), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_44), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_44), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_44), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_44), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_44), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_44), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_44), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_44), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_44), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_44), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_44), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_44), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_44), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_44), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_44), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_44), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_44), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_44), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_44), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_44), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_44), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_44), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_44), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_44), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_44), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_44), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_44), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_44), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_44), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_44), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_44), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_44), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_44), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_44), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_44), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_44), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_44), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_44), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_44), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_44), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_44), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_44), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_44), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_44), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_44), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_44), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_44), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_44), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_44), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_44), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_44), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_44), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_44), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_44), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_44), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_44), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_44), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_44), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_44), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_44), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_44), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_44), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_44), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_44), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_44), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_44), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_44), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_44), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_44), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_44), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_44), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_44), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_44), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_44), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_44), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_44), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_44), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_44), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_44), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_44), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_40), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_40), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_40), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_40), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_40), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_44), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_40), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_40), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_44), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_44), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_44), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_44), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_40), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_40), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_40), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_40), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_40), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_44), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_40), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_40), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_40), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_40), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_40), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_40), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_40), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_44), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_40), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_40), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_40), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_40), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_40), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_40), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_40), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_44), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_40), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_40), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_40), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_40), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_40), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_40), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_40), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_44), 0x42f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_42f8_40), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_40), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_44), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_44), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_44), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_44), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_44), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_44), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_44), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_44), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_44), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_44), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_42), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_42), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_42), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_42), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_42), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_44), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_42), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_42), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_44), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_44), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_44), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_44), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_44), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_44), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_44), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_44), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_44), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_44), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_44), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_44), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_44), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_44), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_44), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_44), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_44), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_44), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_44), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_40), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_40), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_40), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_40), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_44), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_44), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_44), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_44), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_44), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_44), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_44), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_40), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_40), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_40), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_40), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_40), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_44), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_40), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_40), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_44), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_44), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_44), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_40), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_40), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_40), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_40), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_40), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_44), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_40), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_40), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_40), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_40), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_40), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_40), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_40), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_44), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_40), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_40), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_40), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_40), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_40), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_40), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_40), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_44), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_40), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_40), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_40), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_40), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_40), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_40), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_40), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_44), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_40), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_40), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_40), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_40), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_40), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_40), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_40), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_44), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_40), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_40), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_40), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_40), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_40), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_40), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_40), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_44), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_40), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_40), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_40), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_40), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_40), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_40), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_40), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_44), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_40), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_40), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_40), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_40), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_40), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_40), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_40), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_44), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_40), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_40), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_40), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_40), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_40), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_40), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_40), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_44), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_40), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_40), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_40), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_40), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_40), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_40), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_40), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_44), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_40), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_40), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_40), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_40), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_40), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_40), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_40), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_44), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_40), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_40), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_40), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_40), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_40), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_40), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_40), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_44), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_40), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_40), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_40), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_40), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_40), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_40), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_40), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_44), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_40), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_40), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_40), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_40), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_40), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_40), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_40), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_44), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_40), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_40), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_40), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_40), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_40), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_40), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_40), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_44), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_40), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_40), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_44), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_44), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_44), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_44), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_44), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_44), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_44), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_44), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_44), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_44), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_44), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_44), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_44), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_44), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_44), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_44), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_44), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_44), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_44), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_44), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_44), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_44), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_44), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_44), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_42), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_42), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_44), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_44), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_44), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_44), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_44), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_44), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_44), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_44), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_44), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_44), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_44), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_44), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_44), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_44), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_44), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_44), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_44), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_44), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_44), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_44), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_44), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_44), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_44), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_44), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_44), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_44), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_44), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_44), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_44), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_44), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_44), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_44), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_44), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_44), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_44), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_44), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_44), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_44), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_44), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_42), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_42), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_44), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_44), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_44), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_44), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_44), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_44), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_44), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_44), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_44), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_44), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_44), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_44), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_44), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_44), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_44), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_44), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_44), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_44), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_44), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_44), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_44), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_44), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_44), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_44), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_44), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_44), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_40 */
#ifdef CPUEMU_40
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_45)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_44), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_44), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_44), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_44), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_44), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_44), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_44), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_44), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_44), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_44), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_44), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_44), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_44), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_44), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_44), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_44), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_44), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_44), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_44), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_44), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_44), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_44), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_44), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_44), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_44), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_44), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_44), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_44), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_44), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_44), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_44), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_44), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_44), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_44), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_44), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_44), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_44), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_44), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_44), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_44), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_44), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_44), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_44), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_44), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_44), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_44), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_44), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_44), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_44), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_44), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_44), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_44), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_44), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_44), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_44), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_44), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_44), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_44), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_44), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_44), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_44), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_44), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_44), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_44), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_44), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_44), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_44), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_44), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_44), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_44), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_44), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_44), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_44), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_44), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_44), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_44), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_44), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_44), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_44), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_44), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_44), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_44), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_44), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_44), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_44), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_44), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_44), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_44), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_44), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_44), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_44), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_44), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_44), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_44), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_44), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_44), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_44), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_44), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_44), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_44), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_44), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_44), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_44), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_44), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_44), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_44), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_44), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_44), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_44), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_44), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_44), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_44), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_45), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_45), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_45), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_45), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_45), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_45), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_45), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_45), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_44), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_44), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_44), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_44), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_45), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_45), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_45), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_45), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_45), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_45), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_45), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_45), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_45), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_45), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_45), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_45), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_45), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_45), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_45), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_45), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_45), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_45), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_45), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_45), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_45), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_45), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_45), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_45), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_44), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_44), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_44), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_44), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_44), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_44), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_44), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_44), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_44), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_44), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_42), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_42), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_42), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_42), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_42), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_44), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_42), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_42), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_44), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_44), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_44), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_44), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_44), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_44), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_44), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_44), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_44), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_44), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_44), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_44), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_44), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_44), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_44), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_44), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_44), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_44), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_44), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_45), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_44), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_44), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_44), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_44), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_44), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_44), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_44), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_45), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_45), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_45), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_45), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_45), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_45), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_45), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_45), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_44), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_44), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_44), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_45), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_45), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_45), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_45), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_45), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_45), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_45), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_45), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_45), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_45), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_45), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_45), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_45), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_45), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_45), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_45), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_45), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_45), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_45), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_45), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_45), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_45), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_45), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_45), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_45), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_45), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_45), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_45), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_45), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_45), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_45), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_45), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_45), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_45), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_45), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_45), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_45), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_45), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_45), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_45), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_45), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_45), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_45), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_45), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_45), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_45), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_45), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_45), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_45), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_45), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_45), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_45), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_45), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_45), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_45), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_45), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_45), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_45), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_45), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_45), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_45), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_45), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_45), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_45), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_45), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_45), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_45), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_45), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_45), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_45), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_45), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_45), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_45), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_45), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_45), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_45), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_45), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_45), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_45), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_45), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_45), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_45), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_45), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_45), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_45), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_45), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_45), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_45), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_45), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_45), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_45), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_45), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_45), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_45), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_45), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_45), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_45), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_45), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_45), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_45), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_45), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_45), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_45), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_45), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_45), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_45), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_45), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_45), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_45), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_45), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_45), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_45), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_45), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_45), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_45), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_45), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_45), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_45), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_45), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_45), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_44), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_44), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_44), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_44), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_44), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_44), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_44), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_44), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_44), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_44), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_44), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_44), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_44), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_44), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_44), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_44), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_44), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_44), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_44), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_44), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_44), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_44), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_44), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_44), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_42), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_42), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_44), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_44), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_44), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_44), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_44), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_44), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_44), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_44), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_44), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_44), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_44), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_44), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_44), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_44), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_44), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_44), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_44), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_44), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_44), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_44), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_44), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_44), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_44), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_44), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_44), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_44), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_44), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_44), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_44), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_44), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_44), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_44), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_44), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_44), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_44), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_44), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_44), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_44), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_44), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_42), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_42), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_44), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_44), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_44), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_44), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_44), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_44), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_44), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_44), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_44), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_44), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_44), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_44), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_44), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_44), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_44), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_44), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_44), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_44), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_44), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_44), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_44), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_44), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_44), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_44), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_44), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_44), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_40 */
const struct cputbl CPUFUNC(op_smalltbl_46)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_44), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_44), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_44), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_44), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_44), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_44), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_44), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_44), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_44), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_44), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_44), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_44), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_44), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_44), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_44), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_44), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_44), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_44), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_44), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_44), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_44), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_44), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_44), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_44), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_44), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_44), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_44), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_44), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_44), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_44), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_44), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_44), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_44), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_44), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_44), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_44), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_44), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_44), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_44), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_44), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_44), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_44), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_44), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_44), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_44), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_44), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_44), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_44), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_44), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_44), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_44), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_44), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_44), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_44), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_44), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_44), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_44), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_44), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_44), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_44), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_44), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_44), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_44), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_44), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_44), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_44), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_44), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_44), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_44), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_44), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_44), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_44), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_44), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_44), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_44), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_44), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_44), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_44), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_44), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_44), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_44), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_44), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_44), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_44), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_44), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_44), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_44), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_44), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_44), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_44), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_44), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_44), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_44), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_44), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_44), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_44), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_44), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_44), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_44), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_44), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_44), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_44), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_44), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_44), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_44), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_44), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_44), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_44), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_44), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_44), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_44), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_44), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_45), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_45), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_45), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_45), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_45), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_45), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_45), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_45), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_44), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_44), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_44), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_44), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_46), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_46), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_46), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_46), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_46), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_46), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_46), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_46), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_46), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_46), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_46), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_46), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_46), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_46), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_46), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_46), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_46), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_46), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_46), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_46), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_46), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_46), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_46), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_46), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_44), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_44), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_44), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_44), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_44), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_44), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_44), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_44), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_44), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_44), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_42), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_42), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_42), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_42), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_42), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_44), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_42), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_42), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_44), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_44), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_44), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_44), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_44), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_44), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_44), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_44), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_44), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_44), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_44), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_44), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_44), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_44), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_44), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_44), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_44), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_44), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_44), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_46), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_44), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_44), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_44), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_44), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_44), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_44), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_44), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_46), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_46), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_46), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_46), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_46), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_46), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_46), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_46), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_44), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_44), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_44), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_46), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_46), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_46), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_46), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_46), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_46), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_46), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_46), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_46), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_46), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_46), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_46), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_46), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_46), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_46), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_46), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_46), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_46), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_46), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_46), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_46), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_46), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_46), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_46), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_46), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_46), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_46), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_46), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_46), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_46), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_46), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_46), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_46), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_46), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_46), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_46), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_46), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_46), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_46), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_46), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_46), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_46), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_46), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_46), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_46), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_46), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_46), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_46), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_46), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_46), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_46), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_46), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_46), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_46), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_46), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_46), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_46), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_46), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_46), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_46), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_46), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_46), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_46), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_46), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_46), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_46), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_46), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_46), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_46), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_46), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_46), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_46), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_46), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_46), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_46), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_46), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_46), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_46), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_46), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_46), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_46), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_46), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_46), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_46), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_46), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_46), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_46), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_46), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_46), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_46), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_46), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_46), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_46), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_46), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_46), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_46), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_46), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_46), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_46), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_46), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_46), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_46), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_46), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_46), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_46), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_46), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_46), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_46), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_46), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_46), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_46), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_46), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_46), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_46), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_46), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_46), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_46), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_46), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_46), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_46), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_44), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_44), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_44), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_44), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_44), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_44), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_44), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_44), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_44), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_44), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_44), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_44), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_44), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_44), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_44), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_44), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_44), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_44), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_44), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_44), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_44), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_44), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_44), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_44), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_42), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_42), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_44), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_44), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_44), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_44), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_44), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_44), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_44), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_44), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_44), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_44), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_44), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_44), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_44), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_44), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_44), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_44), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_44), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_44), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_44), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_44), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_44), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_44), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_44), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_44), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_44), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_44), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_44), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_44), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_44), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_44), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_44), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_44), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_44), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_44), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_44), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_44), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_44), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_44), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_44), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_42), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_42), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_44), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_44), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_44), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_44), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_44), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_44), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_44), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_44), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_44), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_44), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_44), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_44), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_44), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_44), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_44), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_44), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_44), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_44), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_44), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_44), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_44), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_44), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_44), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_44), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_44), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_44), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
const struct cputbl CPUFUNC(op_smalltbl_47)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_44), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_44), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_44), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_44), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_44), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_44), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_44), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_44), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_44), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_44), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_44), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_44), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_44), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_44), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_44), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_44), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_44), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_44), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_44), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_44), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_44), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_44), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_44), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_44), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_44), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_44), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_44), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_44), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_44), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_44), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_44), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_44), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_44), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_44), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_44), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_44), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_44), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_44), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_44), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_44), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_44), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_44), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_44), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_44), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_44), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_44), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_44), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_44), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_44), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_44), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_44), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_44), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_44), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_44), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_44), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_44), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_44), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_44), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_44), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_44), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_44), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_44), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_44), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_44), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_44), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_44), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_44), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_44), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_44), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_44), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_44), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_44), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_44), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_44), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_44), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_44), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_44), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_44), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_44), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_44), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_44), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_44), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_44), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_44), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_44), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_44), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_44), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_44), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_44), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_44), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_44), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_44), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_44), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_44), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_44), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_44), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_44), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_44), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_44), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_44), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_44), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_44), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_44), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_44), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_44), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_44), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_44), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_44), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_44), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_44), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_44), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_44), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_45), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_45), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_45), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_45), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_45), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_45), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_45), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_45), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_44), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_44), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_44), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_44), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_47), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_47), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_47), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_47), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_47), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_47), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_47), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_47), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_47), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_47), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_47), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_47), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_47), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_47), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_47), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_47), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_47), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_47), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_47), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_47), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_47), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_47), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_47), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_47), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_44), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_44), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_44), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_44), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_44), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_44), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_44), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_44), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_44), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_44), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_42), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_42), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_42), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_42), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_42), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_44), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_42), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_42), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_44), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_44), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_44), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_44), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_44), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_44), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_44), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_44), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_44), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_44), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_44), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_44), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_44), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_44), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_44), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_44), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_44), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_44), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_44), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_47), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_44), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_44), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_44), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_44), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_44), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_44), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_44), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_47), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_47), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_47), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_47), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_47), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_47), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_47), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_47), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_44), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_44), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_44), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_47), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_47), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_47), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_47), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_47), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_47), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_47), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_47), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_47), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_47), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_47), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_47), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_47), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_47), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_47), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_47), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_47), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_47), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_47), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_47), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_47), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_47), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_47), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_47), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_47), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_47), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_47), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_47), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_47), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_47), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_47), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_47), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_47), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_47), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_47), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_47), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_47), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_47), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_47), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_47), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_47), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_47), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_47), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_47), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_47), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_47), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_47), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_47), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_47), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_47), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_47), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_47), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_47), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_47), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_47), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_47), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_47), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_47), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_47), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_47), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_47), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_47), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_47), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_47), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_47), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_47), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_47), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_47), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_47), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_47), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_47), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_47), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_47), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_47), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_47), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_47), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_47), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_47), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_47), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_47), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_47), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_47), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_47), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_47), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_47), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_47), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_47), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_47), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_47), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_47), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_47), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_47), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_47), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_47), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_47), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_47), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_47), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_47), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_47), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_47), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_47), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_47), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_47), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_47), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_47), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_47), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_47), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_47), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_47), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_47), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_47), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_47), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_47), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_47), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_47), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_47), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_47), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_47), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_47), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_47), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_44), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_44), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_44), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_44), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_44), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_44), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_44), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_44), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_44), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_44), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_44), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_44), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_44), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_44), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_44), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_44), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_44), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_44), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_44), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_44), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_44), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_44), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_44), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_44), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_42), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_42), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_44), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_44), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_44), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_44), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_44), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_44), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_44), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_44), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_44), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_44), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_44), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_44), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_44), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_44), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_44), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_44), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_44), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_44), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_44), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_44), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_44), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_44), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_44), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_44), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_44), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_44), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_44), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_44), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_44), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_44), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_44), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_44), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_44), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_44), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_44), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_44), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_44), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_44), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_44), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_42), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_42), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_44), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_44), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_44), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_44), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_44), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_44), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_44), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_44), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_44), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_44), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_44), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_44), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_44), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_44), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_44), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_44), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_44), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_44), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_44), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_44), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_44), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_44), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_44), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_44), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_44), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_44), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
const struct cputbl CPUFUNC(op_smalltbl_48)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_44), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_44), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_44), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_44), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_44), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_44), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_44), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_44), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_44), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_44), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_44), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_44), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_44), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_44), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_44), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_44), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_44), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_44), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_44), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_44), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_44), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_44), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_44), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_44), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_44), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_44), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_44), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_44), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_44), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_44), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_44), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_44), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_44), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_44), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_44), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_44), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_44), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_44), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_44), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_44), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_44), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_44), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_44), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_44), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_44), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_44), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_44), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_44), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_44), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_44), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_44), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_44), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_44), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_44), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_44), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_44), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_44), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_44), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_44), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_44), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_44), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_44), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_44), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_44), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_44), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_44), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_44), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_44), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_44), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_44), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_44), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_44), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_44), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_44), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_44), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_44), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_44), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_44), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_44), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_44), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_44), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_44), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_44), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_44), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_44), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_44), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_44), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_44), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_44), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_44), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_44), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_44), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_44), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_44), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_44), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_44), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_44), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_44), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_44), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_44), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_44), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_44), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_44), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_44), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_44), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_44), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_44), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_44), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_44), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_44), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_44), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_44), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_45), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_45), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_45), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_45), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_45), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_45), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_45), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_45), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_44), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_44), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_44), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_44), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_48), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_48), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_48), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_48), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_48), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_48), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_48), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_48), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_48), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_48), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_48), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_48), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_48), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_48), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_48), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_48), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_48), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_48), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_48), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_48), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_48), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_48), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_48), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_48), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_44), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_44), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_44), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_44), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_44), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_44), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_44), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_44), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_44), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_44), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_42), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_42), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_42), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_42), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_42), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_44), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_42), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_42), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_44), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_44), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_44), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_44), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_44), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_44), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_44), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_44), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_44), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_44), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_44), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_44), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_44), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_44), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_44), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_44), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_44), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_44), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_44), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_48), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_44), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_44), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_44), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_44), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_44), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_44), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_44), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_48), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_48), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_48), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_48), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_48), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_48), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_48), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_48), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_44), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_44), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_44), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_48), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_48), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_48), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_48), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_48), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_48), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_48), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_48), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_48), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_48), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_48), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_48), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_48), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_48), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_48), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_48), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_48), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_48), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_48), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_48), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_48), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_48), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_48), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_48), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_48), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_48), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_48), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_48), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_48), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_48), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_48), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_48), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_48), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_48), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_48), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_48), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_48), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_48), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_48), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_48), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_48), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_48), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_48), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_48), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_48), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_48), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_48), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_48), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_48), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_48), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_48), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_48), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_48), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_48), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_48), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_48), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_48), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_48), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_48), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_48), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_48), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_48), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_48), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_48), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_48), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_48), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_48), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_48), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_48), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_48), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_48), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_48), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_48), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_48), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_48), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_48), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_48), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_48), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_48), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_48), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_48), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_48), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_48), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_48), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_48), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_48), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_48), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_48), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_48), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_48), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_48), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_48), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_48), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_48), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_48), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_48), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_48), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_48), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_48), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_48), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_48), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_48), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_48), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_48), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_48), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_48), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_48), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_48), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_48), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_48), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_48), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_48), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_48), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_48), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_48), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_48), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_48), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_48), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_48), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_48), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_44), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_44), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_44), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_44), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_44), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_44), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_44), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_44), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_44), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_44), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_44), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_44), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_44), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_44), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_44), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_44), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_44), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_44), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_44), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_44), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_44), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_44), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_44), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_44), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_42), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_42), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_44), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_44), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_44), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_44), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_44), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_44), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_44), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_44), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_44), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_44), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_44), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_44), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_44), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_44), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_44), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_44), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_44), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_44), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_44), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_44), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_44), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_44), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_44), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_44), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_44), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_44), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_44), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_44), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_44), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_44), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_44), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_44), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_44), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_44), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_44), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_44), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_44), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_44), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_44), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_42), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_42), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_44), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_44), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_44), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_44), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_44), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_44), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_44), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_44), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_44), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_44), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_44), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_44), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_44), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_44), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_44), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_44), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_44), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_44), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_44), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_44), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_44), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_44), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_44), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_44), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_44), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_44), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
const struct cputbl CPUFUNC(op_smalltbl_49)[] = {
{ CPUFUNC(op_0000_40), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_40), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_40), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_40), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_40), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_44), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_40), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_40), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_40), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_40), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_40), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_40), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_40), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_40), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_44), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_40), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_40), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_40), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_40), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_40), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_40), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_40), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_40), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_44), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_40), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_40), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_40), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_40), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_40), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_40), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_40), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_40), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_44), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_40), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_40), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_40), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_44), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_40), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_40), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_40), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_40), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_40), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_40), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_40), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_44), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_40), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_40), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_40), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_40), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_40), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_40), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_40), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_40), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_44), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_40), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_40), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_40), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_40), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_40), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_40), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_40), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_40), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_44), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_40), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_40), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_40), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_40), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_40), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_40), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_40), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_44), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_40), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_40), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_40), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_40), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_40), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_40), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_40), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_40), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_44), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_40), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_40), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_40), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_40), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_40), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_40), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_40), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_40), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_44), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_40), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_40), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_40), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_40), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_40), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_40), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_40), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_44), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_40), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_40), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_40), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_40), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_40), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_40), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_40), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_44), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_40), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_40), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_40), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_40), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_40), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_40), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_40), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_44), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_40), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_40), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_40), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_40), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_40), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_40), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_40), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_44), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_40), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_40), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_40), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_40), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_40), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_40), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_40), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_44), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_40), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_40), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_40), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_40), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_40), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_40), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_40), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_44), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_40), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_40), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_40), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_40), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_40), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_40), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_40), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_44), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_40), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_40), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_40), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_44), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_40), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_40), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_40), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_40), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_40), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_44), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_40), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_40), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_40), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_40), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_40), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_40), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_40), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_44), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_40), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_40), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_40), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_40), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_40), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_40), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_40), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_44), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_40), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_40), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_40), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_40), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_40), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_40), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_40), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_44), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_40), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_40), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_40), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_40), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_40), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_40), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_40), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_40), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_44), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_40), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_40), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_40), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_40), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_40), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_40), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_40), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_40), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_44), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_40), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_40), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_40), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_40), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_40), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_40), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_40), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_44), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_40), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_40), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_40), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_40), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_40), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_40), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_40), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_44), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_40), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_40), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_40), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_40), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_40), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_40), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_40), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_44), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_40), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_40), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_40), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_40), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_40), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_40), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_40), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_44), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_40), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_40), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_40), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_44), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_40), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_40), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_40), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_40), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_40), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_40), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_44), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_40), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_40), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_40), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_44), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_40), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_40), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_40), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_40), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_40), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_40), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_44), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_40), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_40), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_40), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_44), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_40), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_40), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_40), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_40), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_40), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_40), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_44), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_40), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_40), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_40), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_44), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_40), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_40), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_40), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_40), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_40), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_40), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_44), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_40), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_40), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_40), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_44), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_40), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_44), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_44), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_44), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_44), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_44), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_44), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_44), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_44), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_44), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_44), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_44), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_40), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_40), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_40), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_40), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_40), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_44), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_40), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_40), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_40), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_44), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_40), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_40), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_40), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_40), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_40), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_40), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_44), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_40), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_40), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_40), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_44), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_40), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_40), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_40), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_40), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_40), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_40), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_40), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_44), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_40), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_40), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_40), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_44), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_40), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_40), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_40), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_40), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_40), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_40), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_40), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_44), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_40), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_40), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_40), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_44), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_40), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_40), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_40), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_40), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_40), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_40), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_40), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_44), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_40), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_40), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_40), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_44), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_40), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_40), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_40), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_40), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_40), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_40), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_40), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_44), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_40), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_40), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_40), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_44), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_40), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_40), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_40), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_40), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_40), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_40), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_40), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_44), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_40), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_40), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_40), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_44), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_40), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_40), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_40), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_40), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_40), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_40), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_40), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_44), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_40), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_40), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_40), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_44), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_40), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_44), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_44), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_44), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_44), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_44), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_44), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_44), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_44), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_44), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_44), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_44), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_44), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_40), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_40), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_40), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_40), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_40), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_40), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_44), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_40), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_40), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_40), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_44), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_40), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_40), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_40), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_40), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_40), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_40), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_40), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_44), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_40), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_40), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_40), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_44), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_40), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_40), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_40), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_40), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_40), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_40), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_40), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_44), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_40), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_40), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_40), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_44), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_40), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_40), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_40), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_40), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_40), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_40), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_40), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_44), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_40), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_40), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_40), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_44), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_40), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_40), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_40), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_40), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_40), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_40), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_40), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_44), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_40), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_40), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_40), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_44), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_40), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_40), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_40), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_40), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_40), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_40), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_40), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_44), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_40), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_40), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_40), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_44), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_40), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_40), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_40), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_40), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_40), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_40), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_40), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_44), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_40), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_40), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_40), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_44), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_40), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_40), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_40), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_40), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_40), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_40), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_40), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_44), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_40), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_40), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_40), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_44), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_40), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_44), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_44), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_44), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_44), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_44), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_44), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_44), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_44), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_44), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_44), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_44), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_44), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_40), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_40), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_40), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_40), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_40), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_40), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_44), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_40), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_40), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_40), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_44), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_40), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_40), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_40), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_40), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_40), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_40), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_40), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_44), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_40), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_40), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_40), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_44), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_40), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_40), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_40), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_40), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_40), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_40), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_44), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_40), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_40), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_40), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_40), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_40), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_40), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_40), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_44), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_40), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_40), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_40), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_40), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_40), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_40), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_40), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_44), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_40), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_40), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_45), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_45), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_45), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_45), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_45), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_45), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_45), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_45), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_40), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_40), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_40), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_40), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_40), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_44), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_40), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_40), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_40), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_44), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_40), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_40), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_40), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_44), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_40), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_40), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_40), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_44), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_49), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_49), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_49), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_49), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_49), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_49), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_49), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_49), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_49), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_49), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_49), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_49), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_49), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_49), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_49), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_49), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_49), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_49), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_49), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_49), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_49), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_49), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_49), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_49), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4400_40), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_40), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_40), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_40), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_40), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_44), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_40), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_40), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_40), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_40), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_40), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_40), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_40), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_44), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_40), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_40), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_40), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_40), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_40), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_40), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_40), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_44), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_40), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_40), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_40), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_40), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_40), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_40), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_40), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_44), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_40), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_40), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_40), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_44), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_40), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_40), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_40), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_40), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_40), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_40), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_44), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_40), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_40), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_40), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_40), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_40), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_40), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_40), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_44), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_40), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_40), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_40), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_40), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_40), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_40), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_40), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_44), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_40), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_40), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_40), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_40), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_40), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_40), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_40), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_44), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_40), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_40), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_40), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_44), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_40), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_42), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_42), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_42), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_42), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_42), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_44), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_42), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_42), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_40), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_40), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_40), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_44), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_40), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_40), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_40), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_44), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_40), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_40), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_40), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_40), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_44), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_40), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_40), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_40), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_40), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_40), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_40), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_44), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_40), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_40), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_40), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_40), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_40), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_40), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_40), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_44), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_40), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_40), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_40), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_40), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_40), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_40), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_40), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_44), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_40), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_40), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_40), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_40), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_40), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_40), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_40), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_44), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_40), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_40), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_44), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_44), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_44), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_44), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_44), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_44), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_44), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_44), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_40), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_40), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_40), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_44), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_40), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_40), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_40), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_44), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_40), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_40), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_40), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_44), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_40), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_40), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_40), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_44), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_40), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_40), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_40), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_40), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_40), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_40), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_40), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_40), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_49), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e75_40), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_40), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_40), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e90_40), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_40), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_44), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_40), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_40), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_40), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_44), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_40), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_40), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_44), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_40), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_40), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_40), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_44), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_40), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_40), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_40), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_40), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_40), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_44), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_40), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_40), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_40), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_40), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_40), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_40), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_40), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_40), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_44), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_40), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_40), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_40), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_40), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_40), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_40), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_40), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_40), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_44), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_40), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_40), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_49), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_40), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_49), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_49), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_49), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_49), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_49), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_49), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_49), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_40), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_40), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_40), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_40), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_40), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_44), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_40), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_40), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_40), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_40), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_40), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_40), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_40), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_40), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_44), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_40), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_40), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_40), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_40), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_40), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_40), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_40), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_40), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_44), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_40), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_40), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_49), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_40), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_49), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_49), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_49), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_49), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_49), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_49), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_49), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_49), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_40), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_49), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_49), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_49), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_49), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_49), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_49), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_49), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_49), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_40), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_49), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_49), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_49), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_49), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_49), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_49), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_49), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_49), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_40), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_49), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_49), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_49), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_49), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_49), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_49), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_49), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_49), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_40), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_49), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_49), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_49), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_49), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_49), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_49), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_49), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_49), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_40), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_49), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_49), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_49), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_49), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_49), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_49), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_49), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_49), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_40), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_49), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_49), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_49), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_49), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_49), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_49), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_49), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_49), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_40), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_49), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_49), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_49), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_49), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_49), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_49), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_49), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_49), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_40), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_49), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_49), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_49), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_49), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_49), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_49), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_49), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_49), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_40), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_49), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_49), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_49), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_49), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_49), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_49), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_49), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_49), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_40), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_49), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_49), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_49), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_49), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_49), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_49), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_49), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_49), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_40), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_49), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_49), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_49), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_49), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_49), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_49), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_49), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_49), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_40), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_49), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_49), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_49), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_49), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_49), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_49), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_49), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_49), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_40), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_49), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_49), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_49), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_49), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_49), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_49), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_49), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_49), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_40), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_49), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_49), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_49), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_49), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_49), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_49), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_49), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_40), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_40), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_44), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_40), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_40), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_44), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_40), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_40), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_44), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_40), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_40), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_44), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_40), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_40), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_44), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_40), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_40), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_44), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_40), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_40), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_44), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_40), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_40), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_44), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_40), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_40), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_44), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_40), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_40), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_44), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_40), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_40), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_44), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_40), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_40), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_44), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_40), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_40), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_44), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_40), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_40), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_44), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_40), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_40), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_44), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_40), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_40), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_44), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_40), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_40), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_40), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_40), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_40), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_40), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_44), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_40), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_40), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_40), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_44), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_40), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_40), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_40), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_40), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_40), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_40), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_44), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_40), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_40), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_40), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_44), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_40), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_40), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_40), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_40), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_40), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_40), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_44), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_40), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_40), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_40), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_44), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_40), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_40), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_40), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_40), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_40), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_40), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_44), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_40), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_40), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_40), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_44), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_40), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_42), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_42), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_40), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_40), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_40), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_40), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_44), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_40), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_40), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_40), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_40), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_40), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_40), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_44), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_40), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_40), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_40), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_40), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_40), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_40), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_44), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_40), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_40), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_40), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_40), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_40), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_40), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_40), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_44), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_40), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_40), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_40), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_44), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_40), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_40), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_40), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_40), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_40), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_40), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_44), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_40), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_40), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_40), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_44), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_40), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_40), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_40), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_40), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_40), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_40), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_40), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_44), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_40), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_40), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_40), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_44), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_40), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_40), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_40), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_40), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_40), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_40), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_40), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_44), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_40), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_40), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_40), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_44), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_40), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_40), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_40), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_40), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_40), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_40), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_40), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_44), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_40), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_40), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_40), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_44), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_40), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_40), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_40), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_40), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_40), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_40), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_40), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_44), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_40), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_40), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_40), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_40), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_40), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_40), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_40), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_40), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_44), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_40), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_40), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_40), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_40), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_40), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_40), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_40), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_40), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_44), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_40), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_40), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_40), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_40), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_40), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_40), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_40), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_40), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_44), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_40), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_40), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_40), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_44), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_40), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_40), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_40), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_40), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_40), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_40), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_44), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_40), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_40), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_40), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_44), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_40), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_40), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_40), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_40), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_40), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_40), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_40), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_44), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_40), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_40), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_40), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_44), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_40), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_40), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_40), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_40), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_40), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_40), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_40), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_44), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_40), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_40), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_40), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_44), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_40), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_40), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_40), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_40), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_40), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_40), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_40), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_44), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_40), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_40), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_40), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_44), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_40), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_40), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_40), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_40), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_40), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_40), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_40), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_44), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_40), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_40), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_40), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_40), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_40), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_40), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_40), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_40), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_44), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_40), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_40), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_40), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_40), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_40), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_40), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_40), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_40), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_44), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_40), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_40), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_40), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_40), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_40), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_40), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_40), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_40), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_44), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_40), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_40), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_40), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_44), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_40), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_40), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_40), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_40), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_40), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_40), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_44), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_40), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_40), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_40), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_44), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_40), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_40), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_40), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_40), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_40), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_40), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_44), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_40), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_40), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_40), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_44), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_40), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_40), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_40), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_40), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_40), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_40), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_44), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_40), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_40), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_40), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_44), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_40), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_40), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_40), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_40), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_40), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_40), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_44), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_40), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_40), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_40), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_44), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_40), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_42), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_42), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_40), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_40), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_40), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_40), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_44), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_40), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_40), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_40), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_40), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_40), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_40), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_40), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_40), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_44), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_40), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_40), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_40), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_40), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_40), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_40), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_40), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_44), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_40), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_40), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_40), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_40), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_40), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_40), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_40), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_44), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_40), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_40), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_40), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_44), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_40), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_40), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_40), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_40), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_40), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_40), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_44), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_40), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_40), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_40), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_44), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_40), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_40), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_40), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_40), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_40), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_40), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_40), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_44), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_40), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_40), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_40), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_44), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_40), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_40), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_40), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_40), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_40), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_40), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_40), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_44), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_40), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_40), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_40), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_44), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_40), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_40), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_40), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_40), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_40), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_40), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_40), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_44), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_40), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_40), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_40), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_44), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_40), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_40), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_40), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_40), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_40), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_40), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_40), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_44), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_40), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_40), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_40), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_40), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_40), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_40), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_40), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_40), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_44), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_40), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_40), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_40), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_40), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_40), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_40), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_40), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_40), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_44), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_40), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_40), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_40), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_40), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_40), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_40), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_40), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_40), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_44), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_40), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_40), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_40), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_44), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_40), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_40), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_40), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_40), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_40), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_40), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_40), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_40), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_40), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_40), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_40), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_40), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_40), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_40), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_40), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_40), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_40), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_40), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_40), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_40), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_40), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_40), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_40), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_40), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_40), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_40), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_40), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_40), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_40), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_44), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_40), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_40), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_40), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_40), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_40), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_40), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_40), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_40), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_40), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_40), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_40), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_40), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_40), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_40), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_40), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_40), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_40), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_40), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_40), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_40), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_40), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_40), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_40), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_40), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_40), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_40), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_40), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_40), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_40), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_40), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_44), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_40), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_40), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_40), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_40), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_40), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_40), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_44), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_40), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_40), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_40), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_40), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_40), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_40), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_44), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_40), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_40), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_40), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_40), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_40), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_40), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_44), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_40), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_40), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_40), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_40), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_40), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_40), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_44), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_40), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_40), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_40), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_40), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_40), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_40), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_44), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_40), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_40), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_40), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_40), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_40), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_40), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_44), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_40), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_40), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#ifdef CPUEMU_50
const struct cputbl CPUFUNC(op_smalltbl_50)[] = {
{ CPUFUNC(op_0000_50), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_50), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_50), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_50), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_50), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_50), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_50), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_50), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_50), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_50), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_50), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_50), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_50), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_50), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_50), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_50), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_50), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_50), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_50), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_50), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_50), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_50), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_50), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_50), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_50), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_50), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00d0_50), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00e8_50), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f0_50), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f8_50), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00f9_50), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fa_50), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_00fb_50), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0100_50), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_50), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_50), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_50), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_50), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_50), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_50), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_50), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_50), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_50), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_50), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_50), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_50), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_50), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_50), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_50), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_50), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_50), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_50), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_50), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_50), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_50), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_50), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_50), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_50), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_50), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_50), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_50), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_50), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_50), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_50), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_50), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_50), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_50), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_50), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_50), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_50), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_50), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_50), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_50), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_50), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_50), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_50), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_50), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_50), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_50), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_50), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_50), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_50), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_50), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_50), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_50), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_50), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_50), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_50), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_50), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_50), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_50), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_50), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_50), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_50), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_50), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_50), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_50), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_50), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02d0_50), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02e8_50), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f0_50), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f8_50), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02f9_50), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fa_50), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_02fb_50), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0400_50), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_50), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_50), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_50), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_50), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_50), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_50), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_50), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_50), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_50), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_50), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_50), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_50), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_50), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_50), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_50), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_50), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_50), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_50), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_50), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_50), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_50), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_50), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_50), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04d0_50), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04e8_50), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f0_50), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f8_50), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04f9_50), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fa_50), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_04fb_50), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
#endif
{ CPUFUNC(op_0600_50), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_50), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_50), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_50), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_50), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_50), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_50), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_50), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_50), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_50), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_50), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_50), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_50), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_50), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_50), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_50), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_50), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_50), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_50), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_50), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_50), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_50), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_50), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_50), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c0_50), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06c8_50), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06d0_50), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06e8_50), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f0_50), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f8_50), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06f9_50), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fa_50), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_06fb_50), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
#endif
{ CPUFUNC(op_0800_50), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_50), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_50), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_50), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_50), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_50), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_50), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_50), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_50), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_50), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_50), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_50), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_50), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_50), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_50), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_50), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_50), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_50), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_50), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_50), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_50), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_50), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_50), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_50), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_50), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_50), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_50), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_50), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_50), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_50), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_50), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_50), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_50), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_50), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_50), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_50), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_50), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_50), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_50), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_50), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_50), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_50), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_50), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_50), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_50), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_50), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_50), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_50), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_50), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_50), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_50), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_50), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_50), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_50), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_50), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_50), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_50), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_50), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_50), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_50), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad0_50), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ad8_50), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae0_50), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ae8_50), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af0_50), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af8_50), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0af9_50), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
#endif
{ CPUFUNC(op_0c00_50), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_50), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_50), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_50), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_50), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_50), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_50), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_50), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3a_50), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c3b_50), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c40_50), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_50), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_50), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_50), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_50), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_50), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_50), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_50), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7a_50), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0c7b_50), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
#endif
{ CPUFUNC(op_0c80_50), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_50), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_50), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_50), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_50), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_50), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_50), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_50), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cba_50), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cbb_50), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd0_50), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cd8_50), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce0_50), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ce8_50), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf0_50), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf8_50), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cf9_50), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0cfc_50), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e10_50), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e18_50), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e20_50), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e28_50), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e30_50), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e38_50), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e39_50), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e50_50), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e58_50), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e60_50), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e68_50), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e70_50), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e78_50), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e79_50), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e90_50), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0e98_50), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea0_50), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ea8_50), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb0_50), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb8_50), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0eb9_50), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed0_50), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ed8_50), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee0_50), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ee8_50), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef0_50), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef8_50), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0ef9_50), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_0efc_50), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
#endif
{ CPUFUNC(op_1000_50), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_50), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_50), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_50), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_50), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_50), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_50), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_50), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_50), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_50), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_50), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_50), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_50), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_50), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_50), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_50), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_50), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_50), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_50), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_50), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_50), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_50), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_50), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_50), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_50), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_50), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_50), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_50), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_50), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_50), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_50), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_50), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_50), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_50), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_50), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_50), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_50), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_50), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_50), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_50), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_50), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_50), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_50), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_50), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_50), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_50), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_50), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_50), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_50), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_50), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_50), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_50), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_50), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_50), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_50), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_50), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_50), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_50), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_50), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_50), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_50), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_50), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_50), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_50), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_50), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_50), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_50), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_50), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_50), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_50), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_50), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_50), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_50), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_50), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_50), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_50), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_50), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_50), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_50), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_50), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_50), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_50), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_50), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_50), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_50), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_50), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_50), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_50), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_50), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_50), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_50), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_50), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_50), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_50), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_50), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_50), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_50), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_50), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_50), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_50), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_50), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_50), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_50), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_50), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_50), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_50), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_50), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_50), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_50), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_50), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_50), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_50), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_50), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_50), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_50), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_50), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_50), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_50), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_50), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_50), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_50), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_50), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_50), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_50), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_50), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_50), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_50), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_50), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_50), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_50), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_50), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_50), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_50), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_50), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_50), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_50), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_50), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_50), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_50), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_50), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_50), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_50), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_50), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_50), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_50), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_50), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_50), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_50), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_50), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_50), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_50), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_50), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_50), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_50), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_50), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_50), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_50), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_50), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_50), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_50), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_50), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_50), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_50), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_50), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_50), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_50), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_50), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_50), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_50), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_50), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_50), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_50), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_50), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_50), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_50), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_50), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_50), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_50), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_50), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_50), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_50), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_50), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_50), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_50), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_50), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_50), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_50), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_50), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_50), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_50), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_50), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_50), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_50), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_50), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_50), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_50), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_50), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_50), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_50), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_50), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_50), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_50), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_50), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_50), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_50), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_50), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_50), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_50), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_50), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_50), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_50), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_50), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_50), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_50), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_50), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_50), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_50), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_50), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_50), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_50), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_50), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_50), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_50), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_50), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_50), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_50), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_50), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_50), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_50), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_50), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_50), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_50), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_50), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_50), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_50), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_50), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_50), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_50), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_50), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_50), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_50), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_50), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_50), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_50), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_50), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_50), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_50), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_50), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_50), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_50), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_50), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_50), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_50), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_50), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_50), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_50), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_50), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_50), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_50), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_50), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_50), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_50), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_50), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_50), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_50), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_50), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_50), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_50), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_50), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_50), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_50), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_50), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_50), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_50), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_50), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_50), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_50), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_50), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_50), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_50), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_50), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_50), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_50), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_50), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_50), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_50), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_50), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_50), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_50), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_50), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_50), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_50), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_50), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_50), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_50), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_50), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_50), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_50), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_50), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_50), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_50), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_50), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_50), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_50), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_50), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_50), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_50), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_50), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_50), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_50), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_50), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_50), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_50), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_50), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_50), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_50), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_50), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_50), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_50), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_50), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_50), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_50), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_50), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_50), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_50), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_50), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_50), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_50), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_50), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_50), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_50), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_50), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_50), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_50), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_50), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_50), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4100_50), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4110_50), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4118_50), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4120_50), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4128_50), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4130_50), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4138_50), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4139_50), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413a_50), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413b_50), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_413c_50), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
#endif
{ CPUFUNC(op_4180_50), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_50), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_50), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_50), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_50), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_50), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_50), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_50), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_50), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_50), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_50), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_50), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_50), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_50), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_50), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_50), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_50), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_50), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_50), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_50), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_50), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_50), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_50), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_50), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_50), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_50), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_50), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_50), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_50), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_50), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_50), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_50), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_50), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_50), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_50), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_50), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_50), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_50), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_50), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_50), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_50), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_50), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42c0_50), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d0_50), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42d8_50), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e0_50), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42e8_50), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_50), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f8_50), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f9_50), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_4400_50), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_50), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_50), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_50), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_50), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_50), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_50), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_50), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_50), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_50), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_50), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_50), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_50), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_50), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_50), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_50), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_50), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_50), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_50), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_50), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_50), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_50), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_50), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_50), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_50), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_50), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_50), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_50), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_50), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_50), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_50), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_50), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_50), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_50), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_50), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_50), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_50), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_50), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_50), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_50), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_50), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_50), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_50), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_50), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_50), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_50), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_50), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_50), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_50), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_50), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_50), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_50), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_50), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_50), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_50), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_50), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_50), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_50), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_50), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_50), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_50), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_50), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_50), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_50), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_50), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_50), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_50), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_50), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_50), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_50), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_50), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4808_50), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
#endif
{ CPUFUNC(op_4810_50), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_50), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_50), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_50), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_50), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_50), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_50), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_50), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4848_50), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
#endif
{ CPUFUNC(op_4850_50), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_50), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_50), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_50), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_50), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_50), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_50), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_50), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_50), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_50), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_50), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_50), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_50), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_50), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_50), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_50), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_50), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_50), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_50), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_50), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_50), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_49c0_50), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
#endif
{ CPUFUNC(op_4a00_50), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_50), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_50), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_50), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_50), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_50), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_50), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_50), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3a_50), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3b_50), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a3c_50), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a40_50), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a48_50), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a50_50), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_50), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_50), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_50), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_50), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_50), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_50), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7a_50), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7b_50), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a7c_50), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a80_50), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4a88_50), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4a90_50), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_50), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_50), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_50), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_50), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_50), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_50), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4aba_50), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abb_50), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4abc_50), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
#endif
{ CPUFUNC(op_4ac0_50), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_50), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_50), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_50), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_50), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_50), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_50), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_50), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c00_50), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c10_50), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c18_50), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c20_50), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c28_50), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c30_50), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c38_50), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c39_50), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3a_50), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3b_50), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c3c_50), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c40_50), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c50_50), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c58_50), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c60_50), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c68_50), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c70_50), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c78_50), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c79_50), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7a_50), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7b_50), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4c7c_50), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
#endif
{ CPUFUNC(op_4c90_50), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_50), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_50), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_50), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_50), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_50), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_50), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_50), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_50), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_50), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_50), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_50), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_50), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_50), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_50), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_50), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_50), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_50), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_50), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_50), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_50), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_50), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_50), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_50), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_50), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e74_50), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
#endif
{ CPUFUNC(op_4e75_50), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_50), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_50), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7a_50), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_4e7b_50), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
#endif
{ CPUFUNC(op_4e90_50), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_50), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_50), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_50), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_50), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_50), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_50), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_50), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_50), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_50), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_50), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_50), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_50), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_50), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_50), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_50), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_50), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_50), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_50), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_50), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_50), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_50), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_50), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_50), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_50), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_50), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_50), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_50), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_50), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_50), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_50), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_50), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_50), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_50), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_50), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_50), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_50), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_50), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_50), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_50), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_50), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_50), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_50), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_50), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_50), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_50), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_50), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_50), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_50), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fa_50), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fb_50), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_50fc_50), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5100_50), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_50), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_50), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_50), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_50), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_50), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_50), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_50), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_50), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_50), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_50), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_50), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_50), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_50), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_50), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_50), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_50), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_50), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_50), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_50), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_50), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_50), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_50), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_50), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_50), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_50), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_50), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_50), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_50), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_50), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_50), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_50), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_50), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_50), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_50), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fa_50), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fb_50), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_51fc_50), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_52c0_50), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_50), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_50), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_50), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_50), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_50), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_50), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_50), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_50), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fa_50), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fb_50), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_52fc_50), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_53c0_50), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_50), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_50), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_50), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_50), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_50), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_50), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_50), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_50), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fa_50), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fb_50), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_53fc_50), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_54c0_50), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_50), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_50), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_50), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_50), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_50), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_50), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_50), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_50), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fa_50), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fb_50), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_54fc_50), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_55c0_50), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_50), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_50), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_50), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_50), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_50), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_50), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_50), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_50), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fa_50), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fb_50), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_55fc_50), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_56c0_50), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_50), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_50), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_50), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_50), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_50), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_50), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_50), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_50), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fa_50), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fb_50), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_56fc_50), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_57c0_50), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_50), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_50), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_50), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_50), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_50), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_50), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_50), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_50), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fa_50), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fb_50), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_57fc_50), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_58c0_50), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_50), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_50), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_50), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_50), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_50), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_50), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_50), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_50), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fa_50), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fb_50), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_58fc_50), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_59c0_50), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_50), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_50), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_50), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_50), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_50), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_50), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_50), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_50), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fa_50), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fb_50), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_59fc_50), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ac0_50), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_50), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_50), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_50), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_50), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_50), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_50), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_50), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_50), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afa_50), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afb_50), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5afc_50), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5bc0_50), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_50), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_50), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_50), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_50), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_50), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_50), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_50), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_50), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfa_50), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfb_50), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5bfc_50), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5cc0_50), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_50), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_50), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_50), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_50), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_50), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_50), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_50), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_50), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfa_50), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfb_50), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5cfc_50), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5dc0_50), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_50), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_50), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_50), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_50), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_50), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_50), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_50), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_50), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfa_50), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfb_50), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5dfc_50), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5ec0_50), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_50), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_50), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_50), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_50), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_50), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_50), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_50), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_50), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efa_50), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efb_50), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5efc_50), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_5fc0_50), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_50), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_50), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_50), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_50), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_50), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_50), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_50), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_50), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffa_50), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffb_50), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_5ffc_50), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
#endif
{ CPUFUNC(op_6000_50), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_50), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_50), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_50), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_50), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_50), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_50), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_50), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_50), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_50), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_50), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_50), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_50), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_50), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_50), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_50), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_50), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_50), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_50), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_50), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_50), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_50), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_50), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_50), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_50), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_50), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_50), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_50), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_50), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_50), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_50), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_50), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_50), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_50), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_50), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_50), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_50), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_50), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_50), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_50), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_50), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_50), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_50), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_50), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_50), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_50), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_50), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_50), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_50), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_50), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_50), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_50), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_50), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_50), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_50), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_50), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_50), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_50), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_50), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_50), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_50), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_50), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_50), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_50), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_50), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_50), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_50), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_50), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_50), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_50), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_50), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_50), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_50), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_50), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_50), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_50), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_50), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_50), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_50), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_50), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_50), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_50), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_50), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_50), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_50), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_50), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_50), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_50), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_50), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_50), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_50), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_50), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_50), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_50), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_50), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_50), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_50), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_50), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_50), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_50), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_50), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_50), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8140_50), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8148_50), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
#endif
{ CPUFUNC(op_8150_50), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_50), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_50), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_50), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_50), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_50), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_50), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8180_50), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_8188_50), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
#endif
{ CPUFUNC(op_8190_50), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_50), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_50), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_50), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_50), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_50), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_50), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_50), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_50), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_50), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_50), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_50), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_50), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_50), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_50), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_50), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_50), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_50), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_50), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_50), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_50), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_50), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_50), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_50), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_50), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_50), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_50), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_50), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_50), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_50), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_50), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_50), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_50), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_50), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_50), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_50), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_50), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_50), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_50), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_50), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_50), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_50), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_50), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_50), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_50), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_50), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_50), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_50), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_50), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_50), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_50), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_50), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_50), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_50), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_50), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_50), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_50), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_50), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_50), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_50), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_50), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_50), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_50), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_50), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_50), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_50), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_50), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_50), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_50), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_50), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_50), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_50), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_50), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_50), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_50), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_50), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_50), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_50), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_50), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_50), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_50), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_50), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_50), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_50), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_50), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_50), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_50), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_50), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_50), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_50), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_50), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_50), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_50), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_50), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_50), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_50), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_50), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_50), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_50), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_50), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_50), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_50), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_50), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_50), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_50), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_50), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_50), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_50), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_50), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_50), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_50), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_50), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_50), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_50), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_50), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_50), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_50), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_50), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_50), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_50), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_50), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_50), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_50), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_50), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_50), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_50), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_50), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_50), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_50), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_50), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_50), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_50), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_50), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_50), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_50), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_50), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_50), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_50), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_50), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_50), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_50), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_50), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_50), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_50), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_50), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_50), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_50), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_50), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_50), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_50), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_50), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_50), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_50), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_50), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_50), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_50), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_50), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_50), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_50), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_50), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_50), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_50), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_50), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_50), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_50), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_50), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_50), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_50), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_50), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_50), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_50), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_50), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_50), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_50), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_50), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_50), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_50), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_50), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_50), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_50), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_50), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_50), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_50), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_50), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_50), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_50), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_50), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_50), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_50), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_50), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_50), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_50), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_50), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_50), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_50), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_50), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_50), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_50), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_50), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_50), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_50), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_50), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_50), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_50), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_50), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_50), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_50), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_50), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_50), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_50), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_50), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_50), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_50), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_50), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_50), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_50), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_50), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_50), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_50), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_50), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_50), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_50), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_50), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_50), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_50), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_50), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_50), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_50), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_50), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_50), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_50), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_50), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_50), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_50), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_50), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_50), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_50), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_50), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_50), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_50), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_50), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_50), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_50), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_50), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_50), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_50), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_50), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_50), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_50), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_50), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_50), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_50), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_50), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_50), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_50), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_50), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_50), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_50), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_50), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_50), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_50), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_50), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_50), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_50), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_50), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_50), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_50), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_50), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_50), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_50), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_50), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_50), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_50), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_50), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_50), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_50), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_50), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_50), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_50), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_50), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_50), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_50), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_50), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_50), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_50), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_50), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_50), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_50), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_50), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_50), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_50), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_50), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_50), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_50), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_50), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_50), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_50), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_50), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_50), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_50), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_50), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_50), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_50), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_50), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_50), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_50), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_50), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_50), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_50), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_50), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_50), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_50), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_50), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_50), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_50), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_50), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_50), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_50), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_50), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_50), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_50), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_50), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_50), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_50), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_50), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_50), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_50), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_50), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_50), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_50), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_50), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_50), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_50), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_50), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_50), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_50), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_50), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_50), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_50), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_50), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_50), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_50), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_50), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_50), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_50), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_50), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_50), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_50), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_50), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_50), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_50), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_50), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_50), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_50), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_50), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_50), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_50), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_50), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_50), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_50), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_50), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_50), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_50), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_50), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_50), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_50), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_50), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_50), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_50), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_50), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_50), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_50), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_50), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_50), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_50), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_50), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_50), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_50), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_50), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_50), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_50), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_50), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_50), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_50), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_50), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_50), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_50), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_50), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_50), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_50), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_50), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_50), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_50), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_50), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_50), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_50), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_50), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_50), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_50), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_50), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_50), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_50), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_50), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_50), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_50), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_50), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_50), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_50), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_50), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_50), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_50), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_50), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_50), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_50), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_50), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_50), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_50), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_50), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_50), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_50), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_50), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_50), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_50), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_50), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_50), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_50), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_50), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_50), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_50), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_50), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_50), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_50), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_50), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_50), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_50), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_50), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_50), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_50), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_50), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_50), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_50), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_50), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_50), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_50), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_50), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_50), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_50), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_50), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_50), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_50), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_50), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_50), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_50), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_50), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_50), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_50), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_50), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_50), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_50), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_50), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_50), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8c0_50), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8d0_50), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8e8_50), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f0_50), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f8_50), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8f9_50), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fa_50), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e8fb_50), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9c0_50), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9d0_50), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9e8_50), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f0_50), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f8_50), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9f9_50), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fa_50), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_e9fb_50), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eac0_50), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ead0_50), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eae8_50), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf0_50), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf8_50), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eaf9_50), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebc0_50), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebd0_50), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebe8_50), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf0_50), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf8_50), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebf9_50), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfa_50), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ebfb_50), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecc0_50), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecd0_50), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ece8_50), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf0_50), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf8_50), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ecf9_50), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edc0_50), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edd0_50), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_ede8_50), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf0_50), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf8_50), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edf9_50), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfa_50), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_edfb_50), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eec0_50), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eed0_50), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eee8_50), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef0_50), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef8_50), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eef9_50), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efc0_50), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efd0_50), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_efe8_50), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff0_50), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff8_50), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_eff9_50), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f000_50), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f008_50), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f010_50), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f018_50), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f020_50), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f028_50), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f030_50), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f038_50), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f039_50), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f200_50), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f208_50), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f210_50), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f218_50), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f220_50), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f228_50), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f230_50), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f238_50), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f239_50), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23a_50), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23b_50), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f23c_50), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f240_50), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f248_50), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f250_50), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f258_50), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f260_50), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f268_50), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f270_50), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f278_50), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f279_50), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27a_50), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27b_50), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f27c_50), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f280_50), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f2c0_50), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f310_50), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f320_50), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f328_50), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f330_50), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f338_50), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f339_50), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f350_50), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f358_50), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f368_50), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f370_50), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f378_50), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f379_50), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37a_50), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f37b_50), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f408_50), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f410_50), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f418_50), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f419_50), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41a_50), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41b_50), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41c_50), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41d_50), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41e_50), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f41f_50), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f428_50), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f430_50), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f438_50), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f439_50), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43a_50), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43b_50), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43c_50), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43d_50), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43e_50), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f43f_50), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f500_50), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f508_50), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f510_50), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f518_50), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f548_50), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f568_50), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f588_50), 0xf588, -1, { 0, 0 }, 0 }, /* PLPAW */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f5c8_50), 0xf5c8, -1, { 0, 0 }, 0 }, /* PLPAR */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f600_50), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f608_50), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f610_50), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f618_50), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f620_50), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
#endif
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_f800_50), 0xf800, -1, { 0, 0 }, 0 }, /* LPSTOP */
#endif
{ 0, 0 }};
#endif /* CPUEMU_50 */
#ifdef CPUEMU_50
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_51)[] = {
{ CPUFUNC(op_0000_50), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_50), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_50), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_50), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_50), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_50), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_50), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_50), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_50), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_50), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_50), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_50), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_50), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_50), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_50), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_50), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_50), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_50), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_50), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_50), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_50), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_50), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_50), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_50), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_50), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_50), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_50), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_50), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_50), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_50), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_50), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_50), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_50), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_50), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_50), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_50), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_50), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_50), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_50), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_50), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_50), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_50), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_50), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_50), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_50), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_50), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_50), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_50), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_50), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_50), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_50), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_50), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_50), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_50), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_50), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_50), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_50), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_50), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_50), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_50), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_50), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_50), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_50), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_50), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_50), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_50), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_50), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_50), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_50), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_50), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_50), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_50), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_50), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_50), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_50), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_50), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_50), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_50), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_50), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_50), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_50), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_50), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_50), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_50), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_50), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_50), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_50), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_50), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_50), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_50), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_50), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_50), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_50), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_50), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_50), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_50), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_50), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_50), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_50), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_50), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_50), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_50), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_50), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_50), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_50), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_50), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_50), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_50), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_50), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_50), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_50), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_50), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_50), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_50), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_50), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_50), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_50), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_50), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_50), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_50), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_50), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_50), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_50), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_50), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_50), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_50), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_50), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_50), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_50), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_50), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_50), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_50), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_50), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_50), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_50), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_50), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_50), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_50), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_50), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_50), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_50), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_50), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_50), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_50), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_50), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_50), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_50), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_50), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_50), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_50), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_50), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_50), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_50), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_50), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_50), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_50), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_50), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_50), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_50), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_50), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_50), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_50), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_50), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_50), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_50), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_50), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_50), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_50), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_50), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_50), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_50), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_50), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_50), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_50), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_50), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_50), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_50), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_50), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_50), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_50), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_50), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_50), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_50), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_50), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_50), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_50), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_50), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_50), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_50), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_50), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_50), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_50), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_50), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_50), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_50), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_50), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_50), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_50), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_50), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_50), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_50), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_50), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_50), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_50), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_50), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_50), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_50), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_50), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_50), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_50), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_50), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_50), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_50), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_50), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_50), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_50), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_50), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_50), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_50), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_50), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_50), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_50), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_50), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_50), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_50), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_50), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_50), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_50), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_50), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_50), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_50), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_50), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_50), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_50), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_50), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_50), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_50), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_50), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_50), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_50), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_50), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_50), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_50), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_50), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_50), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_50), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_50), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_50), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_50), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_50), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_50), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_50), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_50), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_50), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_50), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_50), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_50), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_50), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_50), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_50), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_50), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_50), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_50), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_50), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_50), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_50), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_50), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_50), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_50), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_50), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_50), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_50), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_50), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_50), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_50), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_50), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_50), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_50), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_50), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_50), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_50), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_50), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_50), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_50), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_50), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_50), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_50), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_50), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_50), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_50), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_50), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_50), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_50), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_50), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_50), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_50), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_50), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_50), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_50), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_50), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_50), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_50), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_50), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_50), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_50), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_50), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_50), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_50), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_50), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_50), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_50), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_50), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_50), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_50), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_50), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_50), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_50), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_50), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_50), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_50), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_50), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_50), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_50), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_50), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_50), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_50), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_50), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_50), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_50), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_50), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_50), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_50), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_50), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_50), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_50), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_50), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_50), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_50), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_50), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_50), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_50), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_50), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_50), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_50), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_50), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_50), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_50), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_50), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_50), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_50), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_50), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_50), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_50), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_50), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_50), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_50), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_50), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_50), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_50), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_50), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_50), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_50), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_50), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_50), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_50), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_50), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_50), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_50), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_50), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_50), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_50), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_50), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_50), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_50), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_50), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_50), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_50), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_50), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_50), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_50), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_50), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_50), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_50), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_50), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_50), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_50), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_50), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_50), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_50), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_50), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_50), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_50), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_50), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_50), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_50), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_50), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_50), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_50), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_50), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_50), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_50), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_50), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_50), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_50), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_50), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_50), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_50), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_50), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_50), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_50), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_50), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_50), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_50), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_50), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_50), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_50), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_50), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_50), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_50), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_50), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_50), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_50), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_50), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_50), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_50), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_50), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_50), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_50), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_50), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_50), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_50), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_50), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_50), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_50), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_50), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_50), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_50), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_50), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_50), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_50), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_50), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_50), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_50), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_50), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_50), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_50), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_50), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_50), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_50), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_50), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_50), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_50), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_50), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_50), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_50), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_50), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_50), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_50), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_50), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_50), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_50), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_50), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_50), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_50), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_50), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_50), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_50), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_50), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_50), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_50), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_50), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_50), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_50), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_50), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_50), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_50), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_50), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_50), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_50), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_50), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_50), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_50), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_50), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_50), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_50), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_50), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_50), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_50), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_50), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_50), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_50), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_50), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_50), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_50), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_50), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_50), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_50), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_50), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_50), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_50), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_50), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_50), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_50), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_50), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_50), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_50), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_50), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_50), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_50), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_50), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_50), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_50), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_50), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_50), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_50), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_50), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_50), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_50), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_50), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_50), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_50), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_50), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_50), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_50), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_50), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_50), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_50), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_50), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_50), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_50), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_50), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_50), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_50), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_50), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_50), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_50), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_50), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_50), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_50), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_50), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_50), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_50), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_50), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_50), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_50), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_50), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_50), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_50), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_50), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_50), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_50), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_50), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_50), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_50), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_50), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_50), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_50), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_50), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_50), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_50), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_50), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_50), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_50), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_50), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_50), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_50), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_50), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_50), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_50), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_50), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_50), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_50), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_50), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_50), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_50), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_50), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_50), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_50), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_50), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_50), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_50), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_50), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_50), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_50), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_50), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_50), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_50), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_50), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_50), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_50), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_50), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_50), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_50), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_50), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_50), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_50), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_50), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_50), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_50), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_50), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_50), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_50), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_50), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_50), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_50), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_50), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_50), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_50), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_50), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_50), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_50), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_50), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_50), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_50), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_50), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_50), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_50), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_50), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_50), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_50), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_50), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_50), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_50), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_50), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_50), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_50), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_50), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_50), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_50), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_50), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_50), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_50), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_50), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_50), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_50), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_50), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_50), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_50), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_50), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_50), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_50), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_50), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_50), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_50), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_50), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_50), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_50), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_50), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_50), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_50), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_50), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_50), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_50), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_50), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_50), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_50), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_50), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_50), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_50), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_50), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_50), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_50), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_50), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_50), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_50), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_50), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_50), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_50), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_50), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_50), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_50), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_50), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_50), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_50), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_50), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_50), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_50), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_50), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_50), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_50), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_50), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_50), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_50), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_50), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_50), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_50), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_50), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_50), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_50), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_50), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_50), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_50), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_50), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_50), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_50), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_50), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_50), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_50), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_50), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_50), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_50), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_50), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_50), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_50), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_50), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_50), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_50), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_50), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_50), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_50), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_50), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_50), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_50), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_50), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_50), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_50), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_50), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_50), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_50), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_50), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_50), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_50), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_50), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_50), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_50), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_50), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_50), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_50), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_50), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_50), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_50), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_50), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_50), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_50), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_50), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_50), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_50), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_50), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_50), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_50), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_50), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_50), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_50), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_50), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_50), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_50), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_50), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_50), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_50), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_50), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_50), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_50), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_50), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_50), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_50), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_50), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_50), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_50), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_50), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_50), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_50), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_50), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_50), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_50), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_50), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_50), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_50), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_50), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_50), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_50), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_50), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_50), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_50), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_50), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_50), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_50), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_50), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_50), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_50), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_50), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_50), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_50), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_50), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_50), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_50), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_50), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_50), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_50), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_50), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_50), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_50), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_50), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_50), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_50), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_50), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_50), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_50), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_50), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_50), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_50), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_50), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_50), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_50), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_50), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_50), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_50), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_50), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_50), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_50), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_50), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_50), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_50), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_50), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_50), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_50), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_50), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_50), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_50), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_50), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_50), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_50), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_50), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_50), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_50), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_50), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_50), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_50), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_50), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_50), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_50), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_50), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_50), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_50), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_50), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_50), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_50), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_50), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_50), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_50), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_50), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_50), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_50), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_50), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_50), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_50), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_50), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_50), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_50), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_50), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_50), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_50), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_50), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_50), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_50), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_50), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_50), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_50), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_50), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_50), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_50), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_50), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_50), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_50), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_50), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_50), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_50), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_50), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_50), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_50), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_50), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_50), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_50), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_50), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_50), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_50), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_50), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_50), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_50), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_50), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_50), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_50), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_50), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_50), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_50), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_50), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_50), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_50), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_50), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_50), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_50), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_50), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_50), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_50), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_50), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_50), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_50), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_50), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_50), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_50), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_50), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_50), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_50), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_50), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_50), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_50), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_50), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_50), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_50), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_50), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_50), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_50), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_50), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_50), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_50), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_50), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_50), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_50), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_50), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_50), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_50), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_50), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_50), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_50), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_50), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_50), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_50), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_50), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_50), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_50), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_50), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_50), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_50), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_50), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_50), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_50), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_50), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_50), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_50), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_50), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_50), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_50), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_50), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_50), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_50), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_50), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_50), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_50), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_50), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_50), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_50), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_50), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_50), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_50), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_50), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_50), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_50), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_50), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_50), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_50), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_50), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_50), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_50), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_50), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_50), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_50), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_50), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_50), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_50), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_50), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_50), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_50), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_50), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_50), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_50), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_50), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_50), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_50), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_50), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_50), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_50), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_50), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_50), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_50), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_50), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_50), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_50), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_50), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_50), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_50), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_50), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_50), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_50), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_50), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_50), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_50), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_50), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_50), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_50), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_50), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_50), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_50), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_50), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_50), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_50), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_50), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_50), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_50), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_50), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_50), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_50), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_50), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_50), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_50), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_50), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_50), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_50), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_50), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_50), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_50), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_50), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_50), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_50), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_50), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_50), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_50), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_50), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_50), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_50), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_50), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_50), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_50), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_50), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_50), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_50), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_50), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_50), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_50), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_50), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_50), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_50), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_50), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_50), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_50), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_50), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_50), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_50), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_50), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_50), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_50), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_50), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_50), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_50), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_50), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_50), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_50), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_50), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_50), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_50), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_50), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_50), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_50), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_50), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_50), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_50), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_50), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_50), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_50), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_50), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_50), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_50), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_50), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_50), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_50), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_50), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_50), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_50), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_50), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_50), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_50), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_50), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_50), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_50), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_50), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_50), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_50), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_50), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_50), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_50), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_50), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_50), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_50), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_50), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_50), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_50), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_50), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_50), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_50), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_50), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_50), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_50), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_50), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_50), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_50), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_50), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_50), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_50), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_50), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_50), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_50), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_50), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_50), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_50), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_50), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_50), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_50), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_50), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_50), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_50), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_50), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_50), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_50), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_50), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_50), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_50), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_50), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_50), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_50), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_50), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_50), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_50), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_50), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_50), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_50), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_50), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_50), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_50), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_50), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_50), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_50), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_50), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_50), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_50), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_50), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_50), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_50), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_50), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_50), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_50), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_50), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_50), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_50), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_50), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_50), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_50), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_50), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_50), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_50), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_50), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_50), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_50), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_50), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_50), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_50), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_50), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_50), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_50), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_50), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_50), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_50), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_50), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_50), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_50), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_50), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_50), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_50), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_50), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_50), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_50), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_50), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_50), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_50), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_50), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_50), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_50), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_50), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_50), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_50), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_50), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_50), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_50), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_50), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_50), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_50), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_50), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_50), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_50), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_50), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_50), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_50), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_50), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_50), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_50), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_50), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_50), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_50), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_50), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_50), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_50), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_50), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_50), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_50), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_50), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_50), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_50), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_50), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_50), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_50), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_50), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_50), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_50), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_50), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_50), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_50), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_50), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_50), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_50), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_50), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_50), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_50), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_50), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_50), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_50), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_50), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_50), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_50), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_50), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_50), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_50), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_50), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_50), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_50), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_50), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_50), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_50), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_50), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_50), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_50), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_50), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_50), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_50), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_50), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_50), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_50), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_50), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_50), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_50), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_50), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_50), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_50), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_50), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_50), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_50), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_50), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_50), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_50), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_50), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_50), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_50), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_50), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_50), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_50), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_50), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_50), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_50), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_50), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_50), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_50), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_50), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_50), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_50), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_50), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_50), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_50), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_50), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_50), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_50), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_50), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_50), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_50), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_50), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_50), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_50), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_50), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_50), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_50), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_50), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_50), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_50), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_50), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_50), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_50), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_50), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_50), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_50), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_50), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_50), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_50), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_50), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_50), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_50), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_50), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_50), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_50), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_50), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_50), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_50), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_50), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_50), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_50), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_50), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_50), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_50), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_50), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_50), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_50), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_50), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_50), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_50), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_50), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_50), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_50), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_50), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_50), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_50), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_50), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_50), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_50), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_50), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_50), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_50), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_50), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_50), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_50), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_50), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_50), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_50), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_50), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_50), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_50), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_50), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_50), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_50), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_50), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_50), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_50), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_50), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_50), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_50), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_50), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_50), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_50), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_50), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_50), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_50), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_50), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_50), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_50), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_50), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_50), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_50), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_50), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_50), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_50), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_50), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_50), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_50), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_50), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_50), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_50), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_50), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_50), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_50), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_50), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_50), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_50), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_50), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_50), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_50), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_50), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_50), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_50), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_50), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_50), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_50), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_50), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_50), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_50), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_50), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_50), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_50), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_50), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_50), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_50), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_50), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_50), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_50), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_50), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_50), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_50), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_50), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_50), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_50), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_50), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_50), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_50), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_50), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_50), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_50), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_50), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_50), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_50), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_50), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_50), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_50), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_50), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_50), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_50), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_50), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_50), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_50), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_50), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_50), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_50), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_50), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_50), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_50), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_50), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_50), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_50), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_50), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_50), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_50), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_50), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_50), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_50), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_50), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_50), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_50), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_50), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_50), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_50), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_50), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_50), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_50), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_50), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_50), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_50), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_50), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_50), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_50), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_50), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_50), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_50), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_50), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_50), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_50), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_50), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_50), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_50), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_50), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_50), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_50), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_50), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_50), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_50), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_50), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_50), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_50), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_50), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_50), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_50), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_50), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_50), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_50), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_50), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_50), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_50), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_50), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_50), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_50), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_50), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_50), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_50), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_50), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_50), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_50), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_50), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_50), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_50), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_50), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_50), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_50), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_50), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_50), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_50), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_50), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_50), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_50), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_50), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_50), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_50), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_50), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_50), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_50), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_50), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_50), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_50), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_50), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_50), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_50), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_50), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_50), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_50), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_50), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_50), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_50), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_50), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_50), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_50), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_50), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_50), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_50), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_50), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_50), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_50), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_50), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_50), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_50), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_50), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_50), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_50), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_50), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_50), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_50), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_50), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_50), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_50), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_50), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_50), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_50), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_50), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_50), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_50), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_50), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_50), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_50), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_50), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_50), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_50), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_50), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_50), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_50), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_50), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_50), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_50), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_50), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_50), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_50), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_50), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_50), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_50), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_50), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_50), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_50), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_50), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_50), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_50), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_50), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_50), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_50), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_50), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_50), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_50), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_50), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_50), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_50), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_50), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_50), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_50), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_50), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_50), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_50), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_50), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_50), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_50), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_50), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_50), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_50), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_50), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_50), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_50), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_50), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_50), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_50), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_50), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_50), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_50), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_50), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_50), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_50), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_50), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_50), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_50), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_50), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_50), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_50), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_50), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_50), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_50), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_50), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_50), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_50), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_50), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_50), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_50), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_50), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_50), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_50), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_50), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_50), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_50), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_50), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_50), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_50), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_50), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_50), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_50), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_50), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_50), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_50), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_50), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_50), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_50), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_50), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_50), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_50), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_50), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_50), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_50), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_50), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_50), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_50), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_50), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_50), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_50), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_50), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_50), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_50), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_50), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_50), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_50), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_50), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_50), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_50), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_50), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_50), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_50), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_50), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_50), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_50), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_50), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_50), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_50), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_50), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_50), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_50), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_50), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_50), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_50), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_50), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_50), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_50), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_50), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_50), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_50), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_50), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_50), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_50), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_50), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_50), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_50), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_50), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_50), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_50), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_50), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_50), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_50), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_50), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_50), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_50), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_50), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_50), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_50), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_50), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_50), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_50), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_50), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_50), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_50), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_50), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_50), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_50), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_50), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_50), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_50), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_50), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_50), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_50), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_50), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_50), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_50), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_50), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_50), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_50), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_50), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_50), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_50), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_50), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_50), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_50), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_50), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_50), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_50), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_50), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_50), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_50), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_50), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_50), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_50), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_50), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_50), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_50), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_50), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_50), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_50), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_50), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_50), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_50), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_50), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_50), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_50), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_50), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_50), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_50), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_50), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_50), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_50), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_50), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_50), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_50), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_50), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_50), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_50), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_50), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_50), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_50), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_50), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_50), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_50), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_50), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_50), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_50), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_50), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_50), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_50), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_50), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_50), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_50), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_50), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_50), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_50), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_50), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_50), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_50), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_50), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_50), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_50), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f000_50), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f008_50), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f010_50), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f018_50), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f020_50), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f028_50), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f030_50), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f038_50), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f039_50), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f200_50), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_50), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_50), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_50), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_50), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_50), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_50), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_50), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_50), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_50), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_50), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_50), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_50), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_50), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_50), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_50), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_50), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_50), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_50), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_50), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_50), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_50), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_50), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_50), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_50), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_50), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_50), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_50), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_50), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_50), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_50), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_50), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_50), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_50), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_50), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_50), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_50), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_50), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_50), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_50), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f408_50), 0xf408, -1, { 0, 0 }, 0 }, /* CINVL */
{ CPUFUNC(op_f410_50), 0xf410, -1, { 0, 0 }, 0 }, /* CINVP */
{ CPUFUNC(op_f418_50), 0xf418, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f419_50), 0xf419, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41a_50), 0xf41a, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41b_50), 0xf41b, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41c_50), 0xf41c, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41d_50), 0xf41d, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41e_50), 0xf41e, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f41f_50), 0xf41f, -1, { 0, 0 }, 0 }, /* CINVA */
{ CPUFUNC(op_f428_50), 0xf428, -1, { 0, 0 }, 0 }, /* CPUSHL */
{ CPUFUNC(op_f430_50), 0xf430, -1, { 0, 0 }, 0 }, /* CPUSHP */
{ CPUFUNC(op_f438_50), 0xf438, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f439_50), 0xf439, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43a_50), 0xf43a, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43b_50), 0xf43b, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43c_50), 0xf43c, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43d_50), 0xf43d, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43e_50), 0xf43e, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f43f_50), 0xf43f, -1, { 0, 0 }, 0 }, /* CPUSHA */
{ CPUFUNC(op_f500_50), 0xf500, -1, { 0, 0 }, 0 }, /* PFLUSHN */
{ CPUFUNC(op_f508_50), 0xf508, -1, { 0, 0 }, 0 }, /* PFLUSH */
{ CPUFUNC(op_f510_50), 0xf510, -1, { 0, 0 }, 0 }, /* PFLUSHAN */
{ CPUFUNC(op_f518_50), 0xf518, -1, { 0, 0 }, 0 }, /* PFLUSHA */
{ CPUFUNC(op_f548_50), 0xf548, -1, { 0, 0 }, 0 }, /* PTESTW */
{ CPUFUNC(op_f568_50), 0xf568, -1, { 0, 0 }, 0 }, /* PTESTR */
{ CPUFUNC(op_f600_50), 0xf600, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f608_50), 0xf608, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f610_50), 0xf610, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f618_50), 0xf618, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ CPUFUNC(op_f620_50), 0xf620, -1, { 0, 0 }, 0 }, /* MOVE16 */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_50 */
#ifdef CPUEMU_50
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_52)[] = {
{ CPUFUNC(op_0000_50), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_50), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_50), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_50), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_50), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_50), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_50), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_50), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_50), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_50), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_50), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_50), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_50), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_50), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_50), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_50), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_50), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_50), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_50), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_50), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_50), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_50), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_50), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_50), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_50), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_50), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_50), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_50), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_50), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_50), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_50), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_50), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_50), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_50), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_50), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_50), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_50), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_50), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_50), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_50), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_50), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_50), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_50), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_50), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_50), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_50), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_50), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_50), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_50), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_50), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_50), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_50), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_50), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_50), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_50), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_50), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_50), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_50), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_50), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_50), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_50), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_50), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_50), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_50), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_50), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_50), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_50), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_50), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_50), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_50), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_50), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_50), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_50), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_50), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_50), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_50), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_50), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_50), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_50), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_50), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_50), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_50), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_50), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_50), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_50), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_50), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_50), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_50), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_50), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_50), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_50), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_50), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_50), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_50), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_50), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_50), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_50), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_50), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_50), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_50), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_50), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_50), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_50), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_50), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_50), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_50), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_50), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_50), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_50), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_50), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_50), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_50), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_50), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_50), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_50), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_50), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_50), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_50), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_50), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_50), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_50), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_50), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_50), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_50), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_50), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_50), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_50), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_50), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_50), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_50), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_50), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_50), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_50), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_50), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_50), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_50), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_50), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_50), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_50), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_50), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_50), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_50), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_50), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_50), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_50), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_50), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_50), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_50), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_50), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_50), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_50), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_50), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_50), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_50), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_50), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_50), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_50), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_50), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_50), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_50), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_50), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_50), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_50), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_50), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_50), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_50), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_50), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_50), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_50), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_50), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_50), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_50), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_50), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_50), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_50), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_50), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_50), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_50), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_50), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_50), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_50), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_50), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_50), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_50), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_50), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_50), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_50), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_50), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_50), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_50), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_50), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_50), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_50), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_50), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_50), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_50), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_50), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_50), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_50), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_50), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_50), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_50), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_50), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_50), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_50), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_50), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_50), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_50), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_50), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_50), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_50), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_50), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_50), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_50), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_50), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_50), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_50), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_50), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_50), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_50), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_50), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_50), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_50), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_50), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_50), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_50), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_50), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_50), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_50), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_50), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_50), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_50), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_50), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_50), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_50), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_50), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_50), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_50), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_50), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_50), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_50), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_50), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_50), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_50), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_50), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_50), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_50), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_50), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_50), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_50), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_50), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_50), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_50), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_50), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_50), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_50), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_50), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_50), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_50), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_50), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_50), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_50), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_50), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_50), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_50), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_50), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_50), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_50), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_50), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_50), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_50), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_50), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_50), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_50), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_50), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_50), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_50), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_50), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_50), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_50), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_50), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_50), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_50), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_50), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_50), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_50), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_50), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_50), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_50), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_50), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_50), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_50), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_50), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_50), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_50), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_50), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_50), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_50), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_50), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_50), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_50), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_50), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_50), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_50), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_50), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_50), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_50), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_50), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_50), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_50), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_50), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_50), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_50), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_50), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_50), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_50), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_50), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_50), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_50), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_50), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_50), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_50), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_50), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_50), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_50), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_50), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_50), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_50), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_50), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_50), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_50), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_50), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_50), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_50), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_50), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_50), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_50), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_50), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_50), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_50), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_50), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_50), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_50), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_50), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_50), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_50), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_50), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_50), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_50), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_50), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_50), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_50), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_50), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_50), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_50), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_50), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_50), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_50), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_50), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_50), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_50), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_50), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_50), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_50), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_50), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_50), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_50), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_50), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_50), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_50), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_50), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_50), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_50), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_50), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_50), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_50), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_50), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_50), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_50), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_50), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_50), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_50), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_50), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_50), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_50), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_50), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_50), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_50), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_50), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_50), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_50), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_50), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_50), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_50), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_50), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_50), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_50), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_50), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_50), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_50), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_50), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_50), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_50), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_50), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_50), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_50), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_50), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_50), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_50), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_50), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_50), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_50), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_50), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_50), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_50), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_50), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_50), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_50), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_50), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_50), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_50), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_50), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_50), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_50), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_50), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_50), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_50), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_50), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_50), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_50), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_50), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_50), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_50), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_50), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_50), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_50), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_50), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_50), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_50), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_50), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_50), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_50), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_50), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_50), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_50), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_50), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_50), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_50), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_50), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_50), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_50), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_50), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_50), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_50), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_50), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_50), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_50), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_50), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_50), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_50), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_50), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_50), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_50), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_50), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_50), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_50), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_50), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_50), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_50), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_50), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_50), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_50), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_50), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_50), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_50), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_50), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_50), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_50), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_50), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_50), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_50), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_50), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_50), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_50), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_50), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_50), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_50), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_50), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_50), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_50), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_50), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_50), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_50), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_50), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_50), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_50), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_50), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_50), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_50), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_50), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_50), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_50), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_50), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_50), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_50), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_50), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_50), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_50), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_50), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_50), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_50), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_50), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_50), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_50), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_50), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_50), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_50), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_50), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_50), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_50), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_50), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_50), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_50), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_50), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_50), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_50), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_50), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_50), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_50), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_50), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_50), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_50), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_50), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_50), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_50), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_50), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_50), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_50), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_50), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_50), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_50), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_50), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_50), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_50), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_50), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_50), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_50), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_50), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_50), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_50), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_50), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_50), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_50), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_50), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_50), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_50), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_50), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_50), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_50), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_50), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_50), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_50), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_50), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_50), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_50), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_50), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_50), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_50), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_50), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_50), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_50), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_50), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_50), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_50), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_50), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_50), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_50), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_50), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_50), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_50), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_50), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_50), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_50), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_50), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_50), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_50), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_50), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_50), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_50), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_50), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_50), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_50), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_50), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_50), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_50), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_50), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_50), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_50), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_50), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_50), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_50), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_50), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_50), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_50), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_50), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_50), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_50), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_50), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_50), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_50), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_50), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_50), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_50), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_50), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_50), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_50), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_50), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_50), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_50), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_50), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_50), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_50), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_50), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_50), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_50), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_50), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_50), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_50), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_50), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_50), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_50), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_50), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_50), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_50), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_50), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_50), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_50), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_50), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_50), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_50), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_50), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_50), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_50), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_50), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_50), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_50), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_50), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_50), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_50), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_50), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_50), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_50), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_50), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_50), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_50), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_50), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_50), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_50), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_50), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_50), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_50), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_50), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_50), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_50), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_50), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_50), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_50), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_50), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_50), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_50), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_50), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_50), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_50), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_50), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_50), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_50), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_50), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_50), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_50), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_50), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_50), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_50), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_50), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_50), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_50), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_50), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_50), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_50), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_50), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_50), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_50), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_50), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_50), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_50), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_50), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_50), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_50), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_50), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_50), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_50), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_50), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_50), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_50), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_50), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_50), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_50), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_50), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_50), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_50), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_50), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_50), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_50), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_50), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_50), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_50), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_50), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_50), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_50), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_50), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_50), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_50), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_50), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_50), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_50), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_50), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_50), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_50), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_50), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_50), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_50), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_50), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_50), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_50), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_50), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_50), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_50), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_50), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_50), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_50), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_50), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_50), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_50), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_50), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_50), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_50), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_50), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_50), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_50), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_50), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_50), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_50), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_50), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_50), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_50), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_50), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_50), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_50), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_50), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_50), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_50), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_50), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_50), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_50), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_50), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_50), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_50), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_50), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_50), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_50), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_50), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_52), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_50), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_52), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_52), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_52), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_52), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_52), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_52), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_52), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_50), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_50), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_50), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_50), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_50), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_50), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_50), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_50), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_50), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_50), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_50), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_50), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_50), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_50), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_50), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_50), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_50), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_50), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_50), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_50), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_50), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_50), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_50), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_50), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_50), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_50), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_50), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_50), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_50), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_50), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_50), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_50), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_50), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_50), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_50), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_50), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_50), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_50), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_50), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_50), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_50), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_50), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_50), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_50), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_50), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_50), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_50), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_50), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_50), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_50), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_50), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_50), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_50), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_50), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_50), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_50), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_50), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_50), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_50), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_50), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_50), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_50), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_50), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_50), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_50), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_50), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_50), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_50), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_50), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_50), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_50), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_50), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_50), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_50), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_50), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_50), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_50), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_50), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_50), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_50), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_50), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_50), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_50), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_50), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_50), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_50), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_50), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_50), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_50), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_50), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_50), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_50), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_50), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_50), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_50), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_50), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_50), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_50), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_50), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_50), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_50), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_50), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_50), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_50), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_50), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_50), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_50), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_50), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_50), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_50), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_50), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_50), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_50), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_50), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_50), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_50), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_50), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_50), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_50), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_50), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_50), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_50), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_50), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_50), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_50), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_50), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_50), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_50), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_50), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_50), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_50), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_50), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_50), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_50), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_50), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_50), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_50), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_50), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_50), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_50), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_50), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_50), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_50), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_50), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_50), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_50), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_50), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_50), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_50), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_50), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_50), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_50), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_50), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_50), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_50), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_50), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_50), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_50), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_50), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_50), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_50), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_50), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_50), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_50), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_50), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_50), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_50), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_50), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_50), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_50), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_50), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_50), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_50), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_50), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_50), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_50), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_50), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_50), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_50), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_50), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_50), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_50), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_50), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_50), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_50), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_50), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_50), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_50), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_50), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_50), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_50), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_50), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_50), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_50), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_50), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_50), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_50), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_50), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_50), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_50), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_50), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_50), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_50), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_50), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_50), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_50), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_50), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_50), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_50), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_50), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_50), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_50), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_50), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_50), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_50), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_50), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_50), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_50), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_50), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_50), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_50), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_50), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_50), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_50), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_50), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_50), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_50), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_50), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_50), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_50), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_50), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_50), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_50), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_50), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_50), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_50), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_50), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_50), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_50), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_50), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_50), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_50), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_50), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_50), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_50), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_50), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_50), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_50), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_50), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_50), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_50), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_50), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_50), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_50), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_50), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_50), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_50), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_50), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_50), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_50), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_50), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_50), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_50), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_50), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_50), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_50), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_50), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_50), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_50), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_50), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_50), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_50), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_50), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_50), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_50), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_50), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_50), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_50), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_50), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_50), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_50), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_50), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_50), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_50), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_50), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_50), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_50), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_50), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_50), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_50), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_50), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_50), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_50), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_50), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_50), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_50), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_50), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_50), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_50), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_50), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_50), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_50), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_50), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_50), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_50), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_50), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_50), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_50), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_50), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_50), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_50), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_50), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_50), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_50), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_50), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_50), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_50), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_50), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_50), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_50), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_50), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_50), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_50), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_50), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_50), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_50), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_50), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_50), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_50), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_50), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_50), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_50), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_50), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_50), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_50), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_50), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_50), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_50), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_50), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_50), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_50), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_50), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_50), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_50), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_50), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_50), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_50), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_50), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_50), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_50), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_50), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_50), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_50), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_50), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_50), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_50), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_50), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_50), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_50), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_50), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_50), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_50), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_50), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_50), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_50), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_50), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_50), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_50), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_50), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_50), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_50), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_50), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_50), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_50), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_50), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_50), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_50), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_50), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_50), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_50), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_50), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_50), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_50), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_50), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_50), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_50), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_50), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_50), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_50), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_50), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_50), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_50), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_50), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_50), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_50), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_50), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_50), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_50), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_50), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_50), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_50), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_50), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_50), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_50), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_50), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_50), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_50), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_50), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_50), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_50), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_50), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_50), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_50), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_50), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_50), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_50), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_50), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_50), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_50), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_50), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_50), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_50), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_50), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_50), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_50), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_50), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_50), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_50), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_50), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_50), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_50), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_50), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_50), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_50), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_50), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_50), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_50), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_50), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_50), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_50), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_50), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_50), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_50), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_50), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_50), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_50), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_50), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_50), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_50), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_50), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_50), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_50), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_50), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_50), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_50), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_50), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_50), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_50), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_50), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_50), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_50), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_50), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_50), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_50), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_50), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_50), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_50), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_50), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_50), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_50), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_50), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_52), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_52), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_50), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_50), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_50), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_50), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_50), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_50), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_50), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_50), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_50), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_50), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_50), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_50), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_50), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_50), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_50), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_50), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_50), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_50), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_50), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_50), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_50), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_50), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_50), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_50), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_50), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_50), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_50), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_50), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_50), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_50), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_50), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_50), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_50), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_50), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_50), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_50), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_50), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_50), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_50), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_50), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_50), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_50), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_50), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_50), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_50), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_50), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_50), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_50), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_50), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_50), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_50), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_50), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_50), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_50), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_50), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_50), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_50), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_50), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_50), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_50), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_50), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_50), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_50), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_50), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_50), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_50), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_50), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_50), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_50), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_50), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_50), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_50), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_50), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_50), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_50), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_50), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_50), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_50), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_50), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_50), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_50), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_50), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_50), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_50), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_50), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_50), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_50), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_50), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_50), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_50), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_50), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_50), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_50), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_50), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_50), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_50), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_50), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_50), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_50), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_50), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_50), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_50), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_50), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_50), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_50), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_50), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_50), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_50), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_50), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_50), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_50), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_50), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_50), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_50), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_50), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_50), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_50), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_50), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_50), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_50), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_50), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_50), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_50), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_50), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_50), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_50), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_50), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_50), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_50), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_50), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_50), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_50), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_50), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_50), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_50), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_50), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_50), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_50), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_50), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_50), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_50), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_50), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_50), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_50), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_50), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_50), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_50), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_50), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_50), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_50), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_50), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_50), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_50), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_50), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_50), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_50), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_50), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_50), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_50), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_50), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_50), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_50), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_50), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_50), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_50), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_50), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_50), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_50), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_50), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_50), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_50), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_50), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_50), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_50), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_50), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_50), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_50), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_50), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_50), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_50), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_50), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_50), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_50), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_50), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_50), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_50), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_50), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_50), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_50), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_50), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_50), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_50), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_50), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_50), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_50), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_50), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_50), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_50), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_50), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_50), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_50), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_50), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_50), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_50), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_50), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_50), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_50), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_50), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_50), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_50), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_50), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_50), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_50), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_50), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_50), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_50), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_50), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_50), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_50), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_50), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_50), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_50), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_50), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_50), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_50), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_50), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_50), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_50), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_50), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_50), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_50), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_50), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_50), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_50), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_50), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_50), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_50), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_50), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_50), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_50), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_50), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_50), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_50), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_50), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_50), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_50), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_50), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_50), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_50), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_50), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_50), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_50), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_52), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_52), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_50), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_50), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_50), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_50), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_50), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_50), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_50), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_50), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_50), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_50), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_50), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_50), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_50), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_50), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_50), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_50), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_50), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_50), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_50), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_50), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_50), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_50), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_50), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_50), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_50), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_50), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_50), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_50), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_50), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_50), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_50), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_50), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_50), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_50), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_50), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_50), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_50), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_50), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_50), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_50), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_50), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_50), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_50), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_50), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_50), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_50), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_50), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_50), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_50), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_50), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_50), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_50), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_50), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_50), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_50), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_50), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_50), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_50), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_50), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_50), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_50), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_50), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_50), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_50), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_50), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_50), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_50), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_50), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_50), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_50), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_50), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_50), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_50), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_50), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_50), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_50), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_50), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_50), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_50), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_50), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_50), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_50), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_50), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_50), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_50), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_50), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_50), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_50), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_50), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_50), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_50), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_50), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_50), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_50), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_50), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_50), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_50), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_50), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_50), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_50), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_50), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_50), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_50), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_50), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_50), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_50), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_50), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_50), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_50), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_50), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_50), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_50), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_50), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_50), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_50), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_50), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_50), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_50), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_50), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_50), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_50), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_50), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_50), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_50), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_50), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_50), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_50), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_50), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_50), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_50), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_50), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_50), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_50), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_50), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_50), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_50), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_50), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_50), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_50), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_50), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_50), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_50), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_50), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_50), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_50), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_50), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_50), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_50), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_50), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_50), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_50), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_50), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_50), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_50), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_50), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_50), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_50), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_50), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_50), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_50), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_50), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_50), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_50), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_50), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_50), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_50), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_50), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_50), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_50), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_50), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_50), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_50), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_50), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_50), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_50), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_50), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_50), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_50), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_50), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_50), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_50), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_50), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_50), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_50), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_50), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_50), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_50), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_50), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_50), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_50), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_50), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_50), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_50), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_50), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_50), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_50), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_50), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_50), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_50), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_50), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_50), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_50), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_50), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_50), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_50), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_50), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_50), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_50), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_50), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_50), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_50), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_50), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_50), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_50), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_50), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_50), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_50), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_50), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_50), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_50), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_50), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_50), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_50), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_50), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_50), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_50), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_50), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_50), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_50), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_50), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_50), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_50), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_50), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_50), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_50), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_50), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_50), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_50), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_50), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_50), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_50), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_50), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_50), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_50), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_50), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_50), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_50), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_50), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_50), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_50), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_50), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_50), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_50), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_50), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_50), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_50), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_50), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_50), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_50), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_50), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_50), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_50), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_50), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_50), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_50), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_50), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_50), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_50), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_50), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_50), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_50), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_50), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_50), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_50), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_50), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_50), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_50), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_50), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_50), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_50), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_50), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f000_50), 0xf000, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f008_50), 0xf008, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f010_50), 0xf010, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f018_50), 0xf018, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f020_50), 0xf020, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f028_50), 0xf028, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f030_50), 0xf030, -1, { -3, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f038_50), 0xf038, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f039_50), 0xf039, -1, { 0, 0 }, 0 }, /* MMUOP030 */
{ CPUFUNC(op_f200_50), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_50), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_50), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_50), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_50), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_50), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_50), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_50), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_50), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_50), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_50), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_50), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_50), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_50), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_50), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_50), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_50), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_50), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_50), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_50), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_50), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_50), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_50), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_50), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_50), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_50), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_50), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_50), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_50), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_50), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_50), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_50), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_50), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_50), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_50), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_50), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_50), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_50), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_50), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_50), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_50 */
#ifdef CPUEMU_50
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_53)[] = {
{ CPUFUNC(op_0000_50), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_50), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_50), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_50), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_50), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_50), 0x0030, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_50), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_50), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_50), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_50), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_50), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_50), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_50), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_50), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_50), 0x0070, 4, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_50), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_50), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_50), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_50), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_50), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_50), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_50), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_50), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_50), 0x00b0, 6, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_50), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_50), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00d0_50), 0x00d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00e8_50), 0x00e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f0_50), 0x00f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f8_50), 0x00f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00f9_50), 0x00f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fa_50), 0x00fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_00fb_50), 0x00fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0100_50), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_50), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_50), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_50), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_50), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_50), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_50), 0x0130, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_50), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_50), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_50), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_50), 0x013b, 2, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_50), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_50), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_50), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_50), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_50), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_50), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_50), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_50), 0x0170, 2, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_50), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_50), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_50), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_50), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_50), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_50), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_50), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_50), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_50), 0x01b0, 2, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_50), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_50), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_50), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_50), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_50), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_50), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_50), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_50), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_50), 0x01f0, 2, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_50), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_50), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_50), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_50), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_50), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_50), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_50), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_50), 0x0230, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_50), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_50), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_50), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_50), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_50), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_50), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_50), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_50), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_50), 0x0270, 4, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_50), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_50), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_50), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_50), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_50), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_50), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_50), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_50), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_50), 0x02b0, 6, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_50), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_50), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02d0_50), 0x02d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02e8_50), 0x02e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f0_50), 0x02f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f8_50), 0x02f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02f9_50), 0x02f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fa_50), 0x02fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_02fb_50), 0x02fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0400_50), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_50), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_50), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_50), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_50), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_50), 0x0430, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_50), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_50), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_50), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_50), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_50), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_50), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_50), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_50), 0x0470, 4, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_50), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_50), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_50), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_50), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_50), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_50), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_50), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_50), 0x04b0, 6, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_50), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_50), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04d0_50), 0x04d0, 4, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04e8_50), 0x04e8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f0_50), 0x04f0, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f8_50), 0x04f8, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04f9_50), 0x04f9, 8, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fa_50), 0x04fa, 6, { 0, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_04fb_50), 0x04fb, 4, { 2, 0 }, 0 }, /* CHK2 */
{ CPUFUNC(op_0600_50), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_50), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_50), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_50), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_50), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_50), 0x0630, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_50), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_50), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_50), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_50), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_50), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_50), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_50), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_50), 0x0670, 4, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_50), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_50), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_50), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_50), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_50), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_50), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_50), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_50), 0x06b0, 6, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_50), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_50), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06c0_50), 0x06c0, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06c8_50), 0x06c8, 2, { 0, 0 }, 0 }, /* RTM */
{ CPUFUNC(op_06d0_50), 0x06d0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06e8_50), 0x06e8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f0_50), 0x06f0, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f8_50), 0x06f8, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06f9_50), 0x06f9, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fa_50), 0x06fa, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_06fb_50), 0x06fb, 2, { 0, 0 }, 0 }, /* CALLM */
{ CPUFUNC(op_0800_50), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_50), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_50), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_50), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_50), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_50), 0x0830, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_50), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_50), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_50), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_50), 0x083b, 4, { 2, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_50), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_50), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_50), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_50), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_50), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_50), 0x0870, 4, { 2, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_50), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_50), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_50), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_50), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_50), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_50), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_50), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_50), 0x08b0, 4, { 2, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_50), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_50), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_50), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_50), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_50), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_50), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_50), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_50), 0x08f0, 4, { 2, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_50), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_50), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_50), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_50), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_50), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_50), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_50), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_50), 0x0a30, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_50), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_50), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_50), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_50), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_50), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_50), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_50), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_50), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_50), 0x0a70, 4, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_50), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_50), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_50), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_50), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_50), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_50), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_50), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_50), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_50), 0x0ab0, 6, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_50), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_50), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ad0_50), 0x0ad0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ad8_50), 0x0ad8, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae0_50), 0x0ae0, 4, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ae8_50), 0x0ae8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af0_50), 0x0af0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af8_50), 0x0af8, 6, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0af9_50), 0x0af9, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0c00_50), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_50), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_50), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_50), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_50), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_50), 0x0c30, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_50), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_50), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3a_50), 0x0c3a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c3b_50), 0x0c3b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_50), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_50), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_50), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_50), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_50), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_50), 0x0c70, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_50), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_50), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7a_50), 0x0c7a, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c7b_50), 0x0c7b, 4, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_50), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_50), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_50), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_50), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_50), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_50), 0x0cb0, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_50), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_50), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cba_50), 0x0cba, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cbb_50), 0x0cbb, 6, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cd0_50), 0x0cd0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cd8_50), 0x0cd8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce0_50), 0x0ce0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ce8_50), 0x0ce8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf0_50), 0x0cf0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf8_50), 0x0cf8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cf9_50), 0x0cf9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0cfc_50), 0x0cfc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_0e10_50), 0x0e10, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e18_50), 0x0e18, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e20_50), 0x0e20, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e28_50), 0x0e28, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e30_50), 0x0e30, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e38_50), 0x0e38, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e39_50), 0x0e39, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e50_50), 0x0e50, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e58_50), 0x0e58, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e60_50), 0x0e60, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e68_50), 0x0e68, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e70_50), 0x0e70, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e78_50), 0x0e78, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e79_50), 0x0e79, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e90_50), 0x0e90, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0e98_50), 0x0e98, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea0_50), 0x0ea0, 4, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ea8_50), 0x0ea8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb0_50), 0x0eb0, 8, { 6, 2 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb8_50), 0x0eb8, 6, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0eb9_50), 0x0eb9, 8, { 0, 0 }, 0 }, /* MOVES */
{ CPUFUNC(op_0ed0_50), 0x0ed0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ed8_50), 0x0ed8, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee0_50), 0x0ee0, 8, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ee8_50), 0x0ee8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef0_50), 0x0ef0, 4, { 2, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef8_50), 0x0ef8, 12, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0ef9_50), 0x0ef9, 16, { 0, 0 }, 0 }, /* CAS */
{ CPUFUNC(op_0efc_50), 0x0efc, 6, { 0, 0 }, 0 }, /* CAS2 */
{ CPUFUNC(op_1000_50), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_50), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_50), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_50), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_50), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_50), 0x1030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_50), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_50), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_50), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_50), 0x103b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_50), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_50), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_50), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_50), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_50), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_50), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_50), 0x10b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_50), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_50), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_50), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_50), 0x10bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_50), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_50), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_50), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_50), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_50), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_50), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_50), 0x10f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_50), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_50), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_50), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_50), 0x10fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_50), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_50), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_50), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_50), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_50), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_50), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_50), 0x1130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_50), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_50), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_50), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_50), 0x113b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_50), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_50), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_50), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_50), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_50), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_50), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_50), 0x1170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_50), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_50), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_50), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_50), 0x117b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_50), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_50), 0x1180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_50), 0x1190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_50), 0x1198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_50), 0x11a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_50), 0x11a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_50), 0x11b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_50), 0x11b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_50), 0x11b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_50), 0x11ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_50), 0x11bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_50), 0x11bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_50), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_50), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_50), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_50), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_50), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_50), 0x11f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_50), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_50), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_50), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_50), 0x11fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_50), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_50), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_50), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_50), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_50), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_50), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_50), 0x13f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_50), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_50), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_50), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_50), 0x13fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_50), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_50), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_50), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_50), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_50), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_50), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_50), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_50), 0x2030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_50), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_50), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_50), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_50), 0x203b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_50), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_50), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_50), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_50), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_50), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_50), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_50), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_50), 0x2070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_50), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_50), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_50), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_50), 0x207b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_50), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_50), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_50), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_50), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_50), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_50), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_50), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_50), 0x20b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_50), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_50), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_50), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_50), 0x20bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_50), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_50), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_50), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_50), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_50), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_50), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_50), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_50), 0x20f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_50), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_50), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_50), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_50), 0x20fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_50), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_50), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_50), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_50), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_50), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_50), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_50), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_50), 0x2130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_50), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_50), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_50), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_50), 0x213b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_50), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_50), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_50), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_50), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_50), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_50), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_50), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_50), 0x2170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_50), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_50), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_50), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_50), 0x217b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_50), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_50), 0x2180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_50), 0x2188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_50), 0x2190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_50), 0x2198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_50), 0x21a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_50), 0x21a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_50), 0x21b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_50), 0x21b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_50), 0x21b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_50), 0x21ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_50), 0x21bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_50), 0x21bc, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_50), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_50), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_50), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_50), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_50), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_50), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_50), 0x21f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_50), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_50), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_50), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_50), 0x21fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_50), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_50), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_50), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_50), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_50), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_50), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_50), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_50), 0x23f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_50), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_50), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_50), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_50), 0x23fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_50), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_50), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_50), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_50), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_50), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_50), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_50), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_50), 0x3030, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_50), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_50), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_50), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_50), 0x303b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_50), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_50), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_50), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_50), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_50), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_50), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_50), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_50), 0x3070, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_50), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_50), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_50), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_50), 0x307b, 2, { 2, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_50), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_50), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_50), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_50), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_50), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_50), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_50), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_50), 0x30b0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_50), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_50), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_50), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_50), 0x30bb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_50), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_50), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_50), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_50), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_50), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_50), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_50), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_50), 0x30f0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_50), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_50), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_50), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_50), 0x30fb, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_50), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_50), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_50), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_50), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_50), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_50), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_50), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_50), 0x3130, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_50), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_50), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_50), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_50), 0x313b, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_50), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_50), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_50), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_50), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_50), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_50), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_50), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_50), 0x3170, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_50), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_50), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_50), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_50), 0x317b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_50), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_50), 0x3180, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_50), 0x3188, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_50), 0x3190, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_50), 0x3198, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_50), 0x31a0, 2, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_50), 0x31a8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_50), 0x31b0, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_50), 0x31b8, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_50), 0x31b9, 6, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_50), 0x31ba, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_50), 0x31bb, 2, { 2, 2 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_50), 0x31bc, 4, { 2, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_50), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_50), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_50), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_50), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_50), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_50), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_50), 0x31f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_50), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_50), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_50), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_50), 0x31fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_50), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_50), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_50), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_50), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_50), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_50), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_50), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_50), 0x33f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_50), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_50), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_50), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_50), 0x33fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_50), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_50), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_50), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_50), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_50), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_50), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_50), 0x4030, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_50), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_50), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_50), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_50), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_50), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_50), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_50), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_50), 0x4070, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_50), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_50), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_50), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_50), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_50), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_50), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_50), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_50), 0x40b0, 2, { 2, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_50), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_50), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_50), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_50), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_50), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_50), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_50), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_50), 0x40f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_50), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_50), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4100_50), 0x4100, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4110_50), 0x4110, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4118_50), 0x4118, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4120_50), 0x4120, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4128_50), 0x4128, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4130_50), 0x4130, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4138_50), 0x4138, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4139_50), 0x4139, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413a_50), 0x413a, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413b_50), 0x413b, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_413c_50), 0x413c, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4180_50), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_50), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_50), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_50), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_50), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_50), 0x41b0, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_50), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_50), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_50), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_50), 0x41bb, 2, { 2, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_50), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_50), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_50), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_50), 0x41f0, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_50), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_50), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_50), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_50), 0x41fb, 2, { 2, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_50), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_50), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_50), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_50), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_50), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_50), 0x4230, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_50), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_50), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_50), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_50), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_50), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_50), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_50), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_50), 0x4270, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_50), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_50), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_50), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_50), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_50), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_50), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_50), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_50), 0x42b0, 2, { 2, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_50), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_50), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_50), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_50), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_50), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_50), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_50), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f0_50), 0x42f0, 2, { 2, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f8_50), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_50), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_50), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_50), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_50), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_50), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_50), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_50), 0x4430, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_50), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_50), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_50), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_50), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_50), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_50), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_50), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_50), 0x4470, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_50), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_50), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_50), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_50), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_50), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_50), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_50), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_50), 0x44b0, 2, { 2, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_50), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_50), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_50), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_50), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_50), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_50), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_50), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_50), 0x44f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_50), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_50), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_50), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_50), 0x44fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_50), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_50), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_50), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_50), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_50), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_50), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_50), 0x4630, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_50), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_50), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_50), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_50), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_50), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_50), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_50), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_50), 0x4670, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_50), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_50), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_50), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_50), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_50), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_50), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_50), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_50), 0x46b0, 2, { 2, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_50), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_50), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_50), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_50), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_50), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_50), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_50), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_50), 0x46f0, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_50), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_50), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_50), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_50), 0x46fb, 2, { 2, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_50), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_52), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4808_50), 0x4808, 6, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4810_52), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_52), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_52), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_52), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_52), 0x4830, 2, { 2, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_52), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_52), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_50), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4848_50), 0x4848, 2, { 0, 0 }, 0 }, /* BKPT */
{ CPUFUNC(op_4850_50), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_50), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_50), 0x4870, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_50), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_50), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_50), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_50), 0x487b, 2, { 2, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_50), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_50), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_50), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_50), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_50), 0x48b0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_50), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_50), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_50), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_50), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_50), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_50), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_50), 0x48f0, 4, { 2, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_50), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_50), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_49c0_50), 0x49c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4a00_50), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_50), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_50), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_50), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_50), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_50), 0x4a30, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_50), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_50), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3a_50), 0x4a3a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3b_50), 0x4a3b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a3c_50), 0x4a3c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_50), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a48_50), 0x4a48, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_50), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_50), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_50), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_50), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_50), 0x4a70, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_50), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_50), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7a_50), 0x4a7a, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7b_50), 0x4a7b, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a7c_50), 0x4a7c, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_50), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a88_50), 0x4a88, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_50), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_50), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_50), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_50), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_50), 0x4ab0, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_50), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_50), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aba_50), 0x4aba, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abb_50), 0x4abb, 2, { 2, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4abc_50), 0x4abc, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_50), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_50), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_50), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_50), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_50), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_50), 0x4af0, 2, { 2, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_50), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_50), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c00_50), 0x4c00, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c10_50), 0x4c10, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c18_50), 0x4c18, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c20_50), 0x4c20, 4, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c28_50), 0x4c28, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c30_50), 0x4c30, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c38_50), 0x4c38, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c39_50), 0x4c39, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3a_50), 0x4c3a, 6, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3b_50), 0x4c3b, 4, { 2, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c3c_50), 0x4c3c, 8, { 0, 0 }, 0 }, /* MULL */
{ CPUFUNC(op_4c40_50), 0x4c40, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c50_50), 0x4c50, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c58_50), 0x4c58, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c60_50), 0x4c60, 4, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c68_50), 0x4c68, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c70_50), 0x4c70, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c78_50), 0x4c78, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c79_50), 0x4c79, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7a_50), 0x4c7a, 6, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7b_50), 0x4c7b, 4, { 2, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c7c_50), 0x4c7c, 8, { 0, 0 }, 0 }, /* DIVL */
{ CPUFUNC(op_4c90_50), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_50), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_50), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_50), 0x4cb0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_50), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_50), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_50), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_50), 0x4cbb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_50), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_50), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_50), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_50), 0x4cf0, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_50), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_50), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_50), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_50), 0x4cfb, 4, { 2, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_50), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_50), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_50), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_50), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_50), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_50), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_50), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_50), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_50), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_50), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_50), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_50), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_50), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_50), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_50), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_50), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_50), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_50), 0x4eb0, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_50), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_50), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_50), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_50), 0x4ebb, 2, { 2, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_50), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_50), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_50), 0x4ef0, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_50), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_50), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_50), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_50), 0x4efb, 2, { 2, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_50), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_50), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_50), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_50), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_50), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_50), 0x5030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_50), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_50), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_50), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_50), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_50), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_50), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_50), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_50), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_50), 0x5070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_50), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_50), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_50), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_50), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_50), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_50), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_50), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_50), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_50), 0x50b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_50), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_50), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_50), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_50), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_50), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_50), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_50), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_50), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_50), 0x50f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_50), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_50), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50fa_50), 0x50fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fb_50), 0x50fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_50fc_50), 0x50fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5100_50), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_50), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_50), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_50), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_50), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_50), 0x5130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_50), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_50), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_50), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_50), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_50), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_50), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_50), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_50), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_50), 0x5170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_50), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_50), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_50), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_50), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_50), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_50), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_50), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_50), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_50), 0x51b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_50), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_50), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_50), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_50), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_50), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_50), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_50), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_50), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_50), 0x51f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_50), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_50), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51fa_50), 0x51fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fb_50), 0x51fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_51fc_50), 0x51fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52c0_50), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_50), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_50), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_50), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_50), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_50), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_50), 0x52f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_50), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_50), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52fa_50), 0x52fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fb_50), 0x52fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_52fc_50), 0x52fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53c0_50), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_50), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_50), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_50), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_50), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_50), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_50), 0x53f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_50), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_50), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53fa_50), 0x53fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fb_50), 0x53fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_53fc_50), 0x53fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54c0_50), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_50), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_50), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_50), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_50), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_50), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_50), 0x54f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_50), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_50), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54fa_50), 0x54fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fb_50), 0x54fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_54fc_50), 0x54fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55c0_50), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_50), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_50), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_50), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_50), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_50), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_50), 0x55f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_50), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_50), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55fa_50), 0x55fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fb_50), 0x55fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_55fc_50), 0x55fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56c0_50), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_50), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_50), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_50), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_50), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_50), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_50), 0x56f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_50), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_50), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56fa_50), 0x56fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fb_50), 0x56fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_56fc_50), 0x56fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57c0_50), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_50), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_50), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_50), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_50), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_50), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_50), 0x57f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_50), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_50), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57fa_50), 0x57fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fb_50), 0x57fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_57fc_50), 0x57fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58c0_50), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_50), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_50), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_50), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_50), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_50), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_50), 0x58f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_50), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_50), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58fa_50), 0x58fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fb_50), 0x58fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_58fc_50), 0x58fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59c0_50), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_50), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_50), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_50), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_50), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_50), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_50), 0x59f0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_50), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_50), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59fa_50), 0x59fa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fb_50), 0x59fb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_59fc_50), 0x59fc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_50), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_50), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_50), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_50), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_50), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_50), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_50), 0x5af0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_50), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_50), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5afa_50), 0x5afa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afb_50), 0x5afb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5afc_50), 0x5afc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_50), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_50), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_50), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_50), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_50), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_50), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_50), 0x5bf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_50), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_50), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bfa_50), 0x5bfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_50), 0x5bfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_50), 0x5bfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_50), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_50), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_50), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_50), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_50), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_50), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_50), 0x5cf0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_50), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_50), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cfa_50), 0x5cfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_50), 0x5cfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_50), 0x5cfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_50), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_50), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_50), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_50), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_50), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_50), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_50), 0x5df0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_50), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_50), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dfa_50), 0x5dfa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_50), 0x5dfb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_50), 0x5dfc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_50), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_50), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_50), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_50), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_50), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_50), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_50), 0x5ef0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_50), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_50), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5efa_50), 0x5efa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efb_50), 0x5efb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5efc_50), 0x5efc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_50), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_50), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_50), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_50), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_50), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_50), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_50), 0x5ff0, 2, { 2, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_50), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_50), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ffa_50), 0x5ffa, 4, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_50), 0x5ffb, 6, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_50), 0x5ffc, 2, { 0, 0 }, 0 }, /* TRAPcc */
{ CPUFUNC(op_6000_50), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_50), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_50), 0x60ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6100_50), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_50), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_50), 0x61ff, 6, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_50), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_50), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_50), 0x62ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6300_50), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_50), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_50), 0x63ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6400_50), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_50), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_50), 0x64ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6500_50), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_50), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_50), 0x65ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6600_50), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_50), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_50), 0x66ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6700_50), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_50), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_50), 0x67ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6800_50), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_50), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_50), 0x68ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6900_50), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_50), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_50), 0x69ff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a00_50), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_50), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_50), 0x6aff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b00_50), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_50), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_50), 0x6bff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c00_50), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_50), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_50), 0x6cff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d00_50), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_50), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_50), 0x6dff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e00_50), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_50), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_50), 0x6eff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f00_50), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_50), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_50), 0x6fff, 6, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_7000_50), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_50), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_50), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_50), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_50), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_50), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_50), 0x8030, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_50), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_50), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_50), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_50), 0x803b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_50), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_50), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_50), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_50), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_50), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_50), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_50), 0x8070, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_50), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_50), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_50), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_50), 0x807b, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_50), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_50), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_50), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_50), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_50), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_50), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_50), 0x80b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_50), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_50), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_50), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_50), 0x80bb, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_50), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_50), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_50), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_50), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_50), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_50), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_50), 0x80f0, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_50), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_50), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_50), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_50), 0x80fb, 2, { 2, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_50), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_52), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_52), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_50), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_50), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_50), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_50), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_50), 0x8130, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_50), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_50), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8140_50), 0x8140, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8148_50), 0x8148, 4, { 0, 0 }, 0 }, /* PACK */
{ CPUFUNC(op_8150_50), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_50), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_50), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_50), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_50), 0x8170, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_50), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_50), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8180_50), 0x8180, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8188_50), 0x8188, 4, { 0, 0 }, 0 }, /* UNPK */
{ CPUFUNC(op_8190_50), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_50), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_50), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_50), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_50), 0x81b0, 2, { 2, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_50), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_50), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_50), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_50), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_50), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_50), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_50), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_50), 0x81f0, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_50), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_50), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_50), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_50), 0x81fb, 2, { 2, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_50), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_50), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_50), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_50), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_50), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_50), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_50), 0x9030, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_50), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_50), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_50), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_50), 0x903b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_50), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_50), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_50), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_50), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_50), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_50), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_50), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_50), 0x9070, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_50), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_50), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_50), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_50), 0x907b, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_50), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_50), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_50), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_50), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_50), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_50), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_50), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_50), 0x90b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_50), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_50), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_50), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_50), 0x90bb, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_50), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_50), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_50), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_50), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_50), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_50), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_50), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_50), 0x90f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_50), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_50), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_50), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_50), 0x90fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_50), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_50), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_50), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_50), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_50), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_50), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_50), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_50), 0x9130, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_50), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_50), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_50), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_50), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_50), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_50), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_50), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_50), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_50), 0x9170, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_50), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_50), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_50), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_50), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_50), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_50), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_50), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_50), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_50), 0x91b0, 2, { 2, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_50), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_50), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_50), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_50), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_50), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_50), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_50), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_50), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_50), 0x91f0, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_50), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_50), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_50), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_50), 0x91fb, 2, { 2, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_50), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_50), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_50), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_50), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_50), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_50), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_50), 0xb030, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_50), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_50), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_50), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_50), 0xb03b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_50), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_50), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_50), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_50), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_50), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_50), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_50), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_50), 0xb070, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_50), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_50), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_50), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_50), 0xb07b, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_50), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_50), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_50), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_50), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_50), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_50), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_50), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_50), 0xb0b0, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_50), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_50), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_50), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_50), 0xb0bb, 2, { 2, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_50), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_50), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_50), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_50), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_50), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_50), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_50), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_50), 0xb0f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_50), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_50), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_50), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_50), 0xb0fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_50), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_50), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_50), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_50), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_50), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_50), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_50), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_50), 0xb130, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_50), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_50), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_50), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_50), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_50), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_50), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_50), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_50), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_50), 0xb170, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_50), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_50), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_50), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_50), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_50), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_50), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_50), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_50), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_50), 0xb1b0, 2, { 2, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_50), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_50), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_50), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_50), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_50), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_50), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_50), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_50), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_50), 0xb1f0, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_50), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_50), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_50), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_50), 0xb1fb, 2, { 2, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_50), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_50), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_50), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_50), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_50), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_50), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_50), 0xc030, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_50), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_50), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_50), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_50), 0xc03b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_50), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_50), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_50), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_50), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_50), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_50), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_50), 0xc070, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_50), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_50), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_50), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_50), 0xc07b, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_50), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_50), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_50), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_50), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_50), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_50), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_50), 0xc0b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_50), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_50), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_50), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_50), 0xc0bb, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_50), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_50), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_50), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_50), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_50), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_50), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_50), 0xc0f0, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_50), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_50), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_50), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_50), 0xc0fb, 2, { 2, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_50), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_52), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_52), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_50), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_50), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_50), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_50), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_50), 0xc130, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_50), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_50), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_50), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_50), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_50), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_50), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_50), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_50), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_50), 0xc170, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_50), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_50), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_50), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_50), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_50), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_50), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_50), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_50), 0xc1b0, 2, { 2, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_50), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_50), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_50), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_50), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_50), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_50), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_50), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_50), 0xc1f0, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_50), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_50), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_50), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_50), 0xc1fb, 2, { 2, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_50), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_50), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_50), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_50), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_50), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_50), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_50), 0xd030, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_50), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_50), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_50), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_50), 0xd03b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_50), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_50), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_50), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_50), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_50), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_50), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_50), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_50), 0xd070, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_50), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_50), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_50), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_50), 0xd07b, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_50), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_50), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_50), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_50), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_50), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_50), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_50), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_50), 0xd0b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_50), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_50), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_50), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_50), 0xd0bb, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_50), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_50), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_50), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_50), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_50), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_50), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_50), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_50), 0xd0f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_50), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_50), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_50), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_50), 0xd0fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_50), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_50), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_50), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_50), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_50), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_50), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_50), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_50), 0xd130, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_50), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_50), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_50), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_50), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_50), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_50), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_50), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_50), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_50), 0xd170, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_50), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_50), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_50), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_50), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_50), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_50), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_50), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_50), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_50), 0xd1b0, 2, { 2, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_50), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_50), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_50), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_50), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_50), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_50), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_50), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_50), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_50), 0xd1f0, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_50), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_50), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_50), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_50), 0xd1fb, 2, { 2, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_50), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_50), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_50), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_50), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_50), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_50), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_50), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_50), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_50), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_50), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_50), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_50), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_50), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_50), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_50), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_50), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_50), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_50), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_50), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_50), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_50), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_50), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_50), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_50), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_50), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_50), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_50), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_50), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_50), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_50), 0xe0f0, 2, { 2, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_50), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_50), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_50), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_50), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_50), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_50), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_50), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_50), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_50), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_50), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_50), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_50), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_50), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_50), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_50), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_50), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_50), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_50), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_50), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_50), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_50), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_50), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_50), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_50), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_50), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_50), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_50), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_50), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_50), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_50), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_50), 0xe1f0, 2, { 2, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_50), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_50), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_50), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_50), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_50), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_50), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_50), 0xe2f0, 2, { 2, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_50), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_50), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_50), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_50), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_50), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_50), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_50), 0xe3f0, 2, { 2, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_50), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_50), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_50), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_50), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_50), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_50), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_50), 0xe4f0, 2, { 2, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_50), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_50), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_50), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_50), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_50), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_50), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_50), 0xe5f0, 2, { 2, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_50), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_50), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_50), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_50), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_50), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_50), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_50), 0xe6f0, 2, { 2, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_50), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_50), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_50), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_50), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_50), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_50), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_50), 0xe7f0, 2, { 2, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_50), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_50), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e8c0_50), 0xe8c0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8d0_50), 0xe8d0, 4, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8e8_50), 0xe8e8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f0_50), 0xe8f0, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f8_50), 0xe8f8, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8f9_50), 0xe8f9, 8, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fa_50), 0xe8fa, 6, { 0, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e8fb_50), 0xe8fb, 4, { 2, 0 }, 0 }, /* BFTST */
{ CPUFUNC(op_e9c0_50), 0xe9c0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_50), 0xe9d0, 4, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_50), 0xe9e8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_50), 0xe9f0, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_50), 0xe9f8, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_50), 0xe9f9, 8, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_50), 0xe9fa, 6, { 0, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_50), 0xe9fb, 4, { 2, 0 }, 0 }, /* BFEXTU */
{ CPUFUNC(op_eac0_50), 0xeac0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ead0_50), 0xead0, 4, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eae8_50), 0xeae8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf0_50), 0xeaf0, 4, { 2, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf8_50), 0xeaf8, 6, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_eaf9_50), 0xeaf9, 8, { 0, 0 }, 0 }, /* BFCHG */
{ CPUFUNC(op_ebc0_50), 0xebc0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_50), 0xebd0, 4, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_50), 0xebe8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_50), 0xebf0, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_50), 0xebf8, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_50), 0xebf9, 8, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_50), 0xebfa, 6, { 0, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_50), 0xebfb, 4, { 2, 0 }, 0 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_50), 0xecc0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecd0_50), 0xecd0, 4, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ece8_50), 0xece8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf0_50), 0xecf0, 4, { 2, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf8_50), 0xecf8, 6, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_ecf9_50), 0xecf9, 8, { 0, 0 }, 0 }, /* BFCLR */
{ CPUFUNC(op_edc0_50), 0xedc0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edd0_50), 0xedd0, 4, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_ede8_50), 0xede8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf0_50), 0xedf0, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf8_50), 0xedf8, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edf9_50), 0xedf9, 8, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfa_50), 0xedfa, 6, { 0, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_edfb_50), 0xedfb, 4, { 2, 0 }, 0 }, /* BFFFO */
{ CPUFUNC(op_eec0_50), 0xeec0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eed0_50), 0xeed0, 4, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eee8_50), 0xeee8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef0_50), 0xeef0, 4, { 2, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef8_50), 0xeef8, 6, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_eef9_50), 0xeef9, 8, { 0, 0 }, 0 }, /* BFSET */
{ CPUFUNC(op_efc0_50), 0xefc0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efd0_50), 0xefd0, 4, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_efe8_50), 0xefe8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff0_50), 0xeff0, 4, { 2, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff8_50), 0xeff8, 6, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_eff9_50), 0xeff9, 8, { 0, 0 }, 0 }, /* BFINS */
{ CPUFUNC(op_f200_50), 0xf200, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f208_50), 0xf208, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f210_50), 0xf210, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f218_50), 0xf218, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f220_50), 0xf220, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f228_50), 0xf228, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f230_50), 0xf230, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f238_50), 0xf238, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f239_50), 0xf239, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23a_50), 0xf23a, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23b_50), 0xf23b, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f23c_50), 0xf23c, -1, { 0, 0 }, 0 }, /* FPP */
{ CPUFUNC(op_f240_50), 0xf240, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f248_50), 0xf248, -1, { 0, 0 }, 0 }, /* FDBcc */
{ CPUFUNC(op_f250_50), 0xf250, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f258_50), 0xf258, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f260_50), 0xf260, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f268_50), 0xf268, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f270_50), 0xf270, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f278_50), 0xf278, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f279_50), 0xf279, -1, { 0, 0 }, 0 }, /* FScc */
{ CPUFUNC(op_f27a_50), 0xf27a, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_50), 0xf27b, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_50), 0xf27c, -1, { 0, 0 }, 0 }, /* FTRAPcc */
{ CPUFUNC(op_f280_50), 0xf280, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f2c0_50), 0xf2c0, -1, { 0, 0 }, 0 }, /* FBcc */
{ CPUFUNC(op_f310_50), 0xf310, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f320_50), 0xf320, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f328_50), 0xf328, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f330_50), 0xf330, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f338_50), 0xf338, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f339_50), 0xf339, -1, { 0, 0 }, 0 }, /* FSAVE */
{ CPUFUNC(op_f350_50), 0xf350, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f358_50), 0xf358, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f368_50), 0xf368, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f370_50), 0xf370, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f378_50), 0xf378, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f379_50), 0xf379, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37a_50), 0xf37a, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ CPUFUNC(op_f37b_50), 0xf37b, -1, { 0, 0 }, 0 }, /* FRESTORE */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_50 */
#ifdef CPUEMU_50
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_54)[] = {
{ CPUFUNC(op_0000_50), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_50), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_50), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_50), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_50), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_54), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_50), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_50), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_50), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_50), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_50), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_50), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_50), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_50), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_54), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_50), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_50), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_50), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_50), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_50), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_50), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_50), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_50), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_54), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_50), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_50), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_50), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_50), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_50), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_50), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_50), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_50), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_54), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_50), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_50), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_50), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_54), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_50), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_50), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_50), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_50), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_50), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_50), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_50), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_54), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_50), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_50), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_50), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_50), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_50), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_50), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_50), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_50), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_54), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_50), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_50), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_50), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_50), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_50), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_50), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_50), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_50), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_54), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_50), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_50), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_50), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_50), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_50), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_50), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_50), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_54), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_50), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_50), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_50), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_50), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_50), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_50), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_50), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_50), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_54), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_50), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_50), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_50), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_50), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_50), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_50), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_50), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_50), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_54), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_50), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_50), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_50), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_50), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_50), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_50), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_50), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_54), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_50), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_50), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_50), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_50), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_50), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_50), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_50), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_54), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_50), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_50), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_50), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_50), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_50), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_50), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_50), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_54), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_50), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_50), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_50), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_50), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_50), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_50), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_50), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_54), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_50), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_50), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_50), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_50), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_50), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_50), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_50), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_54), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_50), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_50), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_50), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_50), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_50), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_50), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_50), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_54), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_50), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_50), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_50), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_50), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_50), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_50), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_50), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_54), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_50), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_50), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_50), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_54), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_50), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_50), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_50), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_50), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_50), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_54), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_50), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_50), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_50), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_50), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_50), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_50), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_50), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_54), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_50), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_50), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_50), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_50), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_50), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_50), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_50), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_54), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_50), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_50), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_50), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_50), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_50), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_50), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_50), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_54), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_50), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_50), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_50), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_50), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_50), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_50), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_50), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_50), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_54), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_50), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_50), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_50), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_50), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_50), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_50), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_50), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_50), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_54), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_50), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_50), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_50), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_50), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_50), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_50), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_50), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_54), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_50), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_50), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_50), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_50), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_50), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_50), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_50), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_54), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_50), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_50), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_50), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_50), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_50), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_50), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_50), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_54), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_50), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_50), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_50), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_50), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_50), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_50), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_50), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_54), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_50), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_50), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_50), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_54), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_50), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_50), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_50), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_50), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_50), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_50), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_54), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_50), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_50), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_50), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_54), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_50), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_50), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_50), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_50), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_50), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_50), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_54), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_50), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_50), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_50), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_54), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_50), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_50), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_50), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_50), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_50), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_50), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_54), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_50), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_50), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_50), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_54), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_50), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_50), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_50), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_50), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_50), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_50), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_54), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_50), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_50), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_50), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_54), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_50), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_54), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_54), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_54), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_54), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_54), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_54), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_54), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_54), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_54), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_54), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_54), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_50), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_50), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_50), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_50), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_50), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_54), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_50), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_50), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_50), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_54), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_50), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_50), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_50), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_50), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_50), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_50), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_54), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_50), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_50), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_50), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_54), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_50), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_50), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_50), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_50), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_50), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_50), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_50), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_54), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_50), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_50), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_50), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_54), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_50), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_50), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_50), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_50), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_50), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_50), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_50), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_54), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_50), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_50), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_50), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_54), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_50), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_50), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_50), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_50), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_50), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_50), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_50), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_54), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_50), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_50), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_50), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_54), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_50), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_50), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_50), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_50), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_50), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_50), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_50), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_54), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_50), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_50), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_50), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_54), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_50), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_50), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_50), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_50), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_50), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_50), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_50), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_54), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_50), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_50), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_50), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_54), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_50), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_50), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_50), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_50), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_50), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_50), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_50), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_54), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_50), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_50), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_50), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_54), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_50), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_54), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_54), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_54), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_54), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_54), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_54), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_54), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_54), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_54), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_54), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_54), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_54), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_50), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_50), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_50), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_50), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_50), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_50), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_54), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_50), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_50), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_50), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_54), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_50), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_50), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_50), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_50), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_50), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_50), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_50), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_54), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_50), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_50), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_50), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_54), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_50), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_50), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_50), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_50), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_50), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_50), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_50), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_54), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_50), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_50), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_50), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_54), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_50), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_50), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_50), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_50), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_50), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_50), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_50), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_54), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_50), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_50), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_50), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_54), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_50), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_50), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_50), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_50), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_50), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_50), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_50), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_54), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_50), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_50), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_50), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_54), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_50), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_50), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_50), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_50), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_50), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_50), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_50), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_54), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_50), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_50), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_50), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_54), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_50), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_50), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_50), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_50), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_50), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_50), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_50), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_54), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_50), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_50), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_50), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_54), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_50), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_50), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_50), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_50), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_50), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_50), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_50), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_54), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_50), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_50), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_50), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_54), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_50), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_54), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_54), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_54), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_54), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_54), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_54), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_54), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_54), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_54), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_54), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_54), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_54), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_50), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_50), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_50), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_50), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_50), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_50), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_54), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_50), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_50), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_50), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_54), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_50), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_50), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_50), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_50), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_50), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_50), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_50), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_54), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_50), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_50), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_50), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_54), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_50), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_50), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_50), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_50), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_50), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_50), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_54), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_50), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_50), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_50), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_50), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_50), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_50), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_50), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_54), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_50), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_50), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_50), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_50), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_50), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_50), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_50), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_54), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_50), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_50), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_50), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_50), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_50), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_50), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_50), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_54), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_50), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_50), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_50), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_50), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_50), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_50), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_50), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_54), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_50), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_50), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_50), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_54), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_50), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_50), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_50), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_54), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_50), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_50), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_50), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_54), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_50), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_50), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_50), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_50), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_50), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_54), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_50), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_50), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_50), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_50), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_50), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_50), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_50), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_54), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_50), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_50), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_50), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_50), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_50), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_50), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_50), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_54), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_50), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_50), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42c0_50), 0x42c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d0_50), 0x42d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42d8_50), 0x42d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e0_50), 0x42e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42e8_50), 0x42e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
#ifndef CPUEMU_68000_ONLY
{ CPUFUNC(op_42f0_54), 0x42f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
#endif
{ CPUFUNC(op_42f8_50), 0x42f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_42f9_50), 0x42f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4400_50), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_50), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_50), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_50), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_50), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_54), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_50), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_50), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_50), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_50), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_50), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_50), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_50), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_54), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_50), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_50), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_50), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_50), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_50), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_50), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_50), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_54), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_50), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_50), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_50), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_50), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_50), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_50), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_50), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_54), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_50), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_50), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_50), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_54), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_50), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_50), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_50), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_50), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_50), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_50), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_54), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_50), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_50), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_50), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_50), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_50), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_50), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_50), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_54), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_50), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_50), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_50), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_50), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_50), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_50), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_50), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_54), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_50), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_50), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_50), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_50), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_50), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_50), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_50), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_54), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_50), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_50), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_50), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_54), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_50), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_52), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_52), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_52), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_52), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_52), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_54), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_52), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_52), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_50), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_50), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_50), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_54), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_50), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_50), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_50), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_54), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_50), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_50), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_50), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_50), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_54), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_50), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_50), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_50), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_50), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_50), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_50), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_54), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_50), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_50), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_50), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_50), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_50), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_50), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_50), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_54), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_50), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_50), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_50), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_50), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_50), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_50), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_50), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_54), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_50), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_50), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_50), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_50), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_50), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_50), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_50), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_54), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_50), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_50), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_54), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_54), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_54), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_54), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_54), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_54), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_54), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_54), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_50), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_50), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_50), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_54), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_50), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_50), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_50), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_54), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_50), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_50), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_50), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_54), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_50), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_50), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_50), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_54), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_50), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_50), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_50), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_50), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_50), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_50), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_50), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_50), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_50), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e74_50), 0x4e74, 4, { 0, 0 }, 1 }, /* RTD */
{ CPUFUNC(op_4e75_50), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_50), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_50), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e7a_50), 0x4e7a, 4, { 0, 0 }, 0 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_50), 0x4e7b, 4, { 0, 0 }, 0 }, /* MOVE2C */
{ CPUFUNC(op_4e90_50), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_50), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_54), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_50), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_50), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_50), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_54), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_50), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_50), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_54), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_50), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_50), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_50), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_54), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_50), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_50), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_50), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_50), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_50), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_54), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_50), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_50), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_50), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_50), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_50), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_50), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_50), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_50), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_54), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_50), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_50), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_50), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_50), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_50), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_50), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_50), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_50), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_54), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_50), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_50), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_50), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_50), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_50), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_50), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_50), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_50), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_54), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_50), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_50), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_50), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_50), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_50), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_50), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_50), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_54), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_50), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_50), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_50), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_50), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_50), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_50), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_50), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_50), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_54), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_50), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_50), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_50), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_50), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_50), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_50), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_50), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_50), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_54), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_50), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_50), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_50), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_50), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_50), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_50), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_50), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_50), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_54), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_50), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_50), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_50), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_50), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_50), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_50), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_50), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_50), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_54), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_50), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_50), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_50), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_50), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_50), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_50), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_50), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_50), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_54), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_50), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_50), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_50), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_50), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_50), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_50), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_50), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_50), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_54), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_50), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_50), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_50), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_50), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_50), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_50), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_50), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_50), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_54), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_50), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_50), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_50), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_50), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_50), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_50), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_50), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_50), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_54), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_50), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_50), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_50), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_50), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_50), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_50), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_50), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_50), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_54), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_50), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_50), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_50), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_50), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_50), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_50), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_50), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_50), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_54), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_50), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_50), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_50), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_50), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_50), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_50), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_50), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_50), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_54), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_50), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_50), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_50), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_50), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_50), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_50), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_50), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_50), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_54), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_50), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_50), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_50), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_50), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_50), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_50), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_50), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_50), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_54), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_50), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_50), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_50), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_50), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_50), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_50), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_50), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_50), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_54), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_50), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_50), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_50), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_50), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_50), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_50), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_50), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_50), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_54), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_50), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_50), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_50), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_50), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_50), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_50), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_50), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_50), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_54), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_50), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_50), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_50), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_50), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_50), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_50), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_50), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_50), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_54), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_50), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_50), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_50), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_50), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_54), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_50), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_50), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_54), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_50), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_50), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_54), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_50), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_50), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_54), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_50), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_50), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_54), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_50), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_50), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_54), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_50), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_50), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_54), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_50), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_50), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_54), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_50), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_50), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_54), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_50), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_50), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_54), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_50), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_50), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_54), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_50), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_50), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_54), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_50), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_50), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_54), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_50), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_50), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_54), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_50), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_50), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_54), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_50), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_50), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_54), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_50), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_50), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_50), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_50), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_50), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_50), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_54), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_50), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_50), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_50), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_54), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_50), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_50), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_50), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_50), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_50), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_50), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_54), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_50), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_50), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_50), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_54), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_50), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_50), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_50), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_50), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_50), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_50), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_54), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_50), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_50), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_50), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_54), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_50), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_50), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_50), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_50), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_50), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_50), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_54), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_50), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_50), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_50), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_54), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_50), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_52), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_52), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_50), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_50), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_50), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_50), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_54), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_50), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_50), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_50), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_50), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_50), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_50), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_54), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_50), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_50), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_50), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_50), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_50), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_50), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_54), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_50), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_50), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_50), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_50), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_50), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_50), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_50), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_54), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_50), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_50), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_50), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_54), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_50), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_50), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_50), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_50), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_50), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_50), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_54), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_50), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_50), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_50), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_54), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_50), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_50), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_50), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_50), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_50), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_50), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_50), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_54), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_50), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_50), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_50), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_54), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_50), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_50), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_50), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_50), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_50), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_50), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_50), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_54), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_50), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_50), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_50), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_54), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_50), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_50), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_50), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_50), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_50), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_50), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_50), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_54), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_50), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_50), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_50), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_54), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_50), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_50), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_50), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_50), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_50), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_50), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_50), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_54), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_50), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_50), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_50), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_50), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_50), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_50), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_50), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_50), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_54), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_50), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_50), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_50), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_50), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_50), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_50), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_50), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_50), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_54), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_50), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_50), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_50), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_50), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_50), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_50), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_50), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_50), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_54), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_50), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_50), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_50), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_54), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_50), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_50), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_50), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_50), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_50), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_50), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_54), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_50), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_50), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_50), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_54), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_50), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_50), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_50), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_50), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_50), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_50), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_50), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_54), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_50), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_50), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_50), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_54), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_50), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_50), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_50), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_50), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_50), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_50), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_50), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_54), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_50), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_50), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_50), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_54), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_50), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_50), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_50), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_50), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_50), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_50), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_50), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_54), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_50), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_50), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_50), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_54), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_50), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_50), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_50), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_50), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_50), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_50), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_50), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_54), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_50), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_50), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_50), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_50), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_50), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_50), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_50), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_50), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_54), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_50), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_50), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_50), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_50), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_50), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_50), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_50), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_50), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_54), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_50), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_50), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_50), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_50), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_50), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_50), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_50), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_50), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_54), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_50), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_50), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_50), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_54), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_50), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_50), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_50), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_50), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_50), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_50), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_54), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_50), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_50), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_50), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_54), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_50), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_50), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_50), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_50), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_50), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_50), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_54), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_50), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_50), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_50), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_54), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_50), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_50), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_50), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_50), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_50), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_50), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_54), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_50), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_50), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_50), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_54), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_50), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_50), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_50), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_50), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_50), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_50), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_54), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_50), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_50), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_50), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_54), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_50), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_52), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_52), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_50), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_50), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_50), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_50), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_54), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_50), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_50), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_50), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_50), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_50), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_50), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_50), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_50), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_54), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_50), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_50), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_50), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_50), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_50), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_50), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_50), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_54), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_50), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_50), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_50), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_50), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_50), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_50), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_50), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_54), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_50), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_50), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_50), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_54), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_50), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_50), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_50), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_50), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_50), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_50), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_54), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_50), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_50), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_50), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_54), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_50), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_50), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_50), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_50), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_50), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_50), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_50), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_54), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_50), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_50), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_50), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_54), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_50), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_50), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_50), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_50), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_50), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_50), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_50), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_54), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_50), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_50), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_50), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_54), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_50), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_50), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_50), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_50), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_50), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_50), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_50), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_54), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_50), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_50), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_50), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_54), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_50), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_50), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_50), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_50), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_50), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_50), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_50), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_54), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_50), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_50), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_50), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_50), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_50), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_50), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_50), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_50), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_54), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_50), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_50), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_50), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_50), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_50), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_50), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_50), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_50), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_54), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_50), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_50), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_50), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_50), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_50), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_50), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_50), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_50), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_54), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_50), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_50), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_50), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_54), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_50), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_50), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_50), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_50), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_50), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_50), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_50), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_50), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_50), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_50), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_50), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_50), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_50), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_50), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_50), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_50), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_50), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_50), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_50), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_50), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_50), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_50), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_50), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_50), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_50), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_50), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_50), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_50), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_50), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_54), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_50), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_50), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_50), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_50), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_50), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_50), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_50), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_50), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_50), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_50), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_50), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_50), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_50), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_50), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_50), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_50), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_50), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_50), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_50), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_50), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_50), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_50), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_50), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_50), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_50), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_50), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_50), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_50), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_50), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_50), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_54), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_50), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_50), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_50), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_50), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_50), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_50), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_54), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_50), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_50), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_50), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_50), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_50), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_50), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_54), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_50), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_50), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_50), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_50), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_50), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_50), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_54), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_50), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_50), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_50), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_50), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_50), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_50), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_54), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_50), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_50), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_50), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_50), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_50), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_50), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_54), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_50), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_50), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_50), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_50), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_50), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_50), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_54), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_50), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_50), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_50 */
#ifdef CPUEMU_50
#ifndef CPUEMU_68000_ONLY
const struct cputbl CPUFUNC(op_smalltbl_55)[] = {
{ CPUFUNC(op_0000_50), 0x0000, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0010_50), 0x0010, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0018_50), 0x0018, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0020_50), 0x0020, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0028_50), 0x0028, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0030_54), 0x0030, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0038_50), 0x0038, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0039_50), 0x0039, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_003c_50), 0x003c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0040_50), 0x0040, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0050_50), 0x0050, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0058_50), 0x0058, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0060_50), 0x0060, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0068_50), 0x0068, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0070_54), 0x0070, 6, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0078_50), 0x0078, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0079_50), 0x0079, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_007c_50), 0x007c, 4, { 0, 0 }, 0 }, /* ORSR */
{ CPUFUNC(op_0080_50), 0x0080, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0090_50), 0x0090, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0098_50), 0x0098, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a0_50), 0x00a0, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00a8_50), 0x00a8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b0_54), 0x00b0, 8, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b8_50), 0x00b8, 8, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_00b9_50), 0x00b9, 10, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_0100_50), 0x0100, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0108_50), 0x0108, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0110_50), 0x0110, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0118_50), 0x0118, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0120_50), 0x0120, 2, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0128_50), 0x0128, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0130_54), 0x0130, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0138_50), 0x0138, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0139_50), 0x0139, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013a_50), 0x013a, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013b_54), 0x013b, 4, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_013c_50), 0x013c, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0140_50), 0x0140, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0148_50), 0x0148, 4, { 0, 0 }, 0 }, /* MVPMR */
{ CPUFUNC(op_0150_50), 0x0150, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0158_50), 0x0158, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0160_50), 0x0160, 2, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0168_50), 0x0168, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0170_54), 0x0170, 4, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0178_50), 0x0178, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0179_50), 0x0179, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0180_50), 0x0180, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0188_50), 0x0188, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_0190_50), 0x0190, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0198_50), 0x0198, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a0_50), 0x01a0, 2, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01a8_50), 0x01a8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b0_54), 0x01b0, 4, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b8_50), 0x01b8, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01b9_50), 0x01b9, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_01c0_50), 0x01c0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01c8_50), 0x01c8, 4, { 0, 0 }, 0 }, /* MVPRM */
{ CPUFUNC(op_01d0_50), 0x01d0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01d8_50), 0x01d8, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e0_50), 0x01e0, 2, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01e8_50), 0x01e8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f0_54), 0x01f0, 4, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f8_50), 0x01f8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_01f9_50), 0x01f9, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0200_50), 0x0200, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0210_50), 0x0210, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0218_50), 0x0218, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0220_50), 0x0220, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0228_50), 0x0228, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0230_54), 0x0230, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0238_50), 0x0238, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0239_50), 0x0239, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_023c_50), 0x023c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0240_50), 0x0240, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0250_50), 0x0250, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0258_50), 0x0258, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0260_50), 0x0260, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0268_50), 0x0268, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0270_54), 0x0270, 6, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0278_50), 0x0278, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0279_50), 0x0279, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_027c_50), 0x027c, 4, { 0, 0 }, 0 }, /* ANDSR */
{ CPUFUNC(op_0280_50), 0x0280, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0290_50), 0x0290, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0298_50), 0x0298, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a0_50), 0x02a0, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02a8_50), 0x02a8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b0_54), 0x02b0, 8, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b8_50), 0x02b8, 8, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_02b9_50), 0x02b9, 10, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_0400_50), 0x0400, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0410_50), 0x0410, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0418_50), 0x0418, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0420_50), 0x0420, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0428_50), 0x0428, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0430_54), 0x0430, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0438_50), 0x0438, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0439_50), 0x0439, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0440_50), 0x0440, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0450_50), 0x0450, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0458_50), 0x0458, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0460_50), 0x0460, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0468_50), 0x0468, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0470_54), 0x0470, 6, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0478_50), 0x0478, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0479_50), 0x0479, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0480_50), 0x0480, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0490_50), 0x0490, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0498_50), 0x0498, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a0_50), 0x04a0, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04a8_50), 0x04a8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b0_54), 0x04b0, 8, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b8_50), 0x04b8, 8, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_04b9_50), 0x04b9, 10, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_0600_50), 0x0600, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0610_50), 0x0610, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0618_50), 0x0618, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0620_50), 0x0620, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0628_50), 0x0628, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0630_54), 0x0630, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0638_50), 0x0638, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0639_50), 0x0639, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0640_50), 0x0640, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0650_50), 0x0650, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0658_50), 0x0658, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0660_50), 0x0660, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0668_50), 0x0668, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0670_54), 0x0670, 6, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0678_50), 0x0678, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0679_50), 0x0679, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0680_50), 0x0680, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0690_50), 0x0690, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0698_50), 0x0698, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a0_50), 0x06a0, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06a8_50), 0x06a8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b0_54), 0x06b0, 8, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b8_50), 0x06b8, 8, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_06b9_50), 0x06b9, 10, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_0800_50), 0x0800, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0810_50), 0x0810, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0818_50), 0x0818, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0820_50), 0x0820, 4, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0828_50), 0x0828, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0830_54), 0x0830, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0838_50), 0x0838, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0839_50), 0x0839, 8, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083a_50), 0x083a, 6, { 0, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_083b_54), 0x083b, 6, { 4, 0 }, 0 }, /* BTST */
{ CPUFUNC(op_0840_50), 0x0840, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0850_50), 0x0850, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0858_50), 0x0858, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0860_50), 0x0860, 4, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0868_50), 0x0868, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0870_54), 0x0870, 6, { 4, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0878_50), 0x0878, 6, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0879_50), 0x0879, 8, { 0, 0 }, 0 }, /* BCHG */
{ CPUFUNC(op_0880_50), 0x0880, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0890_50), 0x0890, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_0898_50), 0x0898, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a0_50), 0x08a0, 4, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08a8_50), 0x08a8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b0_54), 0x08b0, 6, { 4, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b8_50), 0x08b8, 6, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08b9_50), 0x08b9, 8, { 0, 0 }, 0 }, /* BCLR */
{ CPUFUNC(op_08c0_50), 0x08c0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d0_50), 0x08d0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08d8_50), 0x08d8, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e0_50), 0x08e0, 4, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08e8_50), 0x08e8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f0_54), 0x08f0, 6, { 4, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f8_50), 0x08f8, 6, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_08f9_50), 0x08f9, 8, { 0, 0 }, 0 }, /* BSET */
{ CPUFUNC(op_0a00_50), 0x0a00, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a10_50), 0x0a10, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a18_50), 0x0a18, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a20_50), 0x0a20, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a28_50), 0x0a28, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a30_54), 0x0a30, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a38_50), 0x0a38, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a39_50), 0x0a39, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a3c_50), 0x0a3c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a40_50), 0x0a40, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a50_50), 0x0a50, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a58_50), 0x0a58, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a60_50), 0x0a60, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a68_50), 0x0a68, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a70_54), 0x0a70, 6, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a78_50), 0x0a78, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a79_50), 0x0a79, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a7c_50), 0x0a7c, 4, { 0, 0 }, 0 }, /* EORSR */
{ CPUFUNC(op_0a80_50), 0x0a80, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a90_50), 0x0a90, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0a98_50), 0x0a98, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa0_50), 0x0aa0, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0aa8_50), 0x0aa8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab0_54), 0x0ab0, 8, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab8_50), 0x0ab8, 8, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0ab9_50), 0x0ab9, 10, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_0c00_50), 0x0c00, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c10_50), 0x0c10, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c18_50), 0x0c18, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c20_50), 0x0c20, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c28_50), 0x0c28, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c30_54), 0x0c30, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c38_50), 0x0c38, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c39_50), 0x0c39, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c40_50), 0x0c40, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c50_50), 0x0c50, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c58_50), 0x0c58, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c60_50), 0x0c60, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c68_50), 0x0c68, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c70_54), 0x0c70, 6, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c78_50), 0x0c78, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c79_50), 0x0c79, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c80_50), 0x0c80, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c90_50), 0x0c90, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0c98_50), 0x0c98, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca0_50), 0x0ca0, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0ca8_50), 0x0ca8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb0_54), 0x0cb0, 8, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb8_50), 0x0cb8, 8, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_0cb9_50), 0x0cb9, 10, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_1000_50), 0x1000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1010_50), 0x1010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1018_50), 0x1018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1020_50), 0x1020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1028_50), 0x1028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1030_54), 0x1030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1038_50), 0x1038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1039_50), 0x1039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103a_50), 0x103a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103b_54), 0x103b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_103c_50), 0x103c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1080_50), 0x1080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1090_50), 0x1090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1098_50), 0x1098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a0_50), 0x10a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10a8_50), 0x10a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b0_54), 0x10b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b8_50), 0x10b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10b9_50), 0x10b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10ba_50), 0x10ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bb_54), 0x10bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10bc_50), 0x10bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10c0_50), 0x10c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d0_50), 0x10d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10d8_50), 0x10d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e0_50), 0x10e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10e8_50), 0x10e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f0_54), 0x10f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f8_50), 0x10f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10f9_50), 0x10f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fa_50), 0x10fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fb_54), 0x10fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_10fc_50), 0x10fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1100_50), 0x1100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1110_50), 0x1110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1118_50), 0x1118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1120_50), 0x1120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1128_50), 0x1128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1130_54), 0x1130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1138_50), 0x1138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1139_50), 0x1139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113a_50), 0x113a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113b_54), 0x113b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_113c_50), 0x113c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1140_50), 0x1140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1150_50), 0x1150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1158_50), 0x1158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1160_50), 0x1160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1168_50), 0x1168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1170_54), 0x1170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1178_50), 0x1178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1179_50), 0x1179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117a_50), 0x117a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117b_54), 0x117b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_117c_50), 0x117c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1180_54), 0x1180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1190_54), 0x1190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_1198_54), 0x1198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a0_54), 0x11a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11a8_54), 0x11a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b0_54), 0x11b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b8_54), 0x11b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11b9_54), 0x11b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11ba_54), 0x11ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bb_54), 0x11bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_11bc_54), 0x11bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11c0_50), 0x11c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d0_50), 0x11d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11d8_50), 0x11d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e0_50), 0x11e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11e8_50), 0x11e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f0_54), 0x11f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f8_50), 0x11f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11f9_50), 0x11f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fa_50), 0x11fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fb_54), 0x11fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_11fc_50), 0x11fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13c0_50), 0x13c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d0_50), 0x13d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13d8_50), 0x13d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e0_50), 0x13e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13e8_50), 0x13e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f0_54), 0x13f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f8_50), 0x13f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13f9_50), 0x13f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fa_50), 0x13fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fb_54), 0x13fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_13fc_50), 0x13fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2000_50), 0x2000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2008_50), 0x2008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2010_50), 0x2010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2018_50), 0x2018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2020_50), 0x2020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2028_50), 0x2028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2030_54), 0x2030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2038_50), 0x2038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2039_50), 0x2039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203a_50), 0x203a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203b_54), 0x203b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_203c_50), 0x203c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2040_50), 0x2040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2048_50), 0x2048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2050_50), 0x2050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2058_50), 0x2058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2060_50), 0x2060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2068_50), 0x2068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2070_54), 0x2070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2078_50), 0x2078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2079_50), 0x2079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207a_50), 0x207a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207b_54), 0x207b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_207c_50), 0x207c, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_2080_50), 0x2080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2088_50), 0x2088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2090_50), 0x2090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2098_50), 0x2098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a0_50), 0x20a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20a8_50), 0x20a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b0_54), 0x20b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b8_50), 0x20b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20b9_50), 0x20b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20ba_50), 0x20ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bb_54), 0x20bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20bc_50), 0x20bc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c0_50), 0x20c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20c8_50), 0x20c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d0_50), 0x20d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20d8_50), 0x20d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e0_50), 0x20e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20e8_50), 0x20e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f0_54), 0x20f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f8_50), 0x20f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20f9_50), 0x20f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fa_50), 0x20fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fb_54), 0x20fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_20fc_50), 0x20fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2100_50), 0x2100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2108_50), 0x2108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2110_50), 0x2110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2118_50), 0x2118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2120_50), 0x2120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2128_50), 0x2128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2130_54), 0x2130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2138_50), 0x2138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2139_50), 0x2139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213a_50), 0x213a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213b_54), 0x213b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_213c_50), 0x213c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2140_50), 0x2140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2148_50), 0x2148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2150_50), 0x2150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2158_50), 0x2158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2160_50), 0x2160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2168_50), 0x2168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2170_54), 0x2170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2178_50), 0x2178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2179_50), 0x2179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217a_50), 0x217a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217b_54), 0x217b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_217c_50), 0x217c, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2180_54), 0x2180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2188_54), 0x2188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2190_54), 0x2190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_2198_54), 0x2198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a0_54), 0x21a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21a8_54), 0x21a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b0_54), 0x21b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b8_54), 0x21b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21b9_54), 0x21b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21ba_54), 0x21ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bb_54), 0x21bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_21bc_54), 0x21bc, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c0_50), 0x21c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21c8_50), 0x21c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d0_50), 0x21d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21d8_50), 0x21d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e0_50), 0x21e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21e8_50), 0x21e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f0_54), 0x21f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f8_50), 0x21f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21f9_50), 0x21f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fa_50), 0x21fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fb_54), 0x21fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_21fc_50), 0x21fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c0_50), 0x23c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23c8_50), 0x23c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d0_50), 0x23d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23d8_50), 0x23d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e0_50), 0x23e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23e8_50), 0x23e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f0_54), 0x23f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f8_50), 0x23f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23f9_50), 0x23f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fa_50), 0x23fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fb_54), 0x23fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_23fc_50), 0x23fc, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3000_50), 0x3000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3008_50), 0x3008, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3010_50), 0x3010, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3018_50), 0x3018, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3020_50), 0x3020, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3028_50), 0x3028, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3030_54), 0x3030, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3038_50), 0x3038, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3039_50), 0x3039, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303a_50), 0x303a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303b_54), 0x303b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_303c_50), 0x303c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3040_50), 0x3040, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3048_50), 0x3048, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3050_50), 0x3050, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3058_50), 0x3058, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3060_50), 0x3060, 2, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3068_50), 0x3068, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3070_54), 0x3070, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3078_50), 0x3078, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3079_50), 0x3079, 6, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307a_50), 0x307a, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307b_54), 0x307b, 4, { 4, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_307c_50), 0x307c, 4, { 0, 0 }, 0 }, /* MOVEA */
{ CPUFUNC(op_3080_50), 0x3080, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3088_50), 0x3088, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3090_50), 0x3090, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3098_50), 0x3098, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a0_50), 0x30a0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30a8_50), 0x30a8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b0_54), 0x30b0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b8_50), 0x30b8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30b9_50), 0x30b9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30ba_50), 0x30ba, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bb_54), 0x30bb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30bc_50), 0x30bc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c0_50), 0x30c0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30c8_50), 0x30c8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d0_50), 0x30d0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30d8_50), 0x30d8, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e0_50), 0x30e0, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30e8_50), 0x30e8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f0_54), 0x30f0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f8_50), 0x30f8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30f9_50), 0x30f9, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fa_50), 0x30fa, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fb_54), 0x30fb, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_30fc_50), 0x30fc, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3100_50), 0x3100, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3108_50), 0x3108, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3110_50), 0x3110, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3118_50), 0x3118, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3120_50), 0x3120, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3128_50), 0x3128, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3130_54), 0x3130, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3138_50), 0x3138, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3139_50), 0x3139, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313a_50), 0x313a, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313b_54), 0x313b, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_313c_50), 0x313c, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3140_50), 0x3140, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3148_50), 0x3148, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3150_50), 0x3150, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3158_50), 0x3158, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3160_50), 0x3160, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3168_50), 0x3168, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3170_54), 0x3170, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3178_50), 0x3178, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3179_50), 0x3179, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317a_50), 0x317a, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317b_54), 0x317b, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_317c_50), 0x317c, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3180_54), 0x3180, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3188_54), 0x3188, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3190_54), 0x3190, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_3198_54), 0x3198, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a0_54), 0x31a0, 4, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31a8_54), 0x31a8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b0_54), 0x31b0, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b8_54), 0x31b8, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31b9_54), 0x31b9, 8, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31ba_54), 0x31ba, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bb_54), 0x31bb, 6, { 6, 4 }, 0 }, /* MOVE */
{ CPUFUNC(op_31bc_54), 0x31bc, 6, { 4, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c0_50), 0x31c0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31c8_50), 0x31c8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d0_50), 0x31d0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31d8_50), 0x31d8, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e0_50), 0x31e0, 4, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31e8_50), 0x31e8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f0_54), 0x31f0, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f8_50), 0x31f8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31f9_50), 0x31f9, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fa_50), 0x31fa, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fb_54), 0x31fb, 6, { 6, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_31fc_50), 0x31fc, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c0_50), 0x33c0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33c8_50), 0x33c8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d0_50), 0x33d0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33d8_50), 0x33d8, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e0_50), 0x33e0, 6, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33e8_50), 0x33e8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f0_54), 0x33f0, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f8_50), 0x33f8, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33f9_50), 0x33f9, 10, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fa_50), 0x33fa, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fb_54), 0x33fb, 8, { 8, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_33fc_50), 0x33fc, 8, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_4000_50), 0x4000, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4010_50), 0x4010, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4018_50), 0x4018, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4020_50), 0x4020, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4028_50), 0x4028, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4030_54), 0x4030, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4038_50), 0x4038, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4039_50), 0x4039, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4040_50), 0x4040, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4050_50), 0x4050, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4058_50), 0x4058, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4060_50), 0x4060, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4068_50), 0x4068, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4070_54), 0x4070, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4078_50), 0x4078, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4079_50), 0x4079, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4080_50), 0x4080, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4090_50), 0x4090, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_4098_50), 0x4098, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a0_50), 0x40a0, 2, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40a8_50), 0x40a8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b0_54), 0x40b0, 4, { 4, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b8_50), 0x40b8, 4, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40b9_50), 0x40b9, 6, { 0, 0 }, 0 }, /* NEGX */
{ CPUFUNC(op_40c0_55), 0x40c0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d0_55), 0x40d0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40d8_55), 0x40d8, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e0_55), 0x40e0, 2, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40e8_55), 0x40e8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f0_55), 0x40f0, 4, { 4, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f8_55), 0x40f8, 4, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_40f9_55), 0x40f9, 6, { 0, 0 }, 0 }, /* MVSR2 */
{ CPUFUNC(op_4180_50), 0x4180, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4190_50), 0x4190, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_4198_50), 0x4198, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a0_50), 0x41a0, 2, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41a8_50), 0x41a8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b0_54), 0x41b0, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b8_50), 0x41b8, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41b9_50), 0x41b9, 6, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41ba_50), 0x41ba, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bb_54), 0x41bb, 4, { 4, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41bc_50), 0x41bc, 4, { 0, 0 }, 0 }, /* CHK */
{ CPUFUNC(op_41d0_50), 0x41d0, 2, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41e8_50), 0x41e8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f0_54), 0x41f0, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f8_50), 0x41f8, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41f9_50), 0x41f9, 6, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fa_50), 0x41fa, 4, { 0, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_41fb_54), 0x41fb, 4, { 4, 0 }, 0 }, /* LEA */
{ CPUFUNC(op_4200_55), 0x4200, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4210_55), 0x4210, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4218_55), 0x4218, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4220_55), 0x4220, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4228_55), 0x4228, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4230_55), 0x4230, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4238_55), 0x4238, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4239_55), 0x4239, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4240_55), 0x4240, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4250_55), 0x4250, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4258_55), 0x4258, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4260_55), 0x4260, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4268_55), 0x4268, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4270_55), 0x4270, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4278_55), 0x4278, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4279_55), 0x4279, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4280_55), 0x4280, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4290_55), 0x4290, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4298_55), 0x4298, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a0_55), 0x42a0, 2, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42a8_55), 0x42a8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b0_55), 0x42b0, 4, { 4, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b8_55), 0x42b8, 4, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_42b9_55), 0x42b9, 6, { 0, 0 }, 0 }, /* CLR */
{ CPUFUNC(op_4400_50), 0x4400, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4410_50), 0x4410, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4418_50), 0x4418, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4420_50), 0x4420, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4428_50), 0x4428, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4430_54), 0x4430, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4438_50), 0x4438, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4439_50), 0x4439, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4440_50), 0x4440, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4450_50), 0x4450, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4458_50), 0x4458, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4460_50), 0x4460, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4468_50), 0x4468, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4470_54), 0x4470, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4478_50), 0x4478, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4479_50), 0x4479, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4480_50), 0x4480, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4490_50), 0x4490, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_4498_50), 0x4498, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a0_50), 0x44a0, 2, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44a8_50), 0x44a8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b0_54), 0x44b0, 4, { 4, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b8_50), 0x44b8, 4, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44b9_50), 0x44b9, 6, { 0, 0 }, 0 }, /* NEG */
{ CPUFUNC(op_44c0_50), 0x44c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d0_50), 0x44d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44d8_50), 0x44d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e0_50), 0x44e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44e8_50), 0x44e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f0_54), 0x44f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f8_50), 0x44f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44f9_50), 0x44f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fa_50), 0x44fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fb_54), 0x44fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_44fc_50), 0x44fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4600_50), 0x4600, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4610_50), 0x4610, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4618_50), 0x4618, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4620_50), 0x4620, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4628_50), 0x4628, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4630_54), 0x4630, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4638_50), 0x4638, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4639_50), 0x4639, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4640_50), 0x4640, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4650_50), 0x4650, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4658_50), 0x4658, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4660_50), 0x4660, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4668_50), 0x4668, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4670_54), 0x4670, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4678_50), 0x4678, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4679_50), 0x4679, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4680_50), 0x4680, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4690_50), 0x4690, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_4698_50), 0x4698, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a0_50), 0x46a0, 2, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46a8_50), 0x46a8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b0_54), 0x46b0, 4, { 4, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b8_50), 0x46b8, 4, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46b9_50), 0x46b9, 6, { 0, 0 }, 0 }, /* NOT */
{ CPUFUNC(op_46c0_50), 0x46c0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d0_50), 0x46d0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46d8_50), 0x46d8, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e0_50), 0x46e0, 2, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46e8_50), 0x46e8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f0_54), 0x46f0, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f8_50), 0x46f8, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46f9_50), 0x46f9, 6, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fa_50), 0x46fa, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fb_54), 0x46fb, 4, { 4, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_46fc_50), 0x46fc, 4, { 0, 0 }, 0 }, /* MV2SR */
{ CPUFUNC(op_4800_52), 0x4800, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4810_52), 0x4810, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4818_52), 0x4818, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4820_52), 0x4820, 2, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4828_52), 0x4828, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4830_54), 0x4830, 4, { 4, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4838_52), 0x4838, 4, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4839_52), 0x4839, 6, { 0, 0 }, 0 }, /* NBCD */
{ CPUFUNC(op_4840_50), 0x4840, 2, { 0, 0 }, 0 }, /* SWAP */
{ CPUFUNC(op_4850_50), 0x4850, 2, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4868_50), 0x4868, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4870_54), 0x4870, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4878_50), 0x4878, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4879_50), 0x4879, 6, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487a_50), 0x487a, 4, { 0, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_487b_54), 0x487b, 4, { 4, 0 }, 0 }, /* PEA */
{ CPUFUNC(op_4880_50), 0x4880, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_4890_50), 0x4890, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a0_50), 0x48a0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48a8_50), 0x48a8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b0_54), 0x48b0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b8_50), 0x48b8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48b9_50), 0x48b9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48c0_50), 0x48c0, 2, { 0, 0 }, 0 }, /* EXT */
{ CPUFUNC(op_48d0_50), 0x48d0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e0_50), 0x48e0, 4, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48e8_50), 0x48e8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f0_54), 0x48f0, 6, { 4, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f8_50), 0x48f8, 6, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_48f9_50), 0x48f9, 8, { 0, 0 }, 0 }, /* MVMLE */
{ CPUFUNC(op_4a00_50), 0x4a00, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a10_50), 0x4a10, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a18_50), 0x4a18, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a20_50), 0x4a20, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a28_50), 0x4a28, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a30_54), 0x4a30, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a38_50), 0x4a38, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a39_50), 0x4a39, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a40_50), 0x4a40, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a50_50), 0x4a50, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a58_50), 0x4a58, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a60_50), 0x4a60, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a68_50), 0x4a68, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a70_54), 0x4a70, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a78_50), 0x4a78, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a79_50), 0x4a79, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a80_50), 0x4a80, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a90_50), 0x4a90, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4a98_50), 0x4a98, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa0_50), 0x4aa0, 2, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4aa8_50), 0x4aa8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab0_54), 0x4ab0, 4, { 4, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab8_50), 0x4ab8, 4, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ab9_50), 0x4ab9, 6, { 0, 0 }, 0 }, /* TST */
{ CPUFUNC(op_4ac0_54), 0x4ac0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad0_54), 0x4ad0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ad8_54), 0x4ad8, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae0_54), 0x4ae0, 2, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4ae8_54), 0x4ae8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af0_54), 0x4af0, 4, { 4, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af8_54), 0x4af8, 4, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4af9_54), 0x4af9, 6, { 0, 0 }, 0 }, /* TAS */
{ CPUFUNC(op_4c90_50), 0x4c90, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4c98_50), 0x4c98, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ca8_50), 0x4ca8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb0_54), 0x4cb0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb8_50), 0x4cb8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cb9_50), 0x4cb9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cba_50), 0x4cba, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cbb_54), 0x4cbb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd0_50), 0x4cd0, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cd8_50), 0x4cd8, 4, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4ce8_50), 0x4ce8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf0_54), 0x4cf0, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf8_50), 0x4cf8, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cf9_50), 0x4cf9, 8, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfa_50), 0x4cfa, 6, { 0, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4cfb_54), 0x4cfb, 6, { 4, 0 }, 0 }, /* MVMEL */
{ CPUFUNC(op_4e40_50), 0x4e40, 2, { 0, 0 }, 0 }, /* TRAP */
{ CPUFUNC(op_4e50_50), 0x4e50, 4, { 0, 0 }, 0 }, /* LINK */
{ CPUFUNC(op_4e58_50), 0x4e58, 2, { 0, 0 }, 0 }, /* UNLK */
{ CPUFUNC(op_4e60_50), 0x4e60, 2, { 0, 0 }, 0 }, /* MVR2USP */
{ CPUFUNC(op_4e68_50), 0x4e68, 2, { 0, 0 }, 0 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_50), 0x4e70, 2, { 0, 0 }, 0 }, /* RESET */
{ CPUFUNC(op_4e71_50), 0x4e71, 2, { 0, 0 }, 0 }, /* NOP */
{ CPUFUNC(op_4e72_50), 0x4e72, 4, { 0, 0 }, 0 }, /* STOP */
{ CPUFUNC(op_4e73_55), 0x4e73, 2, { 0, 0 }, 1 }, /* RTE */
{ CPUFUNC(op_4e75_50), 0x4e75, 2, { 0, 0 }, 1 }, /* RTS */
{ CPUFUNC(op_4e76_50), 0x4e76, 2, { 0, 0 }, 0 }, /* TRAPV */
{ CPUFUNC(op_4e77_50), 0x4e77, 2, { 0, 0 }, 1 }, /* RTR */
{ CPUFUNC(op_4e90_50), 0x4e90, 2, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ea8_50), 0x4ea8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb0_54), 0x4eb0, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb8_50), 0x4eb8, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eb9_50), 0x4eb9, 6, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4eba_50), 0x4eba, 4, { 0, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ebb_54), 0x4ebb, 4, { 4, 0 }, 1 }, /* JSR */
{ CPUFUNC(op_4ed0_50), 0x4ed0, 2, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ee8_50), 0x4ee8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef0_54), 0x4ef0, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef8_50), 0x4ef8, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4ef9_50), 0x4ef9, 6, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efa_50), 0x4efa, 4, { 0, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_4efb_54), 0x4efb, 4, { 4, 0 }, 1 }, /* JMP */
{ CPUFUNC(op_5000_50), 0x5000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5010_50), 0x5010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5018_50), 0x5018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5020_50), 0x5020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5028_50), 0x5028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5030_54), 0x5030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5038_50), 0x5038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5039_50), 0x5039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5040_50), 0x5040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5048_50), 0x5048, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5050_50), 0x5050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5058_50), 0x5058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5060_50), 0x5060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5068_50), 0x5068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5070_54), 0x5070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5078_50), 0x5078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5079_50), 0x5079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5080_50), 0x5080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5088_50), 0x5088, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_5090_50), 0x5090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_5098_50), 0x5098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a0_50), 0x50a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50a8_50), 0x50a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b0_54), 0x50b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b8_50), 0x50b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50b9_50), 0x50b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_50c0_55), 0x50c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50c8_50), 0x50c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_50d0_55), 0x50d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50d8_55), 0x50d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e0_55), 0x50e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50e8_55), 0x50e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f0_55), 0x50f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f8_55), 0x50f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_50f9_55), 0x50f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5100_50), 0x5100, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5110_50), 0x5110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5118_50), 0x5118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5120_50), 0x5120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5128_50), 0x5128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5130_54), 0x5130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5138_50), 0x5138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5139_50), 0x5139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5140_50), 0x5140, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5148_50), 0x5148, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5150_50), 0x5150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5158_50), 0x5158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5160_50), 0x5160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5168_50), 0x5168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5170_54), 0x5170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5178_50), 0x5178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5179_50), 0x5179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5180_50), 0x5180, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5188_50), 0x5188, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_5190_50), 0x5190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_5198_50), 0x5198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a0_50), 0x51a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51a8_50), 0x51a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b0_54), 0x51b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b8_50), 0x51b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51b9_50), 0x51b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_51c0_55), 0x51c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51c8_50), 0x51c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_51d0_55), 0x51d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51d8_55), 0x51d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e0_55), 0x51e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51e8_55), 0x51e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f0_55), 0x51f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f8_55), 0x51f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_51f9_55), 0x51f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c0_55), 0x52c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52c8_50), 0x52c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_52d0_55), 0x52d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52d8_55), 0x52d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e0_55), 0x52e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52e8_55), 0x52e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f0_55), 0x52f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f8_55), 0x52f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_52f9_55), 0x52f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c0_55), 0x53c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53c8_50), 0x53c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_53d0_55), 0x53d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53d8_55), 0x53d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e0_55), 0x53e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53e8_55), 0x53e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f0_55), 0x53f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f8_55), 0x53f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_53f9_55), 0x53f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c0_55), 0x54c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54c8_50), 0x54c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_54d0_55), 0x54d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54d8_55), 0x54d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e0_55), 0x54e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54e8_55), 0x54e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f0_55), 0x54f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f8_55), 0x54f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_54f9_55), 0x54f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c0_55), 0x55c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55c8_50), 0x55c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_55d0_55), 0x55d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55d8_55), 0x55d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e0_55), 0x55e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55e8_55), 0x55e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f0_55), 0x55f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f8_55), 0x55f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_55f9_55), 0x55f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c0_55), 0x56c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56c8_50), 0x56c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_56d0_55), 0x56d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56d8_55), 0x56d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e0_55), 0x56e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56e8_55), 0x56e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f0_55), 0x56f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f8_55), 0x56f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_56f9_55), 0x56f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c0_55), 0x57c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57c8_50), 0x57c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_57d0_55), 0x57d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57d8_55), 0x57d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e0_55), 0x57e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57e8_55), 0x57e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f0_55), 0x57f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f8_55), 0x57f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_57f9_55), 0x57f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c0_55), 0x58c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58c8_50), 0x58c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_58d0_55), 0x58d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58d8_55), 0x58d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e0_55), 0x58e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58e8_55), 0x58e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f0_55), 0x58f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f8_55), 0x58f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_58f9_55), 0x58f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c0_55), 0x59c0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59c8_50), 0x59c8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_59d0_55), 0x59d0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59d8_55), 0x59d8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e0_55), 0x59e0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59e8_55), 0x59e8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f0_55), 0x59f0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f8_55), 0x59f8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_59f9_55), 0x59f9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac0_55), 0x5ac0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ac8_50), 0x5ac8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ad0_55), 0x5ad0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ad8_55), 0x5ad8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae0_55), 0x5ae0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ae8_55), 0x5ae8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af0_55), 0x5af0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af8_55), 0x5af8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5af9_55), 0x5af9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc0_55), 0x5bc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bc8_50), 0x5bc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5bd0_55), 0x5bd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bd8_55), 0x5bd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be0_55), 0x5be0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5be8_55), 0x5be8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf0_55), 0x5bf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf8_55), 0x5bf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5bf9_55), 0x5bf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc0_55), 0x5cc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cc8_50), 0x5cc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5cd0_55), 0x5cd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cd8_55), 0x5cd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce0_55), 0x5ce0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ce8_55), 0x5ce8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf0_55), 0x5cf0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf8_55), 0x5cf8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5cf9_55), 0x5cf9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc0_55), 0x5dc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dc8_50), 0x5dc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5dd0_55), 0x5dd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5dd8_55), 0x5dd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de0_55), 0x5de0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5de8_55), 0x5de8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df0_55), 0x5df0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df8_55), 0x5df8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5df9_55), 0x5df9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec0_55), 0x5ec0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ec8_50), 0x5ec8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5ed0_55), 0x5ed0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ed8_55), 0x5ed8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee0_55), 0x5ee0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ee8_55), 0x5ee8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef0_55), 0x5ef0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef8_55), 0x5ef8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ef9_55), 0x5ef9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc0_55), 0x5fc0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fc8_50), 0x5fc8, 4, { 0, 0 }, 1 }, /* DBcc */
{ CPUFUNC(op_5fd0_55), 0x5fd0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fd8_55), 0x5fd8, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe0_55), 0x5fe0, 2, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5fe8_55), 0x5fe8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff0_55), 0x5ff0, 4, { 4, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff8_55), 0x5ff8, 4, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_5ff9_55), 0x5ff9, 6, { 0, 0 }, 0 }, /* Scc */
{ CPUFUNC(op_6000_50), 0x6000, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6001_50), 0x6001, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_60ff_54), 0x60ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6100_50), 0x6100, 4, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6101_50), 0x6101, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_61ff_54), 0x61ff, 2, { 0, 0 }, 1 }, /* BSR */
{ CPUFUNC(op_6200_50), 0x6200, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6201_50), 0x6201, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_62ff_54), 0x62ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6300_50), 0x6300, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6301_50), 0x6301, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_63ff_54), 0x63ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6400_50), 0x6400, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6401_50), 0x6401, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_64ff_54), 0x64ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6500_50), 0x6500, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6501_50), 0x6501, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_65ff_54), 0x65ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6600_50), 0x6600, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6601_50), 0x6601, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_66ff_54), 0x66ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6700_50), 0x6700, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6701_50), 0x6701, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_67ff_54), 0x67ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6800_50), 0x6800, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6801_50), 0x6801, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_68ff_54), 0x68ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6900_50), 0x6900, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6901_50), 0x6901, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_69ff_54), 0x69ff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6a00_50), 0x6a00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6a01_50), 0x6a01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6aff_54), 0x6aff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6b00_50), 0x6b00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6b01_50), 0x6b01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6bff_54), 0x6bff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6c00_50), 0x6c00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6c01_50), 0x6c01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6cff_54), 0x6cff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6d00_50), 0x6d00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6d01_50), 0x6d01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6dff_54), 0x6dff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6e00_50), 0x6e00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6e01_50), 0x6e01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6eff_54), 0x6eff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_6f00_50), 0x6f00, 4, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6f01_50), 0x6f01, 2, { 0, 0 }, 1 }, /* Bcc */
{ CPUFUNC(op_6fff_54), 0x6fff, 2, { 0, 0 }, 0 }, /* Bcc */
{ CPUFUNC(op_7000_50), 0x7000, 2, { 0, 0 }, 0 }, /* MOVE */
{ CPUFUNC(op_8000_50), 0x8000, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8010_50), 0x8010, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8018_50), 0x8018, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8020_50), 0x8020, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8028_50), 0x8028, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8030_54), 0x8030, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8038_50), 0x8038, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8039_50), 0x8039, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803a_50), 0x803a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803b_54), 0x803b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_803c_50), 0x803c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8040_50), 0x8040, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8050_50), 0x8050, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8058_50), 0x8058, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8060_50), 0x8060, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8068_50), 0x8068, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8070_54), 0x8070, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8078_50), 0x8078, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8079_50), 0x8079, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807a_50), 0x807a, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807b_54), 0x807b, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_807c_50), 0x807c, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8080_50), 0x8080, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8090_50), 0x8090, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8098_50), 0x8098, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a0_50), 0x80a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80a8_50), 0x80a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b0_54), 0x80b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b8_50), 0x80b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80b9_50), 0x80b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80ba_50), 0x80ba, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bb_54), 0x80bb, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80bc_50), 0x80bc, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_80c0_50), 0x80c0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d0_50), 0x80d0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80d8_50), 0x80d8, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e0_50), 0x80e0, 2, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80e8_50), 0x80e8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f0_54), 0x80f0, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f8_50), 0x80f8, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80f9_50), 0x80f9, 6, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fa_50), 0x80fa, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fb_54), 0x80fb, 4, { 4, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_80fc_50), 0x80fc, 4, { 0, 0 }, 0 }, /* DIVU */
{ CPUFUNC(op_8100_52), 0x8100, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8108_52), 0x8108, 2, { 0, 0 }, 0 }, /* SBCD */
{ CPUFUNC(op_8110_50), 0x8110, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8118_50), 0x8118, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8120_50), 0x8120, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8128_50), 0x8128, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8130_54), 0x8130, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8138_50), 0x8138, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8139_50), 0x8139, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8150_50), 0x8150, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8158_50), 0x8158, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8160_50), 0x8160, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8168_50), 0x8168, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8170_54), 0x8170, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8178_50), 0x8178, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8179_50), 0x8179, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8190_50), 0x8190, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_8198_50), 0x8198, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a0_50), 0x81a0, 2, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81a8_50), 0x81a8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b0_54), 0x81b0, 4, { 4, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b8_50), 0x81b8, 4, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81b9_50), 0x81b9, 6, { 0, 0 }, 0 }, /* OR */
{ CPUFUNC(op_81c0_50), 0x81c0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d0_50), 0x81d0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81d8_50), 0x81d8, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e0_50), 0x81e0, 2, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81e8_50), 0x81e8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f0_54), 0x81f0, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f8_50), 0x81f8, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81f9_50), 0x81f9, 6, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fa_50), 0x81fa, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fb_54), 0x81fb, 4, { 4, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_81fc_50), 0x81fc, 4, { 0, 0 }, 0 }, /* DIVS */
{ CPUFUNC(op_9000_50), 0x9000, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9010_50), 0x9010, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9018_50), 0x9018, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9020_50), 0x9020, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9028_50), 0x9028, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9030_54), 0x9030, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9038_50), 0x9038, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9039_50), 0x9039, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903a_50), 0x903a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903b_54), 0x903b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_903c_50), 0x903c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9040_50), 0x9040, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9048_50), 0x9048, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9050_50), 0x9050, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9058_50), 0x9058, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9060_50), 0x9060, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9068_50), 0x9068, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9070_54), 0x9070, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9078_50), 0x9078, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9079_50), 0x9079, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907a_50), 0x907a, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907b_54), 0x907b, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_907c_50), 0x907c, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9080_50), 0x9080, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9088_50), 0x9088, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9090_50), 0x9090, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9098_50), 0x9098, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a0_50), 0x90a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90a8_50), 0x90a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b0_54), 0x90b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b8_50), 0x90b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90b9_50), 0x90b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90ba_50), 0x90ba, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bb_54), 0x90bb, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90bc_50), 0x90bc, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_90c0_50), 0x90c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90c8_50), 0x90c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d0_50), 0x90d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90d8_50), 0x90d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e0_50), 0x90e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90e8_50), 0x90e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f0_54), 0x90f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f8_50), 0x90f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90f9_50), 0x90f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fa_50), 0x90fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fb_54), 0x90fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_90fc_50), 0x90fc, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_9100_50), 0x9100, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9108_50), 0x9108, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9110_50), 0x9110, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9118_50), 0x9118, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9120_50), 0x9120, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9128_50), 0x9128, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9130_54), 0x9130, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9138_50), 0x9138, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9139_50), 0x9139, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9140_50), 0x9140, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9148_50), 0x9148, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9150_50), 0x9150, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9158_50), 0x9158, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9160_50), 0x9160, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9168_50), 0x9168, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9170_54), 0x9170, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9178_50), 0x9178, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9179_50), 0x9179, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9180_50), 0x9180, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9188_50), 0x9188, 2, { 0, 0 }, 0 }, /* SUBX */
{ CPUFUNC(op_9190_50), 0x9190, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_9198_50), 0x9198, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a0_50), 0x91a0, 2, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91a8_50), 0x91a8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b0_54), 0x91b0, 4, { 4, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b8_50), 0x91b8, 4, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91b9_50), 0x91b9, 6, { 0, 0 }, 0 }, /* SUB */
{ CPUFUNC(op_91c0_50), 0x91c0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91c8_50), 0x91c8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d0_50), 0x91d0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91d8_50), 0x91d8, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e0_50), 0x91e0, 2, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91e8_50), 0x91e8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f0_54), 0x91f0, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f8_50), 0x91f8, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91f9_50), 0x91f9, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fa_50), 0x91fa, 4, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fb_54), 0x91fb, 4, { 4, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_91fc_50), 0x91fc, 6, { 0, 0 }, 0 }, /* SUBA */
{ CPUFUNC(op_b000_50), 0xb000, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b010_50), 0xb010, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b018_50), 0xb018, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b020_50), 0xb020, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b028_50), 0xb028, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b030_54), 0xb030, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b038_50), 0xb038, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b039_50), 0xb039, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03a_50), 0xb03a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03b_54), 0xb03b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b03c_50), 0xb03c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b040_50), 0xb040, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b048_50), 0xb048, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b050_50), 0xb050, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b058_50), 0xb058, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b060_50), 0xb060, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b068_50), 0xb068, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b070_54), 0xb070, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b078_50), 0xb078, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b079_50), 0xb079, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07a_50), 0xb07a, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07b_54), 0xb07b, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b07c_50), 0xb07c, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b080_50), 0xb080, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b088_50), 0xb088, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b090_50), 0xb090, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b098_50), 0xb098, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a0_50), 0xb0a0, 2, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0a8_50), 0xb0a8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b0_54), 0xb0b0, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b8_50), 0xb0b8, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0b9_50), 0xb0b9, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0ba_50), 0xb0ba, 4, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bb_54), 0xb0bb, 4, { 4, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0bc_50), 0xb0bc, 6, { 0, 0 }, 0 }, /* CMP */
{ CPUFUNC(op_b0c0_50), 0xb0c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0c8_50), 0xb0c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d0_50), 0xb0d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0d8_50), 0xb0d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e0_50), 0xb0e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0e8_50), 0xb0e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f0_54), 0xb0f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f8_50), 0xb0f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0f9_50), 0xb0f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fa_50), 0xb0fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fb_54), 0xb0fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b0fc_50), 0xb0fc, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b100_50), 0xb100, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b108_50), 0xb108, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b110_50), 0xb110, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b118_50), 0xb118, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b120_50), 0xb120, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b128_50), 0xb128, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b130_54), 0xb130, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b138_50), 0xb138, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b139_50), 0xb139, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b140_50), 0xb140, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b148_50), 0xb148, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b150_50), 0xb150, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b158_50), 0xb158, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b160_50), 0xb160, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b168_50), 0xb168, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b170_54), 0xb170, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b178_50), 0xb178, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b179_50), 0xb179, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b180_50), 0xb180, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b188_50), 0xb188, 2, { 0, 0 }, 0 }, /* CMPM */
{ CPUFUNC(op_b190_50), 0xb190, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b198_50), 0xb198, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a0_50), 0xb1a0, 2, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1a8_50), 0xb1a8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b0_54), 0xb1b0, 4, { 4, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b8_50), 0xb1b8, 4, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1b9_50), 0xb1b9, 6, { 0, 0 }, 0 }, /* EOR */
{ CPUFUNC(op_b1c0_50), 0xb1c0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1c8_50), 0xb1c8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d0_50), 0xb1d0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1d8_50), 0xb1d8, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e0_50), 0xb1e0, 2, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1e8_50), 0xb1e8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f0_54), 0xb1f0, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f8_50), 0xb1f8, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1f9_50), 0xb1f9, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fa_50), 0xb1fa, 4, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fb_54), 0xb1fb, 4, { 4, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_b1fc_50), 0xb1fc, 6, { 0, 0 }, 0 }, /* CMPA */
{ CPUFUNC(op_c000_50), 0xc000, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c010_50), 0xc010, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c018_50), 0xc018, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c020_50), 0xc020, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c028_50), 0xc028, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c030_54), 0xc030, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c038_50), 0xc038, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c039_50), 0xc039, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03a_50), 0xc03a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03b_54), 0xc03b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c03c_50), 0xc03c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c040_50), 0xc040, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c050_50), 0xc050, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c058_50), 0xc058, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c060_50), 0xc060, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c068_50), 0xc068, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c070_54), 0xc070, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c078_50), 0xc078, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c079_50), 0xc079, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07a_50), 0xc07a, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07b_54), 0xc07b, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c07c_50), 0xc07c, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c080_50), 0xc080, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c090_50), 0xc090, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c098_50), 0xc098, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a0_50), 0xc0a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0a8_50), 0xc0a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b0_54), 0xc0b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b8_50), 0xc0b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0b9_50), 0xc0b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0ba_50), 0xc0ba, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bb_54), 0xc0bb, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0bc_50), 0xc0bc, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c0c0_50), 0xc0c0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d0_50), 0xc0d0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0d8_50), 0xc0d8, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e0_50), 0xc0e0, 2, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0e8_50), 0xc0e8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f0_54), 0xc0f0, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f8_50), 0xc0f8, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0f9_50), 0xc0f9, 6, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fa_50), 0xc0fa, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fb_54), 0xc0fb, 4, { 4, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c0fc_50), 0xc0fc, 4, { 0, 0 }, 0 }, /* MULU */
{ CPUFUNC(op_c100_52), 0xc100, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c108_52), 0xc108, 2, { 0, 0 }, 0 }, /* ABCD */
{ CPUFUNC(op_c110_50), 0xc110, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c118_50), 0xc118, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c120_50), 0xc120, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c128_50), 0xc128, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c130_54), 0xc130, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c138_50), 0xc138, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c139_50), 0xc139, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c140_50), 0xc140, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c148_50), 0xc148, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c150_50), 0xc150, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c158_50), 0xc158, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c160_50), 0xc160, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c168_50), 0xc168, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c170_54), 0xc170, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c178_50), 0xc178, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c179_50), 0xc179, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c188_50), 0xc188, 2, { 0, 0 }, 0 }, /* EXG */
{ CPUFUNC(op_c190_50), 0xc190, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c198_50), 0xc198, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a0_50), 0xc1a0, 2, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1a8_50), 0xc1a8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b0_54), 0xc1b0, 4, { 4, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b8_50), 0xc1b8, 4, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1b9_50), 0xc1b9, 6, { 0, 0 }, 0 }, /* AND */
{ CPUFUNC(op_c1c0_50), 0xc1c0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d0_50), 0xc1d0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1d8_50), 0xc1d8, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e0_50), 0xc1e0, 2, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1e8_50), 0xc1e8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f0_54), 0xc1f0, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f8_50), 0xc1f8, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1f9_50), 0xc1f9, 6, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fa_50), 0xc1fa, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fb_54), 0xc1fb, 4, { 4, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_c1fc_50), 0xc1fc, 4, { 0, 0 }, 0 }, /* MULS */
{ CPUFUNC(op_d000_50), 0xd000, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d010_50), 0xd010, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d018_50), 0xd018, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d020_50), 0xd020, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d028_50), 0xd028, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d030_54), 0xd030, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d038_50), 0xd038, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d039_50), 0xd039, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03a_50), 0xd03a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03b_54), 0xd03b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d03c_50), 0xd03c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d040_50), 0xd040, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d048_50), 0xd048, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d050_50), 0xd050, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d058_50), 0xd058, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d060_50), 0xd060, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d068_50), 0xd068, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d070_54), 0xd070, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d078_50), 0xd078, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d079_50), 0xd079, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07a_50), 0xd07a, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07b_54), 0xd07b, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d07c_50), 0xd07c, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d080_50), 0xd080, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d088_50), 0xd088, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d090_50), 0xd090, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d098_50), 0xd098, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a0_50), 0xd0a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0a8_50), 0xd0a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b0_54), 0xd0b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b8_50), 0xd0b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0b9_50), 0xd0b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0ba_50), 0xd0ba, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bb_54), 0xd0bb, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0bc_50), 0xd0bc, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d0c0_50), 0xd0c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0c8_50), 0xd0c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d0_50), 0xd0d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0d8_50), 0xd0d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e0_50), 0xd0e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0e8_50), 0xd0e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f0_54), 0xd0f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f8_50), 0xd0f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0f9_50), 0xd0f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fa_50), 0xd0fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fb_54), 0xd0fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d0fc_50), 0xd0fc, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d100_50), 0xd100, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d108_50), 0xd108, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d110_50), 0xd110, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d118_50), 0xd118, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d120_50), 0xd120, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d128_50), 0xd128, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d130_54), 0xd130, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d138_50), 0xd138, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d139_50), 0xd139, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d140_50), 0xd140, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d148_50), 0xd148, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d150_50), 0xd150, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d158_50), 0xd158, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d160_50), 0xd160, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d168_50), 0xd168, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d170_54), 0xd170, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d178_50), 0xd178, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d179_50), 0xd179, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d180_50), 0xd180, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d188_50), 0xd188, 2, { 0, 0 }, 0 }, /* ADDX */
{ CPUFUNC(op_d190_50), 0xd190, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d198_50), 0xd198, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a0_50), 0xd1a0, 2, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1a8_50), 0xd1a8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b0_54), 0xd1b0, 4, { 4, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b8_50), 0xd1b8, 4, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1b9_50), 0xd1b9, 6, { 0, 0 }, 0 }, /* ADD */
{ CPUFUNC(op_d1c0_50), 0xd1c0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1c8_50), 0xd1c8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d0_50), 0xd1d0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1d8_50), 0xd1d8, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e0_50), 0xd1e0, 2, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1e8_50), 0xd1e8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f0_54), 0xd1f0, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f8_50), 0xd1f8, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1f9_50), 0xd1f9, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fa_50), 0xd1fa, 4, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fb_54), 0xd1fb, 4, { 4, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_d1fc_50), 0xd1fc, 6, { 0, 0 }, 0 }, /* ADDA */
{ CPUFUNC(op_e000_50), 0xe000, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e008_50), 0xe008, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e010_50), 0xe010, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e018_50), 0xe018, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e020_50), 0xe020, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e028_50), 0xe028, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e030_50), 0xe030, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e038_50), 0xe038, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e040_50), 0xe040, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e048_50), 0xe048, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e050_50), 0xe050, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e058_50), 0xe058, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e060_50), 0xe060, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e068_50), 0xe068, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e070_50), 0xe070, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e078_50), 0xe078, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e080_50), 0xe080, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e088_50), 0xe088, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e090_50), 0xe090, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e098_50), 0xe098, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0a0_50), 0xe0a0, 2, { 0, 0 }, 0 }, /* ASR */
{ CPUFUNC(op_e0a8_50), 0xe0a8, 2, { 0, 0 }, 0 }, /* LSR */
{ CPUFUNC(op_e0b0_50), 0xe0b0, 2, { 0, 0 }, 0 }, /* ROXR */
{ CPUFUNC(op_e0b8_50), 0xe0b8, 2, { 0, 0 }, 0 }, /* ROR */
{ CPUFUNC(op_e0d0_50), 0xe0d0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0d8_50), 0xe0d8, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e0_50), 0xe0e0, 2, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0e8_50), 0xe0e8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f0_54), 0xe0f0, 4, { 4, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f8_50), 0xe0f8, 4, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e0f9_50), 0xe0f9, 6, { 0, 0 }, 0 }, /* ASRW */
{ CPUFUNC(op_e100_50), 0xe100, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e108_50), 0xe108, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e110_50), 0xe110, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e118_50), 0xe118, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e120_50), 0xe120, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e128_50), 0xe128, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e130_50), 0xe130, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e138_50), 0xe138, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e140_50), 0xe140, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e148_50), 0xe148, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e150_50), 0xe150, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e158_50), 0xe158, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e160_50), 0xe160, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e168_50), 0xe168, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e170_50), 0xe170, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e178_50), 0xe178, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e180_50), 0xe180, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e188_50), 0xe188, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e190_50), 0xe190, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e198_50), 0xe198, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1a0_50), 0xe1a0, 2, { 0, 0 }, 0 }, /* ASL */
{ CPUFUNC(op_e1a8_50), 0xe1a8, 2, { 0, 0 }, 0 }, /* LSL */
{ CPUFUNC(op_e1b0_50), 0xe1b0, 2, { 0, 0 }, 0 }, /* ROXL */
{ CPUFUNC(op_e1b8_50), 0xe1b8, 2, { 0, 0 }, 0 }, /* ROL */
{ CPUFUNC(op_e1d0_50), 0xe1d0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1d8_50), 0xe1d8, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e0_50), 0xe1e0, 2, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1e8_50), 0xe1e8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f0_54), 0xe1f0, 4, { 4, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f8_50), 0xe1f8, 4, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e1f9_50), 0xe1f9, 6, { 0, 0 }, 0 }, /* ASLW */
{ CPUFUNC(op_e2d0_50), 0xe2d0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2d8_50), 0xe2d8, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e0_50), 0xe2e0, 2, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2e8_50), 0xe2e8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f0_54), 0xe2f0, 4, { 4, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f8_50), 0xe2f8, 4, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e2f9_50), 0xe2f9, 6, { 0, 0 }, 0 }, /* LSRW */
{ CPUFUNC(op_e3d0_50), 0xe3d0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3d8_50), 0xe3d8, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e0_50), 0xe3e0, 2, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3e8_50), 0xe3e8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f0_54), 0xe3f0, 4, { 4, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f8_50), 0xe3f8, 4, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e3f9_50), 0xe3f9, 6, { 0, 0 }, 0 }, /* LSLW */
{ CPUFUNC(op_e4d0_50), 0xe4d0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4d8_50), 0xe4d8, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e0_50), 0xe4e0, 2, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4e8_50), 0xe4e8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f0_54), 0xe4f0, 4, { 4, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f8_50), 0xe4f8, 4, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e4f9_50), 0xe4f9, 6, { 0, 0 }, 0 }, /* ROXRW */
{ CPUFUNC(op_e5d0_50), 0xe5d0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5d8_50), 0xe5d8, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e0_50), 0xe5e0, 2, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5e8_50), 0xe5e8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f0_54), 0xe5f0, 4, { 4, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f8_50), 0xe5f8, 4, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e5f9_50), 0xe5f9, 6, { 0, 0 }, 0 }, /* ROXLW */
{ CPUFUNC(op_e6d0_50), 0xe6d0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6d8_50), 0xe6d8, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e0_50), 0xe6e0, 2, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6e8_50), 0xe6e8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f0_54), 0xe6f0, 4, { 4, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f8_50), 0xe6f8, 4, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e6f9_50), 0xe6f9, 6, { 0, 0 }, 0 }, /* RORW */
{ CPUFUNC(op_e7d0_50), 0xe7d0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7d8_50), 0xe7d8, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e0_50), 0xe7e0, 2, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7e8_50), 0xe7e8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f0_54), 0xe7f0, 4, { 4, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f8_50), 0xe7f8, 4, { 0, 0 }, 0 }, /* ROLW */
{ CPUFUNC(op_e7f9_50), 0xe7f9, 6, { 0, 0 }, 0 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_68000_ONLY */
#endif /* CPUEMU_50 */
